﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Ability
{
	class HealAbility: thrts.AbilityTemplate
	{
		/// <summary>
		/// HPをいくつ上昇させるか
		/// </summary>
		int healConst;
		/// <summary>
		/// MaxHPの何倍で回復するか
		/// </summary>
		float healRate;

		int interval;

		private HealAbility()
		{
			this.Name = "Heal";
			this.DurationTime = 0;
			healConst = 0;
			healRate = 0.0f;
			interval = 1;

		}
		public HealAbility(int heal,int duration = 0,int interval = 1)
			: this()
		{
			this.DurationTime = duration;
			this.interval = interval;
			healConst = heal;
		}
		public HealAbility(float heal,int duration = 0,int interval = 1)
			: this()
		{
			this.DurationTime = duration;
			this.interval = interval;
			healRate = heal;
		}
		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			/// intervalフレームに1回処理する
			if (DurationTime % interval != 0)
				return true;

			/// HPが満タンなら処理しない
			if (unit.HP >= unit.MaxHP)
				return true;

			switch (order)
			{
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					break;
				case thrts.AbilityOrder.ConstIncParam:
					/// HPをHealConst回復
					unit.HP += healConst;
					break;
				case thrts.AbilityOrder.RateIncParam:
					/// HPをHealRate回復
					unit.HP += (int)(healRate * unit.MaxHP);
					break;
				default:
					break;
			}

			/// HPの上限チェック
			if (unit.HP > unit.MaxHP)
				unit.HP = unit.MaxHP;

			return true;
		}
	}
}
