﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Ability.Neutral
{
	class High01Ability : thrts.AbilityTemplate
	{
		public float IncSpeedRatio;
		public float IncAtkRate;
		IEffect effect;
		public High01Ability(int level,IEffect effect = null)
		{
			this.Name = "中立・妖精(強)";
			this.DurationTime = 1*Def.FPS;
			this.effect = effect;
			switch (level)
			{
				case 1:
					IncSpeedRatio = 1.1f;
					IncAtkRate = 1.1f;
					break;
				case 2:
					IncSpeedRatio = 1.1f;
					IncAtkRate = 1.3f;
					break;
				case 3:
					IncSpeedRatio = 1.1f;
					IncAtkRate = 1.15f;
					break;
				default:
					IncSpeedRatio = 1.0f;
					IncAtkRate = 1.0f;
					break;
			}

		}
		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			switch (order)
			{
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					foreach(var b in unit.ModifiedBulletParameters)
					{
						/// inc damage
						b.Attack = (int)(b.Attack*IncAtkRate);
					}
					
					break;
				case thrts.AbilityOrder.ConstIncParam:
					break;
				case thrts.AbilityOrder.RateIncParam:
					unit.Speed *= IncSpeedRatio;
					break;
				case AbilityOrder.OtherExecs:
					if(effect != null)
						effect.SetPosition(unit.Pos+new Vector3D(2,2,1));
					break;
				default:
					break;
			}

			return true;
		}
		public override bool OnVanish (IUnit unit)
		{
			if (effect != null) {
				effect.Stop ();
				effect = null;
			}
			return base.OnVanish (unit);
		}
		public override bool ModifyBullet(thrts.IBullet bullet)
		{
			return base.ModifyBullet(bullet);
		}
	}

}
