﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Ability.White
{
	class AirMakimonoAbility : thrts.AbilityTemplate
	{
		private float speedRate;
		thrts.IEffect effect;
		public static string AbilityName = "「聖尼公のエア巻物」";
		public AirMakimonoAbility (int level, thrts.IEffect effect=null)
		{
			this.Name = AbilityName;
			this.DurationTime = 1*30;
			this.effect = effect;
			switch (level)
			{
				case 1:
					speedRate = 0.0f;
					this.DurationTime = 1 * 30;
					break;
				case 2:
					speedRate = 0.0f;
					this.DurationTime = (int)(1.5f * 30);
					break;
				case 3:
					speedRate = 0.0f;
					this.DurationTime = (int)(2f * 30);
					break;
				default:
					break;
			}

		}
		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			switch (order)
			{
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					unit.Speed *= speedRate;
					break;
				case thrts.AbilityOrder.ConstIncParam:
					break;
				case thrts.AbilityOrder.RateIncParam:
					break;
				case thrts.AbilityOrder.OtherExecs:
					unit.IsForbiddenAttacking = true;
					if (effect != null)
						effect.SetPosition(unit.Pos + new thrts.Vector3D(2, 2, 1));
					break;
				default:
					break;
			}

			return true;
		}

		public override bool OnVanish(thrts.IUnit unit)
		{
			if (effect != null)
			{
				effect.Stop();
				effect = null;
			}
			if (unit != null)
			{
				unit.IsForbiddenAttacking = false;
			}
			return base.OnVanish(unit);
		}

		public override bool ModifyBullet(thrts.IBullet bullet)
		{
			
			return base.ModifyBullet(bullet);
		}
	}

}
