﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Ability.White
{
	class KibakujinAbility : thrts.AbilityTemplate
	{
		public float SpeedRate{ get; set; }
		IEffect effect;
		public const string AbilityName = "八方鬼縛陣";
		public KibakujinAbility (float speedRatio,int duration,IEffect effect=null)
		{
			this.Name = AbilityName;
			this.DurationTime = duration;
			this.effect = effect;
			this.SpeedRate = speedRatio;
		}
		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			switch (order)
			{
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					///移動速度をspeedRate倍
					unit.Speed *= SpeedRate;
					break;
				case thrts.AbilityOrder.ConstIncParam:
					break;
				case thrts.AbilityOrder.RateIncParam:
					break;
				case AbilityOrder.OtherExecs:
					if(effect != null)
						effect.SetPosition(unit.Pos+new Vector3D(2,2,1));
					break;
				default:
					break;
			}

			return true;
		}
		public override bool OnVanish (IUnit unit)
		{
			if (effect != null) {
				effect.Stop ();
				effect = null;
			}
			return base.OnVanish (unit);
		}
	}

}
