﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.White;
using LotusCraft.Spell.White;

namespace LotusCraft.Ability.White
{
	class MissouAbility : thrts.AbilityTemplate
	{
		thrts.IEffect effect;
		IEnumerable<IUnit> units;
		public MissouAbility (ISpell spell, IEnumerable<IUnit> units, int duration)
		{
			if (spell == null || units == null)
				throw new ArgumentNullException ();

			this.Name = "大結界「博麗弾幕結界」";
			this.DurationTime = duration;
			this.units = units;

			// force escape units
			foreach (var u in units) {
				if( u.Exists() )
				{
					u.Escape();
				}
			}

		}

		public override bool OnVanish (thrts.IUnit unit)
		{
			if (effect != null) {
				effect.Stop ();
				effect = null;
			}
			// back units
			foreach (var u in units) {
				if( u.Exists() )
				{
					u.Enter();
				}
			}
			return base.OnVanish (unit);
		}
	}

}
