﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Ability.White
{
	class MusoTenseiAbility : thrts.AbilityTemplate
	{
		public static float  incAtkRange = 1;
		public static float  incSpeedRate = 1.1f;
		public float AtkRate{get; private set;}
		public int IncArmor{get;private set;}
		thrts.IEffect effect;
		public MusoTenseiAbility(int level,thrts.IEffect effect = null)
		{
			this.Name = "大結界「博麗弾幕結界」";
			this.DurationTime = 1*Def.FPS;
			this.effect = effect;
			switch (level)
			{
				case 1:
					AtkRate = 1.2f;
					IncArmor = 4;
					break;
				default:
					AtkRate = 1.0f;
					IncArmor = 0;
					break;
			}

		}
		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			switch (order)
			{
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					break;
				case thrts.AbilityOrder.ConstIncParam:
					/// inc armor
					unit.Armor += IncArmor;
					break;
				case thrts.AbilityOrder.RateIncParam:
					unit.Speed *= incSpeedRate;
					foreach(var b in unit.ModifiedBulletParameters)
					{
						b.Attack = (int)(AtkRate * b.Attack);
						if(b.MinRange > Def.MapTipLengthOnField)
							b.MinRange += incAtkRange*Def.MapTipLengthOnField;
						if(b.MaxRange > 2*Def.MapTipLengthOnField)
							b.MaxRange += incAtkRange*Def.MapTipLengthOnField;
					}
					break;
				case thrts.AbilityOrder.OtherExecs:
					if(effect != null)
						effect.SetPosition(unit.Pos+new thrts.Vector3D(2,2,1));
					break;
				default:
					break;
			}

			return true;
		}
		public override bool OnVanish (thrts.IUnit unit)
		{
			if (effect != null) {
				effect.Stop ();
				effect = null;
			}
			return base.OnVanish (unit);
		}
		public override bool ModifyBullet(thrts.IBullet bullet)
		{
			return base.ModifyBullet(bullet);
		}
	}

}
