﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Ability.White
{
	class StarSwordAbility : thrts.AbilityTemplate
	{
		thrts.IEffect effect = null;
		public StarSwordAbility(int level, thrts.IEffect effect=null)
		{
			this.Name = "「スターソードの護法」";
			this.DurationTime = 4*30;
			this.effect = effect;
			switch (level)
			{
				case 1:
					this.DurationTime = 4 * 30;
					break;
				case 2:
					this.DurationTime = 6 * 30;
					break;
				case 3:
					this.DurationTime = 8 * 30;
					break;
				default:
					this.DurationTime = 4 * 30;
					break;
			}

		}
		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			switch (order)
			{
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					break;
				case thrts.AbilityOrder.ConstIncParam:
					break;
				case thrts.AbilityOrder.RateIncParam:
					break;
				case thrts.AbilityOrder.OtherExecs:
					unit.IsForbiddenSpelling = true;
					unit.Faction.World.WriteLine(1, "forbidden");
					if (effect != null)
						effect.SetPosition(unit.Pos + new thrts.Vector3D(2, 2, 1));
					break;
				default:
					break;
			}

			return true;
		}

		public override bool OnVanish(thrts.IUnit unit)
		{
			if (effect != null)
			{
				effect.Stop();
				effect = null;
			}
			if (unit != null)
			{
				unit.IsForbiddenSpelling = false;
			}
			return base.OnVanish(unit);
		}

		public override bool ModifyBullet(thrts.IBullet bullet)
		{
			
			return base.ModifyBullet(bullet);
		}
	}

}
