﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Ability.White
{
	class TettuiAbility : thrts.AbilityTemplate
	{
		private float SpeedRate;
		IEffect effect;
		public TettuiAbility(int level,IEffect effect=null)
		{
			this.Name = "天空鉄槌落とし lv"+level.ToString();
			this.DurationTime = 4 * 30;
			this.effect = effect;

			switch (level)
			{
				case 1:
					SpeedRate = 0.95f;
					break;
				case 2:
					SpeedRate = 0.90f;
					break;
				case 3:
					SpeedRate = 0.85f;
					break;
				default:
					SpeedRate = 1.0f;
					break;
			}

		}
		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			switch (order)
			{
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					///移動速度をspeedRate倍
					unit.Speed *= SpeedRate;
					break;
				case thrts.AbilityOrder.ConstIncParam:
					break;
				case thrts.AbilityOrder.RateIncParam:
					break;
				case AbilityOrder.OtherExecs:
					if (effect != null)
						effect.SetPosition(unit.Pos + new Vector3D(2, 2, 1));
					break;
				default:
					break;
			}

			return true;
		}
		public override bool OnVanish(IUnit unit)
		{
			if (effect != null)
			{
				effect.Stop();
				effect = null;
			}
			return base.OnVanish(unit);
		}
		public override bool ModifyBullet(thrts.IBullet bullet)
		{
			
			return base.ModifyBullet(bullet);
		}
	}

}
