﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.AutoCast;
using LotusCraft.Unit.Black;
using LotusCraft.Effect.Black;

namespace LotusCraft.Building.Black
{
	public class Chireiden : General.BaseStructure
	{
		public Chireiden ()
		{
			IconPath = "LotusCraft/Image/Button/Black/Building/Chireiden";
			Name = "地霊殿";
			ButtonDescription += "さとり、ちびお燐、ちびお空が上級魔法陣から生産できるようになります。";
			ShortcutKeyword = "BuildExhibition1";
			Size = 3;

			MakingTime = 70*Def.FPS;
			HP = 1500;
			Armor = 2;
			Supply = 15;
			Costs = new [] {100,100,0,0};

			Animation = new TextureAnimation ();
			Animation.Path = "LotusCraft/Image/Building/Black/Barrack";
			Animation.Width = 128;
			Animation.Height = 128;
			Animation.Center.X = 0;
			Animation.Center.Y = -32;
			Animation.CenterPosition = CenterPosition.LowerMiddle;
			Animation.FrameCount = 1;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 1;
			Animation.Count.Y = 1;

			BuildingAnimation = Animation;
			ObjectPath = "LotusCraft/3D/Model/Chireiden.mdl";
			BuildingObjectPath = "LotusCraft/3D/Model/None.mdl";
			ConstructionPlannedObjectPath = "LotusCraft/3D/Model/BuildingConstructionPlanned3.mdl";

			Bullets = new string[] {  };

			RequireBuildings = new string[]{
				typeof(HomeBase).FullName,
			};
		}
		public override void OnLoad(IFaction faction)
		{
			AutocasterParams = new AutoCastParameter<IBuilding>[]
			{
				new EnqueueProductionUnitAutoCast(typeof(Satori).FullName,faction.GetUnitParameter(typeof(Satori).FullName).MakingTime, ButtonPosition._1, ButtonPosition._0),
//				new EnqueueProductionUnitAutoCast(typeof(Orin).FullName,faction.GetUnitParameter(typeof(Orin).FullName).MakingTime, ButtonPosition._2, ButtonPosition._0),
				new EnqueueProductionUnitAutoCast(typeof(Oku).FullName,faction.GetUnitParameter(typeof(Oku).FullName).MakingTime, ButtonPosition._3, ButtonPosition._0),
				new DissolveAutoCast(),
			};
			var ShortcutKeywords = new string[]
			{
				"CreateSpecial2",
//				"CreateSpecial3",
				"CreateSpecial4",
			};
			/*
			var SatoriSkillTechButtons = new []{
				new LotusCraft.Button.TechnologyButton<IBuilding>(new LotusCraft.Technology.Black.SatoriSkillTech(ButtonPosition._0,ButtonPosition._0)),
			};
			var OrinSkillTechButtons = new []{
				new LotusCraft.Button.TechnologyButton<IBuilding>(new LotusCraft.Technology.Black.OrinSkillTech(ButtonPosition._1,ButtonPosition._0)),
			};
			var OkuSkillTechButtons = new []{
				new LotusCraft.Button.TechnologyButton<IBuilding>(new LotusCraft.Technology.Black.OkuSkillTech(ButtonPosition._2,ButtonPosition._0)),
			};
			*/
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IBuilding>[]
			{
				/*
				new ButtonParameterHolder<IBuilding> (
					SatoriSkillTechButtons[0],SatoriSkillTechButtons
					),
				new ButtonParameterHolder<IBuilding> (
					OrinSkillTechButtons[0],OrinSkillTechButtons
					),
				new ButtonParameterHolder<IBuilding> (
					OkuSkillTechButtons[0],OkuSkillTechButtons
					),
					*/
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[0].Name), AutocasterParams[0].ButtonPosX, AutocasterParams[0].ButtonPosY,
					shortcutKeyword : ShortcutKeywords[0]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[1].Name), AutocasterParams[1].ButtonPosX, AutocasterParams[1].ButtonPosY,
					shortcutKeyword : ShortcutKeywords[1]
					)
					),
//				new ButtonParameterHolder<IBuilding> (
//					new LotusCraft.Button.CreateUnitByBuildingButton (
//					faction.GetUnitParameter(AutocasterParams[2].Name), AutocasterParams[2].ButtonPosX, AutocasterParams[2].ButtonPosY,
//					shortcutKeyword : ShortcutKeywords[2]
//					)
//					),
				new ButtonParameterHolder<IBuilding> (new LotusCraft.Button.DissolveBuildingButton()),
			};
			/*
			TechnologyParams = SatoriSkillTechButtons
					.Concat(OrinSkillTechButtons)
					.Concat(OkuSkillTechButtons)
					.Select (_=>_.TechParam);
			*/
		}
		public override void OnVanish (IBuilding building)
		{
				building.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.BreakBuildingSE).FullName, building.Pos);
				var faction = building.Faction;
				var offset = new Vector3D(-2, -2, 8);
				var effect = faction.World.EffectManager.CreateEffect(typeof(BreakBuilding).FullName, building.Pos + offset);
				var scale = new Vector3D(25, 25, 25);
				effect.SetScale(scale);
		}

		public override void OnStartConstruction (IBuilding building)
		{
			IEffect effect = null;
			var offset = new Vector3D(0,0,1);
			effect = building.Faction.World.EffectManager.CreateEffect(typeof(Effect.Common.CreateBuildingEffect).FullName,building.Pos + offset);
			var scale = 3.0f * building.Parameter.Size;
			effect.SetScale(new Vector3D(scale,scale,scale));
			building.Completed += () => {if(effect != null){effect.Stop ();effect=null;}};
			building.Destoroyed += () => {
				if(effect != null)
				{
					effect.Stop ();
					effect=null;
				}
			};
		}
		public override void OnCompleted(IBuilding building)
		{
			if(building.Faction.World.CurrentTime > 10)
				building.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.CreatedBuilding).FullName, building.Pos);
			
			base.OnCompleted (building);
		}
	}
}
