﻿ using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Building.General
{
	public class BaseStructure: thrts.BuildingParameter
	{
		public const string FirstBuildingKey = "first_building";

		public BaseStructure ()
		{
			IconPath = "LotusCraft/Image/Button/ProduceResType0";
			Name = "";
			Size = 2;
			ViewRange = 13*32;



			MakingTime = 60*30;

			Costs = new [] {400,0,0,0};

			HP = 1500;

			Exp = 150;


		}

		public override void OnVanish (IBuilding building)
		{
				building.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.BreakBuildingSE).FullName, building.Pos);
		}

		public override void OnCompleted (IBuilding building)
		{
			int counter = 0;
			int inFreeCounter = 0;
			int lastHP = building.HP;
			building.Updating += () =>
			{
				if ((++counter) > Def.FPS) {
					counter = 0;

					// check damage
					if (lastHP != building.HP) {
						inFreeCounter = 0;
						lastHP = building.HP;
						return;
					}

					/// less then 10 sec
					if (inFreeCounter++ < 10) {
						lastHP = building.HP;
						return;
					}

					var Dissolve = building.GetIAutoCastWithName ("Dissolve");
					if (Dissolve != null && Dissolve.IsEnable)
						return;
	
					if (Costs.Sum () > 0 && building.HP < building.MaxHP) {
						int diff = building.MaxHP - building.HP;
						float rate = diff / (float)building.MaxHP;
						if (0.02f < rate) {
							rate = 0.02f;
						}
						int spend = 0;
						for (int i=0; i<this.Costs.Length; ++i) {
							if (Costs [i] <= 0)
								continue;
	
							int reqRes = (int)Math.Ceiling (Costs [i] * rate);
	
							if (building.Faction.GetResource (i) < reqRes)
								reqRes = building.Faction.GetResource (i);
	
							building.Faction.DecResource (i, reqRes);
	
							spend += reqRes;
						}
						if (spend > 0) {
							building.HP += spend * building.MaxHP / Costs.Sum ();
						}
					} else {
						building.HP += building.MaxHP * 2 / 100;
					}

					lastHP = building.HP;
				}
			};

			building.Destoroyed += () =>
			{
			};

			/*
			if (building.Parameter.Capacity) {
				building.IsMPBarShown = true;
				building.MPBarMax = building.Parameter.Capacity;
				building.UnitStayed += (IBuilding arg1, IUnit arg2) => building.MPBarCurrent = arg1.StayedUnitCount;
				building.UnitReleased += (IBuilding arg1, IUnit arg2) => building.MPBarCurrent = arg1.StayedUnitCount;
			}
			*/

			base.OnCompleted(building);
		}
	}
}
