﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.AutoCast;
using LotusCraft.Unit.Green;
using LotusCraft.Effect.Green;

namespace LotusCraft.Building.Green
{
	public class Barrack : General.BaseStructure
	{
		public Barrack ()
		{
			IconPath = "LotusCraft/Image/Button/Green/Building/Barrack";
			Name = "下級魔法陣";
			ButtonDescription += "一般ユニットを作成する魔法陣を建築する。\n";
			ShortcutKeyword = "BuildBarrack";
			Size = 3;

			MakingTime = 48*Def.FPS;
			HP = 2200;
			Armor = 2;
			Supply = 5;
			Costs = new [] {125 ,0,0,0};

			Animation = new TextureAnimation ();
			Animation.Path = "LotusCraft/Image/Building/Green/Barrack";
			Animation.Width = 128;
			Animation.Height = 128;
			Animation.Center.X = 0;
			Animation.Center.Y = -32;
			Animation.CenterPosition = CenterPosition.LowerMiddle;
			Animation.FrameCount = 1;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 1;
			Animation.Count.Y = 1;

			BuildingAnimation = Animation;
			ObjectPath = "LotusCraft/3D/Model/MagicCircleLow.mdl";
			BuildingObjectPath = "LotusCraft/3D/Model/None.mdl";
			ConstructionPlannedObjectPath = "LotusCraft/3D/Model/BuildingConstructionPlanned3.mdl";

			Bullets = new string[] {  };

			RequireBuildings = new string[]{
				typeof(HomeBase).FullName,
			};
		}
		public override void OnLoad(IFaction faction)
		{
			AutocasterParams = new AutoCastParameter<IBuilding>[]
			{
				new EnqueueProductionUnitAutoCast(typeof(Farmer).FullName,faction.GetUnitParameter(typeof(Farmer).FullName).MakingTime, ButtonPosition._0, ButtonPosition._0),
				new EnqueueProductionUnitAutoCast(typeof(Low01).FullName,faction.GetUnitParameter(typeof(Low01).FullName).MakingTime, ButtonPosition._0, ButtonPosition._1),
				new EnqueueProductionUnitAutoCast(typeof(Low02).FullName,faction.GetUnitParameter(typeof(Low02).FullName).MakingTime, ButtonPosition._1, ButtonPosition._0),
				new EnqueueProductionUnitAutoCast(typeof(Low03).FullName,faction.GetUnitParameter(typeof(Low03).FullName).MakingTime, ButtonPosition._2, ButtonPosition._0),
				new EnqueueProductionUnitAutoCast(typeof(Komachi).FullName,faction.GetUnitParameter(typeof(Komachi).FullName).MakingTime, ButtonPosition._1, ButtonPosition._1),
				new EnqueueProductionUnitAutoCast(typeof(Medicine).FullName,faction.GetUnitParameter(typeof(Medicine).FullName).MakingTime, ButtonPosition._2, ButtonPosition._1),
				new EnqueueProductionUnitAutoCast(typeof(Elie).FullName,faction.GetUnitParameter(typeof(Komachi).FullName).MakingTime, ButtonPosition._0, ButtonPosition._2),
				new EnqueueProductionUnitAutoCast(typeof(Kurumi).FullName,faction.GetUnitParameter(typeof(Medicine).FullName).MakingTime, ButtonPosition._1, ButtonPosition._2),
				new EnqueueProductionUnitAutoCast(typeof(FlyFighter).FullName,faction.GetUnitParameter(typeof(FlyFighter).FullName).MakingTime, ButtonPosition._2, ButtonPosition._2),
				new DissolveAutoCast(),
			};
			var ShortcutKeywords = new string[]
			{
				"CreateWorker",
				"CreateSpecial1",
				"CreateClay",
				"CreateWater",
				"CreateSpecial2",
				"CreateSpecial3",
				"CreateElie",
				"CreateKurumi",
				"CreateFighter"
			};

			ButtonParams = new thrts.ButtonParameterHolder<thrts.IBuilding>[]
			{
				new ButtonParameterHolder<IBuilding> (
				new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[0].Name), AutocasterParams[0].ButtonPosX, AutocasterParams[0].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[0]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[1].Name), AutocasterParams[1].ButtonPosX, AutocasterParams[1].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[1]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[2].Name), AutocasterParams[2].ButtonPosX, AutocasterParams[2].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[2]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[3].Name), AutocasterParams[3].ButtonPosX, AutocasterParams[3].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[3]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[4].Name), AutocasterParams[4].ButtonPosX, AutocasterParams[4].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[4]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[5].Name), AutocasterParams[5].ButtonPosX, AutocasterParams[5].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[5]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[6].Name), AutocasterParams[6].ButtonPosX, AutocasterParams[6].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[6]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[7].Name), AutocasterParams[7].ButtonPosX, AutocasterParams[7].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[7]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[8].Name), AutocasterParams[8].ButtonPosX, AutocasterParams[7].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[8]
					)
					),
				new ButtonParameterHolder<IBuilding> (new LotusCraft.Button.DissolveBuildingButton()),
			};
			
			
		}
		public override void OnVanish (IBuilding building)
		{
			building.Faction.World.SoundManager.PlaySoundEffect (typeof(SoundEffect.BreakBuildingSE).FullName, building.Pos);
			var faction = building.Faction;
			var offset = new Vector3D (-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect (typeof(BreakBuilding).FullName, building.Pos + offset);
			var scale = new Vector3D (25, 25, 25);
			effect.SetScale (scale);
			/*
			if (faction.UserValues.ContainsKey (Button.CreateBuildingByUnitButton.BuildingCurrentKey)) {
				var curDic = faction.UserValues [Button.CreateBuildingByUnitButton.BuildingCurrentKey] as Dictionary<string,int>;
			
				if (curDic.ContainsKey (typeof(Barrack).FullName))
					curDic [typeof(Barrack).FullName]--;
			}
*/
		}

		public override void OnStartConstruction(IBuilding building)
		{
			/*
			var faction = building.Faction;
			if (!faction.UserValues.ContainsKey (Button.CreateBuildingByUnitButton.BuildingMaxKey)) {
				faction.UserValues.Add (Button.CreateBuildingByUnitButton.BuildingMaxKey, new Dictionary<string,int> ());
			}
			var maxDic = faction.UserValues [Button.CreateBuildingByUnitButton.BuildingMaxKey] as Dictionary<string,int>;
			if (!faction.UserValues.ContainsKey (Button.CreateBuildingByUnitButton.BuildingCurrentKey)) {
				faction.UserValues.Add (Button.CreateBuildingByUnitButton.BuildingCurrentKey, new Dictionary<string,int> ());
			}
			var curDic = faction.UserValues [Button.CreateBuildingByUnitButton.BuildingCurrentKey] as Dictionary<string,int>;
			
			if (!curDic.ContainsKey (typeof(Barrack).FullName))
				curDic.Add (typeof(Barrack).FullName, 0);
			if (!maxDic.ContainsKey (typeof(Barrack).FullName))
				maxDic.Add (typeof(Barrack).FullName, 0);

			if (curDic [typeof(Barrack).FullName] >= maxDic [typeof(Barrack).FullName])
			{
				building.CancelProgress();
				return;
			}

			curDic [typeof(Barrack).FullName]++;
			*/

			IEffect effect = null;
			var offset = new Vector3D(0, 0, 1);
			effect = building.Faction.World.EffectManager.CreateEffect(typeof(Effect.Common.CreateBuildingEffect).FullName, building.Pos + offset);
			var scale = 3.0f * building.Parameter.Size;
			effect.SetScale(new Vector3D(scale, scale, scale));
			building.Completed += () => { if (effect != null) { effect.StopRoot(); effect = null; } };
			building.Destoroyed += () =>
			{
				if (effect != null)
				{
					effect.Stop();
					effect = null;
				}
			};
		}

		public override void OnCompleted(IBuilding building)
		{
			IEffect effect = null;

			building.Updating += () =>
			{
				if (effect == null)
				{
					effect = building.Faction.World.EffectManager.CreateEffect(
							typeof(Effect.Green.Barracks).FullName,
							new Vector3D(building.Pos.X, building.Pos.Y, building.Pos.Z + 16));
				}
			};

			building.Destoroyed += () =>
			{
				if (effect != null)
				{
					effect.Stop();
				}
			};

			BuildingUtls.ShowComplete(building);
			
			base.OnCompleted (building);
		}
	}
}
