﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Red;
using LotusCraft.Bullet.Red;
using LotusCraft.Unit.Red;

namespace LotusCraft.Building.Red
{
	public class ProduceResType1 : General.ProduceResources<HomeBase,CollectPowerStone>
	{
		static string defenceUnitKindName = typeof(Unit.Common.Patchouli).FullName;
		
		
		public ProduceResType1 ()
		{
			IconPath = "LotusCraft/Image/Button/ProduceResType1";
			Name = "霊力回収施設";
			ShortcutKeyword = "BuildOratory";
			Size = 2;

//			Bullets = new string[] { typeof(ResType1Bullet).FullName };

			HP = 1000;

			Exp = 300;


			MakingTime = 30*30;
			Costs = new [] {80,0,0,0};

			ButtonDescription += "霊石から資源を回収することができる。\n作業者を付随させることで回収を早められる。\n近辺に本拠地が必要である。";

			EnableBuildingOnResourceKindSequence =  new []{1};

			Animation = new TextureAnimation ();
			Animation.Path = "LotusCraft/Image/Building/Red/Barrack";
			Animation.Width = 128;
			Animation.Height = 128;
			Animation.Center.X = 0;
			Animation.Center.Y = -32;
			Animation.CenterPosition = CenterPosition.LowerMiddle;
			Animation.FrameCount = 1;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 1;
			Animation.Count.Y = 1;

			BuildingAnimation = Animation;
			ObjectPath = "LotusCraft/3D/Model/PowerStoneCollector.mdl";
			BuildingObjectPath = "LotusCraft/3D/Model/None.mdl";
			ConstructionPlannedObjectPath = "LotusCraft/3D/Model/BuildingConstructionPlanned2.mdl";

			DoesRequireWorkerToTouch = true;
			Capacity = 6;
		}
		
		public override void OnLoad (IFaction faction)
		{
			correctPerSec = 1.5f;
			incPerFarmer = 0.25f;

			AutocasterParams = new AutoCastParameter<IBuilding>[]{
				new LotusCraft.AutoCast.DissolveAutoCast(),
			};


			ButtonParams = new thrts.ButtonParameterHolder<thrts.IBuilding>[]
			{
				new ButtonParameterHolder<IBuilding> (new LotusCraft.Button.UnStationButton()),
				new ButtonParameterHolder<IBuilding> (new LotusCraft.Button.DissolveBuildingButton()),
				new ButtonParameterHolder<IBuilding> (
				new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(defenceUnitKindName), ButtonPosition._2, ButtonPosition._0,
					shortcutKeyword: "CreateDefender"
					)
				),
			};
			

		}
		public override void OnVanish (IBuilding building)
		{
				building.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.BreakBuildingSE).FullName, building.Pos);
				var faction = building.Faction;
				var offset = new Vector3D(-2, -2, 8);
				var effect = faction.World.EffectManager.CreateEffect(typeof(BreakBuilding).FullName, building.Pos + offset);
				var scale = new Vector3D(25, 25, 25);
				effect.SetScale(scale);
		}
		public override void OnStartConstruction(IBuilding building)
		{
			IEffect effect = null;
			var offset = new Vector3D(0, 0, 1);
			effect = building.Faction.World.EffectManager.CreateEffect(typeof(Effect.Common.CreateBuildingEffect).FullName, building.Pos + offset);
			var scale = 3.0f * building.Parameter.Size;
			effect.SetScale(new Vector3D(scale, scale, scale));
			building.Completed += () => { if (effect != null) { effect.StopRoot(); effect = null; } };
			building.Destoroyed += () =>
			{
				if (effect != null)
				{
					effect.Stop();
					effect = null;
				}
			};
		}

		public override void OnCompleted(IBuilding building)
		{
			BuildingUtls.ShowComplete(building);
			
			base.OnCompleted (building);
		}
	}
}
