﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using thrts;

namespace LotusCraft.Bullet.Common
{
	public class Changebullet : General.LongRangeBullet
	{
		public Changebullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			this.Attack = 24;
			DamageBonus[(int)TargetObjectType.Hero] =  1.25f;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			Gravity = 0.75f;
			MaxRange = 6 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.5f * Def.FPS);
			AttackRigor = (int)(0.0f * Def.FPS);
			AttackSpeed =  (int)(1.5f * Def.FPS);
			OnCreated = OnCreate;
			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 0;
			TextureAnimation.Center.Y = 0;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 1;
			TextureAnimation.Offset.X = 128 * 2 + 16 * 0;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 5;
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.taihou).FullName, bullet.Position);
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalBlue);
		}
	}
}