﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using LotusCraft.Unit;
using LotusCraft.Building.General;

namespace LotusCraft.COM
{
	public class Common : thrts.COM
	{
		/// <summary>
		/// デバッグ
		/// </summary>
		public static void Debug(thrts.ICOMController com)
		{
			//com.World.Factions[0].SetResource(0, com.Faction.GetResource(0) + 1000);
			//com.World.Factions[0].SetResource(1, com.Faction.GetResource(1) + 1000);
		}

		public static void Cheat(thrts.ICOMController com, int time, ref bool instant, ref int uniquestart, bool green = false)
		{
			{
				if (com.Difficulty == thrts.COMDifficulty.Lunatic && time % (30 * 30) == 0)
				{
					if (time == 0) com.Faction.IncResource(0, 150);
					instant = true; uniquestart = 0;
					int getr = Math.Min(time / (30 * 60) + 1, 10);
					int getr2 = getr;
					com.Faction.IncResource(0, 30 * getr);
					com.Faction.IncResource(1, 30 * getr2);
				}
				if (com.Difficulty == thrts.COMDifficulty.Hard && time % (30 * 30) == 0)
				{
					if (time == 0) com.Faction.IncResource(0, 50);
					int getr = Math.Min(time / (30 * 75) + 1, 10);
					int getr2 = getr;
					com.Faction.IncResource(0, 10 * getr);
					com.Faction.IncResource(1, 10 * getr2);
				}
			}
			if (!green)
			{
				if (com.Difficulty == thrts.COMDifficulty.Easy && time % (30 * 4) == 0)
				{
					if (time == 0) com.Faction.IncResource(0, -150);
					instant = false; uniquestart = 60;
					int getr = Math.Min(time / (30 * 60) + 1, 5);
					if (time > (30 * 600)) getr -= 1;
					int getr2 = getr - 2;
					if (getr2 < 0) getr2 = 0;
					if (com.Faction.GetResource(0) >= 20) com.Faction.IncResource(0, -5 * getr);
					if (com.Faction.GetResource(1) >= 20) com.Faction.IncResource(1, -5 * getr2);
				}
			}
			else
			{
				if (com.Difficulty == thrts.COMDifficulty.Easy && time % (30 * 4) == 0)
				{
					if (time == 0) com.Faction.IncResource(0, -150);
					instant = false; uniquestart = 60;
					int getr = Math.Min(time / (30 * 50) + 1, 6);
					if (time > (30 * 600)) getr -= 1;
					int getr2 = getr - 2;
					if (getr2 < 0) getr2 = 0;
					if (com.Faction.GetResource(1) <= 100 && getr2 > 1) getr2 = 1;
					if (com.Faction.GetResource(0) >= 20) com.Faction.IncResource(0, -5 * getr);
					if (com.Faction.GetResource(1) >= 20) com.Faction.IncResource(1, -5 * getr2);
				}
			}
		}

		/// <summary>
		/// 農民作成
		/// </summary>
		public static void CreateFarmer(thrts.ICOMController com)
		{
			var homebases = com.GetMyBuildings(_ => IsHome(_.Parameter) && !_.HasProductionQueue());

			foreach (var home in homebases)
			{
				var button = home.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
				button.CreateUnitEvent(home, false);
				break;
			}
		}

		/// <summary>
		/// ユニット作成
		/// </summary>
		public static void CreateUnit(thrts.ICOMController com, Type b, Type u, string fac, int max = 1)
		{
			var bs = com.GetMyBuildings(_ => _.Parameter.GetType() == b && !_.HasProductionQueue());
			int count = 0;

			foreach (var baseb in bs)
			{
				thrts.ButtonParameter<thrts.IBuilding> button = null;
				#region Red
				if (fac == "Red")
				{
					if (u == typeof(LotusCraft.Unit.Red.Unique.Sanae))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._1);
					else if (u == typeof(LotusCraft.Unit.Red.Low01))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._1, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Red.Low02))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._2, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Red.Kanako))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Red.Flandre))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._1, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Red.Suwako))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._2, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Red.Namazu))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._3, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Red.FlyBomber))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
					else if (b != typeof(LotusCraft.Building.Red.HomeBase))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
				}
				#endregion
				#region White
				if (fac == "White")
				{
					if (u == typeof(LotusCraft.Unit.White.Unique.Reimu))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._1);
					else if (u == typeof(LotusCraft.Unit.White.Low02))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._1, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.White.Low03))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._2, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.White.Kaguya))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.White.Toramaru))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._1, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.White.Murasa))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._2, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.White.Reisen))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._3, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.White.FlyBomber))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
					else if (b != typeof(LotusCraft.Building.White.HomeBase))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
				}
				#endregion
				#region Green
				if (fac == "Green")
				{
					if (u == typeof(LotusCraft.Unit.Green.Unique.Alice))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._2);
					else if (u == typeof(LotusCraft.Unit.Green.Farmer))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Green.Low01))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._1);
					else if (u == typeof(LotusCraft.Unit.Green.Low02))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._1, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Green.Low03))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._2, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Green.Komachi))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._1, thrts.ButtonPosition._1);
					else if (u == typeof(LotusCraft.Unit.Green.Medicine))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._2, thrts.ButtonPosition._1);
					else if (b != typeof(LotusCraft.Building.Green.HomeBase))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
				}
				#endregion

#if !_TRIAL
				#region Blue
				if (fac == "Blue")
				{
					if (u == typeof(LotusCraft.Unit.Blue.Unique.Mystia))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._1, thrts.ButtonPosition._2);
					else if (u == typeof(LotusCraft.Unit.Blue.Unique.Chirno))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._1, thrts.ButtonPosition._1);
					else if (u == typeof(LotusCraft.Unit.Blue.Low02))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._1, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Blue.Low03))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._2, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Blue.Iku))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Blue.Sunny))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._1, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Blue.Lunar))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._2, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Blue.Star))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._3, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Blue.FlyBomber))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
					else if (b != typeof(LotusCraft.Building.Blue.HomeBase))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
				}
				#endregion
				#region Black
				if (fac == "Black")
				{
					if (u == typeof(LotusCraft.Unit.Black.Unique.Yuyuko))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._2);
					else if (u == typeof(LotusCraft.Unit.Black.Low02))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Black.Low03))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Black.Youmu))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Black.Satori))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._1, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Black.Orin))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._2, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Black.Oku))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._3, thrts.ButtonPosition._0);
					else if (u == typeof(LotusCraft.Unit.Black.FlyBomber))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
					else if (b != typeof(LotusCraft.Building.Black.HomeBase))
						button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
				}
				#endregion
#endif
				if (button != null) button.CreateUnitEvent(baseb, false);
				count++;
				if (count >= max) break;
			}
		}

		/// <summary>
		/// 研究
		/// </summary>
		public static void PushTech(thrts.ICOMController com, Type b, string tech)
		{
			if (tech == "弾幕指南")
				if (com.Faction.IsSatisfyTechnologies(new[] { typeof(LotusCraft.Technology.Red.GunLv1Tech).FullName })) return;
			if (tech == "鍛冶")
				if (com.Faction.IsSatisfyTechnologies(new[] { typeof(LotusCraft.Technology.Red.CannonAtkLv1Tech).FullName })) return;
			


			var bs = com.GetMyBuildings(_ => _.Parameter.GetType() == b && !_.HasProductionQueue() && _.IsComplete);

			thrts.ButtonParameter<thrts.IBuilding> button = null;

			foreach (var baseb in bs)
			{
				if (tech == "弾幕指南")
					button = baseb.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._0);
				if (tech == "鍛冶")
					button = baseb.TryGetButtonParameter(thrts.ButtonPosition._1, thrts.ButtonPosition._0);

				if (button == null) return;
				button.CreateUnitEvent(baseb, false);
				
				//baseb.AddCreationOfTechnology(tech, tech);
			}
		}

		/// <summary>
		/// 資源回収施設作成
		/// </summary>
		public static int CreateResource(thrts.ICOMController com, Type b, thrts.Vector3D Initpos, int around, int allcount = 1)
		{
			var buildingParam = com.Faction.GetBuildingParameter(b.FullName);
			int need = buildingParam.Costs[0];
			int count = 0;

			var resources = com.World.ResourceManager.GetResources(_ => Common.GetRinTip(_.Pos, Initpos) < around);
			foreach (var r in resources)
			{
				thrts.Vector3D pos = r.Pos;

				var farmer = com.GetMyUnits(_ => IsFarmer(_.Parameter)).Where(__ => IsFree(__)).FirstOrDefault();
				if (farmer != null)
				{
					var tipX = (int)(pos.X / thrts.Def.MapTipLengthOnField);
					var tipY = (int)(pos.Y / thrts.Def.MapTipLengthOnField);

					thrts.IBuilding building = null;

					farmer.StartBuilding(buildingParam, new thrts.Point2D(tipX, tipY), out building);
					
					if (building != null)
					{
						need = 0;
					}
					else need = buildingParam.Costs[0];

					if (building != null)
					{
						count++;
						if (count >= allcount) break;
					}
				}
			}
			return need;
		}

		/// <summary>
		/// 建物作成
		/// </summary>
		public static int CreateBuilding(thrts.ICOMController com, Type b, thrts.Vector3D pos, int aroundmin, int around, int time)
		{
			var buildingParam = com.Faction.GetBuildingParameter(b.FullName);
			int need = buildingParam.Costs[0];

			var farmer = com.GetMyUnits(_ => IsFarmer(_.Parameter)).Where(__ => IsFree(__)).FirstOrDefault();
			if (farmer != null)
			{
				/*thrts.ButtonParameter<thrts.IUnit> button = null;
				if (b == typeof(Barrack))
					button = farmer.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._2);
				if (b == typeof(BlackSmith))
					button = farmer.TryGetButtonParameter(thrts.ButtonPosition._0, thrts.ButtonPosition._3);
				var e = button.CreateBuildingEvent(farmer);
				var buildingParam = com.Faction.GetBuildingParameter(e);*/
				
				var tipX = (int)(pos.X / thrts.Def.MapTipLengthOnField);
				var tipY = (int)(pos.Y / thrts.Def.MapTipLengthOnField);
				//int tipX = posX;
				//int tipY = posY;

				var rand = (time / 60) % 10;

				for (int i = 0; i < 50; i++)
				{
					var x_ = com.NextRand(aroundmin, around);
					if (com.NextRand() % 2 == 1) x_ = -x_;

					var y_ = com.NextRand(aroundmin, around);
					if (com.NextRand() % 2 == 1) y_ = -y_;

					/*var building = com.World.BuildingManager.Create(
						b.FullName,
						com.Faction,
						x_ + tipX,
						y_ + tipY,
						0,
						null);

					button.EndBuilding(farmer);*/

					thrts.IBuilding building = null;

					if (com.HasObstacleToBuild(buildingParam, new thrts.Point2D(x_ + tipX, y_ + tipY), buildingParam.Size + 2)) continue;

					farmer.StartBuilding(buildingParam, new thrts.Point2D(x_ + tipX, y_ + tipY), out building);

					if (building != null)
					{
						//com.World.UnitManager.SelectTarget(new[] { farmer }, building, false);
						need = 0;
						break;
					}
					else need = buildingParam.Costs[0];
				}
			}
			return need;
		}

		/// <summary>
		/// 農民の資源収集
		/// </summary>
		public static void CollectResource(thrts.ICOMController com, int plus = 18)
		{
			var farmers = com.GetMyUnits(_ => IsFarmer(_.Parameter)).Where(__ => !__.IsEscaping && __.ActualAction == thrts.UnitAction.Free && !__.HasNextOrder());

			if (farmers.Count() > 0)
			{
				var sake = com.GetMyBuildings(_ => _.Parameter.Name == "酒回収施設");
				var isi = com.GetMyBuildings(_ => _.Parameter.Name == "霊力回収施設");

				var scount = sake.Sum(_ => _.WorkerCount);
				var icount = isi.Sum(_ => _.WorkerCount);

				if (scount < icount + plus)
				{
					foreach (var farmer in farmers)
					{
						foreach (var s in sake)
						{
							if (s.IsComplete && s.WorkerCount < 6)
							{
								com.World.UnitManager.SelectTarget(new[] { farmer }, s, false);
								return;
							}
						}
					}
					foreach (var farmer in farmers)
					{
						foreach (var s in isi)
						{
							if (s.IsComplete && s.WorkerCount < 6)
							{
								com.World.UnitManager.SelectTarget(new[] { farmer }, s, false);
								return;
							}
						}
					}
				}
				else
				{
					foreach (var farmer in farmers)
					{
						foreach (var s in isi)
						{
							if (s.IsComplete && s.WorkerCount < 6)
							{
								com.World.UnitManager.SelectTarget(new[] { farmer }, s, false);
								return;
							}
						}
					}
					foreach (var farmer in farmers)
					{
						foreach (var s in sake)
						{
							if (s.IsComplete && s.WorkerCount < 6)
							{
								com.World.UnitManager.SelectTarget(new[] { farmer }, s, false);
								return;
							}
						}
					}
				}
					
			}
		}

		/// <summary>
		/// 建築失敗した建物の再建築
		/// </summary>
		public static void ReBuild(thrts.ICOMController com, ref float LastProgress, ref thrts.IBuilding LastBuilding)
		{
			var building = com.GetMyBuildings(_ => _.GetProgress == 0).FirstOrDefault();
			if (building == null) building = com.GetMyBuildings(_ => !_.IsComplete).FirstOrDefault();

			if (building != null)
			{
				if (LastProgress == building.GetProgress && LastBuilding == building)
				{
					var farmer = com.GetMyUnits(_ => Common.IsFarmer(_.Parameter)).Where(__ => Common.IsFree(__)).FirstOrDefault();
					if (farmer != null)
					{
						com.World.UnitManager.SelectTarget(new[] { farmer }, building, false);
						LastProgress = -1;
						LastBuilding = null;
					}
				}
				else
				{
					LastProgress = building.GetProgress;
					LastBuilding = building;
				}
			}
			else
			{
				LastBuilding = null;
				LastProgress = -1;
			}
		}

		/// <summary>
		/// フラグ作成
		/// </summary>
		public static void SetFlag(Dictionary<string, bool> flag, string s)
		{
			if (!flag.ContainsKey(s)) flag.Add(s, true);
		}

		/// <summary>
		/// フリーユニットか　資源収集もフリー扱い
		/// </summary>
		public static bool IsFree(thrts.IUnit u)
		{
			if (!u.IsEscaping && u.ActualAction == thrts.UnitAction.Free && !u.HasNextOrder())
			{
				return true;
			}
			if (u.IsAlcoholIconShowing) return true;
			return false;
		}

		/// <summary>
		/// 拠点か
		/// </summary>
		public static bool IsHome(thrts.BuildingParameter b)
		{
			Type t = b.GetType();
			if (t == typeof(Building.White.HomeBase) ||
						 t == typeof(Building.Red.HomeBase) ||
						 t == typeof(Building.Blue.HomeBase) ||
						 t == typeof(Building.Green.HomeBase) ||
						 t == typeof(Building.Black.HomeBase))
				return true;
			return false;
		}

		/// <summary>
		/// 農民か
		/// </summary>
		public static bool IsFarmer(thrts.UnitParameter u)
		{
			Type t = u.GetType();
			if (t == typeof(Unit.White.Farmer) ||
						 t == typeof(Unit.Red.Farmer) ||
						 t == typeof(Unit.Green.Farmer) ||
						 t == typeof(Unit.Black.Farmer) ||
						 t == typeof(Unit.Blue.Farmer))
				return true;
			return false;
		}

		/// <summary>
		/// 距離取得(マップチップ単位)
		/// </summary>
		public static int GetRinTip(thrts.Vector3D a, thrts.Vector3D b)
		{
			return (int)(Math.Sqrt((a.X - b.X) * (a.X - b.X) + (a.Y - b.Y) * (a.Y - b.Y)) / thrts.Def.MapTipLengthOnField);
		}

		/// <summary>
		/// 距離取得
		/// </summary>
		public static int GetR(thrts.Vector3D a, thrts.Vector3D b)
		{
			return (int)(Math.Sqrt((a.X - b.X) * (a.X - b.X) + (a.Y - b.Y) * (a.Y - b.Y)));
		}

		/// <summary>
		/// レベルアップ
		/// </summary>
		public static void LVUP(thrts.IUnit uni, string name)
		{
			var s = uni.GetSpellWithName(name);
			if (s.Level != s.MaxLevel && uni.GetLevel() >= s.RequireLevel)
				uni.LvUpSpellWithName(name);
		}

		/// <summary>
		/// クリーピング
		/// </summary>
		public static void Creeping(thrts.ICOMController com, thrts.IUnit uni, bool instant, Dictionary<string, bool> flag, thrts.Vector3D InitPos, thrts.Vector3D EnPos, thrts.Vector3D GatherPos, ref thrts.Vector3D AlterPos, int time, ref int stoptime)
		{
			if (uni == null) return;
			if (!flag.ContainsKey("狩り終了") && !flag.ContainsKey("狩り一時終了"))
			{
				if (stoptime > 0) { stoptime--; return; }
				bool enunique = com.GetEnemyUnits(_ => _.Parameter.IsUnique).Count() > 0;
				bool toenemy = true;
				IEnumerable<thrts.ITargetObject> targets = null;
				if (!enunique && instant && time < (30 * 130)) targets = uni.Faction.World.GetObjectFromCircle(new thrts.Circle2D(45 * 32, new thrts.Vector2D(EnPos.X, EnPos.Y)));
				else
				{
					toenemy = false;
					targets = uni.Faction.World.GetObjectFromCircle(new thrts.Circle2D(55 * 32, new thrts.Vector2D(InitPos.X, InitPos.Y)));

					foreach (thrts.IUnit u in targets.OfType<thrts.IUnit>().Where(_ => _.Faction.IsNeutral && _.HP >= 300))
					{
						int r = Common.GetRinTip(u.Pos, InitPos);
						if (r < 15) AlterPos = GatherPos;
					}
				}
				int range = 100000; thrts.IUnit tu = null;
				while (true)
				{
					foreach (thrts.IUnit u in targets.OfType<thrts.IUnit>().Where(_ => _.Faction.IsNeutral && _.HP <= 200))
					{
						int r = Common.GetR(u.Pos, InitPos);
						if (r < range + u.HP * 30)
						{
							var hps = uni.Faction.World.GetObjectFromCircle(new thrts.Circle2D(8 * 32, new thrts.Vector2D(u.Pos.X, u.Pos.Y))).Where(_ => _.Faction != null && _.Faction.IsNeutral);
							if (hps.OfType<thrts.IUnit>().Sum(_ => _.HP) >= 1000) continue;
							if (hps.OfType<thrts.IUnit>().Any(_ => _.HP > 400 && _.Parameter.Armor > 0)) continue;
							if (toenemy && hps.OfType<thrts.IUnit>().Any(_ => _.HP > 200)) continue;

							range = r + u.HP * 30;
							tu = u;
						}
					}
					if (tu == null && !enunique)
					{
						enunique = true;
						toenemy = false;
						targets = uni.Faction.World.GetObjectFromCircle(new thrts.Circle2D(55 * 32, new thrts.Vector2D(InitPos.X, InitPos.Y)));
						continue;
					}
					break;
				}
				if (tu != null)
				{
					var lows = com.GetMyUnits(_ => !Common.IsFarmer(_.Parameter) && !_.UserValues.ContainsKey("com攻撃")).ToArray();
					foreach (var low in lows)
					{
						var lowtarget = low.GetTarget();
						var lowtargetu = lowtarget as thrts.IUnit;
						if (low.Parameter.IsUnique/* || lows.Where(_ => !_.Parameter.IsUnique).Sum(_ => _.Parameter.Exp) > 70*/)
						{
							if ((lowtargetu != null && lowtargetu.Faction.IsNeutral && lowtargetu.HP > 200))
							{
								stoptime = 6;
								com.World.UnitManager.SelectTarget(new[] { low }, new thrts.Vector2D(tu.Pos.X, tu.Pos.Y), false);
							}
							else if (!low.Parameter.IsUnique && low.GetTarget() == low && low.Parameter.Costs[1] == 0)
							{
								stoptime = 6;
								com.World.UnitManager.SelectTarget(new[] { low }, new thrts.Vector2D(GatherPos.X, GatherPos.Y), false);
							}
							else if (low.Parameter.IsUnique && low.HP * 100 / low.MaxHP < 40)
							{
								Common.SetFlag(flag, "狩り一時終了");
							}
							else if (low.Parameter.IsUnique && low.HP * 100 / low.MaxHP < 50 && lowtargetu != null && lowtargetu.HP > 70)
							{
								Common.SetFlag(flag, "狩り一時終了");
							}
							else if (time % 90 == 10 && (low.ActualAction != thrts.UnitAction.Attack || lowtarget is thrts.IBuilding))
							{
								com.World.UnitManager.AttackMove(new[] { low.UniqueID }, tu, false);
							}
						}
					}
					if (flag.ContainsKey("狩り終了") || flag.ContainsKey("狩り一時終了"))
					{
						foreach (var low in lows)
						{
							com.World.UnitManager.SelectTarget(new[] { low }, new thrts.Vector2D(GatherPos.X, GatherPos.Y), false);
							if (low.UserValues.ContainsKey("集合済み"))
								low.UserValues.Remove("集合済み");
						}
					}
				}
				else
				{
					var lows = com.GetMyUnits(_ => !Common.IsFarmer(_.Parameter) && !_.UserValues.ContainsKey("com攻撃")).ToArray();
					bool stop = false;
					foreach (var low in lows)
					{
						var lowtarget = low.GetTarget();
						var lowtargetu = lowtarget as thrts.IUnit;
						if (low.Parameter.IsUnique && (low.ActualAction == thrts.UnitAction.Free || lowtarget is thrts.IBuilding || (lowtargetu != null && lowtargetu.Faction.IsNeutral && lowtargetu.HP > 200)))
						{
							stop = true;
						}
						if (low.Parameter.IsUnique && low.HP * 100 / low.MaxHP < 40)
						{
							stop = true;
						}
						else if (!low.Parameter.IsUnique && low.GetTarget() == low && low.Parameter.Costs[1] == 0)
						{
							stoptime = 6;
							com.World.UnitManager.SelectTarget(new[] { low }, new thrts.Vector2D(GatherPos.X, GatherPos.Y), false);
						}
					}
					if (stop)
					{
						foreach (var low in lows)
						{
							Common.SetFlag(flag, "狩り終了");
							com.World.UnitManager.SelectTarget(new[] { low }, new thrts.Vector2D(GatherPos.X, GatherPos.Y), false);
							if (low.UserValues.ContainsKey("集合済み"))
								low.UserValues.Remove("集合済み");
						}
					}
				}
			}
			if (flag.ContainsKey("狩り一時終了"))
			{
				if (uni.HP == uni.MaxHP)
					flag.Remove("狩り一時終了");
			}
		}

		/// <summary>
		/// 攻め
		/// </summary>
		public static void Attack(thrts.ICOMController com, ref int threshold, ref thrts.Vector2D AttackPos, thrts.Vector3D GatherPos, thrts.Vector3D EnPos, thrts.Vector3D GatherFirstPos)
		{
			var lows = com.GetMyUnits(_ => !Common.IsFarmer(_.Parameter) && _.ActualAction == thrts.UnitAction.Free).ToArray();

			foreach (var low in lows)
			{
				if (low.UserValues.ContainsKey("com攻撃"))
				{
					int atime = (int)low.UserValues["com攻撃"];
					low.UserValues["com攻撃"] = atime - 35;
					if (atime <= 0)
					{
						low.UserValues.Remove("com攻撃");
						if (low.UserValues.ContainsKey("com援軍"))
						{
							low.UserValues.Remove("com援軍");
						}
					}
				}
			}

			var nextattacker = lows.Where(_ => !_.UserValues.ContainsKey("com攻撃"));
			var attackcount = Common.GetPower(nextattacker);

			var ens = com.GetEnemyBuildings(_ =>
					 _.Parameter.GetType() == typeof(Building.White.HomeBase) ||
					 _.Parameter.GetType() == typeof(Building.Red.HomeBase) ||
					 _.Parameter.GetType() == typeof(Building.Blue.HomeBase) ||
					 _.Parameter.GetType() == typeof(Building.Green.HomeBase) ||
					 _.Parameter.GetType() == typeof(Building.Black.HomeBase)).Where(_ => _.GetProgress > 0 || _.IsComplete).OrderBy(_ => Common.GetR(_.Pos, EnPos));

			var en = ens.FirstOrDefault();

			if (com.Difficulty == thrts.COMDifficulty.Hard || com.Difficulty == thrts.COMDifficulty.Lunatic)
			{
				if (en != null && ens.Count() > 1)
				{
					en = ens.Where(_ => _ != en).FirstOrDefault();
				}
			}

			// 突撃
			if (attackcount > threshold || en == null)
			{
				{
					//加減
					int nowpower = 0;
					int nowthreshold = attackcount - 620;

					if (threshold < 1600) threshold += 200;

					var my = com.GetMyBuildings(_ => Common.IsHome(_.Parameter)).FirstOrDefault();

					thrts.IBuilding targetb = null;
					thrts.IUnit targetu = null;

					if (my == null || en == null)
					{
						var ebu = com.GetEnemyUnits(_ => !_.Faction.IsNeutral);
						if (ebu.Count() > 0) targetu = ebu.First();
					}

					if ((my != null && en != null) || targetu != null)
					{
						if (my != null && en != null)
						{
							var ebs = com.GetEnemyBuildingsOnPathway(new thrts.Vector2D(my.Pos.X, my.Pos.Y), new thrts.Vector2D(en.Pos.X, en.Pos.Y));

							foreach (var eb in ebs)
							{
								if (!eb.Faction.IsNeutral && eb.Exists() && eb.GetProgress > 0) { targetb = eb; break; }
							}
						}

						foreach (var low in lows)
						{
							if (targetb == null && targetu == null) break;

							//加減
							if (com.Difficulty == thrts.COMDifficulty.Easy)
								if (!low.Parameter.IsUnique)
								{
									int thispower = GetPower(new[] { low });
									nowpower += thispower;
									if (nowpower > nowthreshold && thispower > 0) continue;
								}
							

							var pos = low.Pos;
							thrts.Vector3D targetPos = new thrts.Vector3D(0, 0, 0);
							if (targetb != null) targetPos = targetb.Pos;
							else if (targetu != null) targetPos = targetu.Pos;

							var dx = targetPos.X - pos.X;
							var dy = targetPos.Y - pos.Y;

							var len = Math.Sqrt(dx * dx + dy * dy);

							dx = dx * 32.0f * 25 / (float)len;
							dy = dy * 32.0f * 25 / (float)len;

							if (!low.UserValues.ContainsKey("com攻撃"))
								low.UserValues.Add("com攻撃", (int)100);

							//com.World.UnitManager.SelectTarget(new[] { low }, new thrts.Vector2D(dx + pos.X, dy + pos.Y), false);

							if (targetb != null)
							{
								AttackPos = new thrts.Vector2D(targetb.Pos.X, targetb.Pos.Y);
								if (low.Parameter.Speed < thrts.UnitParameter.BasisSpeed * 1.35f)
									com.World.UnitManager.AttackMove(new[] { low.UniqueID }, AttackPos, false);
								else
								{
									com.World.UnitManager.AttackMove(new[] { low.UniqueID }, new thrts.Vector2D(GatherFirstPos.X, GatherFirstPos.Y), false);
									com.World.UnitManager.AttackMove(new[] { low.UniqueID }, AttackPos, true);
								}
							}
							else if (targetu != null) com.World.UnitManager.AttackMove(new[] { low.UniqueID }, targetu, false);
						}
					}
				}
			}
		}

		/// <summary>
		/// 援軍と逃走
		/// </summary>
		public static void ReinforceAndRun(thrts.ICOMController com, int threshold, ref thrts.Vector2D AttackPos, thrts.Vector3D GatherPos, int time, bool dorun = true)
		{
			if (com.Difficulty == thrts.COMDifficulty.Easy) return;
			var attakings = com.GetMyUnits(_ => !Common.IsFarmer(_.Parameter) && _.UserValues.ContainsKey("com攻撃") && !_.UserValues.ContainsKey("com援軍"));
			int attakingcount = GetPower(attakings);
			int px = 0, py = 0, enemycount = 0, allyscount = 0;
			bool running = false;
			IEnumerable<thrts.IUnit> lows = null;
			IEnumerable<thrts.IUnit> nextattacker = null;
			IEnumerable<thrts.IUnit> enemyunit = null;
			IEnumerable<thrts.IUnit> allyunit = null;
			if (attakings == null || attakings.Count() == 0 || attakingcount < 150)
			{
				//run = true;
				//attakings = com.GetMyUnits(_ => !Common.IsFarmer(_.Parameter) && _.UserValues.ContainsKey("com逃走"));
				//if (attakings == null || attakings.Count() == 0) return;
			}
			else
			{
				lows = com.GetMyUnits(_ => !Common.IsFarmer(_.Parameter));
				nextattacker = lows.Where(_ => !_.UserValues.ContainsKey("com攻撃") && _.ActualAction == thrts.UnitAction.Free);
				var reinforces = attakings.Where(_ => _.UserValues.ContainsKey("com援軍"));
				if (attakings != null && attakings.Count() > 0)
				{
					px = (int)attakings.Average(_ => _.Pos.X);
					py = (int)attakings.Average(_ => _.Pos.Y);
				}
				else if (reinforces != null && reinforces.Count() > 0)
				{
					if (GetPower(reinforces) > 1200)
					{
						px = (int)reinforces.Average(_ => _.Pos.X);
						py = (int)reinforces.Average(_ => _.Pos.Y);
					}
				}
				if (px != 0 || py != 0)
				{
					var nearunits = com.Faction.World.GetObjectFromCircle(new thrts.Circle2D(15 * 32, new thrts.Vector2D(px, py))).OfType<thrts.IUnit>().Where(_ => !_.Faction.IsNeutral);
					enemyunit = nearunits.Where(_ => !com.Faction.World.IsSameTeam(com.Faction, _.Faction));
					allyunit = nearunits.Where(_ => com.Faction.World.IsSameTeam(com.Faction, _.Faction));
					enemycount = GetPower(enemyunit, time);
					allyscount = GetPower(allyunit, time);

					var uni = attakings.Where(_ => _.Parameter.IsUnique).FirstOrDefault();
					if (uni != null && uni.Exists())
					{
						var enemycount2 = GetPower(com.Faction.World.GetObjectFromCircle(new thrts.Circle2D(15 * 32, new thrts.Vector2D(uni.Pos.X, uni.Pos.Y))).OfType<thrts.IUnit>().Where(_ => !_.Faction.IsNeutral && !com.Faction.World.IsSameTeam(com.Faction, _.Faction)), time);
						if (enemycount2 > enemycount)
						{
							enemycount = enemycount2;
						}

						if (!allyunit.Contains(uni))
						{
							allyscount += GetPower(new[] { uni }, time);
						}
					}

					foreach (var rei in reinforces)
					{
						if (GetRinTip(rei.Pos, new thrts.Vector3D(px, py, 0)) < 7)
						{
							if (rei.UserValues.ContainsKey("com援軍")) rei.UserValues.Remove("com援軍");
						}
					}
				}
				else
				{
					enemycount = 1;
					allyscount = 0;
				}
			}
			//援軍関連
			if (com.Difficulty != thrts.COMDifficulty.Easy && com.Difficulty != thrts.COMDifficulty.Normal)
			{
				//com援軍
				if (enemycount <= allyscount && attakingcount >= 200)
				{
					foreach (var low in nextattacker)
					{
						if (!low.UserValues.ContainsKey("com援軍"))
							low.UserValues.Add("com援軍", 100);
						if (!low.UserValues.ContainsKey("com攻撃"))
							low.UserValues.Add("com攻撃", (int)100);
						com.World.UnitManager.AttackMove(new[] { low.UniqueID }, AttackPos, false);
					}
				}
				//com援軍停止
				if ((dorun && enemycount * 7 > allyscount * 10) || enemycount * 6 > allyscount * 10)
				{
					foreach (var low in lows)
					{
						if (low.UserValues.ContainsKey("com援軍") && low.ActualAction == thrts.UnitAction.Move)
						{
							low.UserValues.Remove("com援軍");
							com.World.UnitManager.AttackMove(new[] { low.UniqueID }, new thrts.Vector2D(GatherPos.X, GatherPos.Y), false);
							if (low.UserValues.ContainsKey("com攻撃"))
								low.UserValues.Remove("com攻撃");
							if (low.UserValues.ContainsKey("集合済み"))
								low.UserValues.Remove("集合済み");
						}
					}
				}
			}
			//逃げ
			if ((dorun && enemycount * 5 > allyscount * 10) || enemycount * 4 > allyscount * 10)
			{
				int ms = 0, es = 0;
				if (allyunit != null && allyunit.Count() > 0) ms = (int)allyunit.Average(_ => _.Speed);
				if (enemyunit != null && enemyunit.Count() > 0) es = (int)enemyunit.Average(_ => _.Speed);

				if (ms * 11 >= es * 10)
				{
					running = true;
					foreach (var low in lows)
					{
						if (low.UserValues.ContainsKey("com援軍"))
						{
							low.UserValues.Remove("com援軍");
							com.World.UnitManager.SelectTarget(new[] { low }, new thrts.Vector2D(GatherPos.X, GatherPos.Y), false);
						}
						if (low.UserValues.ContainsKey("com攻撃"))
						{
							low.UserValues.Remove("com攻撃");
							com.World.UnitManager.SelectTarget(new[] { low }, new thrts.Vector2D(GatherPos.X, GatherPos.Y), false);
							if (!low.UserValues.ContainsKey("com逃走"))
								low.UserValues.Add("com逃走", 100);
							if (low.UserValues.ContainsKey("集合済み"))
								low.UserValues.Remove("集合済み");
						}
						if (low.UserValues.ContainsKey("com中断"))
							low.UserValues.Remove("com中断");
					}
				}
			}
			//逃走中止
			var runs = com.GetMyUnits(_ => !Common.IsFarmer(_.Parameter) && _.UserValues.ContainsKey("com逃走"));
			if (!running)
			{
				foreach (var run in runs)
				{
					if (GetR(run.Pos, GatherPos) < 80)
					{
						run.StopOrder();
						if (run.UserValues.ContainsKey("com逃走"))
							run.UserValues.Remove("com逃走");
					}
					if (attakings != null && attakings.Count() > 0)
					{
						if (GetR(run.Pos, new thrts.Vector3D(px, py, 0)) < thrts.Def.MapTipLengthOnField * 3)
						{
							run.StopOrder();
							if (run.UserValues.ContainsKey("com逃走"))
								run.UserValues.Remove("com逃走");
						}
					}
					if (run.ActualAction == thrts.UnitAction.Attack)
					{
						if (GetR(run.Pos, GatherPos) > 224)
							com.World.UnitManager.SelectTarget(new[] { run }, new thrts.Vector2D(GatherPos.X, GatherPos.Y), false);
						else
						{
							if (run.UserValues.ContainsKey("com逃走"))
								run.UserValues.Remove("com逃走");
						}
					}
				}
			}
		}

		/// <summary>
		/// 戦力計算
		/// </summary>
		public static int GetPower(IEnumerable<thrts.IUnit> units, int time = 0)
		{
			if (units == null || units.Count() == 0) return 0;
			int power = 0;
			int uniquepower = 500;
			int uniquecount = units.Count(_ => _.Parameter.IsUnique);

			if (uniquecount >= 2)
			{
				uniquepower = (500 + uniquecount * 150) / 2;
			}
			foreach (var u in units)
			{
				if (u.Parameter.IsUnique)
				{
					int level = u.GetLevel();
					power += uniquepower * u.HP / u.MaxHP;
					if (u.HP == u.MaxHP) power += uniquepower / 5;
					if (time > 30 * 240 || uniquecount >= 3) power = power * (level + 6) / 10;
				}
				else if (u.Parameter.Name != "人形")//仮
				{
					power += u.Parameter.Exp + u.Parameter.Exp * u.HP / u.MaxHP;
				}
			}
			return power;
		}

		/// <summary>
		/// 全建物のキューが埋まってるかの目安
		/// </summary>
		public static bool HasQue(thrts.ICOMController com, thrts.IBuilding home)
		{
			if (home == null) return true;
			var t = home.Parameter.GetType();
			var bs = com.GetMyBuildings(_ => !_.IsCollectingResources && ((_.IsComplete && !_.HasProductionQueue()) || (_.GetProgress > 75 && _.GetProgress < 100))).Select(_ => _.Parameter.GetType());

			#region Red
			if (t == typeof(Building.Red.HomeBase))
			{
				if (bs.Count(_ => _ == typeof(Building.Red.Barrack)
					|| _ == typeof(Building.Red.Factory)
					|| _ == typeof(Building.Red.FrogSculpture)
					|| _ == typeof(Building.Red.StairsOfKoumakan)
					|| _ == typeof(Building.Red.NamazuSculpture)
					|| _ == typeof(Building.Red.Airport)) > 0)
				{
					return false;
				}
			}
			#endregion
			#region White
			if (t == typeof(Building.White.HomeBase))
			{
				if (bs.Count(_ => _ == typeof(Building.White.Barrack)
					|| _ == typeof(Building.White.Factory)
					|| _ == typeof(Building.White.Seirensen)
					|| _ == typeof(Building.White.Houtou)
					|| _ == typeof(Building.White.Hospital)
					|| _ == typeof(Building.White.Airport)) > 0)
				{
					return false;
				}
			}
			#endregion
			#region Green
			if (t == typeof(Building.Green.HomeBase))
			{
				if (bs.Count(_ => _ == typeof(Building.Green.Barrack)
					|| _ == typeof(Building.Green.Barrack)) > 0)
				{
					return false;
				}
			}
			#endregion
			#region Blue
			if (t == typeof(Building.Blue.HomeBase))
			{
				if (bs.Count(_ => _ == typeof(Building.Blue.Barrack)
					|| _ == typeof(Building.Blue.Factory)
					|| _ == typeof(Building.Blue.BigTree)
					|| _ == typeof(Building.Blue.Airport)) > 0)
				{
					return false;
				}
			}
			#endregion
			#region Black
			if (t == typeof(Building.Black.HomeBase))
			{
				if (bs.Count(_ => _ == typeof(Building.Black.Chireiden)
					|| _ == typeof(Building.Black.Factory)
					|| _ == typeof(Building.Black.Airport)) > 0)
				{
					return false;
				}
			}
			#endregion
			return true;
		}

		public static thrts.ISpell GetNowSpell(thrts.IUnit uni, int param)
		{
			return uni.GetSpellWithName(uni.Parameter.SpellParams[param].Name);
		}

		/// <summary>
		/// スペル使用
		/// </summary>
		public static void UseSpell(thrts.IUnit uni, thrts.SpellParameter<thrts.IUnit> para, int range = 0, bool toUnit = true, int pointrange = 0, bool nomove = false)
		{
			//ターゲットがあるか
			var target = uni.GetTarget();
			if (target == null) return;
			if (toUnit && !(target is thrts.IUnit)) return;
			var tunit = target as thrts.IUnit;
			if (tunit.Faction.IsNeutral) return;
			if (nomove && tunit.ActualAction == thrts.UnitAction.Move) return;

			//クールタイム完了しているか
			string name = para.Name;
			var spell = uni.GetSpellWithName(name);
			if (spell.GetCoolTimeRate() > 0) return;

			thrts.ButtonParameter<thrts.IUnit> button = null;
			thrts.Vector2D pos = new thrts.Vector2D();

			button = uni.TryGetButtonParameter(para.ButtonPosX, para.ButtonPosY);
			if (button == null) return;


			if (tunit != null)
			{
				pos = new thrts.Vector2D(tunit.Pos.X, tunit.Pos.Y);
				float tbx = tunit.Pos.X - uni.Pos.X;
				float tby = tunit.Pos.Y - uni.Pos.Y;
				int rr = (int)Math.Sqrt(tbx * tbx + tby * tby);

				if (para.MaxRanges[spell.Level] < rr || (range < rr && range != 0))
				{
					var targets = uni.Faction.World.GetObjectFromCircle(new thrts.Circle2D(para.MaxRanges[spell.Level] * 32, new thrts.Vector2D(uni.Pos.X, uni.Pos.Y))).Where(_ => _ is thrts.IUnit);
					var en = targets.Where(_ => _.Exists() && !_.Faction.World.IsSameTeam(uni.Faction, _.Faction)).OrderBy(_ => GetR(uni.Pos, _.Pos)).FirstOrDefault();
					if (en != null)
					{
						tunit = en as thrts.IUnit;
						pos = new thrts.Vector2D(tunit.Pos.X, tunit.Pos.Y);
					}
				}

				//位置調整&射程内か判断
				if (pointrange > 0 || range > 0)
				{
					float tx = tunit.Pos.X - uni.Pos.X;
					float ty = tunit.Pos.Y - uni.Pos.Y;
					int r = (int)Math.Sqrt(tx * tx + ty * ty);
					if (r == 0) return;
					//射程内か判断
					if (range > 0)
					{
						if (r > range)
						{
							return;
						}
					}
					//位置調整
					if (pointrange > 0)
					{
						if (r < pointrange)
						{
							float rate = (pointrange * 100) / r;
							rate = rate / 100;

							float lx = tx * rate;
							float ly = ty * rate;
							lx = (int)lx;
							ly = (int)ly;
							pos = new thrts.Vector2D(uni.Pos.X + lx, uni.Pos.Y + ly);
						}
					}
				}

				if (button.Kind == thrts.ButtonKind.SelectObjectOrPlace)
					button.SelectObjectOrPlaceButtonEvent(uni, null, null, null, pos, false);

				if (button.Kind == thrts.ButtonKind.SelectPlace)
					button.SelectPlaceButtonEvent(uni, pos, false);

				if (button.Kind == thrts.ButtonKind.Normal)
					button.NormalButtonEvent(uni, false);
			}
		}

		/// <summary>
		/// 生産後一ヶ所に集合
		/// </summary>
		public static void Gathering(thrts.ICOMController com, thrts.Vector3D GatherPos)
		{
			var lows = com.GetMyUnits(_ => !IsFarmer(_.Parameter)).ToArray();
			foreach (var low in lows)
			{
				if (low.ActualAction == thrts.UnitAction.Free)
				{
					if (!low.UserValues.ContainsKey("集合済み") && !low.UserValues.ContainsKey("com攻撃"))
					{
						if (!low.UserValues.ContainsKey("com逃走"))
							com.World.UnitManager.AttackMove(new[] { low.UniqueID }, new thrts.Vector2D(GatherPos.X, GatherPos.Y), false);
						else
							com.World.UnitManager.SelectTarget(new[] { low }, new thrts.Vector2D(GatherPos.X, GatherPos.Y), false);
					}
					if (!low.UserValues.ContainsKey("集合済み"))
						low.UserValues.Add("集合済み", (int)100);
					else
					{
						int atime = (int)low.UserValues["集合済み"];
						if (atime < 100)
							low.UserValues["集合済み"] = atime - 20;
						if (atime <= 0)
						{
							low.UserValues.Remove("集合済み");
						}
					}
				}
				else
				{
					if (low.GetTarget() != null && !low.UserValues.ContainsKey("com攻撃"))
					{
						if (low.UserValues.ContainsKey("集合済み"))
						{
							int atime = (int)low.UserValues["集合済み"];
							if (atime == 100)
								low.UserValues["集合済み"] = atime - 10;
							if (atime <= 0)
							{
								low.UserValues.Remove("集合済み");
							}
						}
					}
				}
			}
		}

		/// <summary>
		/// 中立への攻撃停止
		/// </summary>
		public static void StopNeutralAttack(thrts.ICOMController com, Dictionary<string, bool> flag, thrts.Vector3D GatherPos, thrts.Vector2D AttackPos)
		{
			if (!flag.ContainsKey("狩り一時終了") && !flag.ContainsKey("狩り終了")) return;
			var lows = com.GetMyUnits(_ => !Common.IsFarmer(_.Parameter)).ToArray();
			foreach (var low in lows)
			{
				thrts.IUnit target = low.GetTarget() as thrts.IUnit;
				if (target != null && target.Faction.IsNeutral && (target.MaxHP > 150 || GetRinTip(target.Pos, new thrts.Vector3D(AttackPos.X, AttackPos.Y, 0)) >= 18))
				{
					if (low.UserValues.ContainsKey("com攻撃"))
					{
						if (!low.UserValues.ContainsKey("com中断"))
						{
							com.World.UnitManager.SelectTarget(new[] { low }, AttackPos, false);
							low.UserValues.Add("com中断", (int)20);
						}
					}
					else
					{
						com.World.UnitManager.SelectTarget(new[] { low }, new thrts.Vector2D(GatherPos.X, GatherPos.Y), false);
					}
				}
				if (low.UserValues.ContainsKey("com中断"))
				{
					int atime = (int)low.UserValues["com中断"];
					low.UserValues["com中断"] = atime - 1;
					if (atime <= 0)
					{
						low.UserValues.Remove("com中断");
						if (low.UserValues.ContainsKey("com攻撃"))
						{
							com.World.UnitManager.AttackMove(new[] { low.UniqueID }, AttackPos, false);
						}
						else
						{
							com.World.UnitManager.SelectTarget(new[] { low }, new thrts.Vector2D(GatherPos.X, GatherPos.Y), false);
						}
					}
				}
			}
		}

		/// <summary>
		/// 農民反撃
		/// </summary>
		public static void Counter(thrts.ICOMController com, thrts.Vector3D InitPos, thrts.IBuilding home)
		{
			if (com.Difficulty != thrts.COMDifficulty.Hard && com.Difficulty != thrts.COMDifficulty.Lunatic) return;
			var farmers = com.GetMyUnits(_ => IsFarmer(_.Parameter) && !_.IsEscaping);
			bool fight = false;
			foreach (var farmer in farmers)
			{
				thrts.IUnit target = farmer.GetTarget() as thrts.IUnit;
				if (target != null)
				{
					if (!target.Faction.IsNeutral && GetRinTip(InitPos, farmer.Pos) > 30)
					{
						com.World.UnitManager.SelectTarget(new[] { farmer }, new thrts.Vector2D(InitPos.X, InitPos.Y), false);
					}
					else if (target.Faction.IsNeutral)
					{
						com.World.UnitManager.SelectTarget(new[] { farmer }, new thrts.Vector2D(InitPos.X, InitPos.Y), false);
					}
				}
			}
			foreach (var farmer in farmers)
			{
				if (IsFree(farmer) && (farmer.Warnedtime.Any(_ => _ > 0) || home.Warnedtime.Any(_ => _ > 0)))
				{
					var nearunits = com.Faction.World.GetObjectFromCircle(new thrts.Circle2D(30 * 32, new thrts.Vector2D(InitPos.X, InitPos.Y))).OfType<thrts.IUnit>().Where(_ => !_.Faction.IsNeutral);
					var allyunits = nearunits.Where(_ => com.Faction.World.IsSameTeam(com.Faction, _.Faction));
					var enemyunits = nearunits.Where(_ => !com.Faction.World.IsSameTeam(com.Faction, _.Faction));
					if (GetPower(allyunits) < 1000 && GetPower(enemyunits) > 300)
					{
						fight = true;
					}
					break;
				}
			}
			if (!fight)
			{
				foreach (var farmer in farmers)
				{
					if (IsFree(farmer) && farmer.Warnedtime.Any(_ => _ > 0))
					{
						var nearenemyunits = com.Faction.World.GetObjectFromCircle(new thrts.Circle2D(5 * 32, new thrts.Vector2D(farmer.Pos.X, farmer.Pos.Y))).OfType<thrts.IUnit>().Where(_ => !_.Faction.IsNeutral && !com.Faction.World.IsSameTeam(com.Faction, _.Faction) && _.FlyingState == thrts.FlyingState.TouchGround);
						if (nearenemyunits == null || nearenemyunits.Count() > 0)
							farmer.StopOrder();
						break;
					}
				}
			}
			if (fight)
			{
				foreach (var farmer in farmers)
				{
					if (IsFree(farmer))
						com.World.UnitManager.AttackMove(new[] { farmer.UniqueID }, new thrts.Vector2D(InitPos.X, InitPos.Y), false);
				}
			}
		}
	}
}
