﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Effect.Green
{
	public class MedicineAcidEffect : thrts.EffectParameter
	{
		public MedicineAcidEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/reimu_happou_effect.efk";
		}
	}

	public class GensoEffect : thrts.EffectParameter
	{
		public GensoEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/yuuka_last.efk";
		}
	}

	public class CommonBolEffect : thrts.EffectParameter
	{
		public CommonBolEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/common_bol.efk";
		}
	}
	public class CommonBolAreaEffect : thrts.EffectParameter
	{
		public CommonBolAreaEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/common_bol_loop.efk";
		}
	}
	public class RangeCircleEffect : thrts.EffectParameter
	{
		public RangeCircleEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/RangeCircle.efk";
		}
	}

	
	public class HitSplashRedEffect : thrts.EffectParameter
	{
		public HitSplashRedEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/HitSplash_red.efk";
		}
	}
	public class HitSplashBlueEffect : thrts.EffectParameter
	{
		public HitSplashBlueEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/HitSplash_blue.efk";
		}
	}
	public class HitSplashGreenEffect : thrts.EffectParameter
	{
		public HitSplashGreenEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/HitSplash_green.efk";
		}
	}

	public class HealEffect : thrts.EffectParameter
	{
		public HealEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/HealUnit.efk";
		}
	}
	public class BackLightEffect : thrts.EffectParameter
	{
		public BackLightEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/BackLight.efk";
		}
	}

	public class MedicineSkillEffect : thrts.EffectParameter
	{
		public MedicineSkillEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/medi_skill.efk";
		}
	}

	public class MedicineAcidCloudEffect : thrts.EffectParameter
	{
		public MedicineAcidCloudEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/medi_acid.efk";
		}
	}

	public class MediTextureEffect : thrts.TextureEffectParameter
	{
		public MediTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/acid";

			Animation.Width = 64;
			Animation.Height = 64;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 20;
			Animation.FrameTime = 4;
			Animation.HasDirection = false;
			Animation.Count.X = 10;
			Animation.Count.Y = 2;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Blend;

			Time = int.MaxValue;
			Animation.Scale = new thrts.Vector2D(4.0f, 4.0f);
		}
	}

	public class KomachiTextureEffect : thrts.TextureEffectParameter
	{
		public KomachiTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.FrameCount = 32;
			Animation.FrameTime = 2;
			Animation.Count.X = 8;
			Animation.Count.Y = 2;
			Animation.AlphaBlend = thrts.AlphaBlend.Blend;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Loop;
			Animation.Path = "LotusCraft/Image/TextureEffect/komachi_skill_effect";

			Time = int.MaxValue;
			IsHorizontal = true;
			Is3DMode = true;
		}
	}

	public class KomachiSkillEffect : thrts.EffectParameter
	{
		public KomachiSkillEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/komachi_skill.efk";
		}
	}
}
