﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Effect.White
{
	public class CommonBolEffect : thrts.EffectParameter
	{
		public CommonBolEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/common_bol.efk";
		}
	}
	public class CommonBolAreaEffect : thrts.EffectParameter
	{
		public CommonBolAreaEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/common_bol_loop.efk";
		}
	}
	public class RangeCircleEffect : thrts.EffectParameter
	{
		public RangeCircleEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/RangeCircle.efk";
		}
	}

	
	public class HitSplashRedEffect : thrts.EffectParameter
	{
		public HitSplashRedEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/HitSplash_red.efk";
		}
	}
	public class HitSplashBlueEffect : thrts.EffectParameter
	{
		public HitSplashBlueEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/HitSplash_blue.efk";
		}
	}
	public class HitSplashGreenEffect : thrts.EffectParameter
	{
		public HitSplashGreenEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/HitSplash_green.efk";
		}
	}

	public class BackLightEffect : thrts.EffectParameter
	{
		public BackLightEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/BackLight.efk";
		}
	}

	public class AuraTextureEffect : thrts.TextureEffectParameter
	{
		public AuraTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.FrameCount = 15;
			Animation.FrameTime = 5;
			Animation.Count.X = 5;
			Animation.Count.Y = 3;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Loop;
			Animation.Path = "LotusCraft/Image/TextureEffect/nazurin_effect";

			Time = int.MaxValue;
			IsHorizontal = true;
			Is3DMode = true;
		}
	}
	public class HealEffect : thrts.EffectParameter
	{
		public HealEffect()
		{ 
			EffectPath = "LotusCraft/3D/Effect/HealUnit.efk";
		}
	}
	public class StanEffect : thrts.EffectParameter
	{
		public StanEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/common_stun.efk";
		}
	}

	#region KaguyaMob

	public class KaguyaMobAreaModelEffect : thrts.ModelEffectParameter
	{
		public KaguyaMobAreaModelEffect()
		{
			ObjectPath = "LotusCraft/3D/Spell/danger_area01.mdl";
			Time = int.MaxValue / 4;
		}
	}

	public class KaguyaMobAreaEffect : thrts.EffectParameter
	{
		public KaguyaMobAreaEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/kaguya_m_area.efk";
		}
	}

	public class KaguyaMobChangeEffect : thrts.EffectParameter
	{
		public KaguyaMobChangeEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/kaguya_m_change.efk";
		}
	}

	public class KaguyaMobFlashEffect : thrts.EffectParameter
	{
		public KaguyaMobFlashEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/kaguya_m_flash.efk";
		}
	}

	public class KaguyaMobHitEffect : thrts.EffectParameter
	{
		public KaguyaMobHitEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/kaguya_m_hit.efk";
		}
	}

	public class KaguyaMobHitBigEffect : thrts.EffectParameter
	{
		public KaguyaMobHitBigEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/kaguya_m_hit_big.efk";
		}
	}

	public class SummonEffect : thrts.EffectParameter
	{
		public SummonEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/alice_semi.efk";
		}
	}

	#endregion
}
