﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

using LotusCraft.Unit.Red;
using LotusCraft.Unit.Red.Unique;
using LotusCraft.Building.Red;
using LotusCraft.Effect.Red;

namespace LotusCraft.Faction
{
	public class Red : thrts.FactionParameter
	{
		public Red ()
		{
			ImageOnSelection800 = "System/BattleSetting/SelectWorkforce/800/workforce_red_m";
			ImageOnSelection1280 = "System/BattleSetting/SelectWorkforce/1280/workforce_red_m";

			ImageLongOnSelection800 = "System/BattleSetting/SelectWorkforce/800/workforce_red";
			ImageLongOnSelection1280 = "System/BattleSetting/SelectWorkforce/1280/workforce_red";

			Name = "赤勢力";
			DefaultScreenPosition = new thrts.Point2D (-480, -640);

			Units = new string[] { 
				typeof(Unit.Common.Mercenary01).FullName,
				typeof(Unit.Common.Mercenary02).FullName,
				typeof(Unit.Common.Eiki).FullName,
				typeof(Unit.Common.Patchouli).FullName,

				typeof(Farmer).FullName,
				typeof(Low01).FullName,
				typeof(Low02).FullName,

				typeof(Kanako).FullName,
				typeof(Suwako).FullName,
				typeof(Namazu).FullName,
				typeof(Flandre).FullName,
				typeof(FlandreImage).FullName,

				typeof(Koakuma).FullName,
				typeof(Meirin).FullName,

				typeof(FlyBomber).FullName,
				typeof(FlyFighter).FullName,
				typeof(FlyTransporter).FullName,

				typeof(Sanae).FullName,
				typeof(Moko).FullName,
#if !_TRIAL
				typeof(Aya).FullName,
				typeof(Remilia).FullName,
				typeof(Sakuya).FullName,
				typeof(Patchouli).FullName,
#endif
			};
			Buildings = new string[] { 
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
				typeof(Airport).FullName,

				typeof(NamazuSculpture).FullName,
				typeof(StairsOfKoumakan).FullName,
				typeof(FrogSculpture).FullName,
			};

			TextureEffects = new string[] { 
				typeof(Effect.Common.AlcoholIconEffect).FullName,
				typeof(Effect.Common.ReiryokuIconEffect).FullName,
				typeof(KaminokazeTextureEffect).FullName,

				typeof(Effect.Common.NormalHitOrangeTextureEffect).FullName,
				typeof(Effect.Common.NormalHitGreenTextureEffect).FullName,
				typeof(Effect.Common.NormalHitBlueTextureEffect).FullName,
				typeof(Effect.Common.NormalHitPurpleTextureEffect).FullName,
				typeof(Effect.Common.NormalHitRedTextureEffect).FullName,
				typeof(Effect.Common.NormalHitYellowTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitRedTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitGreenTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitBlueTextureEffect).FullName,
				typeof(Effect.Common.BombHitTextureEffect).FullName,
				typeof(Effect.Common.BombHitRedTextureEffect).FullName,
				typeof(Effect.Common.BombHitGreenTextureEffect).FullName,
				typeof(Effect.Common.BombHitBlueTextureEffect).FullName,
//追記
				typeof(Effect.Common.GunFireTextureEffect).FullName,
				typeof(Effect.Common.IncreaseBombEffect).FullName,
				typeof(Effect.Common.DefenceAuraTextureEffect).FullName,
			};

			Effects = new string[] {
				typeof(Arrow).FullName, 
				typeof(Stronghold).FullName,
				typeof(Barracks).FullName,
				typeof(Factories).FullName,
				typeof(Airports).FullName,
				typeof(CollectAlcohol).FullName,
				typeof(CollectPowerStone).FullName,

				typeof(Effect.Common.AttackBombEffect).FullName,
				typeof(Effect.Common.AttackBombAreaEffect).FullName,
				typeof(Effect.Common.FastBombEffect).FullName,
				typeof(Effect.Common.FastBombAreaEffect).FullName,
				typeof(Effect.Common.IncreaseBombAreaEffect).FullName,
				typeof(Effect.Common.ReviveBombEffect).FullName,
				typeof(Effect.Common.TownPortalBombEffect).FullName,


				typeof(Effect.Common.CreateBuildingEffect).FullName,
				typeof(BreakBuilding).FullName, 
				typeof(Effect.Common.DissolveBuilding).FullName, 

				typeof(Effect.Common.CircleAreaEffect).FullName,
				typeof(Effect.Common.DebuffEffect).FullName,
				typeof(Effect.Common.HitRemoteWhiteEffect).FullName,
				typeof(Effect.Common.HitRemoteBlueEffect).FullName,
				typeof(Effect.Common.HitRemoteRedEffect).FullName,
				typeof(Effect.Common.HitRemoteGreenEffect).FullName,
				typeof(Effect.Common.HitCloseRedEffect).FullName,
				typeof(Effect.Common.HitCloseBlueEffect).FullName,
				typeof(Effect.Common.HitCloseGreenEffect).FullName,
				typeof(Effect.Common.HitCloseWhiteEffect).FullName,
				typeof(Effect.Common.HitSplashRedEffect).FullName,
				typeof(Effect.Common.HitSplashBlueEffect).FullName,
				typeof(Effect.Common.HitSplashGreenEffect).FullName,
				typeof(HitSplashRedEffect).FullName,
				typeof(HitSplashBlueEffect).FullName,
				typeof(HitSplashGreenEffect).FullName,

				typeof(DeadUnitEffect).FullName,
				typeof(DeadUniqueEffect).FullName,

				typeof(CommonBolEffect).FullName, 
				typeof(CommonBolAreaEffect).FullName, 
				typeof(RangeCircleEffect).FullName, 
				typeof(HealEffect).FullName, 
				typeof(StanEffect).FullName, 

				typeof(NamazuEarthquakeEffect).FullName,
				typeof(FlandreDeadEffect).FullName,

				typeof(KouanAreaEffect).FullName,
				typeof(HakuchuShotEffect).FullName,
				typeof(HakuchuSelfEffect).FullName,
				typeof(HanjoThrowEffect).FullName,
				typeof(HanjoHitEffect).FullName,
				typeof(KamiNoKazeEffect).FullName,
				typeof(KamiNoKazeAreaEffect).FullName,
				typeof(KamiNoKazeSelfEffect).FullName,
				typeof(KouanChargeEffect).FullName,
				typeof(KouanAreaEffect).FullName,
				typeof(KouanHitEffect).FullName,
				typeof(KouanSelfEffect).FullName,
			
#if !_TRIAL
				typeof(SarutahikoEffect).FullName,
				typeof(SarutahikoAreaEffect).FullName,
				typeof(KouyouSenpuEffect).FullName,
				typeof(HujinSelfEffect).FullName,
				typeof(HujinAreaEffect).FullName,
				typeof(GyakuhuAreaEffect).FullName,

				typeof(HeartBulletEffect).FullName,
				typeof(HeartHitEffect).FullName,
				typeof(ServantBulletEffect).FullName,
				typeof(ScarletAreaEffect).FullName,
				typeof(NightmareAreaEffect).FullName,
				typeof(NightmareEffect).FullName,

				typeof(SakuyaStopWatchEffect).FullName,

				typeof(AgniEffect).FullName,
				typeof(PillarAreaEffect).FullName,
				typeof(KenjaAreaEffect).FullName,
				typeof(KenjaEffect).FullName,
				typeof(RoyalSelfEffect).FullName,
				typeof(RoyalAreaEffect).FullName,
#endif
				typeof(PhenixEffect).FullName,
				typeof(HinotoriAreaEffect).FullName,
				typeof(HinotoriSelfEffect).FullName,
				typeof(FujiyamaEffect).FullName,
				typeof(SaitanEffect).FullName,
				typeof(SaitanReviveEffect).FullName,

				typeof(Effect.Common.KokoroKirouEffect).FullName,
				typeof(Effect.Common.KokoroKurumaEffect).FullName,
				typeof(Effect.Common.KokoroShishiEffect).FullName,
				
				typeof(KaguyaMobAreaEffect).FullName,
				typeof(KaguyaMobHitEffect).FullName,
				typeof(KaguyaMobFlashEffect).FullName,

				typeof(MeirinMobHitBigEffect).FullName,
				typeof(MeirinMobChangeEffect).FullName,


				typeof(Effect.Common.LvUpEffect).FullName,
				typeof(Effect.Common.DeadUniqueEffect).FullName,
				typeof(Effect.Common.DeadUnitEffect).FullName,

				typeof(Effect.Common.CreateBuildingEffect).FullName,
				typeof(Effect.Common.CompleteBuildingEffect).FullName,
				typeof(Effect.Common.CreateUnitEffect).FullName,

				typeof(Effect.Common.UnitCollectAlcoholEffect).FullName,
				typeof(Effect.Common.UnitCollectPowerStoneEffect).FullName,
			};

			ModelEffects = new string[]
			{
				typeof(MeirinMobAreaModelEffect).FullName,
			};

			SoundEffects = new string[]
			{
				typeof(SoundEffect.BreakBuildingSE).FullName,
				typeof(SoundEffect.ChooseUnit).FullName,
				typeof(SoundEffect.Click).FullName,
				typeof(SoundEffect.CreatedUnit).FullName,
				typeof(SoundEffect.CreatedBuilding).FullName,
				typeof(SoundEffect.EndCharge).FullName,
				typeof(SoundEffect.EndResearch).FullName,
				typeof(SoundEffect.EndRevolution).FullName,
				typeof(SoundEffect.FailedClick).FullName,
				typeof(SoundEffect.HitLongRangeAttack).FullName,
				typeof(SoundEffect.HitShortRangeAttack).FullName,
				typeof(SoundEffect.HitZangeki).FullName,
				typeof(SoundEffect.HitDageki).FullName,
				typeof(SoundEffect.HitOther).FullName,
				typeof(SoundEffect.PCH).FullName,
				typeof(SoundEffect.PointPosition).FullName,
				typeof(SoundEffect.Alarm01).FullName,
				typeof(SoundEffect.Jet).FullName,
				typeof(SoundEffect.Wind).FullName,
				typeof(SoundEffect.Cutin).FullName,
				typeof(SoundEffect.Charge1).FullName,
				typeof(SoundEffect.Charge2).FullName,
				typeof(SoundEffect.Shuiin01).FullName,
				typeof(SoundEffect.Shuiin02).FullName,
				typeof(SoundEffect.BiriBiri).FullName,
				typeof(SoundEffect.LvUp).FullName,
				typeof(SoundEffect.Burst).FullName,
				typeof(SoundEffect.Jishin).FullName,
//追記
				typeof(SoundEffect.GunFire).FullName,
				typeof(SoundEffect.GunRenzoku).FullName,
				typeof(SoundEffect.GunLong).FullName,
				typeof(SoundEffect.taihou).FullName,

				typeof(SoundEffect.Bom01).FullName,
				typeof(SoundEffect.Bom12).FullName
			};

			CommonUnitButton = new List<ButtonParameterHolder<IUnit>>(){
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.MoveButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StopButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.HoldPositionButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.PatrolButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.AttackMoveButton ()),
				//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StationButton ()),
			};
		}
	}
}
