﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

using LotusCraft.Ability;
using LotusCraft.Ability.Black;
using LotusCraft.Effect;
using LotusCraft.Effect.Black;
using LotusCraft.Bullet.Black;

namespace LotusCraft.Spell.Black
{

	class YoumuSkill:thrts.SpellParameter<thrts.IUnit>
	{
		float affectRadius = 2;
		public YoumuSkill()
		{
			DefaultLevel = 1;
			MaxLevel = 1;
			Name = "断命剣「冥想斬」";
			string basePath = "Black/Spell/YoumuSkill/";

			CoolTimes = new int[2];
			CoolTimes[0] = 15*30;
			CoolTimes[1] = 15*30;

			Description = "建物以外の相手の防御力を無視する。また、稀に攻撃がクリティカルヒットする";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"防御力無視、攻撃が約10%の確率でクリティカルヒット",
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._0;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャストの生成
			SpellAutoCasts = new AutoCastParameter<IUnit>[]
			{
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,15,null),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,15,(unit)=>Spelling(unit,1),true),
			};
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",1),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}

		public bool Spelling (thrts.IUnit selfUnit, int level)
		{
			/// show effect

			foreach (var b in selfUnit.ModifiedBulletParameters) {
				b.IgnoreArmor = true;;
			}
			
			return true;
		}
	}
}
