﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

using LotusCraft.Ability;
using LotusCraft.Ability.Common;
using LotusCraft.Effect;
using LotusCraft.Effect.Common;
using LotusCraft.Bullet.Common;

namespace LotusCraft.Spell.Common
{

	class ArmbreakSkill:thrts.SpellParameter<thrts.IUnit>
	{
		const int interval = 15;
		float affectRadius = 2;
		public ArmbreakSkill()
		{
			DefaultLevel = 1;
			MaxLevel = 1;
			Name = "アーマーブレイク";
			string basePath = "Green/Spell/ElieSkill/";
			CoolTimes = new int[2];
			CoolTimes[0] = 15*30;
			CoolTimes[1] = 15*30;

			Description = "建物以外の相手の防御力を無視する。";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"防御力無視",
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._0;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャストの生成
			SpellAutoCasts = new AutoCastParameter<IUnit>[]
			{
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,15,null),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,15,(unit)=>Spelling(unit,1),true),
			};
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",1),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public bool Spelling(thrts.IUnit selfUnit, int level)
		{
			{

				if (selfUnit.AbilityManager.ContainsAbility(ArmbreakSkillAbility.AbilityName))
				{
					selfUnit.AbilityManager.ExtendLifetimeWithName(interval,ArmbreakSkillAbility.AbilityName,interval*2);
				}
				else
				{
					selfUnit.AbilityManager.AppendAbility(new ArmbreakSkillAbility(interval*2));
				}
			}
			return true;
		}
		public IEnumerable<object> PrivilegeModeSpelling (thrts.IUnit selfUnit, int level)
		{
			yield return false;
		}
	}
}


namespace LotusCraft.Ability
{
	class ArmbreakSkillAbility : AbilityTemplate
	{
		public const string AbilityName = "アーマーブレイク";
		public ArmbreakSkillAbility (int duration)
		{
			this.Name = AbilityName;
			this.DurationTime = duration;
		}
		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			switch (order)
			{
			case thrts.AbilityOrder.ConstDecParam:
				break;
			case thrts.AbilityOrder.RateDecParam:
				break;
			case thrts.AbilityOrder.ConstIncParam:
				foreach (var b in unit.ModifiedBulletParameters) 
				{
					b.IgnoreArmor = true;
				}
				break;
			case thrts.AbilityOrder.RateIncParam:
				break;
			case AbilityOrder.OtherExecs:
				break;
			default:
				break;
			}
			
			return base.ExecUnitAbility(unit,order);
		}
		public override bool OnVanish (IUnit unit)
		{
			return base.OnVanish (unit);
		}
	}
}
