﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

using LotusCraft.Effect.Common;
using LotusCraft.Bullet.Common;
using LotusCraft.Ability;
//using LotusCraft.Bullet.Black;

namespace LotusCraft.Spell.Common
{
	class ChangebulletSkill : thrts.SpellParameter<thrts.IUnit>
	{

		/// <summary>
		/// The mode change time[s].
		/// </summary>
		const float modeChangeTime = 4f;
		const float modeDisChangeTime = 1.0f;
		const int interval = 10;
		public ChangebulletSkill()
		{
			DefaultLevel = 1;
			MaxLevel = 1;
			Name = "砲撃モード";
			string basePath = "Black/Spell/KokoroSkill/Shishi/";
			
			CoolTimes = new int[2];
			CoolTimes[0] = 2 * Def.FPS;
			CoolTimes[1] = 2 * Def.FPS;

			//			Description = 
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"遠隔攻撃に切り替える。",
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._2;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャストの生成
			SpellAutoCasts = null;
			
			
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",(unit)=>PrivilegeModeSpelling(unit,1)),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}

		public void Spelling(thrts.IUnit selfUnit, int level)
		{
			thrts.AbilityTemplate abiity = null;
			selfUnit.AbilityManager.AppendAbility(abiity);
		}
		public IEnumerable<object> PrivilegeModeSpelling(thrts.IUnit selfUnit, int level)
		{
			if (level <= 0)
				yield return false;



			// クールタイムをリセット
			selfUnit.GetSpellWithName(Name).ResetCoolTime();

			int modeCTime = (int)(modeChangeTime * Def.FPS);
			int modeDisCTime = (int)(modeDisChangeTime * Def.FPS);

			var orgFaction = selfUnit.Parameter.Faction; // for effect

			if (!selfUnit.AbilityManager.ContainsAbility(ChangebulletInterceptionModeAbility.AbilityName))
			{

				// 変形開始エフェクト
				//{
				//	var change = selfUnit.Faction.World.EffectManager.CreateEffect(typeof(ChangebulletMobChangeEffect).FullName, selfUnit.Pos + new Vector3D(0, 0, 1), orgFaction);
				//	change.SetScale(new Vector3D(16.0f, 16.0f, 16.0f));
				//}
				selfUnit.HoldPosition(false);
				for (int i = 0; i < modeCTime; ++i)
				{
					// ユニット動作停止
					selfUnit.Speed = 0.0f;

					if (i == 0 || i % (Def.FPS * 2) == 0)
					{
						//selfUnit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.Alarm01).FullName, selfUnit.Pos);
					}
					if (i == 0 || i % (Def.FPS * 2) == 0)
					{
						if (i < 7 * Def.FPS )
						{
						var change = selfUnit.Faction.World.EffectManager.CreateEffect(typeof(ChangebulletMobChangeEffect).FullName, selfUnit.Pos + new Vector3D(0, 0, 1), orgFaction);
						change.SetScale(new Vector3D(16.0f, 16.0f, 16.0f));
						}
					}
					
					yield return true;
				}

				// Create Area Effect And Add Ability
				CreateAreaEffect(selfUnit, level);
			}
			/*
			else
			{
				var ability = selfUnit.AbilityManager.GetAbilityWithName(ChangebulletInterceptionModeAbility.AbilityName) as ChangebulletInterceptionModeAbility;
				if (null != ability)
					ability.NowPrepareing = true;

				for (int i = 0; i < modeDisCTime; ++i)
				{
					// stay stop
					selfUnit.Speed = 0.0f;
					yield return true;
				}
				// Remove Interception mode ability
				selfUnit.AbilityManager.RemoveAbility(ChangebulletInterceptionModeAbility.AbilityName, true);

			}
			*/

			yield return false;
		}

		private static void CreateAreaEffect(thrts.IUnit selfUnit, int level)
		{

			var orgFaction = selfUnit.Parameter.Faction; // for effect
			var world = selfUnit.Faction.World;
			// 範囲表示
			
			if (!selfUnit.AbilityManager.ContainsAbility(Ability.ChangebulletInterceptionModeAbility.AbilityName))
			{
				var offset = new Vector3D (2, 2, 2);
				var effect = world.EffectManager.CreateEffect (typeof(Effect.Common.KokoroShishiEffect ).FullName, selfUnit.Pos + offset);
				var scale = 8;
				effect.SetScale (new Vector3D (scale, scale, scale));
				var ability = new ChangebulletInterceptionModeAbility(level, effect);
				if (!selfUnit.AbilityManager.AppendAbility (ability))
					effect.Stop ();
			
			}
			else
			{
				selfUnit.AbilityManager.ExtendLifetimeWithName(interval, Ability.ChangebulletInterceptionModeAbility.AbilityName, 15);
			}
			
			
		
		}

	}
}

namespace LotusCraft.Ability
{
	class ChangebulletInterceptionModeAbility : FollowEffectAbility
	{
		//IModelEffect effect;
		Vector3D rotation;
		
		public const string AbilityName = "砲撃モード";

		public bool NowPrepareing = false;
		//public int ShootTimeCounter = 0;
		const float speedRatio = 0.85f;
		public ChangebulletInterceptionModeAbility(int level, IEffect effect)
		{
			this.Name = AbilityName;
			this.DurationTime = 1; // inf
			this.Effect = effect;
			this.NowPrepareing = false;
			
		}
		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			switch (order)
			{
			case thrts.AbilityOrder.ConstDecParam:
				//unit.CanStateNow = false;
				// 移動しようとしていたらホールドポジションに強制変更
				//if(!unit.IsHoldPosition || unit.ActualAction == UnitAction.Move)
				//	unit.HoldPosition(false);
				//
				// set speed=0;
				//unit.Speed = 0.0f;
				foreach(var b in unit.ModifiedBulletParameters)
				{
					if (unit.Name == "寅丸 星(式神)")
					{
						unit.Armor -=1;
						b.Attack -=2;
					}
					if (unit.Name == "小野塚 小町(式神)")
					{
						b.MaxRange -=1f* Def.MapTipLengthOnField;;
					}
					if (unit.Name == "霊烏路 空(式神)")
					{
					}
				}
				unit.Speed *= speedRatio;
				unit.Armor /= 2;
				break;
			case thrts.AbilityOrder.RateDecParam:
				break;
			case thrts.AbilityOrder.ConstIncParam:
				break;
			case thrts.AbilityOrder.RateIncParam:
				break;
			case AbilityOrder.OtherExecs:
				unit.SelectBullet = SelectIntercepterBullet;
				if (Effect != null)
				{
					Effect.SetPosition(unit.Pos + new Vector3D(0, 0, 1));
				}
				break;
			default:
				break;
			}

			
			return true;
		}
		public override bool OnVanish (IUnit unit)
		{
			if (null != unit && unit.Exists ()) {
				unit.CanStateNow = true;
				//unit.IsMPBarShown = false;
				;
			}
			if (Effect != null)
			{
				Effect.Stop();
				Effect = null;
			}
			
			return base.OnVanish(unit);
		}
		// inf. ability
		public override void DecDurationTime ()
		{
			;
		}
		public override bool ModifyBullet (IBullet bullet)
		{
			//ShootTimeCounter = 0;
			return base.ModifyBullet (bullet);
		}
		static int SelectIntercepterBullet(IUnit unit,ITargetObject target,float distance)
		{
			/// return aja bullet
			return 1;
		}
	}

	
}
