﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

using LotusCraft.Effect.Common;
using LotusCraft.Bullet.Common;
using LotusCraft.Ability;
//using LotusCraft.Bullet.Black;

namespace LotusCraft.Spell.Common
{
	class DefaultbulletSkill : thrts.SpellParameter<thrts.IUnit>
	{

		/// <summary>
		/// The mode change time[s].
		/// </summary>
		const float modeChangeTime = 4f;
		const float modeDisChangeTime = 1.0f;
		const int interval = 10;
		public DefaultbulletSkill()
		{
			DefaultLevel = 1;
			MaxLevel = 1;
			Name = "近接モード";
			string basePath = "Black/Spell/YoumuSkill/";
			CoolTimes = new int[2];
			CoolTimes[0] = 2 * Def.FPS;
			CoolTimes[1] = 2 * Def.FPS;

			//			Description = 
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"近接攻撃に切り替える。",
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._3;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャストの生成
			SpellAutoCasts = null;
			
			
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",(unit)=>PrivilegeModeSpelling(unit,1)),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}

		public void Spelling(thrts.IUnit selfUnit, int level)
		{
			//thrts.AbilityTemplate abiity = null;
			//selfUnit.AbilityManager.AppendAbility(abiity);
		}
		public IEnumerable<object> PrivilegeModeSpelling(thrts.IUnit selfUnit, int level)
		{
			if (level <= 0)
				yield return false;



			// クールタイムをリセット
			selfUnit.GetSpellWithName(Name).ResetCoolTime();

			int modeCTime = (int)(modeChangeTime * Def.FPS);
			int modeDisCTime = (int)(modeDisChangeTime * Def.FPS);

			//var orgFaction = selfUnit.Parameter.Faction; // for effect

			if (!selfUnit.AbilityManager.ContainsAbility(ChangebulletInterceptionModeAbility.AbilityName))
			{
					yield return true;
			}
			else
			{

				for (int i = 0; i < modeDisCTime; ++i)
				{
					// stay stop
					selfUnit.Speed = 0.0f;
					yield return true;
				}
				// Remove Interception mode ability
				selfUnit.AbilityManager.RemoveAbility(ChangebulletInterceptionModeAbility.AbilityName, true);

			}

			yield return false;
		}
		
	}
}
