﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Unit.Green;
using LotusCraft.Ability;
using LotusCraft.Ability.Green;
using LotusCraft.Effect.Green;

namespace LotusCraft.Spell.Green
{
	class Kokumotsusin:thrts.SpellParameter<thrts.IUnit>
	{
		IEffect selfEffect = null;
		const int incResource = 5000;
		public Kokumotsusin()
		{
			DefaultLevel = 0;
			MaxLevel = 1;
			RequireLevels[0] = 6;

			CoolTimes = new int[MaxLevel + 1];
			CoolTimes[0] = 0;
			CoolTimes[1] = 120 * 30;

			Name = "豊作「穀物神の約束」";
			string basePath = "Green/Spell/Kokumotsusin/";
			Description = "酒を5000得る。";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"酒:+"+incResource
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._3;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャストの生成
			SpellAutoCasts = null;
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",(unit)=>Spelling(unit,1))
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(
				this,
				basePath + "LvUp",
				(unit) =>
				{
					/*
					// エフェクトを生成
					var effect = unit.Faction.World.EffectManager.CreateEffect(typeof(CommonBolEffect).FullName, unit.Pos);
					var scale = 10.0f;

					// 拡大率を設定
					effect.SetScale(new Vector3D(scale, scale, scale));

					// アビリティを生成(ユニットに追尾するエフェクト用)
					var ability = new FollowEffectAbility(effect, new Vector3D(0, 0, 16), Def.FPS * 10, this.Name + "effect");

					// アビリティを追加
					var sof = unit.AbilityManager.AppendAbility(ability);

					// 追加に失敗するので自分でエフェクトを消す
					if (!sof)
					{
						effect.Stop();
					}
					*/
				}
				);
		}
		public IEnumerable<object> Spelling(thrts.IUnit selfUnit, int level)
		{
			// スペルが現在使用可能か判断
			var spell = selfUnit.GetSpellWithName (Name);
			if (null == spell || !spell.CanExec) {
				yield return false;
				yield break;
			}
			spell.ResetCoolTime();

			var selfFaction = selfUnit.Faction;
			var world = selfUnit.Faction.World;

			selfUnit.ShowCutin();

			var offset = new Vector3D(1.0f, 3.0f, 1.0f);
			var areaEffect = world.EffectManager.CreateEffect(typeof(KokumotsusinEffect).FullName, selfUnit.Pos + offset, selfFaction);
			areaEffect.SetScale(new Vector3D(15.0f, 15.0f, 15.0f));

			var ability = new EffectContinuousAbility(areaEffect, 2 * 30, this.Name + "AreaEffect");
			if (!selfUnit.AbilityManager.AppendAbility(ability))
				if (areaEffect != null)
					areaEffect.Stop();

			selfFaction.IncResource(0, incResource);

			yield return true;
		}
		
	}
}
