﻿#if !_TRIAL
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Ability;
using LotusCraft.Ability.Green;
using LotusCraft.Bullet.Green;
using LotusCraft.Effect.Green;

namespace LotusCraft.Spell.Green
{
	class Onibi : thrts.SpellParameter<thrts.IUnit>
	{
		float[] decMoveRatio;
		int[] damages;
		public Onibi()
		{
			DefaultLevel = 0;
			MaxLevel = 3;
			Name = "鬼火「超高密度燐禍術」";
			string basePath = "Green/Spell/Onibi/";
			CoolTimes = new int[MaxLevel + 1];
			CoolTimes[0] = 0;
			CoolTimes[1] = 30 * Def.FPS;
			CoolTimes[2] = 20 * Def.FPS;
			CoolTimes[3] = 10 * Def.FPS;

			damages = new int[MaxLevel + 1];
			damages[0] = 0;
			damages[1] = 30;
			damages[2] = 50;
			damages[3] = 70;

			decMoveRatio = new float[MaxLevel + 1];
			decMoveRatio[0] = 0;
			decMoveRatio[1] = 0;
			decMoveRatio[2] = 0;
			decMoveRatio[3] = 0;

			Description = "周囲の敵にダメージを与える。\n作業員へのダメージ-50%";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"溶岩弾の攻撃力" + damages[1] ,
				"溶岩弾の攻撃力" + damages[2] ,
				"溶岩弾の攻撃力" + damages[3] ,
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._1;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャスト無し
			SpellAutoCasts = null;
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0", 0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",PrivilegeModeSpelling, 1),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "2",PrivilegeModeSpelling, 2),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "3",PrivilegeModeSpelling, 3),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public IEnumerable<object> PrivilegeModeSpelling(thrts.IUnit selfUnit, int level)
		{
			{
				// reset cooltime
				var spell = selfUnit.GetSpellWithName(Name);
				if (null == spell || !spell.CanExec)
				{
					yield return false;
					yield break;
				}

				spell.ResetCoolTime();
				var vec = selfUnit.GetFrontDirection();
				Vector3D direction = new Vector3D(vec.X, vec.Y, 0);
				direction.X *= 3 * Def.MapTipLengthOnField;
				direction.Y *= 3 * Def.MapTipLengthOnField;

				var b = selfUnit.GetModifiedBulletParameter(typeof(OnibiLargeBullet).FullName);
				if (null != b)
				{
					b.Attack = damages[level];
					selfUnit.CreateBullet(typeof(OnibiLargeBullet).FullName, direction + selfUnit.Pos, selfUnit.Pos);
				}
			}
			yield return false;
		}
	}
}

#endif