﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

using LotusCraft.Effect.Red;
using LotusCraft.Bullet.Red;
using LotusCraft.Ability.Red;
using LotusCraft.Ability;

namespace LotusCraft.Spell.Red
{
	class Phenix:thrts.SpellParameter<thrts.IUnit>
	{
		int counter = 0;
		int HealDelay = Def.FPS;
		int[] Gain = new int[4];
		float[] Limit = new float[4];
		int[] Size = new int[4];
		int nowSize = 0;

		IEffect areaEffect = null;
		public Phenix()
		{
			DefaultLevel = 0;
			MaxLevel = 3;
			Name = "不滅「フェニックスの尾」";
			Description = "HPが時間ごとに自動回復するようになる。						";
			string basePath = "Red/Spell/Phenix/";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"HP毎秒8回復, 回復上限 70%",
				"HP毎秒14回復, 回復上限 80%",
				"HP毎秒20回復, 回復上限 90%",
			};

			Gain[0] = 0;
			Gain[1] = 8;
			Gain[2] = 14;
			Gain[3] = 20;

			Limit[0] = 0f;
			Limit[1] = 0.7f;
			Limit[2] = 0.8f;
			Limit[3] = 0.9f;

			Size[0] = 0;
			Size[1] = 10;
			Size[2] = 15;
			Size[3] = 20;

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._1;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャスト
			SpellAutoCasts = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,1,null),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,1,(unit)=>Spelling(unit,1),true),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,1,(unit)=>Spelling(unit,2),true),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,1,(unit)=>Spelling(unit,3),true),
			};
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",1),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "2",2),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "3",3),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public bool Spelling(thrts.IUnit selfUnit, int level)
		{
			{
				Vector3D offset = new Vector3D(2.0f, 2.0f, 1.0f);
				if (areaEffect == null || nowSize!=Size[level])
				{
					if (areaEffect != null)
					{
						areaEffect.Stop();
						areaEffect = null;
					}
					areaEffect = selfUnit.Faction.World.EffectManager.CreateEffect(typeof(PhenixEffect).FullName, selfUnit.Faction, selfUnit.Pos + offset);
					areaEffect.SetScale(new Vector3D(Size[level], Size[level], Size[level]));
					nowSize = Size[level];
					selfUnit.AddOnVanishEvent(OnVanishUnit);
				}
				areaEffect.SetPosition(selfUnit.Pos + offset);
			}

			//回復
			counter++;
			if (counter > HealDelay && selfUnit.HP < this.Limit[level] * selfUnit.MaxHP)
			{
				counter = 0;
				selfUnit.HP += Gain[level];
			}

			/*if (selfUnit.AbilityManager.AppendAbility(new PhenixAbility(level)))
			{
				/// 既に掛かっていたら時間を延長
				selfUnit.AbilityManager.ExtendLifetimeWithName(10, spellAbilities[level].Name,10*2);
			}*/

			return true;
		}

		public void OnVanishUnit(thrts.IUnit selfUnit)
		{
			if (areaEffect != null)
			{
				areaEffect.Stop();
				areaEffect = null;
			}

			counter = 0;
		}
	}
}
