﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Ability;
using LotusCraft.Ability.Red;
using LotusCraft.Bullet.Red;
using LotusCraft.Effect.Red;

namespace LotusCraft.Spell.Red
{
	class Gensou:thrts.SpellParameter<thrts.IUnit>
	{
		const int bulletsNum = 16;
		public Gensou()
		{
			DefaultLevel = 0;
			MaxLevel = 1;
			RequireLevels[0] = 6;
			Name = "幻葬「夜霧の幻影殺人鬼」";
			string basePath = "Red/Spell/Gensou/";
			CoolTimes = new int[MaxLevel+1];
			CoolTimes[0] = 0;
			CoolTimes[1] = 60*30;

			MaxRanges= new float[MaxLevel + 1];
			MaxRanges[0] = 0;
			MaxRanges[1] = 8*Def.MapTipLengthOnField;

			Description = "ナイフが一旦広がった後、指定地点に向けてナイフが殺到する。";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"射程8。ダメージ15、防御無視、貫通。16発。主に+100%",
			};
			
			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._3;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;
			
			/// オートキャスト無し
			SpellAutoCasts = null;
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0", 0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",PrivilegeModeSpelling, 1),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public IEnumerable<object> PrivilegeModeSpelling (thrts.IUnit selfUnit,Vector2D targetPosition, int level)
		{
			{
				// reset cooltime
				var spell = selfUnit.GetSpellWithName (Name);
				if(null == spell || !spell.CanExec)
				{
					yield return false;
					yield break;
				}
				
				spell.ResetCoolTime ();
				selfUnit.ShowCutin();

				var targetPos = selfUnit.Faction.World.GetGroundAtPos(targetPosition);

				var r = 16*Def.MapTipLengthOnField;
				for(int i=0;i<bulletsNum;++i)
				{
					var th = (2*Math.PI * i /(float)bulletsNum);
					var bullet = selfUnit.CreateBullet(typeof(YogiriBullet).FullName,new Vector3D(r*(float)Math.Cos ( th ) + selfUnit.Pos.X,r*(float)Math.Sin ( th ) + selfUnit.Pos.Y,selfUnit.Pos.Z),selfUnit.Pos);
					yield return true;
				}
				// delay 2 sec
				for(int i=0;i<1*Def.FPS;++i)
					yield return true;

				r = 3*Def.MapTipLengthOnField;
				for(int i=0;i<bulletsNum;++i)
				{
					var th = -2*Math.PI * i /(float)bulletsNum;
					var bullet = selfUnit.CreateBullet(typeof(Yogiri2Bullet).FullName,new Vector3D(-r*(float)Math.Cos ( th ) + targetPos.X,-r*(float)Math.Sin ( th ) + targetPos.Y,targetPos.Z),new Vector3D(r*(float)Math.Cos ( th ) + targetPos.X,r*(float)Math.Sin ( th ) + targetPos.Y,targetPos.Z));
					
				}


			}
			yield return false;
		}
	}
}

namespace LotusCraft.Bullet.Red
{
	public class YogiriBullet:SakuyaBullet
	{
		public YogiriBullet ()
		{
			Attack = 15;
			HitType = BulletHitType.Pierce;
			MaxRange = 16*Def.MapTipLengthOnField;
			IgnoreArmor = true;
		}
	}
	public class Yogiri2Bullet:YogiriBullet
	{
		public Yogiri2Bullet ()
		{
			Speed = 12f;
			MaxRange = 6*Def.MapTipLengthOnField;
		}
		
		
	}
}

#endif