﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Spell.FactionName
{
	class SpellToTarget:thrts.SpellParameter<thrts.IUnit>
	{
		public SpellToTarget()
		{
			DefaultLevel = 0;
			MaxLevel = 3;
			Name = "SpellName";
			string basePath = "FactionName/Spell/SpellToTarget/";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"Lv1効果",
				"Lv2効果",
				"Lv3効果",
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._1;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャストの生成
			SpellAutoCasts = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,60,null),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,60,this.AutoCastAction_lv1),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,60,this.AutoCastAction_lv2),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,60,this.AutoCastAction_lv3),
			};
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",PrivilegeModeSpelling,1),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "2",PrivilegeModeSpelling,2),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "3",PrivilegeModeSpelling,3),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public IEnumerable<object> PrivilegeModeSpelling(thrts.IUnit selfUnit,thrts.IUnit uTarget,thrts.IBuilding bTarget, int level)
		{
			if (uTarget == null && bTarget == null)
			{
				yield return false;
				yield break;
			}
			yield return true;
		}
		public bool Spelling (thrts.IUnit selfUnit, thrts.IUnit uTarget, thrts.IBuilding bTarget, int level)
		{
			return true;
		}
		public bool AutoCastAction_lv1(thrts.IUnit unit)
		{
			/// select target
			thrts.IUnit uTarget = null;
			thrts.IBuilding bTarget = null;
			Spelling(unit, uTarget, bTarget, 1);
			return true;
		}
		public bool AutoCastAction_lv2(thrts.IUnit unit)
		{
			thrts.IUnit uTarget = null;
			thrts.IBuilding bTarget = null;
			Spelling(unit, uTarget, bTarget, 2);
			return true;
		}
		public bool AutoCastAction_lv3(thrts.IUnit unit)
		{
			thrts.IUnit uTarget = null;
			thrts.IBuilding bTarget = null;
			Spelling(unit, uTarget, bTarget, 3);
			return true;
		}
	}
}
