﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Ability.White;
using LotusCraft.Ability;
using LotusCraft.Effect.White;

namespace LotusCraft.Spell.White
{
	class GensokyoNokioku:thrts.SpellParameter<thrts.IUnit>
	{
		const int duration = 20*Def.FPS;
		public GensokyoNokioku()
		{
			DefaultLevel = 0;
			MaxLevel = 1;
			RequireLevels[0] = 6;
			Name = "幻想郷の記憶";
			Description = "マップ全体の視界を得る。";
			string basePath = "White/Spell/GensokyoNokioku/";

			CoolTimes = new int[MaxLevel + 1];
			CoolTimes[0] = 9999;
			CoolTimes[1] = 60*Def.FPS;
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				duration/(float)Def.FPS+"秒間、マップ全域公開",
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._3;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャスト無し
			SpellAutoCasts = null;

			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",PrivilegeModeSpelling,1),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public IEnumerable<object> PrivilegeModeSpelling (thrts.IUnit selfUnit, int level)
		{
			if (null == selfUnit || !selfUnit.Exists ()) {
				yield return false;
				yield break;
			}

			// スペルが現在使用可能か判断
			var spell = selfUnit.GetSpellWithName (Name);
			if (null == spell || !spell.CanExec) {
				yield return false;
				yield break;
			}
			spell.ResetCoolTime();
			selfUnit.ShowCutin();

			///マップの霧を晴らす
			var world = selfUnit.Faction.World;
			selfUnit.Faction.GetSite(world.Map.Count * 0.7071f * Def.MapTipLengthOnField,world.Map.Count/2 * Def.MapTipLengthOnField,world.Map.Count/2 * Def.MapTipLengthOnField,duration);

			/// エフェクトを描画
			var faction = selfUnit.Faction;
			Vector3D offset = new Vector3D(2.0f, 2.0f, 1.0f);
			var effect = world.EffectManager.CreateEffect(typeof(KiokuEffect).FullName, selfUnit.Pos);
			var scale = new Vector3D(25, 25, 25);
			effect.SetScale(scale);

			var hitAbility = new Ability.EffectContinuousAbility(effect, 10, this.Name + "Effect");
			var flag = selfUnit.AbilityManager.AppendAbility(hitAbility);
			if (!flag)
				effect.Stop();

			yield return false;
		}
	}
}
