﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Ability.White;
using LotusCraft.Ability;
using LotusCraft.Effect.White;

namespace LotusCraft.Spell.White
{
	class Gumonzi : thrts.SpellParameter<thrts.IUnit>
	{
		int[] durations;
		int[] intervals;
		public Gumonzi()
		{
			DefaultLevel = 0;
			MaxLevel = 3;
			Name = "求聞史記";
			Description = "阿求の視界が長時間持続するようになる。 ";
			string basePath = "White/Spell/Gumonzi/";

			intervals = new int[MaxLevel + 1];
			intervals[0] = 9999;
			intervals[1] = 7*Def.FPS;
			intervals[2] = 5*Def.FPS;
			intervals[3] = 3*Def.FPS;

			durations = new int[MaxLevel + 1];
			durations[0] = 0;
			durations[1] = 20*Def.FPS;
			durations[2] = 40*Def.FPS;
			durations[3] = 80*Def.FPS;

			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				durations[1]/(float)Def.FPS+"秒間持続",
				durations[2]/(float)Def.FPS+"秒間持続",
				durations[3]/(float)Def.FPS+"秒間持続",
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._0;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャストの生成
			SpellAutoCasts = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,intervals[0],null),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,intervals[1],(unit)=>Spelling(unit,1),true),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,intervals[2],(unit)=>Spelling(unit,2),true),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,intervals[3],(unit)=>Spelling(unit,3),true),
			};
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",1),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "2",2),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "3",3),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
			IsPassive = true;
		}
		public bool Spelling(thrts.IUnit self, int level)
		{
			if(null == self || !self.Exists())
				return false;

			self.Faction.GetSite(self.ViewRange,self.Pos.X,self.Pos.Y,durations[level]);

			/// エフェクトを描画
			var faction = self.Faction;
			Vector3D offset = new Vector3D(0.0f, 0.0f, 1.0f);
			var effect = self.Faction.World.EffectManager.CreateEffect(typeof(GumonziEffect).FullName, self.Pos);
			var scale = new Vector3D(25, 25, 25);
			effect.SetScale(scale);

			var hitAbility = new Ability.EffectFollowContinuousAbility(effect, intervals[level] - 1, this.Name + "Effect", offset);
			var flag = self.AbilityManager.AppendAbility(hitAbility);
			if (!flag)
				effect.Stop();

			return true;
		}
	}
}
