﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft;

namespace LotusCraft.Spell.White
{
	class Fumajin : thrts.SpellParameter<thrts.IUnit>
	{
		public Fumajin()
		{
			DefaultLevel = 0;
			MaxLevel = 3;
			Name = "「封魔陣」";
			string basePath = "White/Spell/Fumajin/";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"lv1効果",
				"lv2効果",
				"lv3効果",
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._1;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = thrts.ButtonPosition._1;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャスト無し
			SpellAutoCasts = new AutoCastParameter<IUnit>[]
			{
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,60,null),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,60,(unit)=>Spelling(unit,1)),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,60,(unit)=>Spelling(unit,2)),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,60,(unit)=>Spelling(unit,3)),
			};
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",(unit)=>PrivirageModeSpelling(unit,0)),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "2",(unit)=>PrivirageModeSpelling(unit,0)),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "3",(unit)=>PrivirageModeSpelling(unit,0)),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public IEnumerable<object> PrivirageModeSpelling(IUnit selfUnit, int level)
		{
			bool flag = Spelling(selfUnit, level);
			yield return true;
		}
		public bool Spelling(thrts.IUnit selfUnit, int level)
		{

			float affectRange = 0;
			switch (level)
			{
				case 1:
					affectRange = 5 * 32;
					break;
				case 2:
					affectRange = 5 * 32;
					break;
				case 3:
					affectRange = 5 * 32;
					break;
				default:
					break;
			}

			/// 指定地点(x,y)を中心にユニットを選択
			var selfFaction = selfUnit.Faction;
			var target = selfFaction.World.GetObjectFromRectangle(selfUnit.Pos.X, selfUnit.Pos.Y, affectRange, affectRange, selfUnit.Pos.X, selfUnit.Pos.Y, affectRange, affectRange);
			foreach (thrts.IUnit u in target.Where(_ => _ != null && _ as thrts.IUnit != null))
			{
				/// UUを識別

				/// エフェクトを描画
				var faction = u.Faction;
				var world = faction.World;
				var effectPos = u.Pos;
				effectPos.X -= 1f;
				effectPos.Y -= 1f;
				world.EffectManager.CreateTextureEffect("LotusCraft.Effect.Heal", effectPos);


			}

			return true;
		}
	}
}
