﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Spell.White
{
	class Humajin : thrts.SpellParameter<thrts.IUnit>
	{
		public Humajin()
		{
			DefaultLevel = 0;
			MaxLevel = 3;
			Name = "秘術「封魔陣」";
			string basePath = "White/Spell/Humajin/";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"敵ユニットを一時的に追放",
				"敵ユニットを一時的に追放",
				"敵ユニットを一時的に追放",
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._1;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャスト無し
			SpellAutoCasts = null;
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",PrivilegeModeSpelling,1),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "2",PrivilegeModeSpelling,2),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "3",PrivilegeModeSpelling,3),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public void Spelling(thrts.IUnit self, float x, float y, int level)
		{
			float affectRange = 0;
			switch (level)
			{
				case 1:
					affectRange = 5 * 32;
					break;
				case 2:
					affectRange = 5 * 32;
					break;
				case 3:
					affectRange = 5 * 32;
					break;
				default:
					break;
			}

			/// 指定地点(x,y)を中心にユニットを選択
			var selfFaction = self.Faction;
			var target = selfFaction.World.GetObjectFromRectangle(x, y, affectRange, affectRange, x, y, affectRange, affectRange);
			foreach (thrts.IUnit u in target.Where(_ => _ != null && _ as thrts.IUnit != null))
			{
				/// UUを識別

				/// エフェクトを描画
				var faction = u.Faction;
				var world = faction.World;
				var effectPos = u.Pos;
				effectPos.X -= 1f;
				effectPos.Y -= 1f;
				world.EffectManager.CreateTextureEffect("LotusCraft.Effect.Heal", effectPos);


			}

		}
		public IEnumerable<object> PrivilegeModeSpelling(thrts.IUnit selfUnit, float x, float y, int level)
		{
			// スペルが現在使用可能か判断
			var spell = selfUnit.GetSpellWithName (Name);
			if (null == spell || !spell.CanExec) {
				yield return false;
				yield break;
			}
			yield return true;
		}
	}
}
