﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using thrts;

namespace LotusCraft.Story
{
	public class Story01 : thrts.Mission
	{
		/// <summary>
		/// 自軍の勢力
		/// </summary>
		/// <returns></returns>
		public override string[] GetSelectableFactions()
		{
			return new string[] { 
				typeof(LotusCraft.Faction.White).FullName 
			};
		}

		/// <summary>
		/// 登場する勢力
		/// </summary>
		/// <returns></returns>
		public override string[] GetEnableFactions()
		{
			return new string[] { 
				typeof(LotusCraft.Faction.White).FullName,
				typeof(LotusCraft.Faction.Neutral).FullName, 
			}; 
		}

		/// <summary>
		/// 使用するマップ
		/// </summary>
		/// <returns></returns>
		public override string[] GetSelectableMaps()
		{
			return new string[] {
				"LotusCraft/Story/Story01.map",
			};
		}

		int[] Reimu = null;
		int[] Marisa = null;
		int[] Yukari = null;

		public Story01()
			: base()
		{
			Name = "プロローグ第01話";
			Description = "プロローグ第01話専用マップ";
			Mode = thrts.MissionMode.Story;

			this.TheNumberOfMaximumSelectablePlayersInTeam = 0;
			this.TheNumberOfSelectableTeams = 0;
		}

		public override void OnInitialize(thrts.IWorld world)
		{
			// 中立処理
			var neutrals = world.Factions.Where(_ => _.Parameter.GetType() == typeof(LotusCraft.Faction.Neutral));
			foreach (var neutral in neutrals)
			{
				neutral.IsNeutral = false;
			}
			// 中立が負けないように
			world.Factions[1].DoesNotLose = true;

			// 中立扱いを解除
			world.Factions[1].IsNeutral = false;

			// 初期資源を配布 150
			//world.Factions[0].IncResource(0, 200);
			
			// 霊夢を探す
			var reimu = GetUnits(world, world.Factions[0], typeof(LotusCraft.Unit.White.Unique.Reimu)).First();

			// 初期視点位置
			world.Factions[0].Parameter.DefaultScreenPosition = new Point2D((int)(reimu.Pos.X), (int)(reimu.Pos.Y));

			// 経験値0にする。
			world.Factions[0].GetUnitParameter(typeof(LotusCraft.Unit.White.Low02).FullName).Exp = 0;
			world.Factions[0].GetUnitParameter(typeof(LotusCraft.Unit.White.Low03).FullName).Exp = 0;

			world.Factions[0].GetBuildingParameter(typeof(LotusCraft.Building.White.Barrack).FullName).Exp = 0;
			world.Factions[0].GetBuildingParameter(typeof(LotusCraft.Building.White.Factory).FullName).Exp = 0;
			world.Factions[0].GetBuildingParameter(typeof(LotusCraft.Building.White.Airport).FullName).Exp = 0;
			world.Factions[0].GetBuildingParameter(typeof(LotusCraft.Building.White.Houtou).FullName).Exp = 0;
			world.Factions[0].GetBuildingParameter(typeof(LotusCraft.Building.White.Hospital).FullName).Exp = 0;
			world.Factions[0].GetBuildingParameter(typeof(LotusCraft.Building.White.BlackSmith).FullName).Exp = 0;

			world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Neutral.Low01).FullName).HP /= 4;
			world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Neutral.Low11).FullName).HP /= 4;
			
			base.OnInitialize(world);
		}

		/// <summary>
		/// 会話冒頭
		/// </summary>
		/// <param name="world"></param>
		/// <returns></returns>
		System.Collections.IEnumerable Talk会話冒頭(thrts.IWorld world)
		{
			var ui = world.StoryUI;

			// 霊夢と魔理沙を取得
			var reimu = GetUnits(world, world.Factions[0], typeof(LotusCraft.Unit.White.Unique.Reimu)).First();
			var marisa = GetUnits(world, world.Factions[0], typeof(LotusCraft.Unit.White.Unique.Marisa)).First();

			ui.StartStoryEventMode();

			ui.Show();
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Front, true, false);
			ui.ShowText("【霊夢】\nここは博麗神社の村です");
			ui.ShowImage(-1, StoryUIImagePosition.Front, true);
			ui.ShowImage(Marisa[2], StoryUIImagePosition.Right, true, false);
			ui.ShowText("【魔理沙】\n茶の過剰摂取で気でも狂ったか\nボケ老人になるにはまだ早いと思うんだが");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【霊夢】\n違うわよ。舞台が博麗神社で始まるのは最早お約束");
			ui.ShowText("【霊夢】\nだったらそれを私の口から説明するのが手っ取り早いと思って");
			ui.ShowText("【魔理沙】\n何をわけのわからないことを言っているんだ\nまるで霊夢が神社でぼーっとしているときに、偶然私が居合わせ、\nそこに何かしらの事件が持ち込まれることが既定路線みたいじゃないか");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【霊夢】\n定番中の定番よね。厄介事を起こすのは毎回違うけど");
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【魔理沙】\nまぁ突然森の中に放り出されるよりは定番だろうな。\n日常から非日常への暗転は大抵、つまらない日常のシーンから始まるものだからな。\nこないだ早苗から借りた本も大体そうだった");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【霊夢】\nとすると、そろそろ厄介事が持ち込まれるってわけ？\n暇潰しに霧を出す奴とか花を咲かせてみたいから冬を続かせる奴とかあの辺かしら");
			ui.ShowText("【魔理沙】\nいや、私はもっと手堅いところだと思うな。");
			ui.ShowImage(Marisa[2], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【魔理沙】\n最近暇で暇でしょうがないって皆口を揃えていただろ？顔を合わせればそればかりだ。");
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【魔理沙】\nこんなときに真っ先に火を付けて回るような奴を私は知ってる");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【霊夢】\n暇な天人か隙間妖怪のどっちかじゃないの");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true);
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Front, true, false);
			ui.ShowText("【紫】\n呼ばれて飛び出て");
			ui.ShowImage(-1, StoryUIImagePosition.Front, true);
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【霊夢】\n呼んでない");
			ui.ShowImage(Marisa[2], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【魔理沙】\nお呼びじゃないな");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, true, false);
			ui.ShowText("【紫】\nあら、ツレない返事ね。\nせっかく退屈そうな貴女たちのために、暇潰しを持ってきてあげたのに");
			ui.ShowImage(Reimu[1], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【霊夢】\nあんたが持ってくる話題って大抵ロクでもないじゃない　");
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【魔理沙】\nでもここで追い返したら話が進まないのも確かだな");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【霊夢】\n私はここで終わらせてもいいんだけど");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【紫】\nせっかく私が毎日八時間睡眠に昼寝もしながら考えたというのに、袖にされるだなんて、およよよよ");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【霊夢】\n通常運行じゃないの");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【紫】\nいえいえ、雑事は全て藍に押し付けておきましたから");
			ui.ShowImage(Marisa[2], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【魔理沙】\nブラックな職場だな");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【紫】\nでも藍はいつも幸福そうよ？");
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【魔理沙】\n幸福は義務だからな、しょうがない");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【霊夢】\nそれで一日の半分以上を寝て過ごしている紫が考えてきたっていう暇潰しについて説明しなさいよ");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【紫】\nそうこなくっちゃね。なんとこの豪華景品も用意してるの");
			ui.ShowImage(Marisa[2], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【魔理沙】\n景品ってことはアレか、競い事を催すから私達に参加しろって、そういう話なのか？");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【紫】\nふふっ、これも一種の競い事、争い事ではありましょう？");
			ui.ShowImage(Reimu[1], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【霊夢】\nもったいぶらずに何をするつもりなのか説明しなさいよ");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【紫】\n貴女達にやってもらいたいのは「戦争」");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【紫】\nと言っても真面目にやらないと痛い目を見るくらい気楽な戦争ごっこのサバイバルゲームですわ");
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【魔理沙】\n不真面目にやる戦争があるなんて初耳だな");
			ui.ShowText("【紫】\n歴史を学びなさいな、呆れる話は結構あるもの");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【霊夢】\n真面目にやるかどうかは置いておいて、戦争なんてどうやってやれというのよ？\nまた三角ロケットで月にでも行ってこいって言う訳じゃないでしょうね？");

			ui.ShowText("【紫】\nええもちろん、舞台はここで、参加者も幻想郷の住人。それに必要なものは全部こっちで用意いたしましょう");
			ui.ShowImage(-1, StoryUIImagePosition.Left, false);
			var div0 = ui.ShowText("【紫】\nベースとなる拠点に", true);

			while (!ui.IsCompleted(div0))
			{
				yield return null;
			}

			// 建築
			Func<string, string, IBuilding> createBuildingOnArea = (a, type) =>
			{
				var area = world.AllPurposeArea.Where(_ => _.Name == a).First() as thrts.AreaRectangle;
				var b =
					world.BuildingManager.Create(type,
					world.Factions[0],
					(area.Start.X + area.End.X) / 2,
					(area.Start.Y + area.End.Y) / 2,
					100.0f,
					world.Factions[0]);
				return b;
			};

			List<IBuilding> buildings = new List<IBuilding>();
			{
				var b = createBuildingOnArea("紫本拠地", typeof(LotusCraft.Building.White.HomeBase).FullName);
				buildings.Add(b);
				world.Factions[0].MoveScreenPosition(new Vector2D(b.Pos.X + thrts.Def.MapTipLengthOnField * (-2), b.Pos.Y - thrts.Def.MapTipLengthOnField * (-2)));
			}

			var div1 = ui.ShowText("【紫】\n自陣を彩る様々な建造物", true);
			while (!ui.IsCompleted(div1))
			{
				yield return null;
			}

			buildings.Add(createBuildingOnArea("紫下級魔法陣", typeof(LotusCraft.Building.White.Barrack).FullName));
			buildings.Add(createBuildingOnArea("紫上級魔法陣", typeof(LotusCraft.Building.White.Factory).FullName));
			buildings.Add(createBuildingOnArea("紫飛行魔法陣", typeof(LotusCraft.Building.White.Airport).FullName));
			buildings.Add(createBuildingOnArea("紫宝塔", typeof(LotusCraft.Building.White.Houtou).FullName));
			buildings.Add(createBuildingOnArea("紫診療所", typeof(LotusCraft.Building.White.Hospital).FullName));
			buildings.Add(createBuildingOnArea("紫研究所", typeof(LotusCraft.Building.White.BlackSmith).FullName));

			var div2 = ui.ShowText("【紫】\n兵隊は私の式を貸し出すわ、人形だけれど結構強力、甘く見たら怪我じゃすまないわよ？", true);
			while (!ui.IsCompleted(div2))
			{
				yield return null;
			}

			List<IUnit> units = new List<IUnit>();
			units.AddRange(PutUnitsOnArea(world, world.Factions[0], typeof(LotusCraft.Unit.White.Low02), world.AllPurposeArea.Where(_ => _.Name == "紫中距離兵").First()));
			units.AddRange(PutUnitsOnArea(world, world.Factions[0], typeof(LotusCraft.Unit.White.Low03), world.AllPurposeArea.Where(_ => _.Name == "紫遠距離兵").First()));

			{
				var pos = new Vector2D();
				foreach (var u in units)
				{
					pos.X += u.Pos.X;
					pos.Y += u.Pos.Y;
				}

				pos.X /= units.Count;
				pos.Y /= units.Count;

				world.Factions[0].MoveScreenPosition(pos);
			}

			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【紫】\nあとは才知や武勇が優れた英雄だけ、女の子だし女傑…いえ、ヒロインと呼んだほうがいいかしら？");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【霊夢】\nなに？肉体労働付きなの？");
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【魔理沙】\nま、妥当だろうな、幻想郷に軍師気取って後ろで眺めてるだけで満足しそうな奴なんて両手で数えきれそうだ");
			ui.ShowImage(Marisa[2], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【魔理沙】\nでもいいのか？その兵隊共なんて簡単に吹き飛ばしちまえそうだが？");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【紫】\n言ったでしょう？甘く見たら怪我では済まない。なんなら試してみてもいいけれど…？");
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【魔理沙】\nだ、そうだが？");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【霊夢】\nまぁ…本番前にどんな悪ふざけを用意したのか知っておいたほうがいいかもしれないわね");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【紫】\n同意を得られたところで、それじゃあ模擬戦といきましょう");
			ui.ShowText("", false);
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false);
			var talkEvent = ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, false);

			while (!ui.IsCompleted(talkEvent))
			{
				yield return null;
			}

			foreach (var b in buildings)
			{
				b.HP = 0;
			}

			foreach (var u in units)
			{
				u.HP = 0;
			}

			ui.Hide();
			ui.EndStoryEventMode();

			/*
			// 最後に召喚
			{
				var x = marisa.Pos.X - reimu.Pos.X;
				var y = marisa.Pos.Y - reimu.Pos.Y;

				world.UnitManager.Create(typeof(Unit.White.Low03).FullName, world.Factions[0], marisa.Pos.X + x, marisa.Pos.Y + y, world.Factions[0]);
			}
			*/
		}

		System.Collections.IEnumerable Talkユニット選択and移動(thrts.IWorld world)
		{
			var ui = world.StoryUI;

			// 霊夢と魔理沙を取得
			var reimu = GetUnits(world, world.Factions[0], typeof(LotusCraft.Unit.White.Unique.Reimu)).First();
			var marisa = GetUnits(world, world.Factions[0], typeof(LotusCraft.Unit.White.Unique.Marisa)).First();

			ui.StartStoryEventMode();
			ui.Show();

			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true);
			ui.ShowText("【紫】\nさて、ここからは画面の向こうの貴方へのお話、メタ的に言えばチュートリアル解説になりますわ");
			ui.ShowText("【紫】\nこれがゲーム画面、細かいところは追々説明をしていくとしてまずはユニットの解説");
			ui.ShowText("【紫】\nユニットの上にあるバーはそのユニットの体力、HPを表しているわ");
			ui.ShowText("【紫】\nそして霊夢たちの周りだけが明るいのは、その明るいところがユニットの視界を表しているの。視界外の様子はわからないから注意が必要ね？");
			ui.ShowText("【紫】\nそれじゃあ次に覚えることはユニットの操作方法、命令の出し方を覚えるところから");
			ui.ShowText("【紫】\nマップ上に霊夢と魔理沙がいるから、彼女らまずは選択してみましょう");
			ui.ShowText("【紫】\nユニットにカーソルを合わせて左クリックをすればユニットを選択することができるわ");
			ui.ShowText("", false);
			var div0 = ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, false);

			while (!ui.IsCompleted(div0))
			{
				yield return null;
			}

			ui.Hide();
			ui.EndStoryEventMode();

			ui.ShowConditionText("目的：霊夢か魔理沙を選択する。");

			// 選択待ち
			while (!world.StoryUtilities.IsSelected(reimu) && !world.StoryUtilities.IsSelected(marisa))
			{
				yield return null;
			}

			ui.ShowConditionText("");

			ui.PauseGame();
			ui.Show();

			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true);
			ui.ShowText("【紫】\n上出来、でもユニット100体を超えていくこのゲームではこの方法だけでは操作が追いつかない");
			ui.ShowText("【紫】\nそこで範囲選択、適当なところを左クリックしてそのままカーソルを動かしてみて。緑線で枠がでるわね？これで霊夢と魔理沙を囲んでボタンを離す");
			ui.ShowText("", false);
			var div1 = ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, false);

			while (!ui.IsCompleted(div1))
			{
				yield return null;
			}

			ui.Hide();
			ui.ResumeGame();

			ui.ShowConditionText("目的：霊夢と魔理沙を同時に選択する。");

			// 選択待ち
			while (!world.StoryUtilities.IsSelected(reimu) || !world.StoryUtilities.IsSelected(marisa))
			{
				yield return null;
			}

			ui.ShowConditionText("");

			ui.PauseGame();
			ui.Show();

			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true);
			ui.ShowText("【紫】\nはい、これで霊夢と魔理沙を一度に命令できるようになりました");
			ui.ShowText("【紫】\nそれじゃあ次は移動させましょう、ユニットを選んだまま適当なところを右クリックしてみて、そこに向かって移動を始めるはずよ");
			ui.ShowText("", false);
			var div2 = ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, false);

			while (!ui.IsCompleted(div2))
			{
				yield return null;
			}

			ui.Hide();
			ui.ResumeGame();

			ui.ShowConditionText("目的：マップを探索する。");

			var areaEvent1 = world.AllPurposeArea.Where(_ => _.Name == "イベント1").First() as AreaRectangle;
			while (!IsUnitOnArea(areaEvent1, reimu) && !IsUnitOnArea(areaEvent1, marisa))
			{
				yield return null;
			}

			ui.PauseGame();
			ui.Show();

			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true);
			ui.ShowText("【紫】\nそうそう、そうやって移動をさせるの、それじゃあ次は戦闘方法、坂の上にさっき私が出した兵隊がいるから近づいてみましょう？");
			ui.ShowText("", false);
			var div3 = ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, false);

			while (!ui.IsCompleted(div3))
			{
				yield return null;
			}

			ui.Hide();
			ui.ResumeGame();
		}


		System.Collections.IEnumerable Talkユニット戦闘1(thrts.IWorld world)
		{
			var ui = world.StoryUI;

			// 霊夢と魔理沙を取得
			var reimu = GetUnits(world, world.Factions[0], typeof(LotusCraft.Unit.White.Unique.Reimu)).First();
			var marisa = GetUnits(world, world.Factions[0], typeof(LotusCraft.Unit.White.Unique.Marisa)).First();

			ui.PauseGame();
			ui.Show();

			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true);
			ui.ShowText("【紫】\n敵を発見、さぁ戦闘よ");
			ui.ShowText("【紫】\nといっても、何も命令しなくてもユニットの射程内に敵がいれば勝手に戦いだしてくれるわ");
			ui.ShowText("【紫】\nただし、移動とかを命令していたらそっちを優先してしまうので注意ね");

			var stop = ui.LoadImage("LotusCraft/Story/Story01/story01_stop");
			ui.ShowImage(stop, StoryUIImagePosition.Right, true);

			ui.ShowText("【紫】\n右下のアイコンの中には命令を全部キャンセルする「停止ボタン」や…");

			var attack = ui.LoadImage("LotusCraft/Story/Story01/story01_attack");
			ui.ShowImage(attack, StoryUIImagePosition.Right, true);

			ui.ShowText("【紫】\n攻撃を優先して行動する「攻撃移動」のボタンもあるわ。移動中でもこれらを押せば戦いだしてくれるわね");

			ui.ShowImage(-1, StoryUIImagePosition.Right, true);

			ui.ShowText("【紫】\nコンフィグのショートカットを設定すれば簡単に押すことができるわ、一段落したら設定するのもいいかもしれないわね");
			ui.ShowText("【紫】\nとりあえず、今は敵の近くに移動をさせてみればいいわ");
			ui.ShowText("【紫】\nそれでは、二人の続きを見てみましょう？");
			ui.ShowText("", false);
			var div0 = ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, false);

			while (!ui.IsCompleted(div0))
			{
				yield return null;
			}

			ui.Hide();
			ui.ResumeGame();

			ui.ShowConditionText("目的：敵を殲滅する。");

			var enemy = world.UnitManager.GetUnits(_ => _.Faction != world.Factions[0]).FirstOrDefault();

			while (enemy != null && enemy.Exists())
			{
				yield return null;
			}

			ui.ShowConditionText("");

			// 強制レベルアップ
			if (reimu.Exists())
			{
				reimu.AddExperience(100);
			}

			if (marisa.Exists())
			{
				marisa.AddExperience(100);
			}

			for (int loop = 0; loop < 60; loop++)
			{
				yield return true;
			}
		}

		System.Collections.IEnumerable Talkスペル説明(thrts.IWorld world)
		{
			var ui = world.StoryUI;

			// 霊夢と魔理沙を取得
			var reimu = GetUnits(world, world.Factions[0], typeof(LotusCraft.Unit.White.Unique.Reimu)).First();
			var marisa = GetUnits(world, world.Factions[0], typeof(LotusCraft.Unit.White.Unique.Marisa)).First();

			{
				ui.PauseGame();
				ui.Show();

				ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true);
				ui.ShowText("【紫】\n霊夢たちの周りが光ったわね、レベルアップの合図よ");
				ui.ShowText("【紫】\n霊夢や魔理沙のような東方キャラクター本人は「ヒロイン」と呼ばれて、近くで敵が倒されると経験値が入ってレベルアップができるわ");
				ui.ShowText("【紫】\nユニットを選択した状態で、画面の右下にあるボタンをみてちょうだい");

				var sp = ui.LoadImage("LotusCraft/Story/Story01/story01_spell");
				ui.ShowImage(sp, StoryUIImagePosition.Right, true);

				ui.ShowText("【紫】\n一番右下のボタンがスペルポイント、このポイントを割り振ってスペルのレベルをあげるわ");
				ui.ShowText("【紫】\nレベルをあげるボタンは、2段目よ。説明を読んで好きなスペルのレベルをあげてちょうだい");
				ui.ShowText("", false);
				ui.ShowImage(-1, StoryUIImagePosition.Right, true);
				var div0 = ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, false);

				while (!ui.IsCompleted(div0))
				{
					yield return null;
				}

				ui.Hide();
				ui.ResumeGame();

				ui.ShowConditionText("目的：スペルカードのレベルを上げる。");
			}

			while (true)
			{
				var next = false;
				if (reimu != null && reimu.Exists())
				{
					var spell0 = reimu.GetSpellWithParameterName(typeof(Spell.White.NijuKekkai).FullName);
					var spell1 = reimu.GetSpellWithParameterName(typeof(Spell.White.Kibakujin).FullName);
					var spell2 = reimu.GetSpellWithParameterName(typeof(Spell.White.MusoHuin).FullName);

					if (spell0 != null && spell0.Level > 0 ||
						spell1 != null && spell1.Level > 0 ||
						spell2 != null && spell2.Level > 0)
					{
						next = true;
					}
				}

				if (marisa != null && marisa.Exists())
				{
					var spell0 = marisa.GetSpellWithParameterName(typeof(Spell.White.OrreysSun).FullName);
					var spell1 = marisa.GetSpellWithParameterName(typeof(Spell.White.StarDust).FullName);
					var spell2 = marisa.GetSpellWithParameterName(typeof(Spell.White.BlazingStar).FullName);

					if (spell0 != null && spell0.Level > 0 ||
						spell1 != null && spell1.Level > 0 ||
						spell2 != null && spell2.Level > 0)
					{
						next = true;
					}
				}

				if (next) break;

				yield return true;
			}

			{
				ui.ShowConditionText("");
				ui.PauseGame();
				ui.Show();

				ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true);
				ui.ShowText("【紫】\nはい、これでスペルカードが使えるようになるわ");
				ui.ShowText("【紫】\n一番下のレベルアップに対応して押せるようになったアイコンを押せば使えるわね");
				ui.ShowText("【紫】\nただし、スペルカードの使い方は種類によって違ってくるわ。");
				ui.ShowText("【紫】\nアイコン押したのにスペカが出ない！というときは何かアクションが追加で必要なときね、説明文をよく読んで使ってね");
				ui.ShowText("【紫】\nアイコンを押して使う任意発動のタイプにはクールタイムがあって連射はできないのに注意ね");
				ui.ShowText("【紫】\nあと、ひとつのスペルカードはレベル3まで上げられるけれどキャラのレベルが低いうちは割り振りができないわ");
				ui.ShowText("【紫】\nそれじゃあもう一戦、MAPの上の方に敵を用意したから、次はスペルカードも使ってみましょう、レベルもおまけを付けたからちゃんとポイントを割り振ること");
				ui.ShowText("", false);
				ui.ShowImage(-1, StoryUIImagePosition.Right, true);
				var div0 = ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, false);

				while (!ui.IsCompleted(div0))
				{
					yield return null;
				}

				ui.Hide();
				ui.ResumeGame();

				ui.ShowConditionText("目的：敵を殲滅する。");
			}

			// 強制レベルアップ
			if (reimu.Exists())
			{
				reimu.AddExperience(500);
			}

			if (marisa.Exists())
			{
				marisa.AddExperience(500);
			}

			yield return true;
		}

		System.Collections.IEnumerable Talk終了(thrts.IWorld world)
		{
			var ui = world.StoryUI;

			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【紫】\nいかがだったかしら？");
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Right, true, false);
			ui.ShowText("【魔理沙】\nワリと骨のある奴らだったな");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Right, true, false);
			ui.ShowText("【霊夢】\n参加しないといってこんな危ない花火もった奴ら、放置するのもアレね");
			ui.ShowImage(Reimu[1], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【霊夢】\n紫、アンタも含めて");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【紫】\nあら怖い");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【紫】\nけれど乗り気になってくれて助かるわ、1チーム6人までだからそこは気をつけなさい");

			ui.ShowImage(Reimu[0], StoryUIImagePosition.Right, true);
			ui.ShowText("【霊夢】\n大体はわかったわ。でももう少し仲間が欲しいところね");
			ui.ShowText("【紫】\nちなみに私はならないわよ。じゃあ頑張ってね");
			ui.ShowImage(-1, StoryUIImagePosition.Left, true);
			ui.ShowImage(Marisa[2], StoryUIImagePosition.Left, true);
			ui.ShowText("【魔理沙】\n言いたいことだけ言って去っていったな");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Right, false);
			ui.ShowText("【霊夢】\nまぁいつものことよ。で、仲間だけどどうする？");
			ui.ShowText("【魔理沙】\nうーん。とりあえずアリスにでも声をかけてみるか？　なってくれるとは限らんが");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Right, false);
			ui.ShowText("【霊夢】\nアリスはパス。紅魔館とかの連中もどうせ自分たちで固まるだろうから、ここは気軽に行けて戦力になるところを捕まえましょう");
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Left, false);
			ui.ShowText("【魔理沙】\nと、いうと？");
			ui.ShowText("【霊夢】\nまず行くべきは、人里よ");

			ui.ShowText("", false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, false);
			var talkEvent = ui.ShowImage(-1, StoryUIImagePosition.Right, true);
		
			while (!ui.IsCompleted(talkEvent))
			{
				yield return null;
			}

			ui.Hide();
			ui.ResumeGame();
		}


		public override System.Collections.IEnumerable Update(thrts.IWorld world)
		{
			var ui = world.StoryUI;

			// 立ち絵
			Reimu = new int[3] { ui.LoadImage("LotusCraft/Image/Tachie/Reimu_N"), ui.LoadImage("LotusCraft/Image/Tachie/Reimu_S"), ui.LoadImage("LotusCraft/Image/Tachie/Reimu_W") };
			Marisa = new int[3] { ui.LoadImage("LotusCraft/Image/Tachie/Marisa_N"), ui.LoadImage("LotusCraft/Image/Tachie/Marisa_S"), ui.LoadImage("LotusCraft/Image/Tachie/Marisa_W") };
			Yukari = new int[3] { ui.LoadImage("LotusCraft/Image/Tachie/Yukari_N"), ui.LoadImage("LotusCraft/Image/Tachie/Yukari_S"), ui.LoadImage("LotusCraft/Image/Tachie/Yukari_W") };

			/*
			{
				ui.PauseGame();

				ui.Show();
				ui.ShowImage(Reimu[0], StoryUIImagePosition.Front, true);

				ui.ShowImage(black, StoryUIImagePosition.Back, true, true);
				ui.ShowImage(red, StoryUIImagePosition.Back, true, true);

				ui.ShowImage(-1, StoryUIImagePosition.Front, true);
				ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, true);
				ui.ShowImage(Marisa[0], StoryUIImagePosition.Right, true);

				while (true)
				{
					yield return null;
				}
			}
			*/
			// 会話用BGM
			world.ChangeBGM(BGMList.Boushuen_Story1);

			// 霊夢と魔理沙を取得
			var reimu = GetUnits(world, world.Factions[0], typeof(LotusCraft.Unit.White.Unique.Reimu)).First();
			var marisa = GetUnits(world, world.Factions[0], typeof(LotusCraft.Unit.White.Unique.Marisa)).First();

			var talk会話冒頭 = Talk会話冒頭(world);
			foreach (var t in talk会話冒頭)
			{
				yield return true;
			}

			world.ChangeBGM(BGMList.Battle_Hakurei);


			var talkユニット選択and移動 = Talkユニット選択and移動(world);
			foreach (var t in talkユニット選択and移動)
			{
				yield return true;
			}

			// イベント2エリアに侵入待ち
			var areaEvent2 = world.AllPurposeArea.Where(_ => _.Name == "イベント2").First() as AreaRectangle;
			while (!IsUnitOnArea(areaEvent2, reimu) && !IsUnitOnArea(areaEvent2, marisa))
			{
				yield return null;
			}

			var talkユニット戦闘1 = Talkユニット戦闘1(world);
			foreach (var t in talkユニット戦闘1)
			{
				yield return true;
			}

			var talkスペル説明 = Talkスペル説明(world);
			foreach (var t in talkスペル説明)
			{
				yield return true;
			}

			ui.ShowConditionText("目的：敵を殲滅する。");

			var units = new List<IUnit>();
			{
				var area1 = world.AllPurposeArea.Where(_ => _.Name == "雑魚1").First() as AreaRectangle;
				units.AddRange(PutUnitsOnArea(world, world.Factions[1], typeof(LotusCraft.Unit.Neutral.Low01), area1));

				var area2 = world.AllPurposeArea.Where(_ => _.Name == "雑魚2").First() as AreaRectangle;
				units.AddRange(PutUnitsOnArea(world, world.Factions[1], typeof(LotusCraft.Unit.Neutral.Low11), area2));

				if (world.StoryUtilities.GetDifficulty() > 0)
				{
					var area3 = world.AllPurposeArea.Where(_ => _.Name == "雑魚3").First() as AreaRectangle;
					units.AddRange(PutUnitsOnArea(world, world.Factions[1], typeof(LotusCraft.Unit.Neutral.Low11), area3));
				}
			}

			// イベント3エリアに侵入待ち
			var areaEvent3 = world.AllPurposeArea.Where(_ => _.Name == "イベント3").First() as AreaRectangle;
			while (!IsUnitOnArea(areaEvent3, reimu) && !IsUnitOnArea(areaEvent3, marisa))
			{
				yield return null;
			}

			{
				ui.PauseGame();
				ui.Show();
				ui.ShowImage(Marisa[2], StoryUIImagePosition.Left, true, false);
				ui.ShowText("【魔理沙】\nおいちょっと待て、さすがにアレは多すぎないか？");
				ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, true, false);
				ui.ShowText("【紫】\nあらあら、吹っ飛ばすのではなくって？");
				ui.ShowImage(Marisa[2], StoryUIImagePosition.Left, false, false);
				ui.ShowText("【魔理沙】\n残念だったな、今日はどうも調子が悪いらしい");
				ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false);
				ui.ShowText("【紫】\n稀代の魔法使いなら一人で大群相手できたりするものよ？");
				ui.ShowImage(Marisa[2], StoryUIImagePosition.Left, false, false);
				ui.ShowText("【魔理沙】\n私は普通の魔法使いで満足のつもりなんだけどな");
				ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, true, false);
				ui.ShowText("【霊夢】\n虐めてないで話し続けなさいよ。別に喧嘩売りに来たわけじゃないでしょ");
				ui.ShowImage(Yukari[1], StoryUIImagePosition.Right, false, false);
				ui.ShowText("【紫】\nそうね、別に私は英雄譚を求めているわけではない。軍勢には軍勢で…さ、戦争ごっこをしてみましょう？");
				ui.ShowText("【紫】\nマップの下のほうに援軍を用意したわ。全員で突撃すればどうにかなるわよ。");

				ui.ShowText("", false);
				ui.ShowImage(-1, StoryUIImagePosition.Left, false);
				var talkEvent = ui.ShowImage(-1, StoryUIImagePosition.Right, true);

				while (!ui.IsCompleted(talkEvent))
				{
					yield return null;
				}

				ui.Hide();
				ui.ResumeGame();
			}

			{
				var area1 = world.AllPurposeArea.Where(_ => _.Name == "増援1").First() as AreaRectangle;
				PutUnitsOnArea(world, world.Factions[0], typeof(LotusCraft.Unit.White.Low02), area1);

				if (world.StoryUtilities.GetDifficulty() < 2)
				{
					var area2 = world.AllPurposeArea.Where(_ => _.Name == "増援2").First() as AreaRectangle;
					PutUnitsOnArea(world, world.Factions[0], typeof(LotusCraft.Unit.White.Low03), area2);
				}

				//var area3 = world.AllPurposeArea.Where(_ => _.Name == "増援3").First() as AreaRectangle;
				//PutUnitsOnArea(world, world.Factions[0], typeof(LotusCraft.Unit.White.Low02), area1);

				world.Factions[0].MoveScreenPosition(new Vector2D((area1.Start.X + area1.End.X) / 2 * Def.MapTipLengthOnField, (area1.Start.Y + area1.End.Y) / 2 * Def.MapTipLengthOnField));
			}




			while (units.Any(_ => _.Exists()))
			{
				yield return true;
			}

			for (int loop = 0; loop < 120; loop++)
			{
				yield return true;
			}

			var talk終了 = Talk終了(world);
			foreach (var t in talk終了)
			{
				yield return true;
			}

			// 終了
			world.Factions[1].DoesNotLose = false;
			world.StoryUtilities.SetDataToSaveData("LotusCraft.Prologue.01", "Clear");

			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				world.StoryUtilities.SetDataToSaveData("LotusCraft.Prologue.01.Easy", "Clear");
			}
			else if (world.StoryUtilities.GetDifficulty() == 1)
			{
				world.StoryUtilities.SetDataToSaveData("LotusCraft.Prologue.01.Normal", "Clear");
			}
			if (world.StoryUtilities.GetDifficulty() == 2)
			{
				world.StoryUtilities.SetDataToSaveData("LotusCraft.Prologue.01.Hard", "Clear");
			}
			
			yield return base.Update(world);
		}

		/// <summary>
		/// ユニットを取得する。
		/// </summary>
		/// <param name="world"></param>
		/// <param name="faction"></param>
		/// <param name="paramType"></param>
		/// <returns></returns>
		public IEnumerable<IUnit> GetUnits(IWorld world, IFaction faction, Type paramType)
		{
			return world.UnitManager.GetUnits(_ => _.Faction == faction && _.Parameter.GetType() == paramType);
		}

		/// <summary>
		/// ユニットをエリア上に生成する。
		/// </summary>
		/// <param name="world"></param>
		/// <param name="faction"></param>
		/// <param name="paramType"></param>
		/// <param name="area"></param>
		/// <returns></returns>
		public IEnumerable<IUnit> PutUnitsOnArea(IWorld world, IFaction faction, Type paramType, Area area)
		{
			var ar = area as AreaRectangle;
			if (ar == null) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min(ar.Start.X,ar.End.X);
			var sy = Math.Min(ar.Start.Y,ar.End.Y);
			var ex = Math.Max(ar.Start.X,ar.End.X);
			var ey = Math.Max(ar.Start.Y,ar.End.Y);

			for( var y = sy; y <= ey; y++)
			{
				for( var x = sx; x <= ex; x++)
				{
					var u = 
						world.UnitManager.Create(paramType.FullName, faction, (x + 0.5f) * thrts.Def.MapTipLengthOnField, (y + 0.5f) * thrts.Def.MapTipLengthOnField, faction);
					if (u != null) units.Add(u);
				}
			}

			return units;
		}

		/// <summary>
		/// ユニットが領域上に重なっているか取得する。
		/// </summary>
		/// <returns></returns>
		bool IsUnitOnArea(AreaRectangle region, IUnit unit)
		{
			var startx = Math.Min(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var starty = Math.Min(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			var endx = Math.Max(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var endy = Math.Max(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			if (unit.Pos.X < endx && startx < unit.Pos.X && unit.Pos.Y < endy && starty< unit.Pos.Y)
			{
				return true;
			}
			return false;
		}

		/// <summary>
		/// 本拠地を建てる
		/// </summary>
		/// <param name="world"></param>
		/// <param name="basePos"></param>
		public void BuildHomebase(IWorld world, Point2D basePos){
		
			string homebaseName = string.Empty;


			// 本拠地を建てる
			homebaseName = typeof(Building.White.HomeBase).FullName;

			var homebase = world.Factions[0].GetBuildingParameter(homebaseName);
			var homeBasePos = new Point2D(basePos.X, basePos.Y);
			world.BuildingManager.Create(homebaseName, world.Factions[0], homeBasePos.X, homeBasePos.Y, 100.0f, world.Factions[0]);

		}
	}
}
