﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using thrts;

namespace LotusCraft.Story
{
	public class StoryBlack01 : thrts.Mission
	{
		public override string[] GetSelectableFactions()
		{
			return new string[] {
				typeof( Faction.Black).FullName
			};
		}

		public override string[] GetEnableFactions()
		{
			return new string[]	{
				typeof( Faction.Black ).FullName
			};
		}

		public override string[] GetSelectableMaps()
		{
			return new string[] {
				"LotusCraft/Story/StoryBlack01.map",
			};
		}

		public StoryBlack01()
			: base()
		{
			Name = "ストーリー黒1話";
			Description = "黒1話のマップ";
			Mode = thrts.MissionMode.Story;

			this.TheNumberOfMaximumSelectablePlayersInTeam = 0;
			this.TheNumberOfSelectableTeams = 0;
		}

		int[] Miko = null;
		int[] Seiga = null;
		int[] Rin = null;
		int[] Utsuho = null;
		int[] Yamame = null;
		int[] Yuyuko = null;
		int Back1 = 0;
		IBuilding enemyHigh1 = null;
		IBuilding enemyHigh2 = null;
		IBuilding enemyHigh3 = null;
		IBuilding blackHome = null;

		int enemySpan = 1800;

		
		public override void OnInitialize(thrts.IWorld world)
		{
			world.Factions[1].PlayerName = "敵勢力";

			// 最初から負けないように
			world.Factions[0].DoesNotLose = true;
			world.Factions[1].DoesNotLose = true;


			// 初期資源を配布
			world.Factions[0].IncResource(0, 200);
			world.Factions[0].IncResource(1, 200);

			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low02).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low03).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Youmu).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Oku).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Orin).FullName).HP /= 2;

				enemySpan = 1900;
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low02).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low02).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low03).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low03).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Youmu).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Youmu).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Oku).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Oku).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Orin).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Orin).FullName).HP * 0.2);

				enemySpan = 1500;
			}

			// 本拠の位置を初期視点にする
			
			var home = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Black.HomeBase) && _.Faction == world.Factions[0]).First();
			var basePos = home.Pos;

			// ボタン仕様禁止
			var ui = world.StoryUI;
			ui.HideButton(home, ButtonPosition._0, ButtonPosition._1);
			ui.HideButton(home, ButtonPosition._1, ButtonPosition._1);
			ui.HideButton(home, ButtonPosition._2, ButtonPosition._1);
			ui.HideButton(home, ButtonPosition._0, ButtonPosition._2);
			
			// 初期視点位置
			world.Factions[0].Parameter.DefaultScreenPosition
				= new Point2D((int)basePos.X, (int)basePos.Y);

			
			//homeparam.ButtonParams

			base.OnInitialize(world);
		}

		public override System.Collections.IEnumerable Update(IWorld world)
		{
			var ui = world.StoryUI;

			// 中央の拠点
			blackHome = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Black.HomeBase) && _.Faction == world.Factions[0]).First();
			enemyHigh1 = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Black.Factory) && _.Pos.Y > 38 * 32 && _.Pos.Y < 88 * 32 && _.Faction == world.Factions[1]).First();
			// 上の拠点
			enemyHigh2 = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Black.Chireiden) && _.Pos.Y > 88 * 32 && _.Faction == world.Factions[1]).First();
			// 下の拠点
			enemyHigh3 = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Black.Factory) && _.Pos.Y < 38 * 32 && _.Faction == world.Factions[1]).First();
			

			Yuyuko = LoadTachies(ui, "LotusCraft/Image/Tachie/Yuyuko_N", "LotusCraft/Image/Tachie/Yuyuko_S", "LotusCraft/Image/Tachie/Yuyuko_W");
			Miko = LoadTachies(ui, "LotusCraft/Image/Tachie/Miko_N", "LotusCraft/Image/Tachie/Miko_S", "LotusCraft/Image/Tachie/Miko_W");
			Seiga = LoadTachies(ui, "LotusCraft/Image/Tachie/Seiga_N", "LotusCraft/Image/Tachie/Seiga_S", "LotusCraft/Image/Tachie/Seiga_W");
			Rin = LoadTachies(ui, "LotusCraft/Image/Tachie/Rin_N", "LotusCraft/Image/Tachie/Rin_S", "LotusCraft/Image/Tachie/Rin_W");
			Utsuho = LoadTachies(ui, "LotusCraft/Image/Tachie/Utsuho_N", "LotusCraft/Image/Tachie/Utsuho_S", "LotusCraft/Image/Tachie/Utsuho_W");
			Back1 = ui.LoadImage("LotusCraft/Image/Back/Black");
			Yamame = LoadTachies(ui, "LotusCraft/Image/Tachie/Yamame_N", "LotusCraft/Image/Tachie/Yamame_S", "LotusCraft/Image/Tachie/Yamame_W");

			var yamameUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Yamame)).First();
			var rinUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Rin)).First();
			var utsuhoUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Utsuho)).First();
			var mikoUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Miko)).First();

			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				yamameUnit.AddExperience(1500);
				rinUnit.AddExperience(1500);
				utsuhoUnit.AddExperience(1500);
			}
			else if (world.StoryUtilities.GetDifficulty() == 1)
			{
				yamameUnit.AddExperience(3000);
				rinUnit.AddExperience(3000);
				utsuhoUnit.AddExperience(3000);
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				yamameUnit.AddExperience(5000);
				rinUnit.AddExperience(5000);
				utsuhoUnit.AddExperience(5000);
			}

			world.ChangeBGM(BGMList.Boushuen_Story1);

			//*
			foreach (var item in Talk会話冒頭(world))
			{
				yield return null;
			}
			//*/

			world.ChangeBGM(BGMList.Battle_Kyuuto);


			ui.ShowConditionText("目的：空、燐、ヤマメの撃破");

			int c = 0;



			while (true)
			{
				if (!utsuhoUnit.Exists() && !rinUnit.Exists() && !yamameUnit.Exists())
				{
					for (var i = 0; i < 1 * Def.FPS; i++) {
						yield return null;
					}

					foreach (var item2 in Talk勝利(world))
					{
						yield return null;
					}
					world.Factions[1].DoesNotLose = false;
					world.Factions[1].Lose();
					world.StoryUtilities.SetDataToSaveData("LotusCraft.Black.01", "Clear");
					if (world.StoryUtilities.GetDifficulty() == 0)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Black.01.Easy", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 1)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Black.01.Normal", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 2)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Black.01.Hard", "Clear");
					}
					world.ChangeBGM(BGMList.Boushuen_Win);

					break;
				}
				if (!blackHome.Exists())
				{
					foreach (var item2 in Talk敗北(world))
					{
						yield return null;
					}
					world.Factions[0].DoesNotLose = false;
					world.Factions[0].Lose();
					world.ChangeBGM(BGMList.Boushuen_Lose);

					break;
				}


				if (world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Yamame) || _.Parameter.GetType() == typeof(Unit.Black.Unique.Rin) || _.Parameter.GetType() == typeof(Unit.Black.Unique.Utsuho)).Count() == 2) {
					if (world.StoryUtilities.GetDifficulty() == 0)
					{
						enemySpan = 1800;
					}
					else if (world.StoryUtilities.GetDifficulty() == 1)
					{
						enemySpan = 1600;
					}
					else if (world.StoryUtilities.GetDifficulty() == 2)
					{
						enemySpan = 1300;
					}
				}
				else if (world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Yamame) || _.Parameter.GetType() == typeof(Unit.Black.Unique.Rin) || _.Parameter.GetType() == typeof(Unit.Black.Unique.Utsuho)).Count() == 1)
				{
					if (world.StoryUtilities.GetDifficulty() == 0)
					{
						enemySpan = 1600;
					}
					else if (world.StoryUtilities.GetDifficulty() == 1)
					{
						enemySpan = 1400;
					}
					else if (world.StoryUtilities.GetDifficulty() == 2)
					{
						enemySpan = 1000;
					}
				}

				world.WriteLine(1, enemySpan + ":" + world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Yamame) || _.Parameter.GetType() == typeof(Unit.Black.Unique.Rin) || _.Parameter.GetType() == typeof(Unit.Black.Unique.Utsuho)).Count());

				// ざこ
				if (c % enemySpan == 0)
				{
					if (c >= enemySpan * 6)
					{

						if (c < enemySpan * 8) {
							if (enemyHigh1.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, enemyHigh1);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, enemyHigh1);
								uniqueIDs.Add(l2.UniqueID);
								foreach (var ln in uniqueIDs)
								{
									var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
									n.HP = n.MaxHP;
								}
								world.UnitManager.AttackMove(uniqueIDs, blackHome, false);
							}
							if (enemyHigh2.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyHigh2);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyHigh2);
								uniqueIDs.Add(l2.UniqueID);
								foreach (var ln in uniqueIDs)
								{
									var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
									n.HP = n.MaxHP;
								}
								world.UnitManager.AttackMove(uniqueIDs, blackHome, false);
							}
							if (enemyHigh3.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyHigh3);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyHigh3);
								uniqueIDs.Add(l2.UniqueID);
								foreach (var ln in uniqueIDs)
								{
									var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
									n.HP = n.MaxHP;
								}
								world.UnitManager.AttackMove(uniqueIDs, blackHome, false);
							}
						}
						else if (c < enemySpan * 14)
						{
							if (enemyHigh1.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								if (world.StoryUtilities.GetDifficulty() == 2)
								{
									var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, enemyHigh1);
									uniqueIDs.Add(l1.UniqueID);
								}
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyHigh1);
								uniqueIDs.Add(l2.UniqueID);
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, enemyHigh1);
								uniqueIDs.Add(l3.UniqueID);
								foreach (var ln in uniqueIDs)
								{
									var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
									n.HP = n.MaxHP;
								}
								world.UnitManager.AttackMove(uniqueIDs, blackHome, false);
							}

							if (enemyHigh2.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, enemyHigh2);
								uniqueIDs.Add(l3.UniqueID);
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, enemyHigh2);
								uniqueIDs.Add(l4.UniqueID);
								if (world.StoryUtilities.GetDifficulty() == 2)
								{
									var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, enemyHigh2);
									uniqueIDs.Add(l1.UniqueID);
								}
								foreach (var ln in uniqueIDs)
								{
									var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
									n.HP = n.MaxHP;
								}
								world.UnitManager.AttackMove(uniqueIDs, blackHome, false);
							}
							if (enemyHigh3.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyHigh3);
								uniqueIDs.Add(l4.UniqueID);
								var l5 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyHigh3);
								uniqueIDs.Add(l5.UniqueID);
								if (world.StoryUtilities.GetDifficulty() == 2)
								{
									var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyHigh3);
									uniqueIDs.Add(l1.UniqueID);
								}
								foreach (var ln in uniqueIDs)
								{
									var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
									n.HP = n.MaxHP;
								}
								world.UnitManager.AttackMove(uniqueIDs, blackHome, false);
							}
						}
						else
						{
							if (enemyHigh1.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, enemyHigh1);
								uniqueIDs.Add(l1.UniqueID);
								if (world.StoryUtilities.GetDifficulty() > 0)
								{
									var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, enemyHigh1);
									uniqueIDs.Add(l2.UniqueID);
								}
								if (world.StoryUtilities.GetDifficulty() == 2)
								{
									var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, enemyHigh1);
									uniqueIDs.Add(l2.UniqueID);
									var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, enemyHigh1);
									uniqueIDs.Add(l4.UniqueID);
								}
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, enemyHigh1);
								uniqueIDs.Add(l3.UniqueID);
								foreach (var ln in uniqueIDs)
								{
									var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
									n.HP = n.MaxHP;
								}
								world.UnitManager.AttackMove(uniqueIDs, blackHome, false);

								uniqueIDs = new List<int>();
								var l6 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyHigh1);
								uniqueIDs.Add(l6.UniqueID);
								if (world.StoryUtilities.GetDifficulty() == 2 && mikoUnit.Exists())
								{
									world.UnitManager.AttackMove(uniqueIDs, mikoUnit, false);
								}
							}

							if (enemyHigh2.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, enemyHigh2);
								uniqueIDs.Add(l3.UniqueID);
								var l6 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, enemyHigh2);
								uniqueIDs.Add(l6.UniqueID);
								if (world.StoryUtilities.GetDifficulty() > 0)
								{
									var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, enemyHigh2);
									uniqueIDs.Add(l4.UniqueID);
								}
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, enemyHigh2);
								uniqueIDs.Add(l2.UniqueID);
								foreach (var ln in uniqueIDs)
								{
									var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
									n.HP = n.MaxHP;
								}
								world.UnitManager.AttackMove(uniqueIDs, blackHome, false);
								
								uniqueIDs = new List<int>();
								var l5 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, enemyHigh1);
								uniqueIDs.Add(l5.UniqueID);
								if (world.StoryUtilities.GetDifficulty() == 2 && mikoUnit.Exists())
								{
									world.UnitManager.AttackMove(uniqueIDs, mikoUnit, false);
								}
							}
							if (enemyHigh3.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, enemyHigh3);
								uniqueIDs.Add(l2.UniqueID);
								var l6 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, enemyHigh3);
								uniqueIDs.Add(l6.UniqueID);
								if (world.StoryUtilities.GetDifficulty() > 0)
								{
									var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, enemyHigh3);
									uniqueIDs.Add(l3.UniqueID);
								}
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyHigh3);
								uniqueIDs.Add(l1.UniqueID);
								foreach (var ln in uniqueIDs)
								{
									var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
									n.HP = n.MaxHP;
								}
								world.UnitManager.AttackMove(uniqueIDs, blackHome, false);

								uniqueIDs = new List<int>();
								var l5 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyHigh1);
								uniqueIDs.Add(l5.UniqueID);
								if (world.StoryUtilities.GetDifficulty() == 2 && mikoUnit.Exists())
								{
									world.UnitManager.AttackMove(uniqueIDs, mikoUnit, false);
								}
								foreach (var ln in uniqueIDs)
								{
									var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
									n.HP = n.MaxHP;
								}
								world.UnitManager.AttackMove(uniqueIDs, blackHome, false);
							}
						}
					}
				}

				c++;
				yield return null;
			}
			
			yield return base.Update(world);
		}


		#region Story
		private System.Collections.IEnumerable Talk会話冒頭(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk1
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Back1,StoryUIImagePosition.Back2,false,false,false);
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n我々の勢力は全部に喧嘩売ります！");
			ui.ShowImage(Seiga[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【青娥】\nあ、はい。太子様？　いきなり何を宣言なされているので？");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n某翻訳家みたいな話し方になっているけど大丈夫？");
			ui.ShowText("【神子】\nとにかく、我々の勢力は幻想郷に来てから日が浅い。今回は割り切って、馴染むために動くのが最適と判断しました");
			ui.ShowImage(Seiga[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【青娥】\n筋は通っているようないないような。それが太子様の欲望なのね");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nちなみに既に寺には果たし状を送り済みです");
			ui.ShowImage(Seiga[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【青娥】\nまぁ、お早いことで");
			ui.ShowText("【神子】\nあそこだけはボコります");
			ui.ShowImage(Seiga[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【青娥】\nはい");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nはい。まぁとりあえず仲間集めですね。");
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n布都は知らない人と居ると燃やしてしまいそうですし、一人にしておくのも不安です。\nよって、屠自古には布都を見ていてもらいます");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nで、まずは冥界に向かおうかと");
			ui.ShowText("【青娥】\nなぜわざわざそのような場所へ？");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nあそこには亡霊の姫が住んでいると聞きます。なんか興奮しませんか？");
			ui.ShowImage(Seiga[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【青娥】\n太子様……？");
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nなんでもないです。彼女は過去に、異変の黒幕にもなったと聞きます。誘って損はないかと");
			ui.ShowText("【青娥】\n従者の武者娘は？");
			ui.ShowText("【神子】\nどうにも武人気質が物部守屋を思い出すので……");
			ui.ShowImage(Seiga[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【青娥】\nあっ……");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Miko[1],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【神子】\nさあ行きましょう青娥。私たちの旅はこれからだ");
			ui.ShowImage(Seiga[1],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【青娥】\n完");
			ui.ShowImage(Back1,StoryUIImagePosition.Back2,false);
			ui.ShowText("～白玉楼～");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nかくかくしがじか");
			ui.ShowImage(Yuyuko[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【幽々子】\nいいわよ");
			ui.ShowImage(Seiga[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【青娥】\nかくかくしかじかで会話が成立しているのを初めて見ましたわ");
			ui.ShowImage(Yuyuko[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽々子】\n要するに楽しい遊びに誘ってくれるということでしょう？\n紫ったら親友である私を差し置いてほかの娘に声をかけているんだもの。失礼しちゃうわ");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\nそのお陰で我々はこうして志を一つにできたのですから、人生万事塞翁が馬という奴ですよ");
			ui.ShowImage(Yuyuko[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽々子】\nあら？　それは中国故事ではなくって？");
			ui.ShowText("【神子】\nもちろん、淮南子にも触れておりますから");
			ui.ShowImage(Yuyuko[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽々子】\nあらあら。それで豊聡耳様には、これからの当てがあるのかしら？");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n地底に行ってみようかと");
			ui.ShowImage(Yuyuko[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽々子】\n地底に？　彼処は疎まれ追いやられた者たちの土地。そんなところに好んで関わるだなんて変わり者ね");
			ui.ShowText("【神子】\nだからこそですよ。");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n私はこの幻想郷に来てからまだ日が浅い――少々荒技を使わなければ、他に出し抜かれてしまうばかりなのです");
			ui.ShowImage(Yuyuko[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽々子】\n手段を選ばないのね");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nそういう性質ですからね");
			ui.ShowImage(Yuyuko[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽々子】\nわかったわ。どうせ乗った時点で一蓮托生ですもの。地獄までお付き合いしますわ");
			ui.ShowImage(Seiga[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【青娥】\n話が纏まったみたいで");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\nええ。全て話し合いで纏まればいいのですが、そういうわけにもいかないでしょうし。");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nあ、果たし状は読んで頂けたかしら。確認がてら、顔を出してみようかしら");
			ui.ShowImage(Yuyuko[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽々子】\n私はしばらくはここで待っておりますわ。あまりここを空けるわけにもいかなくて");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nいずれまたお迎えに参りますゆえ。");
			ui.ShowImage(Yuyuko[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽々子】\n黄色いハンケチを用意して待ってますから");
			ui.ShowImage(Seiga[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【青娥】\nそれ駄目じゃない？");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(-1,StoryUIImagePosition.Back2,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowText("～地底～");
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n地霊殿の主によれば、今日は旧都に居るであろうとのことですが");
			ui.ShowImage(Seiga[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【青娥】\n案外すんなりいくものですね");
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(Miko[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【神子】\nペットの自主性に任せるとのことでしたが、はてさて。\n博麗を味方に付けた寺と事を構えるには、亡霊姫だけでは心許がないのです");
			ui.ShowImage(Yamame[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【ヤマメ】\nうんうん確かに");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【神子】\nできるだけ過激に！　とまではいきませんが、ここは一つ、私たちは狂言回しの役割を演じようではありませんか");
			ui.ShowImage(Yamame[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【ヤマメ】\n乗った！");
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\nありがとうございます。そして貴女は誰ですか？");
			ui.ShowImage(Yamame[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【ヤマメ】\n聞いたよ。あんた、寺に遺恨があるそうだね。そうなれば私たちは姉妹も同然");
			ui.ShowText("【神子】\n貴女も命蓮寺に何かを？");
			ui.ShowImage(Yamame[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【ヤマメ】\n私も仏門に入ろうかなーと思ったのだけど、そんな疚しい理由では認められないと");
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nなるほど。それで一杯食わせたいというわけですね");
			ui.ShowImage(Yamame[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【ヤマメ】\nそうそう。私の名前は黒谷ヤマメ。土蜘蛛をやっている");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n申し遅れました。私は豊郷耳神子と申します。");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n連れは仙人の霍青娥。キョンシーを操り、壁を抜けるプライバシーの欠片もない悪女です");
			ui.ShowImage(Seiga[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【青娥】\nそんな紹介があるものですか");
			ui.ShowImage(Yamame[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【ヤマメ】\n地底は陰気なのが多いから、あんたたちみたいな陽気な連中は珍しいね。\n鬼ぐらいか、そういう性質の奴は");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n鬼ですか。いずれ会ってみたいものです");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nときに、地獄烏と化け猫のコンビを探しているのですが");
			ui.ShowText("【ヤマメ】\nあぁ、あの二匹なら連れ立ってそこらへんで遊んでいるだろうさ。なんでも、妖怪の賢者が新しい遊びを考案したんだとかなんとか");
			ui.ShowText("【神子】\nまさにそれへの誘いをしにきたのです");
			ui.ShowImage(Yamame[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【ヤマメ】\nけれども彼女らのお目当ては巫女たちじゃないかなと私は見ているけれど");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n熱意と情熱を持ってすれば、この世に不可能なことなど何もないのですよ");
			ui.ShowImage(Seiga[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【青娥】\n妄執とも言い換えられるのでは");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\nさもあらん");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(Rin[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【お燐】\nでもお空。あたいは思うんだけど、仲間に入れてって言っても\nあんたは早苗で私は霊夢だろ？　一緒のとこに入れやしないんじゃないか？");
			ui.ShowImage(Utsuho[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【お空】\nうーん。巫女って二種類いるんだっけ？");
			ui.ShowImage(Rin[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【お燐】\nそこから？！　早苗と霊夢の区別も曖昧なの？！");
			ui.ShowImage(Utsuho[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【お空】\n巫女だったらいいかなって");
			ui.ShowImage(Rin[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【お燐】\nそ、そうなんだ……。あたいもまー、お空と一緒ならそれが一番面倒がないなって思うけど");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n話は聞かせてもらいました。私の名前は豊郷耳神子。\n巫女と同音異義語の私ならば、あなたたちを招き入れることも不可能ではないのでは");
			ui.ShowImage(Rin[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【お燐】\nなんか突然出てきた！？");
			ui.ShowImage(Yamame[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【ヤマメ】\nやぁやぁお二人さん");
			ui.ShowImage(Utsuho[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【お空】\nあ。こんにちは。土蜘蛛のお姉さん");
			ui.ShowImage(Rin[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【お燐】\nありゃま、お知り合いですか");
			ui.ShowImage(Yamame[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【ヤマメ】\nちょっとそこでナンパしたんだ。私が");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\nそれで私があなたたちをナンパしにきたのです。上手い仕組みですね");
			ui.ShowImage(Seiga[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【青娥】\nなんだか妙な表現ですが、あながち間違っていないのもなんとも");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n私たちも、八雲紫の提案に一つ乗っかろうと思っています。");
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nが、言ってしまえば頭数が足りません。博麗の巫女や、その他の強豪を相手取るには地底の力を借りなければならぬと判断しました");
			ui.ShowImage(Rin[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【お燐】\nあら情熱的な口説き文句だこと。あたいクラっと来ちゃうかも？　それに、あたいとお空、両方を引っ張ってくれるんでしょ？");
			ui.ShowText("【神子】\nもちろん。笑い声の絶えないアットホームな職場を目指していますから");
			ui.ShowImage(Utsuho[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【お空】\nブラッ");
			ui.ShowImage(Rin[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【お燐】\nでもでも！　それだけじゃああたいたちもはいそうですかってついていくわけにはいきませんね");
			ui.ShowImage(Rin[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【お燐】\n付いてこいってことは、お姉さんがあたいたちの頭領になるわけだ。");
			ui.ShowImage(Rin[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【お燐】\nだったら、それなりの力を見せてもらわなきゃ納得できやしない");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nお互いを理解し合うには拳で語り合うのが大事だと何かで読みました。");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n良いでしょう。ではヤマメさんも向こうということで");
			ui.ShowImage(Yamame[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【ヤマメ】\n了解");
			ui.ShowImage(Seiga[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【青娥】\nまずは力で示さなければならないのはどの世界でも同じこと");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n為政者としての格を知らしめてあげましょう");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			
			
			var talkEnd = ui.ShowText(""); 
			while (!ui.IsCompleted(talkEnd))
				yield return null;
			
			ui.Hide();
			ui.ResumeGame();
			#endregion


			yield return null;
		}

	

		private System.Collections.IEnumerable Talk勝利(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk12
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Miko[1],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【神子】\n私に力を貸して頂けますね");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Rin[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【お燐】\nまぁ初めからそのつもりだったし");
			ui.ShowImage(Utsuho[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【お空】\n異論なーし");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\nこの一連の顛末で、私たちがメインを張ることはないでしょうが、散々掻き回させてもらいますよ");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nそれが私の欲望なのですから");
			ui.ShowImage(Seiga[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【青娥】\n欲の深いお方");
			
			var talkEnd0 = ui.ShowText("", false);
			while (!ui.IsCompleted(talkEnd0))
				yield return null;
			ui.Hide();
			ui.ResumeGame();
			#endregion

			yield return null;
		}

		private System.Collections.IEnumerable Talk敗北(IWorld world)
		{
			var ui = world.StoryUI;

			ui.PauseGame();
			ui.Show();
			ui.Hide();
			ui.ResumeGame();

			yield return null;
		}
		#endregion

		private int[] LoadTachies(IStoryUI ui, string path_N, string path_S, string path_W)
		{
			return new int[3]{
				ui.LoadImage( path_N ),
				ui.LoadImage( path_S ),
				ui.LoadImage( path_W )
			};
		}

		/// <summary>
		/// ユニットをエリア上に生成する。
		/// </summary>
		/// <param name="world"></param>
		/// <param name="faction"></param>
		/// <param name="paramType"></param>
		/// <param name="area"></param>
		/// <returns></returns>
		public IEnumerable<IUnit> PutUnitsOnArea(IWorld world, IFaction faction, Type paramType, Area area)
		{
			var ar = area as AreaRectangle;
			if (ar == null) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min(ar.Start.X, ar.End.X);
			var sy = Math.Min(ar.Start.Y, ar.End.Y);
			var ex = Math.Max(ar.Start.X, ar.End.X);
			var ey = Math.Max(ar.Start.Y, ar.End.Y);

			for (var y = sy; y <= ey; y++)
			{
				for (var x = sx; x <= ex; x++)
				{
					var u =
						world.UnitManager.Create(paramType.FullName, faction, (x + 0.5f) * thrts.Def.MapTipLengthOnField, (y + 0.5f) * thrts.Def.MapTipLengthOnField, faction);
					if (u != null) units.Add(u);
				}
			}

			return units;
		}

		public IEnumerable<IUnit> PutEnemy(IWorld world, Type unitType, Area area, int num, IBuilding target)
		{
			var rect = area as AreaRectangle;
			if (rect == null) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min(rect.Start.X, rect.End.X);
			var sy = Math.Min(rect.Start.Y, rect.End.Y);
			var ex = Math.Max(rect.Start.X, rect.End.X);
			var ey = Math.Max(rect.Start.Y, rect.End.Y);

			for (var y = sy; y < ey; y++)
			{
				for (var x = sx; x < ex; x++)
				{
					if (units.Count >= num)
						goto LoopEnd;

					var u = world.UnitManager.Create(
						unitType.FullName,
						world.Factions[1],
						(x + 0.5f) * thrts.Def.MapTipLengthOnField,
						(y + 0.5f) * thrts.Def.MapTipLengthOnField,
						world.Factions[1]);
					if (u != null)
						units.Add(u);
				}
			}
		LoopEnd:

			if (target != null)
				world.UnitManager.SelectTarget(units, new Vector2D(target.Pos.X, target.Pos.Y), false);

			return units;
		}

		bool IsUnitOnArea(AreaRectangle region, IUnit unit)
		{
			var startx = Math.Min(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var starty = Math.Min(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			var endx = Math.Max(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var endy = Math.Max(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			if (unit.Pos.X < endx && startx < unit.Pos.X && unit.Pos.Y < endy && starty < unit.Pos.Y)
			{
				return true;
			}
			return false;
		}

		IEnumerable<IBuilding> GetBuildings<T>(IWorld world) where T : BuildingParameter
		{
			return world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(T));
		}
	}
}

#endif