﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using thrts;

namespace LotusCraft.Story
{
	public class StoryBlack03 : thrts.Mission
	{
		public override string[] GetSelectableFactions()
		{
			return new string[] {
				typeof( Faction.Black ).FullName
			};
		}

		public override string[] GetEnableFactions()
		{
			return new string[]	{
				typeof( Faction.Black ).FullName,
				typeof( Faction.Blue ).FullName
			};
		}

		public override string[] GetSelectableMaps()
		{
			return new string[] {
				"LotusCraft/Story/StoryBlack03.map",
			};
		}

		public StoryBlack03()
			: base()
		{
			Name = "ストーリー黒03";
			Description = "黒3話のマップ";
			Mode = thrts.MissionMode.Story;

			this.TheNumberOfMaximumSelectablePlayersInTeam = 0;
			this.TheNumberOfSelectableTeams = 0;
		}

		int[] Yuyuko = null;
		int[] Rin = null;
		int[] Utsuho = null;
		int[] Miko = null;
		int[] Yamame = null;
		int[] Koishi = null;
		int[] Seiga = null;
		int[] Tenshi = null;
		int Back1 = 0;
		Area[] areas = null;
		IBuilding BlackHome = null;
		IBuilding blueHome = null;
		IBuilding blueLow = null;
		IBuilding blueLow2 = null;
		IBuilding blueHigh = null;

		int enemySpan = 1800;

		/// <summary>
		/// スペルを使用されたかどうか
		/// </summary>
		bool executedTenshiLastSpall = false;
		bool executedKoishiLastSpall = false;
		bool executedTenshiSpall = false;
		bool executedTenshiSpall2 = false;
		bool executedKoishiSpall = false;

		public override void OnInitialize(thrts.IWorld world)
		{
			// 最初から負けないように
			world.Factions[0].DoesNotLose = true;
			world.Factions[1].DoesNotLose = true;


			// 初期資源を配布
			world.Factions[0].IncResource(0, 200);
			world.Factions[0].IncResource(1, 200);

			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Low02).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Iku).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Lunar).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Star).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Sunny).FullName).HP /= 2;
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Lunar).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Lunar).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Low02).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Low02).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Iku).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Iku).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Sunny).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Sunny).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Star).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Star).FullName).HP * 0.2);
				world.UnitManager.GetUnits(u => u.Faction.Index == 1).Do(u => u.MaxHP = u.Parameter.HP).ForEach(u => u.HP = u.Parameter.HP);
			}

			// 本拠の位置を初期視点にする
			var home = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Black.HomeBase)).First();
			var basePos = home.Pos;
			// 初期視点位置
			world.Factions[0].Parameter.DefaultScreenPosition
				= new Point2D((int)basePos.X, (int)basePos.Y);

			world.Factions[1].PlayerName = "青勢力";

			//homeparam.ButtonParams

			base.OnInitialize(world);
		}

		public override System.Collections.IEnumerable Update(IWorld world)
		{
			var ui = world.StoryUI;
			
			BlackHome = GetBuildings<Building.Black.HomeBase>(world).First();
			blueHome = GetBuildings<Building.Blue.HomeBase>(world).First();
			blueHigh = GetBuildings<Building.Blue.Factory>(world).First();
			blueLow = GetBuildings<Building.Blue.Barrack>(world).Where(_ => _.Pos.Y < 50 * 32).First();
			blueLow2 = GetBuildings<Building.Blue.Barrack>(world).Where(_ => _.Pos.Y > 50 * 32).First();

			Yuyuko = LoadTachies(ui, "LotusCraft/Image/Tachie/Yuyuko_N", "LotusCraft/Image/Tachie/Yuyuko_S", "LotusCraft/Image/Tachie/Yuyuko_W");
			Koishi = LoadTachies(ui, "LotusCraft/Image/Tachie/Koishi_N", "LotusCraft/Image/Tachie/Koishi_S", "LotusCraft/Image/Tachie/Koishi_W");
			Utsuho = LoadTachies(ui, "LotusCraft/Image/Tachie/Utsuho_N", "LotusCraft/Image/Tachie/Utsuho_S", "LotusCraft/Image/Tachie/Utsuho_W");
			Rin = LoadTachies(ui, "LotusCraft/Image/Tachie/Rin_N", "LotusCraft/Image/Tachie/Rin_S", "LotusCraft/Image/Tachie/Rin_W");
			Miko = LoadTachies(ui, "LotusCraft/Image/Tachie/Miko_N", "LotusCraft/Image/Tachie/Miko_S", "LotusCraft/Image/Tachie/Miko_W");
			Yamame = LoadTachies(ui, "LotusCraft/Image/Tachie/Yamame_N", "LotusCraft/Image/Tachie/Yamame_S", "LotusCraft/Image/Tachie/Yamame_W");
			Koishi = LoadTachies(ui, "LotusCraft/Image/Tachie/Koishi_N", "LotusCraft/Image/Tachie/Koishi_S", "LotusCraft/Image/Tachie/Koishi_W");
			Seiga = LoadTachies(ui, "LotusCraft/Image/Tachie/Seiga_N", "LotusCraft/Image/Tachie/Seiga_S", "LotusCraft/Image/Tachie/Seiga_W");
			Tenshi = LoadTachies(ui, "LotusCraft/Image/Tachie/Tenshi_N", "LotusCraft/Image/Tachie/Tenshi_S", "LotusCraft/Image/Tachie/Tenshi_W");
			
			Back1 = ui.LoadImage("LotusCraft/Image/Back/Black");

			var KoishiUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Blue.Unique.Koishi)).First();
			var TenshiUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Blue.Unique.Tenshi)).First();
			
			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				KoishiUnit.AddExperience(3000);
				TenshiUnit.AddExperience(5000);
			}
			else if (world.StoryUtilities.GetDifficulty() == 1)
			{
				KoishiUnit.AddExperience(5000);
				TenshiUnit.AddExperience(7000);
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				KoishiUnit.AddExperience(8000);
				TenshiUnit.AddExperience(10000);
			}

			world.ChangeBGM(BGMList.Boushuen_Story2);

			//*
			foreach (var item in Talk会話冒頭(world))
			{
				yield return null;
			}
			//*/

			world.ChangeBGM(BGMList.Battle_Tenkai);

			ui.ShowConditionText("目的：敵拠点の撃破");

			int c = 0;
			
			while (true)
			{
				if (!blueHome.Exists())
				{
					foreach (var item2 in Talk勝利(world))
					{
						yield return null;
					}
					world.Factions[1].DoesNotLose = false;
					world.Factions[1].Lose();
					world.StoryUtilities.SetDataToSaveData("LotusCraft.Black.03", "Clear");

					if (world.StoryUtilities.GetDifficulty() == 0)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Black.03.Easy", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 1)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Black.03.Normal", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 2)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Black.03.Hard", "Clear");
					}
					world.ChangeBGM(BGMList.Boushuen_Win);

					break;
				}
				if (!BlackHome.Exists())
				{
					foreach (var item2 in Talk敗北(world))
					{
						yield return null;
					}
					world.Factions[0].DoesNotLose = false;
					world.Factions[0].Lose();

					world.ChangeBGM(BGMList.Boushuen_Lose);

					break;
				}

				// スペル発動
				if (TenshiUnit.Exists() && !executedTenshiLastSpall && world.StoryUtilities.GetDifficulty() > 0)
				{
					TryCallTenshiLastSpell(world, TenshiUnit);
				}
				if (TenshiUnit.Exists() && !executedTenshiSpall) {
					TryCallTenshiSpell(world, TenshiUnit);
				}
				if (KoishiUnit.Exists() && !executedKoishiLastSpall && world.StoryUtilities.GetDifficulty() > 0 && KoishiUnit.HP < KoishiUnit.MaxHP * 0.8)
				{
					TryCallKoishiLastSpell(world, KoishiUnit);
				}
				else if (KoishiUnit.Exists() && !executedKoishiSpall)
				{	
					TryCallKoishiSpell(world, KoishiUnit);
				}
				if (TenshiUnit.Exists() && !executedTenshiSpall2)
				{
					TryCallTenshiSpell2(world, TenshiUnit);
				}

				
				// ざこ
				if (c % enemySpan == 0)
				{
					if (c == enemySpan * 4 && world.StoryUtilities.GetDifficulty() == 2)
					{
						if (blueHigh.Exists())
						{
							List<int> uniqueIDs = new List<int>();
							var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHigh);
							uniqueIDs.Add(l2.UniqueID);
							var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHigh);
							uniqueIDs.Add(l3.UniqueID);
							
							foreach (var ln in uniqueIDs)
							{
								var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
								n.HP = n.MaxHP;
							}
							var t = world.BuildingManager.GetBuildings(_ => _.Faction == world.Factions[0] && (_.Parameter.GetType() == typeof(LotusCraft.Building.Black.ProduceResType0) || _.Parameter.GetType() == typeof(LotusCraft.Building.Black.ProduceResType1))).FirstOrDefault();
							world.UnitManager.AttackMove(uniqueIDs, t, false);
						}
					}
					if (c == enemySpan * 9 || c == enemySpan * 22)
					{
						// 青ユニークに攻撃命令
						{
							var uniqueIDs = new List<int>();
							if (KoishiUnit.Exists())
							{
								uniqueIDs.Add(KoishiUnit.UniqueID);
							}
							else {
								KoishiUnit = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Unique.Koishi).FullName, blueHome);
								uniqueIDs.Add(KoishiUnit.UniqueID);
								executedKoishiLastSpall = false;
								executedKoishiSpall = false;
							}
							var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHome);
							uniqueIDs.Add(l1.UniqueID);
							var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHome);
							uniqueIDs.Add(l2.UniqueID);
							var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHome);
							uniqueIDs.Add(l3.UniqueID);
							if (world.StoryUtilities.GetDifficulty() > 0)
							{
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHome);
								uniqueIDs.Add(l4.UniqueID);
								var l10 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHome);
								uniqueIDs.Add(l10.UniqueID);
								var l11 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHome);
								uniqueIDs.Add(l11.UniqueID);
								var l8 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHome);
								uniqueIDs.Add(l8.UniqueID);
							}
							if (world.StoryUtilities.GetDifficulty() == 2)
							{
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHome);
								uniqueIDs.Add(l4.UniqueID);
								var l8 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHome);
								uniqueIDs.Add(l8.UniqueID);
								var l13 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHome);
								uniqueIDs.Add(l13.UniqueID);
								var l11 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHome);
								uniqueIDs.Add(l11.UniqueID);
								var l9 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Sunny).FullName, blueHome);
								uniqueIDs.Add(l9.UniqueID);
							}
							
							var l5 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Sunny).FullName, blueHome);
							uniqueIDs.Add(l5.UniqueID);
							var l6 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Sunny).FullName, blueHome);
							uniqueIDs.Add(l6.UniqueID);
							var l7 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Sunny).FullName, blueHome);
							uniqueIDs.Add(l7.UniqueID);

							foreach (var ln in uniqueIDs) {
								var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
								n.HP = n.MaxHP;
							}
							world.UnitManager.AttackMove(uniqueIDs, BlackHome, false);
							
						}

						if (blueLow2.Exists())
						{
							List<int> uniqueIDs = new List<int>();
							var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
							uniqueIDs.Add(l1.UniqueID);
							var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
							uniqueIDs.Add(l3.UniqueID);
							if (world.StoryUtilities.GetDifficulty() > 0)
							{
								var l10 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
								uniqueIDs.Add(l10.UniqueID);
							}
							if (world.StoryUtilities.GetDifficulty() == 2)
							{
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
								uniqueIDs.Add(l4.UniqueID);
								var l10 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
								uniqueIDs.Add(l10.UniqueID);
							}

							foreach (var ln in uniqueIDs)
							{
								var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
								n.HP = n.MaxHP;
							}

							world.UnitManager.AttackMove(uniqueIDs, BlackHome, false);
						}
					}
					else if (c == enemySpan * 14 || c == enemySpan * 20)
					{
						// 青ユニークに攻撃命令
						{
							var uniqueIDs = new List<int>();
							if (!TenshiUnit.Exists()) {
								TenshiUnit = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Unique.Tenshi).FullName, blueHome);
								uniqueIDs.Add(TenshiUnit.UniqueID);
								executedTenshiLastSpall = false;
								executedTenshiSpall = false;
								executedTenshiSpall2 = false;
							}
							uniqueIDs.Add(TenshiUnit.UniqueID);

							var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHome);
							uniqueIDs.Add(l1.UniqueID);
							var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHome);
							uniqueIDs.Add(l2.UniqueID);
							var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHome);
							uniqueIDs.Add(l3.UniqueID);
							if (world.StoryUtilities.GetDifficulty() > 0)
							{
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHome);
								uniqueIDs.Add(l4.UniqueID);
								var l10 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHome);
								uniqueIDs.Add(l10.UniqueID);
							}
							if (world.StoryUtilities.GetDifficulty() == 2)
							{
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHome);
								uniqueIDs.Add(l4.UniqueID);
								var l8 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHome);
								uniqueIDs.Add(l8.UniqueID);
								var l9 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Star).FullName, blueHome);
								uniqueIDs.Add(l9.UniqueID);
								var l12 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Star).FullName, blueHome);
								uniqueIDs.Add(l12.UniqueID);
							}
							
							var l5 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Star).FullName, blueHome);
							uniqueIDs.Add(l5.UniqueID);
							var l6 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Star).FullName, blueHome);
							uniqueIDs.Add(l6.UniqueID);
							var l7 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Star).FullName, blueHome);
							uniqueIDs.Add(l7.UniqueID);

							foreach (var ln in uniqueIDs)
							{
								var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
								n.HP = n.MaxHP;
							}

							world.UnitManager.AttackMove(uniqueIDs, BlackHome, false);

						}
					}
					
					if (c == enemySpan * 6 || c == enemySpan * 7 || c == enemySpan * 14 || c == enemySpan * 20)
					{
						if (blueLow.Exists())
						{
							List<int> uniqueIDs = new List<int>();
							var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow);
							uniqueIDs.Add(l1.UniqueID);
							var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow);
							uniqueIDs.Add(l2.UniqueID);
							var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow);
							uniqueIDs.Add(l3.UniqueID);
							if (world.StoryUtilities.GetDifficulty() > 0)
							{
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow);
								uniqueIDs.Add(l4.UniqueID);
								var l10 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow);
								uniqueIDs.Add(l10.UniqueID);
							}
							if (world.StoryUtilities.GetDifficulty() == 2)
							{
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow);
								uniqueIDs.Add(l4.UniqueID);
								var l10 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow);
								uniqueIDs.Add(l10.UniqueID);
							}

							foreach (var ln in uniqueIDs)
							{
								var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
								n.HP = n.MaxHP;
							}

							world.UnitManager.AttackMove(uniqueIDs, BlackHome, false);
						}

						if (blueLow2.Exists())
						{
							List<int> uniqueIDs = new List<int>();
							var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
							uniqueIDs.Add(l1.UniqueID);
							var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
							uniqueIDs.Add(l3.UniqueID);
							if (world.StoryUtilities.GetDifficulty() > 0)
							{
								var l10 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
								uniqueIDs.Add(l10.UniqueID);
							}
							if (world.StoryUtilities.GetDifficulty() == 2)
							{
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
								uniqueIDs.Add(l4.UniqueID);
								var l10 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
								uniqueIDs.Add(l10.UniqueID);
							}

							foreach (var ln in uniqueIDs)
							{
								var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
								n.HP = n.MaxHP;
							}

							world.UnitManager.AttackMove(uniqueIDs, BlackHome, false);
						}
					}
					else if (c == enemySpan * 10 || c == enemySpan * 12 || c == enemySpan * 13 || c == enemySpan * 16 || c == enemySpan * 18 || c == enemySpan * 25)
					{
						if (blueLow.Exists())
						{
							List<int> uniqueIDs = new List<int>();
							world.UnitManager.AttackMove(uniqueIDs, BlackHome, false);
							var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow);
							uniqueIDs.Add(l3.UniqueID);
							var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow);
							uniqueIDs.Add(l4.UniqueID);
							if (world.StoryUtilities.GetDifficulty() > 0)
							{
								var l5 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow);
								uniqueIDs.Add(l5.UniqueID);
								var l10 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow);
							}

							foreach (var ln in uniqueIDs)
							{
								var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
								n.HP = n.MaxHP;
							}

							world.UnitManager.AttackMove(uniqueIDs, BlackHome, false);
						}
						if (blueLow2.Exists())
						{
							List<int> uniqueIDs = new List<int>();
							var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
							uniqueIDs.Add(l1.UniqueID);
							var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
							uniqueIDs.Add(l3.UniqueID);
							if (world.StoryUtilities.GetDifficulty() > 0)
							{
								var l10 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
								uniqueIDs.Add(l10.UniqueID);
							}
							if (world.StoryUtilities.GetDifficulty() == 2)
							{
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
								uniqueIDs.Add(l4.UniqueID);
								var l10 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueLow2);
								uniqueIDs.Add(l10.UniqueID);
							}

							foreach (var ln in uniqueIDs)
							{
								var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
								n.HP = n.MaxHP;
							}

							world.UnitManager.AttackMove(uniqueIDs, BlackHome, false);
						}
						if (blueHigh.Exists())
						{
							List<int> uniqueIDs = new List<int>();
							var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHigh);
							uniqueIDs.Add(l1.UniqueID);
							var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHigh);
							uniqueIDs.Add(l2.UniqueID);
							var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Iku).FullName, blueHigh);
							uniqueIDs.Add(l3.UniqueID);
							var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Iku).FullName, blueHigh);
							uniqueIDs.Add(l4.UniqueID);
							if (world.StoryUtilities.GetDifficulty() > 0)
							{
								var l5 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHigh);
								uniqueIDs.Add(l5.UniqueID);
								var l10 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHigh);
							}
							if (world.StoryUtilities.GetDifficulty() == 2)
							{
								var l6 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHigh);
								uniqueIDs.Add(l6.UniqueID);
								var l7 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Lunar).FullName, blueHigh);
								uniqueIDs.Add(l7.UniqueID);
								var l5 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Star).FullName, blueHigh);
								uniqueIDs.Add(l5.UniqueID);
								var l10 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Star).FullName, blueHigh);
							}

							foreach (var ln in uniqueIDs)
							{
								var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
								n.HP = n.MaxHP;
							}
							if (world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0] && _.GetType() == typeof(LotusCraft.Unit.Black.Orin)).Count() > 0) {
								world.UnitManager.AttackMove(uniqueIDs, world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0] && _.GetType() == typeof(LotusCraft.Unit.Black.Orin)).First(), false);
							}
							else
							{
								world.UnitManager.AttackMove(uniqueIDs, BlackHome, false);
							}
						}
					}
				}

				c++;
				yield return null;
			}
			
			yield return base.Update(world);
		}

		private void TryCallTenshiSpell(IWorld world, IUnit TenshiUnit)
		{
			if (executedTenshiSpall || !TenshiUnit.Exists()) return;

			var units = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0]);
			foreach (var u in units)
			{
				var radius = 8 * thrts.Def.MapTipLengthOnField;

				if (radius * radius > (u.Pos.X - TenshiUnit.Pos.X) * (u.Pos.X - TenshiUnit.Pos.X) + (u.Pos.Y - TenshiUnit.Pos.Y) * (u.Pos.Y - TenshiUnit.Pos.Y))
				{
					var targetPos = u.Pos;
					var spell = world.Factions[1].GetUnitSpellButtonParameter(TenshiUnit.Parameter.GetType().FullName, new SpellButtonKey("気符「無念無想の境地」", 1));
					if(world.StoryUtilities.GetDifficulty() > 0){
						spell = world.Factions[1].GetUnitSpellButtonParameter(TenshiUnit.Parameter.GetType().FullName, new SpellButtonKey("気符「無念無想の境地」", 2));
					}
					spell.NormalButtonEvent(TenshiUnit, false);
					executedTenshiSpall = true;
				}
			}
		}

		private void TryCallTenshiSpell2(IWorld world, IUnit TenshiUnit)
		{
			if (!TenshiUnit.Exists()) return;

			var buildings = world.BuildingManager.GetBuildings(_ => _.Faction == world.Factions[0]);
			foreach (var u in buildings)
			{
				var radius = 8 * thrts.Def.MapTipLengthOnField;

				if (radius * radius > (u.Pos.X - TenshiUnit.Pos.X) * (u.Pos.X - TenshiUnit.Pos.X) + (u.Pos.Y - TenshiUnit.Pos.Y) * (u.Pos.Y - TenshiUnit.Pos.Y))
				{
					var targetPos = u.Pos;
					var spell = world.Factions[1].GetUnitSpellButtonParameter(TenshiUnit.Parameter.GetType().FullName, new SpellButtonKey("地震「先憂後楽の剣」", 1));
					if (world.StoryUtilities.GetDifficulty() > 0)
					{
						spell = world.Factions[1].GetUnitSpellButtonParameter(TenshiUnit.Parameter.GetType().FullName, new SpellButtonKey("地震「先憂後楽の剣」", 3));
					}
					spell.NormalButtonEvent(TenshiUnit, false);
					executedTenshiSpall2 = true;
				}
			}
		}

		private void TryCallTenshiLastSpell(IWorld world, IUnit TenshiUnit)
		{
			if (executedTenshiLastSpall || !TenshiUnit.Exists()) return;

			var u = TenshiUnit;
			var blackHomes = GetBuildings<Building.Black.HomeBase>(world);
			var radius = 12 * thrts.Def.MapTipLengthOnField;

			foreach (var t in blackHomes)
			{
				if (radius * radius > (t.Pos.X - u.Pos.X) * (t.Pos.X - u.Pos.X) + (t.Pos.Y - u.Pos.Y) * (t.Pos.Y - u.Pos.Y))
				{
					var targetPos = t.Pos;
					var spell = world.Factions[1].GetUnitSpellButtonParameter(TenshiUnit.Parameter.GetType().FullName, new SpellButtonKey("「全人類の緋想天」", 1));
					spell.SelectPlaceButtonEvent(TenshiUnit, new Vector2D(targetPos.X, targetPos.Y), false);
					executedTenshiLastSpall = true;
				}
			}
		}

		
		private void TryCallKoishiSpell(IWorld world, IUnit KoishiUnit)
		{
			if (executedKoishiSpall || !KoishiUnit.Exists()) return;

			var units = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0]);
			foreach (var u in units)
			{
				var radius = 4 * thrts.Def.MapTipLengthOnField;

				if (radius * radius > (u.Pos.X - KoishiUnit.Pos.X) * (u.Pos.X - KoishiUnit.Pos.X) + (u.Pos.Y - KoishiUnit.Pos.Y) * (u.Pos.Y - KoishiUnit.Pos.Y))
				{
					var targetPos = u.Pos;
					
					if(world.StoryUtilities.GetDifficulty() == 2){
						var spell = world.Factions[1].GetUnitSpellButtonParameter(KoishiUnit.Parameter.GetType().FullName, new SpellButtonKey("「嫌われ者のフィロソフィ」", 2));
						spell.NormalButtonEvent(KoishiUnit, false);
					}else{
						var spell = world.Factions[1].GetUnitSpellButtonParameter(KoishiUnit.Parameter.GetType().FullName, new SpellButtonKey("記憶「ＤＮＡの瑕」", 2));
						spell.SelectPlaceButtonEvent(KoishiUnit, new Vector2D(targetPos.X, targetPos.Y), false);
					}
					
					executedKoishiSpall = true;
				}
			}
		}

		private void TryCallKoishiLastSpell(IWorld world, IUnit KoishiUnit)
		{
			if (executedKoishiLastSpall || !KoishiUnit.Exists()) return;
			var units = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0]);
			foreach (var u in units)
			{
				var radius = 7 * thrts.Def.MapTipLengthOnField;

				if (radius * radius > (u.Pos.X - KoishiUnit.Pos.X) * (u.Pos.X - KoishiUnit.Pos.X) + (u.Pos.Y - KoishiUnit.Pos.Y) * (u.Pos.Y - KoishiUnit.Pos.Y))
				{
					var spell = world.Factions[1].GetUnitSpellButtonParameter(KoishiUnit.Parameter.GetType().FullName, new SpellButtonKey("「サブタレイニアンローズ」", 1));
					spell.NormalButtonEvent(KoishiUnit, false);
					executedKoishiLastSpall = true;
				}
			}
		}

		#region Story
		private System.Collections.IEnumerable Talk会話冒頭(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk1
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Back1,StoryUIImagePosition.Back2,true);
			ui.ShowText("～人里～");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\nあらかた顔を出したりなんなりはしたのですが");
			ui.ShowImage(Rin[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【お燐】\n詳しくは別勢力のシナリオを参照ね！");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n天界に行ってみたいです。天界に");
			ui.ShowImage(Seiga[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【青娥】\nそれは太子様が個人的に？");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nええ、一応私の目指すところも、天人になるということですし\n行ける範囲にあるのならば、顔を出してみたいと思いませんか");
			ui.ShowImage(Yuyuko[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【幽々子】\n冥界もいいところよ？");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nそれは天人も飽きてからにしようかと");
			ui.ShowImage(Yuyuko[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽々子】\nそれは残念\nきっと良いお友達になれると思ったのに");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n良ければたまに伺わせてもらいますよ");
			ui.ShowImage(Yuyuko[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽々子】\nあら、今度は妖夢にも会っていってね");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nええ。その時は是非");
			ui.ShowImage(Rin[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【お燐】\nその天界には、あたいたちもついて行ってもいいのかな？");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nそれはもちろん。皆で行きましょう");
			ui.ShowImage(Rin[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【お燐】\n地底に地上に天界と、目が回りそうになるね");
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nずっと上空にあるとのことなので、高所恐怖症なら本格的に目が回るんじゃないでしょうか");
			ui.ShowImage(Rin[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【お燐】\n猫は高いところは平気で登るんだよ、見くびってもらっちゃ困るね");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n頼もしいことです");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Back2,true);
			ui.ShowText("～天界～");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n思った以上に大変でしたが、こう、思ったよりも桃ぐらいしかないんですね。");
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nそれに結構荒涼としているような");
			ui.ShowImage(Tenshi[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【天子】\n端っこはこんなものよ。桃食って釣りしてる暇人どもが居るのはもっとあっち");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nあら？　初めまして");
			ui.ShowImage(Tenshi[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【天子】\n待ってたわ。あっちこっちに顔を出してる仙人っていうのはあなたのことね");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nいつのまにか有名人になっていましたか？");
			ui.ShowImage(Tenshi[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【天子】\nというか、八雲に歓待してこいって言われただけなんだけど");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nそれはそれは\nということは、私たちの動きもある程度把握されているということでしょうか");
			ui.ShowImage(Tenshi[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【天子】\nもちろん、全部とは言わないけどね。");
			ui.ShowImage(Tenshi[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【天子】\n大方、友人を取られて焦ってるんじゃないの");
			ui.ShowImage(Yuyuko[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【幽々子】\n紫は嫉妬深いからー。あとでフォローしておかないと");
			ui.ShowImage(Tenshi[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【天子】\nジョークよジョーク。");
			ui.ShowImage(Tenshi[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【天子】\nそれはいいとして、あんたたちが私たちを探しているだろうってことはわかってたの。");
			ui.ShowImage(Tenshi[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【天子】\nだから私がここで待っていたわけ");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\nなるほど？");
			ui.ShowImage(Tenshi[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【天子】\n別にけちょんけちょんにやっつけようとか、取って食おうとしてるわけじゃないわよ。");
			ui.ShowImage(Tenshi[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【天子】\n八雲はなんか用事があるとかで居ないけど、私が代表になって相手してあげる");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nご本人様に会えないのは残念ですが、わざわざお相手していただけるのは光栄ですね");
			ui.ShowImage(Tenshi[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【天子】\n私も暇じゃないんだけど、退屈凌ぎにはなるし");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nそれって暇ってことじゃないんですか？");
			ui.ShowImage(Tenshi[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【天子】\n暇を潰すことに忙しくって");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n要するに、遊び相手になれってことですね");
			ui.ShowImage(Tenshi[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【天子】\n平たく言うとそんなところ。\nさ、ここならある程度好き勝手にやらかしても大丈夫よ。かかってきなさい");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			
			var talkEnd = ui.ShowText(""); 
			while (!ui.IsCompleted(talkEnd))
				yield return null;
			
			ui.Hide();
			ui.ResumeGame();
			#endregion

			yield return null;
		}

	

		private System.Collections.IEnumerable Talk勝利(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk12
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n派手にやらせてもらいました");
			ui.ShowImage(Tenshi[2], StoryUIImagePosition.Right, true, false);
			ui.ShowText("【天子】\n遠慮ってのをちょっとは知りなさいよ");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nてへぺろ");
			ui.ShowImage(Tenshi[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【天子】\n私も今日は店じまいよ。あんたたちは？");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n私は行きたいところが、あと一箇所ありまして。");
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n最初に挨拶をしたのですが、その時はほかの方もいらっしゃったので");
			ui.ShowImage(Yamame[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【ヤマメ】\nそれじゃ私はそれまで付き合おっか");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Utsuho[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【お空】\nお燐、私たちはどうしよっか？");
			ui.ShowImage(Rin[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【お燐】\nうーん、そうだねぇ…\nずっとさとり様に連絡してないから心配してるかもしれないし…");
			ui.ShowImage(Koishi[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【こいし】\nそんなこと言わず手伝ってあげなさい\n二人のことはお姉ちゃんに私が伝えといてあげるから");
			ui.ShowImage(Rin[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【お燐】\nこいし様、いいんですか？");
			ui.ShowImage(Koishi[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【こいし】\nお空もお休みもらってるんでしょ、せっかくだから最後まで楽しみなさいって");
			ui.ShowImage(Utsuho[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【お空】\nこいし様ありがとー");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Tenshi[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【天子】\nまぁ、適当にがんばりなよ。私も適当にがんばるから");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\nありがとうございます。天人様");
			
			var talkEnd0 = ui.ShowText("", false);
			while (!ui.IsCompleted(talkEnd0))
				yield return null;
			ui.Hide();
			ui.ResumeGame();
			#endregion

			yield return null;
		}

		private System.Collections.IEnumerable Talk敗北(IWorld world)
		{
			var ui = world.StoryUI;

			ui.PauseGame();
			ui.Show();
			ui.Hide();
			ui.ResumeGame();

			yield return null;
		}
		#endregion

		private int[] LoadTachies(IStoryUI ui, string path_N, string path_S, string path_W)
		{
			return new int[3]{
				ui.LoadImage( path_N ),
				ui.LoadImage( path_S ),
				ui.LoadImage( path_W )
			};
		}

		/// <summary>
		/// ユニットをエリア上に生成する。
		/// </summary>
		/// <param name="world"></param>
		/// <param name="faction"></param>
		/// <param name="paramType"></param>
		/// <param name="area"></param>
		/// <returns></returns>
		public IEnumerable<IUnit> PutUnitsOnArea(IWorld world, IFaction faction, Type paramType, Area area)
		{
			var ar = area as AreaRectangle;
			if (ar == null) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min(ar.Start.X, ar.End.X);
			var sy = Math.Min(ar.Start.Y, ar.End.Y);
			var ex = Math.Max(ar.Start.X, ar.End.X);
			var ey = Math.Max(ar.Start.Y, ar.End.Y);

			for (var y = sy; y <= ey; y++)
			{
				for (var x = sx; x <= ex; x++)
				{
					var u =
						world.UnitManager.Create(paramType.FullName, faction, (x + 0.5f) * thrts.Def.MapTipLengthOnField, (y + 0.5f) * thrts.Def.MapTipLengthOnField, faction);
					if (u != null) units.Add(u);
				}
			}

			return units;
		}

		public IEnumerable<IUnit> PutEnemy(IWorld world, Type unitType, Area area, int num, IBuilding target)
		{
			var rect = area as AreaRectangle;
			if (rect == null) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min(rect.Start.X, rect.End.X);
			var sy = Math.Min(rect.Start.Y, rect.End.Y);
			var ex = Math.Max(rect.Start.X, rect.End.X);
			var ey = Math.Max(rect.Start.Y, rect.End.Y);

			for (var y = sy; y < ey; y++)
			{
				for (var x = sx; x < ex; x++)
				{
					if (units.Count >= num)
						goto LoopEnd;

					var u = world.UnitManager.Create(
						unitType.FullName,
						world.Factions[1],
						(x + 0.5f) * thrts.Def.MapTipLengthOnField,
						(y + 0.5f) * thrts.Def.MapTipLengthOnField,
						world.Factions[1]);
					if (u != null)
						units.Add(u);
				}
			}
		LoopEnd:

			if (target != null)
				world.UnitManager.SelectTarget(units, new Vector2D(target.Pos.X, target.Pos.Y), false);

			return units;
		}

		bool IsUnitOnArea(AreaRectangle region, IUnit unit)
		{
			var startx = Math.Min(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var starty = Math.Min(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			var endx = Math.Max(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var endy = Math.Max(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			if (unit.Pos.X < endx && startx < unit.Pos.X && unit.Pos.Y < endy && starty < unit.Pos.Y)
			{
				return true;
			}
			return false;
		}

		IEnumerable<IBuilding> GetBuildings<T>(IWorld world) where T : BuildingParameter
		{
			return world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(T));
		}
	}
}

#endif