﻿#if !_TRIAL

using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using thrts;

namespace LotusCraft.Story
{
	public class StoryBlue03 : thrts.Mission
	{
		private readonly Dictionary<int, int> Experience;
		private readonly Dictionary<string, Area> areas;

		private int Back1;
		private int Back2;
		private int[] Tenshi;
		private int[] Yukari;
		private int[] Koishi;
		private int[] Nitori;
		private int[] Chilno;
		private int[] Mystia;
		private int[] Hijiri;

		int 敵召喚インターバル = int.MaxValue;
		int 下級召喚まで = int.MaxValue;
		int 上級召喚まで = int.MaxValue;

		int 星召喚数 = 0;
		int 村紗召喚数 = 0;
		int 青兎召喚数 = 0;

		bool useLastSpell = false;

		public StoryBlue03()
		{
			Name = "青3話";
			Description = "青3話専用マップ";
			Mode = thrts.MissionMode.Story;

			this.TheNumberOfMaximumSelectablePlayersInTeam = 0;
			this.TheNumberOfSelectableTeams = 0;
			Experience = new Dictionary<int, int>()
			{
				{0, 0},
				{1,	0}, 
				{2,	60},
				{3,	200},
				{4,	500},
				{5,	1200},
				{6,	2400},
 				{7,	4000},
				{8,	6000},
				{9, 8300},
				{10, 11000},
				{11, 14500}
			};
			areas = new Dictionary<string, Area>();
		}
		/// <summary>
		/// 自軍の勢力
		/// </summary>
		/// <returns></returns>
		public override string[] GetSelectableFactions()
		{
			return new string[] { 
				typeof(LotusCraft.Faction.Blue).FullName 
			};
		}
		/// <summary>
		/// 登場する勢力
		/// </summary>
		/// <returns></returns>
		public override string[] GetEnableFactions()
		{
			return new string[] { 
				typeof(LotusCraft.Faction.Blue).FullName,
				typeof(LotusCraft.Faction.White).FullName, 
			};
		}
		/// <summary>
		/// 使用するマップ
		/// </summary>
		/// <returns></returns>
		public override string[] GetSelectableMaps()
		{
			return new string[] {
				"LotusCraft/Story/StoryBlue03.map",
			};
		}

		public override void OnInitialize(IWorld world)
		{
			world.Factions[1].PlayerName = "白勢力";

			// 最初から負けないように
			world.Factions.ForEach(f => f.DoesNotLose = true);

			// 初期資源を配布
			world.Factions[0].IncResource(0, 300);
			world.Factions[0].IncResource(1, 200);

			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Low03).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Low02).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Murasa).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Toramaru).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Ichirin).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Hijiri).FullName).HP /= 2;

				world.UnitManager.GetUnits(u => u.Faction.Index == 1).Do(u => u.MaxHP = u.Parameter.HP).ForEach(u => u.HP = u.Parameter.HP);

				下級召喚まで = 60 * 30 * 4;
				上級召喚まで = int.MaxValue;
				敵召喚インターバル = 30 * 90;

				星召喚数 = 0;
				村紗召喚数 = 0;
				青兎召喚数 = 2;

				useLastSpell = false;
			}
			else if (world.StoryUtilities.GetDifficulty() == 1)
			{
				下級召喚まで = 60 * 30 * 2;
				上級召喚まで = 6 * 60 * 30;
				敵召喚インターバル = 30 * 60;

				星召喚数 = 1;
				村紗召喚数 = 1;
				青兎召喚数 = 3;

				useLastSpell = true;
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Low03).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Low03).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Low02).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Low03).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Murasa).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Murasa).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Toramaru).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Toramaru).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Ichirin).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Reimu).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Hijiri).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Reimu).FullName).HP * 0.2);

				world.UnitManager.GetUnits(u => u.Faction.Index == 1).Do(u => u.MaxHP = u.Parameter.HP).ForEach(u => u.HP = u.Parameter.HP);

				下級召喚まで = 60 * 30 * 2;
				上級召喚まで = 6 * 60 * 30;
				敵召喚インターバル = 30 * 40;

				星召喚数 = 2;
				村紗召喚数 = 2;
				青兎召喚数 = 4;

				useLastSpell = true;
			}

			world.AllPurposeArea.ForEach(_ => areas[_.Name] = _);

			var ui = world.StoryUI;
			{
				Back1 = ui.LoadImage("LotusCraft/Image/Back/Black");
				Back2 = Back1;
				Tenshi = new int[3] { ui.LoadImage("LotusCraft/Image/Tachie/Tenshi_N"), ui.LoadImage("LotusCraft/Image/Tachie/Tenshi_S"), ui.LoadImage("LotusCraft/Image/Tachie/Tenshi_W") };
				Yukari = new int[3] { ui.LoadImage("LotusCraft/Image/Tachie/Yukari_N"), ui.LoadImage("LotusCraft/Image/Tachie/Yukari_S"), ui.LoadImage("LotusCraft/Image/Tachie/Yukari_W") };
				Koishi = new int[3] { ui.LoadImage("LotusCraft/Image/Tachie/Koishi_N"), ui.LoadImage("LotusCraft/Image/Tachie/Koishi_S"), ui.LoadImage("LotusCraft/Image/Tachie/Koishi_W") };
				Chilno = new int[3] { ui.LoadImage("LotusCraft/Image/Tachie/Chilno_N"), ui.LoadImage("LotusCraft/Image/Tachie/Chilno_S"), ui.LoadImage("LotusCraft/Image/Tachie/Chilno_W") };
				Nitori = new int[3] { ui.LoadImage("LotusCraft/Image/Tachie/Nitori_N"), ui.LoadImage("LotusCraft/Image/Tachie/Nitori_S"), ui.LoadImage("LotusCraft/Image/Tachie/Nitori_W") };
				Mystia = new int[3] { ui.LoadImage("LotusCraft/Image/Tachie/Mystia_N"), ui.LoadImage("LotusCraft/Image/Tachie/Mystia_S"), ui.LoadImage("LotusCraft/Image/Tachie/Mystia_W") };
				Hijiri = new int[3] { ui.LoadImage("LotusCraft/Image/Tachie/Hijiri_N"), ui.LoadImage("LotusCraft/Image/Tachie/Hijiri_S"), ui.LoadImage("LotusCraft/Image/Tachie/Hijiri_W") };
			}
			// ボタン仕様禁止
			var home = world.BuildingManager.GetBuildings(_ => _.Faction == world.Factions[0] && _.Parameter.GetType() == typeof(LotusCraft.Building.Blue.HomeBase)).First();
			ui.HideButton(home, ButtonPosition._0, ButtonPosition._1);
			ui.HideButton(home, ButtonPosition._2, ButtonPosition._1);
			ui.HideButton(home, ButtonPosition._0, ButtonPosition._2);

			base.OnInitialize(world);
		}

		void White初期化(IWorld world)
		{
			GetUnits(world.Factions[1], typeof(LotusCraft.Unit.White.Unique.Ichirin))
				.Single().AddExperience(Experience[7]);
			GetUnits(world.Factions[1], typeof(LotusCraft.Unit.White.Unique.Hijiri))
				.Single().AddExperience(Experience[11]);
		}

		bool moreDifficult = false;

		public override System.Collections.IEnumerable Update(thrts.IWorld world)
		{
			world.ChangeBGM(BGMList.Boushuen_Story2);

			foreach (var item in 導入会話(world))
				yield return item;

			{
				world.ChangeBGM(BGMList.Battle_Hitozato);

				var home = GetBuildings(world.Factions[0], typeof(LotusCraft.Building.Blue.HomeBase)).Single();
				// 初期視点位置
				world.StoryUI.JumpScreenPosition(home.Pos);
			}
			White初期化(world);

			world.StoryUI.ShowConditionText("目的：敵拠点を撃破");


			int frameCount = 0;
			while (true)
			{
				if (useLastSpell && GetUnits(world.Factions[1], typeof(LotusCraft.Unit.White.Toramaru)).IsEmpty())
				{
					GetUnits(world.Factions[1], typeof(LotusCraft.Unit.White.Unique.Hijiri))
						.Do(u => u.HoldPosition(false))
						.Do(u => u.LvUpSpellWithName("超人「聖白蓮」"))
						.ForEach(u => u.Faction.GetUnitSpellButtonParameter("LotusCraft.Unit.White.Unique.Hijiri", new SpellButtonKey("超人「聖白蓮」", 1)).NormalButtonEvent(u, false));

					useLastSpell = false;
				}
				if (frameCount % 敵召喚インターバル == 0)
				{
					var blueBuilding = world.BuildingManager.GetBuildings(b => b.Faction.Index == 0).FirstOrDefault();

					if (!moreDifficult && 100 < world.Factions[0].Population)
					{
						敵召喚インターバル = 敵召喚インターバル / 2;
						//enemyCount = 5;

						moreDifficult = true;
					}

					var houtou = GetBuildings(world.Factions[1], typeof(LotusCraft.Building.White.Houtou));
					var seirensen = GetBuildings(world.Factions[1], typeof(LotusCraft.Building.White.Seirensen));
					var barrack = GetBuildings(world.Factions[1], typeof(LotusCraft.Building.White.Barrack));

					if (blueBuilding != null)
					{

						if (上級召喚まで <= frameCount)
						{
							{
								if (houtou.Take(1).Any())
									world.UnitManager.AttackMove(PutEnemy<LotusCraft.Unit.White.Toramaru>(world.Factions[1], areas["寅召喚1"], 星召喚数 / 2).Select(u => u.UniqueID), blueBuilding, false);
								if (houtou.Skip(1).Take(1).Any())
									world.UnitManager.AttackMove(PutEnemy<LotusCraft.Unit.White.Toramaru>(world.Factions[1], areas["寅召喚2"], 星召喚数 - 星召喚数 / 2).Select(u => u.UniqueID), blueBuilding, false);
							}
							if (seirensen.Take(1).Any())
								world.UnitManager.AttackMove(PutEnemy<LotusCraft.Unit.White.Murasa>(world.Factions[1], areas["村紗召喚1"], 村紗召喚数).Select(u => u.UniqueID), blueBuilding, false);
						}
						if (下級召喚まで <= frameCount)
						{
							if (barrack.Take(1).Any())
								world.UnitManager.AttackMove(PutEnemy<LotusCraft.Unit.White.Low03>(world.Factions[1], areas["兎召喚1"], 青兎召喚数).Select(u => u.UniqueID), blueBuilding, false);
						}
					}
				}
				if (GetBuildings(world.Factions[1], typeof(LotusCraft.Building.White.HomeBase)).IsEmpty())
				{
					foreach (var item in 勝利会話(world))
						yield return item;

					world.StoryUtilities.SetDataToSaveData("LotusCraft.Blue.03", "Clear");

					if (world.StoryUtilities.GetDifficulty() == 0)
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Blue.03.Easy", "Clear");
					else if (world.StoryUtilities.GetDifficulty() == 1)
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Blue.03.Normal", "Clear");
					else if (world.StoryUtilities.GetDifficulty() == 2)
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Blue.03.Hard", "Clear");

					world.ChangeBGM(BGMList.Boushuen_Win);

					break;
				}
				else if ((world.UnitManager.GetUnits(u => u.Faction.Index == 0).IsEmpty() && world.BuildingManager.GetBuildings(b => b.Faction.Index == 0).IsEmpty()))
				{
					foreach (var item in 敗北会話(world))
						yield return item;

					world.ChangeBGM(BGMList.Boushuen_Lose);

					break;
				}
				else
				{
					frameCount++;
					yield return null;
				}
			}
			while (true)
				yield return null;
		}
		IEnumerable<IUnit> PutEnemy<TUnit>(IFaction faction, Area area, int num) where TUnit : UnitParameter
		{
			var rect = area as AreaRectangle;
			if (rect == null)
				return new IUnit[0];

			List<IUnit> units = new List<IUnit>();
			var type = typeof(TUnit);

			var sx = Math.Min(rect.Start.X, rect.End.X);
			var sy = Math.Min(rect.Start.Y, rect.End.Y);
			var ex = Math.Max(rect.Start.X, rect.End.X);
			var ey = Math.Max(rect.Start.Y, rect.End.Y);

			for (var y = sy; y < ey; y++)
			{
				for (var x = sx; x < ex; x++)
				{
					if (units.Count >= num)
						return units;

					var u = faction.World.UnitManager.Create(
						type.FullName,
						faction,
						(x + 0.5f) * thrts.Def.MapTipLengthOnField,
						(y + 0.5f) * thrts.Def.MapTipLengthOnField,
						faction);
					if (u != null)
						units.Add(u);
				}
			}
			return units;
		}

		IEnumerable<IBuilding> GetBuildings(IFaction faction, Type parameterType)
		{
			return faction.World.BuildingManager.GetBuildings(b => b.Faction == faction && b.Parameter.GetType() == parameterType);
		}
		IEnumerable<IUnit> GetUnits(IFaction faction, Type parameterType)
		{
			return faction.World.UnitManager.GetUnits(u => u.Faction == faction && u.Parameter.GetType() == parameterType);
		}

		IEnumerable 導入会話(IWorld world)
		{
			var ui = world.StoryUI;

			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Back2, StoryUIImagePosition.Back, true, false, true);
			ui.ShowText("～天界～");
			ui.ShowImage(Tenshi[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【天子】\nところでさ");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【紫】\nはい？");
			ui.ShowImage(Tenshi[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【天子】\nどうしてユニットに見覚えあるような顔ばっかりなの？");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\n親しみやすいかと思って……");
			ui.ShowImage(Tenshi[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【天子】\nそういうのがわらわら出てくると親しみやすいというか不気味というか");
			ui.ShowImage(Tenshi[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【天子】\nまぁ、気にしたら負けなんだろうけど");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\nそうそう、負け負け");
			ui.ShowImage(Koishi[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【こいし】\nこれからの方針は？");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\n適当に散って、それぞれの様子を見てきてもらおうかしら");
			ui.ShowImage(Koishi[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【こいし】\n要するに適当に荒らし回ってこいってことだね");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\n好きにとって構わないけれど");
			ui.ShowImage(Koishi[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【こいし】\nじゃあ行ってきまーす");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, true);
			ui.ShowImage(Tenshi[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【天子】\n私もついていこうかしら\n一人じゃあの子、何やらかすかわからないし");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\nお目付け役？\nとてつもなく似合っていないけれど");
			ui.ShowImage(Tenshi[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【天子】\nはいはい");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\n私のほうは適当にスカウトしておくから");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\n目星は付いてるのよ");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\n本当よ");
			ui.ShowImage(Tenshi[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【天子】\n期待はしてないから");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\nはて、どうしましょうか");
			ui.ShowImage(Back1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, false);

			var imageEnd = ui.ShowImage(-1, StoryUIImagePosition.Back, true, false, true);
			while (!ui.IsCompleted(imageEnd))
			{
				yield return null;
			}

			ui.Hide();
			ui.ResumeGame();
			world.StoryUI.JumpScreenPosition(GetBuildings(world.Factions[0], typeof(LotusCraft.Building.Blue.HomeBase)).Single().Pos);
			ui.PauseGame();
			ui.Show();

			ui.ShowText("～人里～");
			ui.ShowImage(-1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Chilno[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【チルノ】\nみこを引っ張りだしてくるなんてひきょうなんだからな");
			ui.ShowImage(Mystia[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【ミスティア】\n理不尽くんよ、理不尽くん");
			ui.ShowImage(Chilno[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【チルノ】\nこうなったら助っ人を呼ぶしかないんだけど");
			ui.ShowImage(Mystia[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【ミスティア】\n当てはあるの？");
			ui.ShowImage(Chilno[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【チルノ】\nうーん。蛙ぐらいしか思いつかないからなぁ\nあとはルール教えてくれた青い奴");
			ui.ShowImage(Mystia[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【ミスティア】\n流石に蛙は……ちょっとね……無理かな、みたいなところあるから");
			ui.ShowImage(Chilno[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【チルノ】\nダメかー");
			ui.ShowImage(Mystia[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【ミスティア】\nちょっと、意思疎通からして難しいから……うん……");
			ui.ShowImage(Chilno[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【チルノ】\nじゃあ河童かなぁ");
			ui.ShowImage(Mystia[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【ミスティア】\n河童？\n山に住んでる？");
			ui.ShowImage(Chilno[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【チルノ】\nたまに流れてくるから");
			ui.ShowImage(Mystia[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【ミスティア】\nそういうものだっけ");
			ui.ShowImage(Chilno[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【チルノ】\nじゃあ河童で３人だ");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【紫】\nいえ、六名ですわ");
			ui.ShowImage(-1, StoryUIImagePosition.Front, false, false, true);

			ui.ShowImage(Chilno[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【チルノ】\nファッ！？");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【紫】\n河童さんのお話聞かせてくれないかしら？");
			ui.ShowText("【チルノ】\n河童だったらもしかしてってだけだから、誘えるかはわからないけど……");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\nバランス的に丁度いいのよ\n妖精に夜雀ぐらいがね");
			ui.ShowImage(-1, StoryUIImagePosition.Right, false, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, false, false, true);
			ui.ShowImage(Mystia[2], StoryUIImagePosition.Front, true, false, true);
			ui.ShowText("【ミスティア】\n(偉いことになっちゃったなー……)");
			ui.ShowImage(-1, StoryUIImagePosition.Front, false, false, true);
			ui.ShowImage(Back1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(-1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Nitori[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【にとり】\nスカウトシーンも飛ばされてしまった件について");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【紫】\n近年稀に見る激闘でしたね");
			ui.ShowImage(Chilno[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【チルノ】\nまさかあそこで隠された血の力が覚醒するとは思わなかったよ");
			ui.ShowImage(Mystia[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【ミスティア】\n涙なくして語れないの物語");
			ui.ShowImage(Nitori[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【にとり】\nあんまし山から離れるのは宜しくないんだけども……");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【紫】\n大丈夫でしょ、河童の一匹や二匹ぐらい");
			ui.ShowImage(Nitori[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【にとり】\nそうかなぁ？　じゃあ人里にも行っていい？　相撲を");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\n相撲を取りに行くのはまたの機会にしなさい");
			ui.ShowImage(Nitori[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【にとり】\nちぇっ");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\nさて、別働隊の二人は今頃何をしているのかしら\n何かしら乱入でもしてそうだけど");
			ui.ShowImage(Nitori[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【にとり】\n別働隊？\n相撲でもしてるの？");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\n好き勝手やってきなさいって野放しにしてあるのよ。放し飼いって奴ね");
			ui.ShowImage(Nitori[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【にとり】\n飼い主からクレームが入りそう");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\nそれはそれで\nせっかく人里に来たんだし、お寺にでも顔を出して行きましょう");
			ui.ShowImage(Nitori[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【にとり】\n相撲？");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\nどんだけ相撲がしたいのよ");
			ui.ShowImage(Back1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Hijiri[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【聖】\nあらこんにちは");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【紫】\nありのまま 今　起こった事を話すわ");
			ui.ShowImage(Nitori[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【にとり】\n私たちは住職に会おうと寺へ向かっていたと");
			ui.ShowImage(Mystia[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【ミスティア】\n思ったらいつのまにか背後から話しかけられた");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowImage(Chilno[1], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【チルノ】\n新手のスタンド攻撃てやつだ！犯人はこのなかにいる！");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【紫】\nこんにちは、仲間探しに人里へ？\nめぼしい人材は見つかった？");
			ui.ShowImage(Hijiri[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【聖】\nお陰様で\n霊夢さんや魔理沙さんたちとご一緒させていただくことになりまして");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\nそれで肝心の霊夢たちは何をしているのかしら？");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【聖】\nたぶん、阿求さんちでだらけているかと。");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【聖】\n自由行動ということで私は一端寺に戻っていたんです\n長く空けているわけにもいきませんし");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\n霊夢らしいっちゃ霊夢らしい行動だけど");
			ui.ShowImage(Hijiri[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【聖】\n後ろの方々は？");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\n紹介するわ\n河童のフィッシュ竹中と、こっちは黒猫のジジ");
			ui.ShowImage(Nitori[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【にとり】\nフィッシュ竹中って誰さ！？　あと黒猫居ないし");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【紫】\nちょっとした冗談。河城かとりさん");
			ui.ShowImage(Nitori[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【にとり】\nにとりだよ！\n線香じゃないよ！");
			ui.ShowImage(Hijiri[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【聖】\n線香があると助かるけれど……");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【紫】\nそれは置いといて、こっちもこの子達を引き入れたばかりなの\n良かったらお手合せお願いできないかしら");
			ui.ShowImage(Hijiri[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【聖】\nそういうことなら喜んで。一輪を呼んできますので");
			ui.ShowImage(-1, StoryUIImagePosition.Front, false, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, true);
			ui.ShowImage(Nitori[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowImage(-1, StoryUIImagePosition.Front, false, false, true);
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\nそれじゃあここは貴女に任せるから");
			ui.ShowImage(Nitori[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【にとり】\nえ、私が仕切るの？");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\nほかの二人じゃちょっと不安だし");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, true);
			var talkEnd = ui.ShowText("", false);

			while (!ui.IsCompleted(talkEnd))
			{
				yield return null;
			}

			ui.Hide();
			ui.ResumeGame();
		}
		IEnumerable 勝利会話(IWorld world)
		{
			var ui = world.StoryUI;

			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Nitori[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【にとり】\nか、勝てた……");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【聖】\n負けてしまいました");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【紫】\n最低限、使い物にはなりそうね");
			ui.ShowImage(Chilno[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【チルノ】\nよし、リベンジに行こう！");
			ui.ShowImage(Chilno[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【チルノ】\n河童も来る！今のアタイ達なら巫女にも圧勝間違いない！！");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, true);
			ui.ShowImage(Nitori[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【にとり】\nえ？……私も？");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\nあらあら");
			ui.ShowImage(Nitori[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【にとり】\nえーっと……");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\n手当付けておくわね、二割増しで");
			ui.ShowImage(Nitori[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【にとり】\nいってきまーす……");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, true);
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\nそれにしても、誰にリベンジに行くのかしら");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【聖】\n阿求さんのところにでも行ったんじゃないですかね。遺恨があるとかないとか");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【紫】\nま、後で拾えば大丈夫でしょ。これからもよろしくお願いしますわ");
			ui.ShowImage(Hijiri[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【聖】\nええ。こちらこそ");
			var talkEnd = ui.ShowText("", false);

			while (!ui.IsCompleted(talkEnd))
				yield return null;

			ui.Hide();
			ui.ResumeGame();

			world.Factions[0].DoesNotLose = true;
			world.Factions[0].Win();
			world.Factions[1].DoesNotLose = true;
			world.Factions[1].Lose();
		}
		IEnumerable 敗北会話(IWorld world)
		{
			var ui = world.StoryUI;

			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Nitori[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【にとり】\nま、負けたァ…");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【聖】\n勝ってしまいました");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【紫】\n見込み違いだったかしら、これはお給料払えないわね");
			var talkEnd = ui.ShowText("", false);

			while (!ui.IsCompleted(talkEnd))
				yield return null;

			ui.Hide();
			ui.ResumeGame();

			world.Factions[0].DoesNotLose = true;
			world.Factions[0].Lose();
			world.Factions[1].DoesNotLose = true;
			world.Factions[1].Win();
		}
	}
}
#endif