﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using thrts;

namespace LotusCraft.Story
{
	public class StoryGreen02 : thrts.Mission
	{
		public override string[] GetSelectableFactions()
		{
			return new string[] {
				typeof( Faction.Green).FullName
			};
		}

		public override string[] GetEnableFactions()
		{
			return new string[]	{
				typeof( Faction.Green ).FullName,
				typeof( Faction.Black ).FullName
			};
		}

		public override string[] GetSelectableMaps()
		{
			return new string[] {
				"LotusCraft/Story/StoryGreen02.map",
			};
		}

		public StoryGreen02()
			: base()
		{
			Name = "ストーリー緑２話";
			Description = "緑2話のマップ";
			Mode = thrts.MissionMode.Story;

			this.TheNumberOfMaximumSelectablePlayersInTeam = 0;
			this.TheNumberOfSelectableTeams = 0;
		}

		int[] Alice = null;
		int[] Suika = null;
		int[] Lyrica = null;
		int[] Yuka = null;
		int[] Miko = null;
		int[] Yuyuko = null;
		int[] Minoriko = null;
		int[] Rin = null;
		int[] Utsuho = null;
		int[] Yamame = null;
		int Back1 = 0;
		IBuilding blackHome1 = null;
		IBuilding blackHigh1 = null;
		IBuilding blackHome2 = null;
		IBuilding blackHigh2 = null;
		IBuilding blackHome3 = null;
		IBuilding blackHigh3 = null;
		IBuilding greenHome = null;

		int enemySpan = 1800;

		
		public override void OnInitialize(thrts.IWorld world)
		{
			world.Factions[1].PlayerName = "黒勢力";

			// 最初から負けないように
			world.Factions[0].DoesNotLose = true;
			world.Factions[1].DoesNotLose = true;


			// 初期資源を配布
			world.Factions[0].IncResource(0, 200);
			world.Factions[0].IncResource(1, 200);

			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low02).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low03).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Youmu).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Oku).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Orin).FullName).HP /= 2;
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low02).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low02).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low03).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low03).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Youmu).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Youmu).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Oku).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Oku).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Orin).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Orin).FullName).HP * 0.2);

				enemySpan = 1400;
			}

			// 本拠の位置を初期視点にする
			
			var home = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Green.HomeBase)).First();
			var basePos = home.Pos;
			
			// 初期視点位置
			world.Factions[0].Parameter.DefaultScreenPosition
				= new Point2D((int)basePos.X, (int)basePos.Y);

			
			//homeparam.ButtonParams

			base.OnInitialize(world);
		}

		public override System.Collections.IEnumerable Update(IWorld world)
		{
			var ui = world.StoryUI;

			// 中央の拠点
			greenHome = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Green.HomeBase)).First();
			blackHome1 = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Black.HomeBase) && _.Pos.Y > 23 * 32 && _.Pos.Y < 72 * 32).First();
			blackHigh1 = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Black.Factory) && _.Pos.Y > 23 * 32 && _.Pos.Y < 72 * 32).First();
			// 上の拠点
			blackHome2 = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Black.HomeBase) && _.Pos.Y > 72 * 32).First();
			blackHigh2 = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Black.Factory) && _.Pos.Y > 72 * 32).First();
			// 下の拠点
			blackHome3 = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Black.HomeBase) && _.Pos.Y < 23 * 32).First();
			blackHigh3 = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Black.Factory) && _.Pos.Y < 23 * 32).First();
			

			Alice = LoadTachies(ui, "LotusCraft/Image/Tachie/Alice_N", "LotusCraft/Image/Tachie/Alice_S", "LotusCraft/Image/Tachie/Alice_W");
			Yuyuko = LoadTachies(ui, "LotusCraft/Image/Tachie/Yuyuko_N", "LotusCraft/Image/Tachie/Yuyuko_S", "LotusCraft/Image/Tachie/Yuyuko_W");
			Suika = LoadTachies(ui, "LotusCraft/Image/Tachie/Suika_N", "LotusCraft/Image/Tachie/Suika_S", "LotusCraft/Image/Tachie/Suika_W");
			Yuka = LoadTachies(ui, "LotusCraft/Image/Tachie/Yuka_N", "LotusCraft/Image/Tachie/Yuka_S", "LotusCraft/Image/Tachie/Yuka_W");
			Lyrica = LoadTachies(ui, "LotusCraft/Image/Tachie/Lyrica_N", "LotusCraft/Image/Tachie/Lyrica_S", "LotusCraft/Image/Tachie/Lyrica_W");
			Miko = LoadTachies(ui, "LotusCraft/Image/Tachie/Miko_N", "LotusCraft/Image/Tachie/Miko_S", "LotusCraft/Image/Tachie/Miko_W");
			Minoriko = LoadTachies(ui, "LotusCraft/Image/Tachie/Minoriko_N", "LotusCraft/Image/Tachie/Minoriko_S", "LotusCraft/Image/Tachie/Minoriko_W");
			Rin = LoadTachies(ui, "LotusCraft/Image/Tachie/Rin_N", "LotusCraft/Image/Tachie/Rin_S", "LotusCraft/Image/Tachie/Rin_W");
			Utsuho = LoadTachies(ui, "LotusCraft/Image/Tachie/Utsuho_N", "LotusCraft/Image/Tachie/Utsuho_S", "LotusCraft/Image/Tachie/Utsuho_W");
			Back1 = ui.LoadImage("LotusCraft/Image/Back/Black");
			Yamame = LoadTachies(ui, "LotusCraft/Image/Tachie/Yamame_N", "LotusCraft/Image/Tachie/Yamame_S", "LotusCraft/Image/Tachie/Yamame_W");

			var yuyukoUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Yuyuko)).First();
			var rinUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Rin)).First();
			var utsuhoUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Utsuho)).First();
			

			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				yuyukoUnit.AddExperience(2000);
				rinUnit.AddExperience(1500);
				utsuhoUnit.AddExperience(1500);
			}
			else if (world.StoryUtilities.GetDifficulty() == 1)
			{
				yuyukoUnit.AddExperience(3000);
				rinUnit.AddExperience(2000);
				utsuhoUnit.AddExperience(2000);
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				yuyukoUnit.AddExperience(5000);
				rinUnit.AddExperience(3000);
				utsuhoUnit.AddExperience(3000);
			}

			world.ChangeBGM(BGMList.Boushuen_Story1);

			//*
			foreach (var item in Talk会話冒頭(world))
			{
				yield return null;
			}
			//*/

			world.ChangeBGM(BGMList.Battle_TaiyouNoHatake);


			ui.ShowConditionText("目的：敵拠点を全て撃破");

			int c = 0;

			bool event2 = false;

			while (true)
			{
				if (!blackHome1.Exists() && !blackHome2.Exists() && !blackHome3.Exists())
				{
					foreach (var item2 in Talk勝利(world))
					{
						yield return null;
					}
					world.Factions[1].DoesNotLose = false;
					world.Factions[1].Lose();
					world.StoryUtilities.SetDataToSaveData("LotusCraft.Green.02", "Clear");
					if (world.StoryUtilities.GetDifficulty() == 0)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Green.02.Easy", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 1)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Green.02.Normal", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 2)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Green.02.Hard", "Clear");
					}
					world.ChangeBGM(BGMList.Boushuen_Win);

					break;
				}
				if (!greenHome.Exists() && !greenHome.Exists() && !greenHome.Exists())
				{
					foreach (var item2 in Talk敗北(world))
					{
						yield return null;
					}
					world.Factions[0].DoesNotLose = false;
					world.Factions[0].Lose();

					world.ChangeBGM(BGMList.Boushuen_Lose);

					break;
				}


				

				// ざこ
				if (c % enemySpan == 0)
				{
					if (c >= enemySpan * 5)
					{
						if (c == 1800 * 8)
						{
							if (blackHigh3.Exists() && utsuhoUnit.Exists())
							{
								foreach (var item2 in Talk酒回収施設破壊(world))
								{
									yield return null;
								}
								event2 = true;
							}
						}

						if (c < enemySpan * 6) {
							if (blackHigh1.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, blackHigh1);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, blackHigh1);
								uniqueIDs.Add(l2.UniqueID);
								
								world.UnitManager.AttackMove(uniqueIDs, greenHome, false);
							}
							if (blackHigh2.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, blackHigh2);
								uniqueIDs.Add(l1.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, greenHome, false);
							}
							if (blackHigh3.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, blackHigh3);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, blackHigh3);
								uniqueIDs.Add(l2.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, greenHome, false);
							}
						}
						else if (c < enemySpan * 10)
						{
							if (blackHigh1.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Youmu).FullName, blackHigh1);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, blackHigh1);
								uniqueIDs.Add(l2.UniqueID);
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, blackHigh1);
								uniqueIDs.Add(l3.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, greenHome, false);
							}

							if (blackHigh2.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, blackHigh2);
								uniqueIDs.Add(l3.UniqueID);
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, blackHigh2);
								uniqueIDs.Add(l4.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, greenHome, false);
							}
							if (blackHigh3.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								if (!event2)
								{
									var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, blackHigh3);
									uniqueIDs.Add(l3.UniqueID);
									var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, blackHigh3);
									uniqueIDs.Add(l4.UniqueID);
									var l5 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, blackHigh3);
									uniqueIDs.Add(l5.UniqueID);
								}
								world.UnitManager.AttackMove(uniqueIDs, greenHome, false);
							}
						}
						else
						{
							if (blackHigh1.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Youmu).FullName, blackHigh1);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Youmu).FullName, blackHigh1);
								uniqueIDs.Add(l2.UniqueID);
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, blackHigh1);
								uniqueIDs.Add(l3.UniqueID);
								
								world.UnitManager.AttackMove(uniqueIDs, greenHome, false);
							}

							if (blackHigh2.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, blackHigh2);
								uniqueIDs.Add(l3.UniqueID);
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, blackHigh2);
								uniqueIDs.Add(l4.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, blackHigh1);
								uniqueIDs.Add(l2.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, greenHome, false);
							}
							if (blackHigh3.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								if (!event2)
								{
									var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, blackHigh1);
									uniqueIDs.Add(l2.UniqueID);
									var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, blackHigh3);
									uniqueIDs.Add(l3.UniqueID);
									var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, blackHigh3);
									uniqueIDs.Add(l4.UniqueID);
								}
								world.UnitManager.AttackMove(uniqueIDs, greenHome, false);
							}
						}
					}
				}

				c++;
				yield return null;
			}
			
			yield return base.Update(world);
		}


		#region Story
		private System.Collections.IEnumerable Talk会話冒頭(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk1
			
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Suika[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【萃香】\n連れてきたぞー");
			ui.ShowImage(Alice[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【アリス】\n連れてこられてやったわよ");
			ui.ShowImage(Yuka[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【幽香】\nあら、来たの？\nゴネて来ないかと思ったけど");
			ui.ShowImage(Alice[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【アリス】\nあんたこそ地面に根っこが生えて動かなくなったかと思ったけど、まだ生きてたのね\n土弄り以外にやることでもできた？");
			ui.ShowText("【幽香】\nお陰様でね。久しぶりに運動でもしようかしらと思ったところなの");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Suika[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【萃香】\nあいつら仲悪いのか？");
			ui.ShowImage(Lyrica[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【リリカ】\n知らない……。むしろ顔見知りだって初めて知った");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Suika[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【萃香】\nやれやれ、犬猿の仲もほどほどにして欲しいねぇ\nあまり面識も無いのもいるみたいだから一度自己紹介をしてもいいんじゃないか？");
			ui.ShowImage(Minoriko[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【穣子】\nわた―――");
			ui.ShowImage(Yuka[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽香】\nいい提案ね\nこれから他のチームを殲滅(デストロイ)する仲なんですもの");
			ui.ShowImage(Alice[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【アリス】\n相変わらず思考の全てが物騒ね");
			ui.ShowImage(Yuka[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽香】\nお人形に火薬を詰めているほうがよっぽど物騒だわ\n私は花たちをそんな風に扱わないもの");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Suika[2],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【萃香】\nはいはい。なんで私が仕切ってるんだか");
			ui.ShowImage(Suika[0],StoryUIImagePosition.Front,false,false);
			ui.ShowText("【萃香】\n私は鬼の伊吹萃香。幽香と一緒で、この集まりの発起人みたいなものだぁね");
			ui.ShowText("【萃香】\n紫が言うには、スペルカードルールの変形ルールでフラストレーションが云々とか言ってたし、\n景品も用意するとか言ってたがよく知らん");
			ui.ShowImage(Suika[1],StoryUIImagePosition.Front,false,false);
			ui.ShowText("【萃香】\n幽香の言うように殲滅(デストロイ)するのが我々の目的だ");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Alice[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【アリス】\n武闘派すぎる……。全然スマートじゃないわね");
			ui.ShowImage(Yuka[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【幽香】\nチーム『サーチアンドデストロイ』なんてどうかしら");
			ui.ShowImage(Suika[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【萃香】\nイイネ！");
			ui.ShowImage(Yuka[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽香】\n賛成多数で可決とします");
			ui.ShowImage(Alice[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【アリス】\n二人しか居ないじゃないの");
			ui.ShowImage(Lyrica[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【リリカ】\n私はその……\nなんでもいいかな……");
			ui.ShowImage(Minoriko[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【穣子】\nはいはいは―――");
			ui.ShowImage(Alice[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【アリス】\nまぁチーム名なんてどうでもいいんだけど\nそれでこれからの方針は？\nこれから合流するメンバーも居るの？");
			ui.ShowImage(Yuka[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽香】\nええ。もう一人、当てがあるわ\nそれと、模擬戦の誘いが来ているからまずはそれをこなしてかしら");
			ui.ShowImage(Suika[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【萃香】\nなんて言ったか\n汚物は消毒太子だっけか");
			ui.ShowImage(Yuka[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽香】\n大体合ってるわね、多分");
			ui.ShowImage(Alice[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【アリス】\n何それ。モヒカンなの？");
			ui.ShowImage(Yuka[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【幽香】\nむしろミミズクかしら……");
			ui.ShowImage(Alice[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【アリス】\nそろそろわけがわからないわね");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Miko[0],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【神子】\nええ、なかなか興味深い話です");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowImage(Alice[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【アリス】\nうわっ。ミミズクだ");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n触ってみたいですか？");
			ui.ShowImage(Alice[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【アリス】\n遠慮します");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n触り心地は結構いいんですよ");
			ui.ShowImage(Yuka[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【幽香】\nそれで、ここでやるの？");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n良ければ仙界にご招待しますが、いかがなさいますか？");
			ui.ShowImage(Suika[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【萃香】\nうぇー得体の知れない所に行くのはやだな");
			ui.ShowImage(Minoriko[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【穣子】\n私はなん―――");
			ui.ShowImage(Alice[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【アリス】\nいいんじゃない？\n幽香がいいならここで。開けた場所もあるんでしょ？");
			ui.ShowImage(Lyrica[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【リリカ】\nライブステージの前なんかちょうどいいんじゃないかなぁ");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nわかりました\nでは私も仲間を連れてきますので");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Yuyuko[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【幽々子】\nあらまぁ、珍しい組み合わせもあったものね");
			ui.ShowImage(Alice[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【アリス】\nむしろ私からしてみれば、貴方が出歩いていること自体が驚きだけど");
			ui.ShowImage(Yuyuko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【幽々子】\n面白そうなことがあれば、足を伸ばしたくなるものよ？\nそれに素敵な方からのお誘いを無碍にすることもできませんし");
			ui.ShowImage(Yuyuko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【幽々子】\n殿方でないのが残念だったけれども");
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n申し訳ないです");
			ui.ShowImage(Yamame[0],StoryUIImagePosition.Left,true,false);
			ui.ShowImage(Alice[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【アリス】\n他の面子も毒々しかったり");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Utsuho[0],StoryUIImagePosition.Left,true,false);
			ui.ShowImage(Rin[0],StoryUIImagePosition.Front,true,false);
			ui.ShowImage(Alice[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【アリス】\n獣だったりするし、");
			ui.ShowText("【アリス】\n仙人、亡霊、妖獣に妖怪の混成軍ね");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n空ちゃんは守矢に、\nヤマメさんは命蓮寺に、\nお燐さんは霊夢さんにそれぞれ借りがあるそうで");
			ui.ShowImage(Rin[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【燐】\nそうそう、あたいが昼寝してたら尻尾を踏んづけて、\nそれでそんな所で寝てるのが悪いって言ってつまみ出して");
			ui.ShowImage(Rin[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【燐】\n疲れた心と体を癒す安らぎの縁側から追い出すだなんて許せないよ");
			ui.ShowImage(Utsuho[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【空】\nえーと、なんだっけ？\nとにかく、すとらいきとか、えーと、うん");
			ui.ShowImage(Utsuho[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【空】\nわかんないけどとりあえず消し炭にしちゃえばいいと思うよ！");
			ui.ShowImage(Yuka[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【幽香】\n気が合いそうね");
			ui.ShowImage(Suika[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【萃香】\n私たちのほうに来ない？\nそこの魔法使いと交換で");
			ui.ShowImage(Alice[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【アリス】\n大歓迎だわ");
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n残念ながら地霊殿の方からこの子たちのお世話も頼まれているので\nそんなことはできないのですよ");
			ui.ShowImage(Yuka[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【幽香】\n残念だわ");
			ui.ShowImage(Alice[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【アリス】\n残念ね");
			ui.ShowImage(Rin[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【燐】\nお姉さんたち仲良いね");
			ui.ShowImage(Alice[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【アリス】\n最悪よ");
			ui.ShowImage(Yuka[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【幽香】\n好きのうちって奴よ");
			ui.ShowImage(Suika[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【萃香】\n喧嘩するほど仲が良いって言葉もあるしな");
			ui.ShowImage(Suika[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【萃香】\nそれは置いといて、ちゃっちゃとやろうか\nいつまで経っても始まりゃしない");
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\nええ");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);

			var talkEnd = ui.ShowText(""); 
			while (!ui.IsCompleted(talkEnd))
				yield return null;
			
			ui.Hide();
			ui.ResumeGame();
			#endregion


			yield return null;
		}

		private System.Collections.IEnumerable Talk酒回収施設破壊(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk2,3
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Rin[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【お燐】\nなんか兵の出が悪いような…？");
			ui.ShowImage(Rin[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【お燐】\nって、なんか壊れてる！？\nちょっとお空、なに敵に入られてるのさ！？");
			ui.ShowImage(Utsuho[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【お空】\nえぇ！？入られてないよ！ここで通せんぼしてるんだから！");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Lyrica[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【リリカ】\nんー…？\nなんか向こうの陣地慌ただしいような気がするけれど");
			ui.ShowImage(Suika[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【萃香】\nなんだって？どれどれ");
			ui.ShowImage(Alice[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【アリス】\n確かに騒がしいわね\n何か問題でも起こったのかしら？");
			ui.ShowImage(Yuka[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【幽香】\n戦いの最中情けは無用よ\n隙を見せたなら蹂躙してやりましょう");
			ui.ShowImage(Suika[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【萃香】\nそういうこと\n情け無用ファイア！！");
			ui.ShowImage(Minoriko[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【穣子】\nファイヤー！！");
			ui.ShowImage(Lyrica[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【リリカ】\nファイヤー！！");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Alice[2],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【アリス】\n…脳筋");
			ui.ShowImage(Alice[1],StoryUIImagePosition.Front,false,false);
			ui.ShowText("【アリス】\nまぁ、チャンスには変わらないわ");
			ui.ShowText("【アリス】\n私達から見て左側の道から兵が来なくなったみたいだから、攻めに行くには絶好の機会よ");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);

			var talkEnd2 = ui.ShowText(""); 
			while (!ui.IsCompleted(talkEnd2))
				yield return null;
			
			ui.Hide();
			ui.ResumeGame();
			
			#endregion


			yield return null;
		}


	

		private System.Collections.IEnumerable Talk勝利(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk12
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Yuyuko[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【幽々子】\nむきゅー");
			ui.ShowImage(Alice[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【アリス】\nそれ別の人");
			ui.ShowImage(Yuyuko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【幽々子】\nピンク色が似ているから許されると思って");
			ui.ShowImage(Rin[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【燐】\nんー負けちゃったかー。いやーお姉さんたち強いねえ");
			ui.ShowImage(Suika[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【萃香】\n本ちゃんになるまではそう簡単には負けたりしたくないねえ");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n負けられない相手が居るんですか？");
			ui.ShowImage(Suika[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【萃香】\nまぁ、ねぇ？　あんたにもいるんだろ？");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nええ、勿論");
			ui.ShowImage(Alice[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【アリス】\nそれでこれからどうするの？　幽香");
			ui.ShowImage(Yuka[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【幽香】\nそろそろ八雲紫が餌撒きをする頃だと思うから、それに乗っかってってところかしら");
			ui.ShowImage(Alice[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【アリス】\n餌撒き？\nあぁ。本格的にぶつからせようと、どこかに呼び出すってわけね？");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nそれでは私たちはこの辺で");
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Alice[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【アリス】\nしかし、私たちのところもそうだけど、ほかも異色の組み合わせになっていそうね");
			ui.ShowImage(Suika[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【萃香】\nそれも紫の目的の一つだろうよ");
			ui.ShowImage(Alice[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【アリス】\nなのかもね");
			

			var talkEnd0 = ui.ShowText("", false);
			while (!ui.IsCompleted(talkEnd0))
				yield return null;
			ui.Hide();
			ui.ResumeGame();
			#endregion

			yield return null;
		}

		private System.Collections.IEnumerable Talk敗北(IWorld world)
		{
			var ui = world.StoryUI;

			ui.PauseGame();
			ui.Show();
			ui.Hide();
			ui.ResumeGame();

			yield return null;
		}
		#endregion

		private int[] LoadTachies(IStoryUI ui, string path_N, string path_S, string path_W)
		{
			return new int[3]{
				ui.LoadImage( path_N ),
				ui.LoadImage( path_S ),
				ui.LoadImage( path_W )
			};
		}

		/// <summary>
		/// ユニットをエリア上に生成する。
		/// </summary>
		/// <param name="world"></param>
		/// <param name="faction"></param>
		/// <param name="paramType"></param>
		/// <param name="area"></param>
		/// <returns></returns>
		public IEnumerable<IUnit> PutUnitsOnArea(IWorld world, IFaction faction, Type paramType, Area area)
		{
			var ar = area as AreaRectangle;
			if (ar == null) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min(ar.Start.X, ar.End.X);
			var sy = Math.Min(ar.Start.Y, ar.End.Y);
			var ex = Math.Max(ar.Start.X, ar.End.X);
			var ey = Math.Max(ar.Start.Y, ar.End.Y);

			for (var y = sy; y <= ey; y++)
			{
				for (var x = sx; x <= ex; x++)
				{
					var u =
						world.UnitManager.Create(paramType.FullName, faction, (x + 0.5f) * thrts.Def.MapTipLengthOnField, (y + 0.5f) * thrts.Def.MapTipLengthOnField, faction);
					if (u != null) units.Add(u);
				}
			}

			return units;
		}

		public IEnumerable<IUnit> PutEnemy(IWorld world, Type unitType, Area area, int num, IBuilding target)
		{
			var rect = area as AreaRectangle;
			if (rect == null) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min(rect.Start.X, rect.End.X);
			var sy = Math.Min(rect.Start.Y, rect.End.Y);
			var ex = Math.Max(rect.Start.X, rect.End.X);
			var ey = Math.Max(rect.Start.Y, rect.End.Y);

			for (var y = sy; y < ey; y++)
			{
				for (var x = sx; x < ex; x++)
				{
					if (units.Count >= num)
						goto LoopEnd;

					var u = world.UnitManager.Create(
						unitType.FullName,
						world.Factions[1],
						(x + 0.5f) * thrts.Def.MapTipLengthOnField,
						(y + 0.5f) * thrts.Def.MapTipLengthOnField,
						world.Factions[1]);
					if (u != null)
						units.Add(u);
				}
			}
		LoopEnd:

			if (target != null)
				world.UnitManager.SelectTarget(units, new Vector2D(target.Pos.X, target.Pos.Y), false);

			return units;
		}

		bool IsUnitOnArea(AreaRectangle region, IUnit unit)
		{
			var startx = Math.Min(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var starty = Math.Min(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			var endx = Math.Max(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var endy = Math.Max(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			if (unit.Pos.X < endx && startx < unit.Pos.X && unit.Pos.Y < endy && starty < unit.Pos.Y)
			{
				return true;
			}
			return false;
		}

		IEnumerable<IBuilding> GetBuildings<T>(IWorld world) where T : BuildingParameter
		{
			return world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(T));
		}
	}
}

#endif