﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using thrts;

namespace LotusCraft.Story
{
	public class StoryRed03 : thrts.Mission
	{
		public override string[] GetSelectableFactions()
		{
			return new string[] {
				typeof( Faction.Red ).FullName
			};
		}

		public override string[] GetEnableFactions()
		{
			return new string[]	{
				typeof( Faction.Red ).FullName,
				typeof( Faction.Blue ).FullName
			};
		}

		public override string[] GetSelectableMaps()
		{
			return new string[] {
				"LotusCraft/Story/StoryRed03.map",
			};
		}

		public StoryRed03()
			: base()
		{
			Name = "ストーリー赤03";
			Description = "赤3話のマップ";
			Mode = thrts.MissionMode.Story;

			this.TheNumberOfMaximumSelectablePlayersInTeam = 0;
			this.TheNumberOfSelectableTeams = 0;
		}

		int[] Remilia = null;
		int[] Sanae = null;
		int[] Mokou = null;
		int[] Miko = null;
		int[] Aya = null;
		int[] Yukari = null;
		int[] Patchouli = null;
		int[] Sakuya = null;
		int Back1 = 0;
		Area[] areas = null;
		IBuilding redHome = null;
		IBuilding blueHome = null;
		IBuilding blueHigh = null;

		int enemySpan = 1800;

		/// <summary>
		/// スペルを使用されたかどうか
		/// </summary>
		bool executedChilnoSpall = false;
		bool executedMystiaSpall = false;
		bool executedYukariSpall = false;

		public override void OnInitialize(thrts.IWorld world)
		{
			// 最初から負けないように
			world.Factions[0].DoesNotLose = true;
			world.Factions[1].DoesNotLose = true;


			// 初期資源を配布
			world.Factions[0].IncResource(0, 200);
			world.Factions[0].IncResource(1, 200);

			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Low02).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Low02).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Iku).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Lunar).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Star).FullName).HP /= 2;
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Low02).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Low02).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Low02).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Low02).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Iku).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Blue.Iku).FullName).HP * 0.2);

				enemySpan = 1300;
			}

			// 本拠の位置を初期視点にする
			var home = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Red.HomeBase)).First();
			var basePos = home.Pos;
			// 初期視点位置
			world.Factions[0].Parameter.DefaultScreenPosition
				= new Point2D((int)basePos.X, (int)basePos.Y);

			world.Factions[1].PlayerName = "青勢力";

			//homeparam.ButtonParams

			base.OnInitialize(world);
		}

		public override System.Collections.IEnumerable Update(IWorld world)
		{
			var ui = world.StoryUI;
			
			redHome = GetBuildings<Building.Red.HomeBase>(world).First();
			blueHome = GetBuildings<Building.Blue.HomeBase>(world).First();
			blueHigh = GetBuildings<Building.Blue.Factory>(world).First();

			Remilia = LoadTachies(ui, "LotusCraft/Image/Tachie/Remilia_N", "LotusCraft/Image/Tachie/Remilia_S", "LotusCraft/Image/Tachie/Remilia_W");
			Yukari = LoadTachies(ui, "LotusCraft/Image/Tachie/Yukari_N", "LotusCraft/Image/Tachie/Yukari_S", "LotusCraft/Image/Tachie/Yukari_W");
			Mokou = LoadTachies(ui, "LotusCraft/Image/Tachie/Mokou_N", "LotusCraft/Image/Tachie/Mokou_S", "LotusCraft/Image/Tachie/Mokou_W");
			Sanae = LoadTachies(ui, "LotusCraft/Image/Tachie/Sanae_N", "LotusCraft/Image/Tachie/Sanae_S", "LotusCraft/Image/Tachie/Sanae_W");
			Miko = LoadTachies(ui, "LotusCraft/Image/Tachie/Miko_N", "LotusCraft/Image/Tachie/Miko_S", "LotusCraft/Image/Tachie/Miko_W");
			Aya = LoadTachies(ui, "LotusCraft/Image/Tachie/Aya_N", "LotusCraft/Image/Tachie/Aya_S", "LotusCraft/Image/Tachie/Aya_W");
			Yukari = LoadTachies(ui, "LotusCraft/Image/Tachie/Yukari_N", "LotusCraft/Image/Tachie/Yukari_S", "LotusCraft/Image/Tachie/Yukari_W");
			Patchouli = LoadTachies(ui, "LotusCraft/Image/Tachie/Patchouli_N", "LotusCraft/Image/Tachie/Patchouli_S", "LotusCraft/Image/Tachie/Patchouli_W");
			Sakuya = LoadTachies(ui, "LotusCraft/Image/Tachie/Sakuya_N", "LotusCraft/Image/Tachie/Sakuya_S", "LotusCraft/Image/Tachie/Sakuya_W");
			
			Back1 = ui.LoadImage("LotusCraft/Image/Back/Black");

			var yukariUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Blue.Unique.Yukari)).First();
			var chilnoUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Blue.Unique.Chirno)).First();
			var mystiaUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Blue.Unique.Mystia)).First();
			var nitoriUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Blue.Unique.Nitori)).First();
			
			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				yukariUnit.AddExperience(3500);
				chilnoUnit.AddExperience(3000);
				mystiaUnit.AddExperience(3000);
				nitoriUnit.AddExperience(3000);
			}
			else if (world.StoryUtilities.GetDifficulty() == 1)
			{
				yukariUnit.AddExperience(4000);
				chilnoUnit.AddExperience(3000);
				mystiaUnit.AddExperience(3000);
				nitoriUnit.AddExperience(3000);
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				yukariUnit.AddExperience(8000);
				chilnoUnit.AddExperience(4500);
				mystiaUnit.AddExperience(4500);
				nitoriUnit.AddExperience(5000);
			}

			world.ChangeBGM(BGMList.Boushuen_Story2);

			//*
			foreach (var item in Talk会話冒頭(world))
			{
				yield return null;
			}
			//*/

			world.ChangeBGM(BGMList.Battle_Kouma);

			ui.ShowConditionText("目的：敵拠点の撃破");

			int c = 0;
			
			while (true)
			{
				if (!blueHome.Exists())
				{
					foreach (var item2 in Talk勝利(world))
					{
						yield return null;
					}
					world.Factions[1].DoesNotLose = false;
					world.Factions[1].Lose();
					world.StoryUtilities.SetDataToSaveData("LotusCraft.Red.03", "Clear");

					if (world.StoryUtilities.GetDifficulty() == 0)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Red.03.Easy", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 1)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Red.03.Normal", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 2)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Red.03.Hard", "Clear");
					}
					world.ChangeBGM(BGMList.Boushuen_Win);

					break;
				}
				if (!redHome.Exists())
				{
					foreach (var item2 in Talk敗北(world))
					{
						yield return null;
					}
					world.Factions[0].DoesNotLose = false;
					world.Factions[0].Lose();
					world.ChangeBGM(BGMList.Boushuen_Lose);

					break;
				}

				// スペル発動
				if (chilnoUnit.Exists() && !executedChilnoSpall && world.StoryUtilities.GetDifficulty() > 0)
				{
					TryCallChilnoSpell(world, chilnoUnit);
				}
				if (mystiaUnit.Exists() && !executedMystiaSpall && world.StoryUtilities.GetDifficulty() > 0)
				{
					TryCallMystiaSpell(world, mystiaUnit);
				}
				if (yukariUnit.Exists() && !executedYukariSpall)
				{
					TryCallYukariSpell(world, yukariUnit);
				}

				
				// ざこ
				if (c % enemySpan == 0)
				{
					if (c == enemySpan * 12 && mystiaUnit.Exists())
					{
						// 青ユニークに攻撃命令
						{
							var uniqueIDs = new List<int>();
							uniqueIDs.Add(mystiaUnit.UniqueID);

							world.UnitManager.AttackMove(uniqueIDs, redHome, false);
							
						}
					}

					if (c == enemySpan * 15 && chilnoUnit.Exists())
					{
						// 青ユニークに攻撃命令
						{
							var uniqueIDs = new List<int>();
							uniqueIDs.Add(chilnoUnit.UniqueID);

							world.UnitManager.AttackMove(uniqueIDs, redHome, false);

						}
					}

					if (c >= enemySpan * 5)
					{
						if (c == enemySpan * 5) {
							if (blueHigh.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHigh);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHigh);
								uniqueIDs.Add(l2.UniqueID);
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHigh);
								uniqueIDs.Add(l3.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, redHome, false);
							}
						}
						else if (c == enemySpan * 8)
						{
							if (blueHigh.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHigh);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHigh);
								uniqueIDs.Add(l2.UniqueID);
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Iku).FullName, blueHigh);
								uniqueIDs.Add(l3.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, redHome, false);
							}
						}
						else
						{
							if (blueHigh.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Iku).FullName, blueHigh);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHigh);
								uniqueIDs.Add(l2.UniqueID);
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Low02).FullName, blueHigh);
								uniqueIDs.Add(l3.UniqueID);
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Blue.Iku).FullName, blueHigh);
								uniqueIDs.Add(l4.UniqueID);
								
								world.UnitManager.AttackMove(uniqueIDs, redHome, false);
							}

						}
					}
				}

				c++;
				yield return null;
			}
			
			yield return base.Update(world);
		}

		private void TryCallChilnoSpell(IWorld world, IUnit ChilnoUnit)
		{
			if (executedChilnoSpall) return;

			var units = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0]);
			foreach (var u in units)
			{
				var radius = 6 * thrts.Def.MapTipLengthOnField;

				if (radius * radius > (u.Pos.X - ChilnoUnit.Pos.X) * (u.Pos.X - ChilnoUnit.Pos.X) + (u.Pos.Y - ChilnoUnit.Pos.Y) * (u.Pos.Y - ChilnoUnit.Pos.Y))
				{
					var targetPos = u.Pos;
					var spell = world.Factions[1].GetUnitSpellButtonParameter(ChilnoUnit.Parameter.GetType().FullName, new SpellButtonKey("凍符「パーフェクトフリーズ」", 1));
					spell.NormalButtonEvent(ChilnoUnit, false);
					executedChilnoSpall = true;
				}
			}
		}

		private void TryCallMystiaSpell(IWorld world, IUnit MystiaUnit)
		{
			if (executedMystiaSpall) return;

			var units = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0]);
			foreach (var u in units)
			{
				var radius = 6 * thrts.Def.MapTipLengthOnField;

				if (radius * radius > (u.Pos.X - MystiaUnit.Pos.X) * (u.Pos.X - MystiaUnit.Pos.X) + (u.Pos.Y - MystiaUnit.Pos.Y) * (u.Pos.Y - MystiaUnit.Pos.Y))
				{
					var targetPos = u.Pos;
					var spell = world.Factions[1].GetUnitSpellButtonParameter(MystiaUnit.Parameter.GetType().FullName, new SpellButtonKey("夜雀「真夜中のコーラスマスター」", 1));
					spell.NormalButtonEvent(MystiaUnit, false);
					executedMystiaSpall = true;
				}
			}
		}

		private void TryCallYukariSpell(IWorld world, IUnit YukariUnit)
		{
			if (executedYukariSpall || !YukariUnit.Exists()) return;

			var units = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0]);
			foreach (var u in units)
			{
				var radius = 6 * thrts.Def.MapTipLengthOnField;

				if (radius * radius > (u.Pos.X - YukariUnit.Pos.X) * (u.Pos.X - YukariUnit.Pos.X) + (u.Pos.Y - YukariUnit.Pos.Y) * (u.Pos.Y - YukariUnit.Pos.Y))
				{
					var targetPos = u.Pos;
					var spell = world.Factions[1].GetUnitSpellButtonParameter(YukariUnit.Parameter.GetType().FullName, new SpellButtonKey("紫奥義「弾幕結界」", 1));
					spell.NormalButtonEvent(YukariUnit, false);
					executedYukariSpall = true;
				}
			}
		}


		#region Story
		private System.Collections.IEnumerable Talk会話冒頭(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk1
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Aya[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【文】\nそういうわけで報告です");
			ui.ShowImage(Remilia[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【レミリア】\nどーぞ");
			ui.ShowImage(Aya[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【文】\nぶっちゃけ霊夢さんたちの勢力を直に見ることはできませんでしたが\n各地で小競り合いのようなものは起きています");
			ui.ShowImage(Remilia[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【レミリア】\nふむ");
			ui.ShowImage(Aya[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【文】\n普段交流のなかったもの同士がくっつきあっていて\nうちも似たようなものですけど、一つの集団を作っているようですね");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(ui.LoadImage("LotusCraft/Image/Tachie/Alice_N"),StoryUIImagePosition.Left,true,false);
			ui.ShowImage(ui.LoadImage("LotusCraft/Image/Tachie/Suika_S"),StoryUIImagePosition.Right,true,false);
			ui.ShowText("【文】\nアリス・マーガトロイドに伊吹萃香、\nここは博麗の巫女とはまた別に、独自の勢力を築いています");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Miko[0],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【文】\nまた、新たに幻想郷の住人になった聖人も動いているようです");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(ui.LoadImage("LotusCraft/Image/Tachie/Tenshi_S"), StoryUIImagePosition.Left, true, false);
			ui.ShowImage(ui.LoadImage("LotusCraft/Image/Tachie/Kasen_N"), StoryUIImagePosition.Right, true, false);
			ui.ShowText("【文】\nそれに天人に、仙人も入り乱れているような具合でして");
			ui.ShowImage(Remilia[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【レミリア】\nふむん。楽しそうで何よりだ。\nよほど退屈をしているんだろう、私を含めて、な");
			ui.ShowImage(Aya[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【文】\nええ、特にルールに対して文句も言わず、暇潰しの良い切っ掛けにしているんでしょう\nいつも弾幕ゴッコだけでは飽きますしね");
			ui.ShowImage(Remilia[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【レミリア】\nやるからには楽しんだほうが良いと思っているのさ\n私だってそうだ");
			ui.ShowImage(Aya[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【文】\nして、こちらから打っては出ないので？");
			ui.ShowImage(Remilia[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【レミリア】\n面倒じゃない\n太陽の下に出向くのなんて");
			ui.ShowImage(Aya[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【文】\nはぁ");
			ui.ShowImage(Remilia[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【レミリア】\nだから紅魔館に来させればいい\nついでに宴の席でも設ければ丁度いい");
			ui.ShowImage(Aya[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【文】\nその招待状は、もちろん私が配ると");
			ui.ShowImage(Remilia[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【レミリア】\n新聞のついでに配ればいいじゃない");
			ui.ShowImage(Aya[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【文】\nそうなんですけどね");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Sanae[0],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【早苗】\nところで私の影がとても薄いです");
			ui.ShowImage(Sanae[2],StoryUIImagePosition.Front,false,false);
			ui.ShowText("【早苗】\nヒロインのはずなのに！");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Mokou[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【妹紅】\nいつからヒロインになったの……");
			ui.ShowImage(Sanae[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【早苗】\nこの！\n私がですよ！");
			ui.ShowImage(Sanae[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【早苗】\nタイトル画面にも居る私がどうしてモブキャラの一体のような扱いなんですか！\n訴訟も辞さないですよ！");
			ui.ShowImage(Mokou[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【妹紅】\n雇われだからしょうがないんじゃ");
			ui.ShowImage(Mokou[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【妹紅】\nここ、どう考えてもレミリアと愉快な仲間たちっていう名称が似合いそうな勢力だし");
			ui.ShowImage(Aya[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【文】\nついでに800＊600の解像度だとタイトル画面ですらカットされてますね");
			ui.ShowImage(Sanae[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【早苗】\nだとしてもですよ！\n霊夢さん魔理沙さんに次ぐ存在のはずの私が");
			ui.ShowImage(Mokou[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【妹紅】\n咲夜だって黙々と仕事してるじゃないか");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Sakuya[0],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【咲夜】\n？");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Sanae[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【早苗】\nメイドさんにはメイドのお仕事があるでしょう\n私はもっと目立たなきゃいけないんですよ");
			ui.ShowImage(Mokou[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【妹紅】\n(そんな義務はどこにもないと思うけど)");
			ui.ShowImage(Patchouli[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【パチュリー】\nそうよ。レミィの思いつきに振り回されたって疲れるだけなんだし、ぐったりしてるぐらいで丁度いいのよ");
			ui.ShowImage(Sanae[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【早苗】\nでも、せっかくの出番が……");
			ui.ShowImage(Mokou[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【妹紅】\nここの連中を引っ張っていく積極性があれば別なんだろうけど、愚痴っているだけだし");
			ui.ShowText("【早苗】\n痛いところを突きますね");
			ui.ShowImage(Mokou[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【妹紅】\nそんなもんさ。平和で結構結構");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Yukari[1],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【紫】\nそんな平和を乱す存在を、許してなんておけない");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Mokou[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【妹紅】\nうわ、出た。妖怪隙間オババだ");
			ui.ShowImage(Yukari[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【紫】\n粉々にして亜空間にばら撒いてあげましょうか\nそうしたら化けて出ることもないでしょ");
			ui.ShowImage(Mokou[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【妹紅】\n素敵なお誘いだけど、今は雇われの身だから");
			ui.ShowImage(Yukari[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【紫】\n変わった面子を揃えたのね");
			ui.ShowImage(Remilia[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【レミリア】\nうちも国際交流を考えようと思って");
			ui.ShowText("【紫】\n元から多国籍軍みたいなものだけど");
			ui.ShowImage(Remilia[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【レミリア】\nそれで何の用だ？");
			ui.ShowImage(Yukari[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【紫】\nええ。今回どこまでやるつもりなのか\nそれを聞いておこうと思いまして");
			ui.ShowImage(Remilia[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【レミリア】\nほどほどにやるさ。ほどほどにね");
			ui.ShowImage(Yukari[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【紫】\n成程。それは安心");
			ui.ShowImage(Remilia[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【レミリア】\nで、お前はどこぞの誰を連れてくることにした？");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(ui.LoadImage("LotusCraft/Image/Tachie/Nitori_N"), StoryUIImagePosition.Right, true, false);
			ui.ShowImage(Yukari[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【紫】\n河童と");
			ui.ShowImage(ui.LoadImage("LotusCraft/Image/Tachie/Mystia_N"), StoryUIImagePosition.Right, true, false);
			ui.ShowText("【紫】\n夜雀に");
			ui.ShowImage(ui.LoadImage("LotusCraft/Image/Tachie/Chilno_S"), StoryUIImagePosition.Right, true, false);
			ui.ShowText("【紫】\n氷精を");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(Remilia[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【レミリア】\n数合わせにしか見えないが");
			ui.ShowImage(Yukari[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【紫】\nアテにしていたところに先約が入っていまして");
			ui.ShowImage(Remilia[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【レミリア】\n主催者がやる気を出しすぎても、こっちとしても困るから丁度いいさ\nさて、やりますか");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);

			var talkEnd = ui.ShowText(""); 
			while (!ui.IsCompleted(talkEnd))
				yield return null;
			
			ui.Hide();
			ui.ResumeGame();
			#endregion


			yield return null;
		}

	

		private System.Collections.IEnumerable Talk勝利(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk12
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Remilia[0], StoryUIImagePosition.Right, true, false);
			ui.ShowText("【レミリア】\nそれでこれ、どこで収拾をつけるつもりだ？");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【紫】\nなるように。行き過ぎであれば巫女なりが決着をつけるでしょう");
			ui.ShowImage(Remilia[1], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【レミリア】\nあまり霊夢に負担をかけすぎるなよ。\nどうせ今回だって、ろくに話も通さずに始めたんだろう");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【紫】\nわかるかしら");
			ui.ShowImage(Remilia[1], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【レミリア】\n私たちのご機嫌伺いもいいが、肝心の巫女に拗ねられないようにな");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true);

			var talkEnd0 = ui.ShowText("", false);
			while (!ui.IsCompleted(talkEnd0))
				yield return null;
			ui.Hide();
			ui.ResumeGame();
			#endregion

			yield return null;
		}

		private System.Collections.IEnumerable Talk敗北(IWorld world)
		{
			var ui = world.StoryUI;

			ui.PauseGame();
			ui.Show();
			ui.Hide();
			ui.ResumeGame();

			yield return null;
		}
		#endregion

		private int[] LoadTachies(IStoryUI ui, string path_N, string path_S, string path_W)
		{
			return new int[3]{
				ui.LoadImage( path_N ),
				ui.LoadImage( path_S ),
				ui.LoadImage( path_W )
			};
		}

		/// <summary>
		/// ユニットをエリア上に生成する。
		/// </summary>
		/// <param name="world"></param>
		/// <param name="faction"></param>
		/// <param name="paramType"></param>
		/// <param name="area"></param>
		/// <returns></returns>
		public IEnumerable<IUnit> PutUnitsOnArea(IWorld world, IFaction faction, Type paramType, Area area)
		{
			var ar = area as AreaRectangle;
			if (ar == null) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min(ar.Start.X, ar.End.X);
			var sy = Math.Min(ar.Start.Y, ar.End.Y);
			var ex = Math.Max(ar.Start.X, ar.End.X);
			var ey = Math.Max(ar.Start.Y, ar.End.Y);

			for (var y = sy; y <= ey; y++)
			{
				for (var x = sx; x <= ex; x++)
				{
					var u =
						world.UnitManager.Create(paramType.FullName, faction, (x + 0.5f) * thrts.Def.MapTipLengthOnField, (y + 0.5f) * thrts.Def.MapTipLengthOnField, faction);
					if (u != null) units.Add(u);
				}
			}

			return units;
		}

		public IEnumerable<IUnit> PutEnemy(IWorld world, Type unitType, Area area, int num, IBuilding target)
		{
			var rect = area as AreaRectangle;
			if (rect == null) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min(rect.Start.X, rect.End.X);
			var sy = Math.Min(rect.Start.Y, rect.End.Y);
			var ex = Math.Max(rect.Start.X, rect.End.X);
			var ey = Math.Max(rect.Start.Y, rect.End.Y);

			for (var y = sy; y < ey; y++)
			{
				for (var x = sx; x < ex; x++)
				{
					if (units.Count >= num)
						goto LoopEnd;

					var u = world.UnitManager.Create(
						unitType.FullName,
						world.Factions[1],
						(x + 0.5f) * thrts.Def.MapTipLengthOnField,
						(y + 0.5f) * thrts.Def.MapTipLengthOnField,
						world.Factions[1]);
					if (u != null)
						units.Add(u);
				}
			}
		LoopEnd:

			if (target != null)
				world.UnitManager.SelectTarget(units, new Vector2D(target.Pos.X, target.Pos.Y), false);

			return units;
		}

		bool IsUnitOnArea(AreaRectangle region, IUnit unit)
		{
			var startx = Math.Min(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var starty = Math.Min(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			var endx = Math.Max(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var endy = Math.Max(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			if (unit.Pos.X < endx && startx < unit.Pos.X && unit.Pos.Y < endy && starty < unit.Pos.Y)
			{
				return true;
			}
			return false;
		}

		IEnumerable<IBuilding> GetBuildings<T>(IWorld world) where T : BuildingParameter
		{
			return world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(T));
		}
	}
}

#endif