﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Unit.Green;
using LotusCraft.Building.Green;
using LotusCraft.Spell.Green;
using LotusCraft.Bullet.Green;
using LotusCraft.Bullet.Common;

namespace LotusCraft.Technology.Green
{
	public class BuildingHpLv1Tech : BuildingHPTech
	{
		public BuildingHpLv1Tech()
			:base()
		{
			this.Name += "";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {125,125,0,0};
			this.TechTime = 120 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Cherry).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_hp1";
		}
	}
	public class BuildingArmorLv1Tech : BuildingArmorTech
	{
		public BuildingArmorLv1Tech()
			:base()
		{
			this.Name += " 前編";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {150,150,0,0};
			this.TechTime = 150 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Cherry).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_defence1";
			this.NextLevel = 1;
		}
	}
	public class BuildingArmorLv2Tech : BuildingArmorTech
	{
		public BuildingArmorLv2Tech()
			:base()
		{
			this.Name += " 後編";
			this.ButtonDescription+="\n"+"必要建物 : 上級魔法陣";
			this.Costs = new [] {300,300,0,0};
			this.TechTime = 180 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Cherry).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Muenzuka).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_defence2";
		}
	}
	public class InfantryArmorLv1Tech : UnitArmorTech
	{
		public InfantryArmorLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.armorInc += 0;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(Low01).FullName,
				typeof(Low02).FullName,
				typeof(Low03).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence1";
			this.NextLevel = 1;
		}
	}
	public class InfantryArmorLv2Tech : UnitArmorTech
	{
		public InfantryArmorLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.armorInc += 0;
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.RequireTechnologies = new string[]{
				typeof(InfantryArmorLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Cherry).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low01).FullName,
				typeof(Low02).FullName,
				typeof(Low03).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence2";
			this.NextLevel = 2;
		}
	}
	public class InfantryArmorLv3Tech : UnitArmorTech
	{
		public InfantryArmorLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.armorInc += 0;
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 *Def.FPS;
			this.RequireTechnologies = new string[]{
				typeof(InfantryArmorLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Muenzuka).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low01).FullName,
				typeof(Low02).FullName,
				typeof(Low03).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence3";
		}
	}
	public class GunLv1Tech : GunTech
	{
		public GunLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.atkInc += 0;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(Low01Bullet).FullName,
				typeof(Low02Bullet).FullName,
				typeof(Low03Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack1";
			this.NextLevel = 1;
		}
	}
	public class GunLv2Tech : GunTech
	{
		public GunLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(GunLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Cherry).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low01Bullet).FullName,
				typeof(Low02Bullet).FullName,
				typeof(Low03Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack2";
			this.NextLevel = 2;
		}
	}
	public class GunLv3Tech : GunTech
	{
		public GunLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 *Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(GunLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Muenzuka).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low01Bullet).FullName,
				typeof(Low02Bullet).FullName,
				typeof(Low03Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack3";
		}
	}
	public class CannonArmorLv1Tech : CannonArmorTech
	{
		public CannonArmorLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.armorInc += 0;
			this.TechTargets = new string[]
			{
				typeof(SuikaSmall).FullName,
				typeof(Komachi).FullName,
				typeof(Medicine).FullName,
				typeof(Kurumi).FullName,
				typeof(Elie).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence1";
			this.NextLevel = 1;
		}
	}
	public class CannonArmorLv2Tech : CannonArmorTech
	{
		public CannonArmorLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonArmorLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Cherry).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(SuikaSmall).FullName,
				typeof(Komachi).FullName,
				typeof(Medicine).FullName,
				typeof(Kurumi).FullName,
				typeof(Elie).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence2";
			this.NextLevel = 2;
		}
	}
	public class CannonArmorLv3Tech : CannonArmorTech
	{
		public CannonArmorLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.TechTime = 150 *Def.FPS;
			this.Costs = new [] {250,250,0,0};
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonArmorLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Muenzuka).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(SuikaSmall).FullName,
				typeof(Komachi).FullName,
				typeof(Medicine).FullName,
				typeof(Kurumi).FullName,
				typeof(Elie).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence3";
		}
	}
	public class CannonAtkLv1Tech : CannonAtkTech
	{
		public CannonAtkLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.atkInc += 0;
			this.TechTargets = new string[]
			{
				typeof(SuikaSmallBullet).FullName,
				typeof(KomachiBullet).FullName,
				typeof(MedicineBullet).FullName,
				typeof(KurumiBullet).FullName,
				typeof(KurumiBounsBullet).FullName,
				typeof(KurumiBounsBullet1).FullName,
				typeof(KurumiBounsBullet2).FullName,
				typeof(KurumiBounsBullet3).FullName,
				typeof(KurumiBounsBullet4).FullName,
				typeof(ElieBullet).FullName,
				typeof(Elie).FullName,
				typeof(Komachi).FullName,
				typeof(Changebullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack1";
			this.NextLevel = 1;
			//
			this.UnitTechAction = UnitTech;
		}
		public bool UnitTech(UnitParameter param)
		{
			if(null == param)
				return false;
			if(param.GetType().FullName == typeof(Unit.Green.Elie).FullName)
				param.Speed += 0.05f*UnitParameter.BasisSpeed;
			if(param.GetType().FullName == typeof(Unit.Green.Komachi).FullName)
				param.Speed += 0.05f*UnitParameter.BasisSpeed;
			return true;
		}
	}
	public class CannonAtkLv2Tech : CannonAtkTech
	{
		public CannonAtkLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonAtkLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Cherry).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(SuikaSmallBullet).FullName,
				typeof(KomachiBullet).FullName,
				typeof(MedicineBullet).FullName,
				typeof(KurumiBullet).FullName,
				typeof(KurumiBounsBullet).FullName,
				typeof(KurumiBounsBullet1).FullName,
				typeof(KurumiBounsBullet2).FullName,
				typeof(KurumiBounsBullet3).FullName,
				typeof(KurumiBounsBullet4).FullName,
				typeof(ElieBullet).FullName,
				typeof(Elie).FullName,
				typeof(Komachi).FullName,
				typeof(Changebullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack2";
			this.NextLevel = 2;
			//
			this.UnitTechAction = UnitTech;
		}
		public bool UnitTech(UnitParameter param)
		{
			if(null == param)
				return false;
			if(param.GetType().FullName == typeof(Unit.Green.Elie).FullName)
				param.Speed += 0.05f*UnitParameter.BasisSpeed;
			if(param.GetType().FullName == typeof(Unit.Green.Komachi).FullName)
				param.Speed += 0.05f*UnitParameter.BasisSpeed;
			return true;
		}
	}
	public class CannonAtkLv3Tech : CannonAtkTech
	{
		public CannonAtkLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 *Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonAtkLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Muenzuka).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(SuikaSmallBullet).FullName,
				typeof(KomachiBullet).FullName,
				typeof(MedicineBullet).FullName,
				typeof(KurumiBullet).FullName,
				typeof(KurumiBounsBullet).FullName,
				typeof(KurumiBounsBullet1).FullName,
				typeof(KurumiBounsBullet2).FullName,
				typeof(KurumiBounsBullet3).FullName,
				typeof(KurumiBounsBullet4).FullName,
				typeof(ElieBullet).FullName,
				typeof(Elie).FullName,
				typeof(Komachi).FullName,
				typeof(Changebullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack3";
			//
			this.UnitTechAction = UnitTech;
		}
		public bool UnitTech(UnitParameter param)
		{
			if(null == param)
				return false;
			if(param.GetType().FullName == typeof(Unit.Green.Elie).FullName)
				param.Speed += 0.05f*UnitParameter.BasisSpeed;
			if(param.GetType().FullName == typeof(Unit.Green.Komachi).FullName)
				param.Speed += 0.05f*UnitParameter.BasisSpeed;
			return true;
		}
	}
	/*
	public class SmallSuikaSkillTech : SpecialSkillTech
	{
		public SmallSuikaSkillTech(ButtonPosition x = ButtonPosition._0,ButtonPosition y = ButtonPosition._2)
		{
//			this.skillName = typeof(FlandreSkill).FullName;
			this.Name = "フランドール修練 基本編";
			this.Description = "自爆によって周囲の敵にダメージを与えられるようになる。";
			this.ButtonDescription = Description;
			this.UnitTechAction = TechUnit;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Barrack).FullName,
				typeof(Hyoutan).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Green/FlandreSkill";

		}
		public bool TechUnit(thrts.UnitParameter param)
		{
			param.Armor += 4;
			param.Speed = 0.8f*UnitParameter.BasisSpeed;

			return true;
		}
	}
	public class KomachiSkillTech : SpecialSkillTech
	{
		public KomachiSkillTech(ButtonPosition x = ButtonPosition._1,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(KomachiSkill).FullName;
			this.Name = "小町修練 基本編";
			this.Description = "周囲の味方ユニットは移動速度が上昇し、地上と空中の両方を攻撃できるようになります。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.ButtonDescription = "";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Cherry).FullName,
				typeof(Court).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Green/KomachiSkill";
		}
	}
	public class MedicineSkillTech : SpecialSkillTech
	{
		public MedicineSkillTech(ButtonPosition x = ButtonPosition._2,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(MedicineSkill).FullName;
			this.Name = "メディスン修練 基本編";
			this.Description = "攻撃がヒットした時、周囲に毒の霧を撒きます。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Muenzuka).FullName,
				typeof(SuzuranField).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Green/MedicineSkill";
		}
	}
	*/
	public class MetabolicBoostTech : thrts.TechnologyParameter<ITargetObject>
	{
		public MetabolicBoostTech (ButtonPosition x = ButtonPosition._0, ButtonPosition y = ButtonPosition._2)
		:base()
		{
			this.Name = "走り込み";
			this.Description = "毛玉・妖精(岩)・ちび萃香の移動速度を上昇させる。";
			this.ButtonDescription = Description;
			this.ShortcutKeyword = "TechSpecial1";
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 110 *Def.FPS;
			this.RequireBuildings = new string[] {
				typeof(Cherry).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low01).FullName,
				typeof(Low02).FullName,
				typeof(SuikaSmall).FullName,
			};
			this.UnitTechAction = UnitTech;
			this.IconPath = "LotusCraft/Image/Button/Technology/Green/running";
		}
		public bool UnitTech(UnitParameter param)
		{
			if(null == param)
				return false;

			if(param.GetType().FullName == typeof(Unit.Green.SuikaSmall).FullName)
				param.Speed += 0.35f*UnitParameter.BasisSpeed;
			else if(param.GetType().FullName == typeof(Unit.Green.Low01).FullName)
				param.Speed += 0.3f*UnitParameter.BasisSpeed;
			else if(param.GetType().FullName == typeof(Unit.Green.Low02).FullName)
				param.Speed += 0.2f*UnitParameter.BasisSpeed;

			return true;
		}
	}
	public class LongBow : thrts.TechnologyParameter<ITargetObject>
	{
		public LongBow(ButtonPosition x = ButtonPosition._0, ButtonPosition y = ButtonPosition._2)
			:base()
		{
			this.Name = "遠投";
			this.Description = "妖精(水)の射程が上昇させる。";
			this.ButtonDescription = Description;
			this.ShortcutKeyword = "TechSpecial1";
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 100 *Def.FPS;
			this.RequireBuildings = new string[] {
				typeof(Muenzuka).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low03Bullet).FullName,
			};
			this.BulletTechAction = BulletTech;
			this.IconPath = "LotusCraft/Image/Button/Technology/Green/longthrow";
		}
		public bool BulletTech(BulletParameter param)
		{
			if(null == param)
				return false;
			param.MaxRange += 1*Def.MapTipLengthOnField;
			return true;
		}
	}
}
