﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Unit.Red;
using LotusCraft.Building.Red;
using LotusCraft.Spell.Red;
using LotusCraft.Bullet.Red;
using LotusCraft.Bullet.Common;

namespace LotusCraft.Technology.Red
{
	public class BuildingHpLv1Tech : BuildingHPTech
	{
		public BuildingHpLv1Tech()
			:base()
		{
			this.Name += "";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {125,125,0,0};
			this.TechTime = 120 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_hp1";
		}
	}
	public class BuildingArmorLv1Tech : BuildingArmorTech
	{
		public BuildingArmorLv1Tech()
			:base()
		{
			this.Name += " 前編";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {150,150,0,0};
			this.TechTime = 150 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_defence1";
			this.NextLevel = 1;
		}
	}
	public class BuildingArmorLv2Tech : BuildingArmorTech
	{
		public BuildingArmorLv2Tech()
			:base()
		{
			this.Name += " 後編";
			this.Costs = new [] {300,300,0,0};
			this.TechTime = 180 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_defence2";
		}
	}
	public class InfantryArmorLv1Tech : UnitArmorTech
	{
		public InfantryArmorLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.armorInc += 0;
			this.TechTargets = new string[]
			{
				typeof(Low01).FullName,
				typeof(Low02).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence1";
			this.NextLevel = 1;
		}
	}
	public class InfantryArmorLv2Tech : UnitArmorTech
	{
		public InfantryArmorLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(InfantryArmorLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low01).FullName,
				typeof(Low02).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence2";
			this.NextLevel = 2;
		}
	}
	public class InfantryArmorLv3Tech : UnitArmorTech
	{
		public InfantryArmorLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 *Def.FPS;
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(InfantryArmorLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low01).FullName,
				typeof(Low02).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence3";
		}
	}
	public class GunLv1Tech : GunTech
	{
		public GunLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.atkInc += 0;
			this.TechTargets = new string[]
			{
				typeof(Low01Bullet).FullName,
				typeof(Low02Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack1";
			this.NextLevel = 1;
		}
	}
	public class GunLv2Tech : GunTech
	{
		public GunLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(GunLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low01Bullet).FullName,
				typeof(Low02Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack2";
			this.NextLevel = 2;
		}
	}
	public class GunLv3Tech : GunTech
	{
		public GunLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 *Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(GunLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low01Bullet).FullName,
				typeof(Low02Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack3";
		}
	}
	public class CannonArmorLv1Tech : CannonArmorTech
	{
		public CannonArmorLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.armorInc += 0;
			this.TechTargets = new string[]
			{
				typeof(Namazu).FullName,
				typeof(Suwako).FullName,
				typeof(Flandre).FullName,
				typeof(FlandreImage).FullName,
				typeof(Kanako).FullName,
				typeof(Koakuma).FullName,
				typeof(Meirin).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence1";
			this.NextLevel = 1;
		}
	}
	public class CannonArmorLv2Tech : CannonArmorTech
	{
		public CannonArmorLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonArmorLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Namazu).FullName,
				typeof(Suwako).FullName,
				typeof(Flandre).FullName,
				typeof(FlandreImage).FullName,
				typeof(Kanako).FullName,
				typeof(Koakuma).FullName,
				typeof(Meirin).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence2";
			this.NextLevel = 2;
		}
	}
	public class CannonArmorLv3Tech : CannonArmorTech
	{
		public CannonArmorLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.TechTime = 150 *Def.FPS;
			this.Costs = new [] {250,250,0,0};
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonArmorLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Namazu).FullName,
				typeof(Suwako).FullName,
				typeof(Flandre).FullName,
				typeof(FlandreImage).FullName,
				typeof(Kanako).FullName,
				typeof(Koakuma).FullName,
				typeof(Meirin).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence3";
		}
	}
	public class CannonAtkLv1Tech : CannonAtkTech
	{
		public CannonAtkLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.atkInc += 0;
			this.TechTargets = new string[]
			{
				typeof(NamazuBullet).FullName,
				typeof(NamazuSiegeBullet).FullName,
				typeof(SuwakoBullet).FullName,
				typeof(SuwakoAirBullet).FullName,
				typeof(FlandreBullet).FullName,
				typeof(FlandreImageBullet).FullName,
				typeof(KanakoBullet).FullName,
				typeof(KoakumaBullet).FullName,
				typeof(MeirinMobBigBullet).FullName,
				typeof(Flandre).FullName,
				typeof(FlandreImage).FullName,
				typeof(Changebullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack1";
			this.NextLevel = 1;
			//
			this.UnitTechAction = UnitTech;
		}
		public bool UnitTech(UnitParameter param)
		{
			if(null == param)
				return false;
			if(param.GetType().FullName == typeof(Unit.Red.FlandreImage).FullName)
				param.Speed += 0.1f*UnitParameter.BasisSpeed;

			if(param.GetType().FullName == typeof(Unit.Red.Flandre).FullName)
				param.Speed += 0.1f*UnitParameter.BasisSpeed;
			return true;
		}
	}
	public class CannonAtkLv2Tech : CannonAtkTech
	{
		public CannonAtkLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonAtkLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(NamazuBullet).FullName,
				typeof(NamazuSiegeBullet).FullName,
				typeof(SuwakoBullet).FullName,
				typeof(SuwakoAirBullet).FullName,
				typeof(FlandreBullet).FullName,
				typeof(FlandreImageBullet).FullName,
				typeof(KanakoBullet).FullName,
				typeof(KoakumaBullet).FullName,
				typeof(MeirinMobBigBullet).FullName,
				typeof(Flandre).FullName,
				typeof(FlandreImage).FullName,
				typeof(Changebullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack2";
			this.NextLevel = 2;
			//
			this.UnitTechAction = UnitTech;
		}
		public bool UnitTech(UnitParameter param)
		{
			if(null == param)
				return false;
			if(param.GetType().FullName == typeof(Unit.Red.FlandreImage).FullName)
				param.Speed += 0.1f*UnitParameter.BasisSpeed;

			if(param.GetType().FullName == typeof(Unit.Red.Flandre).FullName)
				param.Speed += 0.1f*UnitParameter.BasisSpeed;
			return true;
		}
	}
	public class CannonAtkLv3Tech : CannonAtkTech
	{
		public CannonAtkLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 *Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonAtkLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(NamazuBullet).FullName,
				typeof(NamazuSiegeBullet).FullName,
				typeof(SuwakoBullet).FullName,
				typeof(SuwakoAirBullet).FullName,
				typeof(FlandreBullet).FullName,
				typeof(FlandreImageBullet).FullName,
				typeof(KanakoBullet).FullName,
				typeof(KoakumaBullet).FullName,
				typeof(MeirinMobBigBullet).FullName,
				typeof(Flandre).FullName,
				typeof(FlandreImage).FullName,
				typeof(Changebullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack3";
			//
			this.UnitTechAction = UnitTech;
		}
		public bool UnitTech(UnitParameter param)
		{
			if(null == param)
				return false;
			if(param.GetType().FullName == typeof(Unit.Red.FlandreImage).FullName)
				param.Speed += 0.1f*UnitParameter.BasisSpeed;

			if(param.GetType().FullName == typeof(Unit.Red.Flandre).FullName)
				param.Speed += 0.1f*UnitParameter.BasisSpeed;
			return true;
		}
	}
	/*
	public class KanakoSkillTech : SpecialSkillTech
	{
		public KanakoSkillTech(ButtonPosition x = ButtonPosition._0,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(KanakoSkill).FullName;
			this.Name = "神奈子修練 基本編";
			this.Description = "射程が減少し、攻撃にスプラッシュ属性が付与されます。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Red/KanakoSkill";
		}
	}
	public class FlandreSkillTech : SpecialSkillTech
	{
		public FlandreSkillTech(ButtonPosition x = ButtonPosition._1,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(FlandreSkill).FullName;
			this.Name = "フランドール修練 基本編";
			this.Description = "HPが減少し移動速度が上昇します。死亡時に周囲にダメージを与える。";
			this.ButtonDescription = Description;
			this.BulletTechAction = TechBullet;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
				typeof(StairsOfKoumakan).FullName,
			};
			this.TechTargets = new []
			{
				typeof(FlandreBullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Red/FlandreSkill";

		}
		public bool TechBullet(BulletParameter param)
		{
			param.Attack += 10;

			return true;
		}
	}
	public class SuwakoSkillTech : SpecialSkillTech
	{
		public SuwakoSkillTech(ButtonPosition x = ButtonPosition._2,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(SuwakoSkill).FullName;
			this.Name = "諏訪子修練 基本編";
			this.Description = "対空攻撃の射程と攻撃力が上昇します。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
				typeof(FrogSculpture).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Red/SuwakoSkill";
		}
	}
	public class NamazuSkillTech : SpecialSkillTech
	{
		public NamazuSkillTech(ButtonPosition x = ButtonPosition._3,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(NamazuSkill).FullName;
			this.Name = "鯰修練 基本編";
			this.Description = "周囲のユニットにダメージと移動速度低下を与えられるようになります。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.ButtonDescription = "";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
				typeof(NamazuSculpture).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Red/NamazuSkill";
		}
	}
	*/
	public class VMaxTech  : thrts.TechnologyParameter<ITargetObject>
	{
		public VMaxTech  (ButtonPosition x = ButtonPosition._0, ButtonPosition y = ButtonPosition._2)
			:base()
		{
			this.Name = "V-MAX";
			this.Description = "白近距離の移動速度が上昇します";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {150,150,0,0};
			this.TechTime = 110 *Def.FPS;
			this.RequireBuildings = new string[] {
				typeof(Barrack).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low01).FullName,
			};
			this.UnitTechAction = UnitTech;
			this.IconPath = "LotusCraft/Image/Button/Technology/Green/running";
		}
		public bool UnitTech(UnitParameter param)
		{
			if(null == param)
				return false;
			param.Speed += 0.2f*UnitParameter.BasisSpeed;
			return true;
		}
	}

}
