﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Unit.White;
using LotusCraft.Building.White;
using LotusCraft.Technology.White;
using LotusCraft.Bullet.White;
using LotusCraft.Bullet.Common;

namespace LotusCraft.Technology.White
{
	public class BuildingHpLv1Tech : BuildingHPTech
	{
		public BuildingHpLv1Tech()
			:base()
		{
			this.Name += "";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {125,125,0,0};
			this.TechTime = 120*30;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_hp1";
		}
	}
	public class BuildingArmorLv1Tech : BuildingArmorTech
	{
		public BuildingArmorLv1Tech()
			:base()
		{
			this.Name += " 前編";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {150,150,0,0};
			this.TechTime = 150*30;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_defence1";
			this.NextLevel = 1;
		}
	}
	public class BuildingArmorLv2Tech : BuildingArmorTech
	{
		public BuildingArmorLv2Tech()
			:base()
		{
			this.Name += " 後編";
			this.TechTime = 180*30;
			this.ButtonDescription+="\n"+"必要建物 : 上級魔法陣";
			this.Costs = new [] {300,300,0,0};
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_defence2";
		}
	}
	public class InfantryArmorLv1Tech : UnitArmorTech
	{
		public InfantryArmorLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 * Def.FPS;
			this.armorInc += 0;
			this.TechTargets = new string[]
			{
				typeof(Low02).FullName,
				typeof(Low03).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence1";
			this.NextLevel = 1;
		}
	}
	public class InfantryArmorLv2Tech : UnitArmorTech
	{
		public InfantryArmorLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 * Def.FPS;
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(InfantryArmorLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low02).FullName,
				typeof(Low03).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence2";
			this.NextLevel = 2;
		}
	}
	public class InfantryArmorLv3Tech : UnitArmorTech
	{
		public InfantryArmorLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 * Def.FPS;
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(InfantryArmorLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low02).FullName,
				typeof(Low03).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence3";
		}
	}
	public class GunLv1Tech : GunTech
	{
		public GunLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 * Def.FPS;
			this.atkInc += 0;
			this.TechTargets = new string[]
			{
				typeof(Low02Bullet).FullName,
				typeof(Low03Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack1";
			this.NextLevel = 1;
		}
	}
	public class GunLv2Tech : GunTech
	{
		public GunLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 * Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(GunLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low02Bullet).FullName,
				typeof(Low03Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack2";
			this.NextLevel = 2;
		}
	}
	public class GunLv3Tech : GunTech
	{
		public GunLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 * Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(GunLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low02Bullet).FullName,
				typeof(Low03Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack3";
		}
	}
	public class CannonArmorLv1Tech : CannonArmorTech
	{
		public CannonArmorLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 * Def.FPS;
			this.armorInc += 0;
			this.TechTargets = new string[]
			{
				typeof(Kaguya).FullName,
				typeof(Reisen).FullName,
				typeof(Toramaru).FullName,
				typeof(Murasa).FullName,
				typeof(Nazurin).FullName,
				typeof(Kosuzu).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence1";
			this.NextLevel = 1;
		}
	}
	public class CannonArmorLv2Tech : CannonArmorTech
	{
		public CannonArmorLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 * Def.FPS;
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonArmorLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Kaguya).FullName,
				typeof(Reisen).FullName,
				typeof(Toramaru).FullName,
				typeof(Murasa).FullName,
				typeof(Nazurin).FullName,
				typeof(Kosuzu).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence2";
			this.NextLevel = 2;
		}
	}
	public class CannonArmorLv3Tech : CannonArmorTech
	{
		public CannonArmorLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 * Def.FPS;
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonArmorLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Kaguya).FullName,
				typeof(Reisen).FullName,
				typeof(Toramaru).FullName,
				typeof(Murasa).FullName,
				typeof(Nazurin).FullName,
				typeof(Kosuzu).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence3";
		}
	}
	public class CannonAtkLv1Tech : CannonAtkTech
	{
		public CannonAtkLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 * Def.FPS;
			this.atkInc += 0;
			this.TechTargets = new string[]
			{
				typeof(KaguyaMobBullet).FullName,
				typeof(KaguyaMobBigBullet).FullName,
				typeof(ReisenBullet).FullName,
				typeof(ToramaruBullet).FullName,
				typeof(MurasaBullet).FullName,
				typeof(MurasaBlueBullet).FullName,
				typeof(NazurinBullet).FullName,
				typeof(Toramaru).FullName,
				typeof(Changebullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack1";
			this.NextLevel = 1;
			//
			this.UnitTechAction = UnitTech;
		}
		public bool UnitTech(UnitParameter param)
		{
			if(null == param)
				return false;

			if(param.GetType().FullName == typeof(Unit.White.Toramaru).FullName)
				param.Speed += 0.05f*UnitParameter.BasisSpeed;
			return true;
		}
	}
	public class CannonAtkLv2Tech : CannonAtkTech
	{
		public CannonAtkLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 * Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonAtkLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(KaguyaMobBullet).FullName,
				typeof(KaguyaMobBigBullet).FullName,
				typeof(ReisenBullet).FullName,
				typeof(ToramaruBullet).FullName,
				typeof(MurasaBullet).FullName,
				typeof(MurasaBlueBullet).FullName,
				typeof(NazurinBullet).FullName,
				typeof(Toramaru).FullName,
				typeof(Changebullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack2";
			this.NextLevel = 2;
			//
			this.UnitTechAction = UnitTech;
		}
		public bool UnitTech(UnitParameter param)
		{
			if(null == param)
				return false;

			if(param.GetType().FullName == typeof(Unit.White.Toramaru).FullName)
				param.Speed += 0.05f*UnitParameter.BasisSpeed;
			return true;
		}
	}
	public class CannonAtkLv3Tech : CannonAtkTech
	{
		public CannonAtkLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 * Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonAtkLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(KaguyaMobBullet).FullName,
				typeof(KaguyaMobBigBullet).FullName,
				typeof(ReisenBullet).FullName,
				typeof(ToramaruBullet).FullName,
				typeof(MurasaBullet).FullName,
				typeof(MurasaBlueBullet).FullName,
				typeof(NazurinBullet).FullName,
				typeof(Toramaru).FullName,
				typeof(Changebullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack3";
			//
			this.UnitTechAction = UnitTech;
		}
		public bool UnitTech(UnitParameter param)
		{
			if(null == param)
				return false;

			if(param.GetType().FullName == typeof(Unit.White.Toramaru).FullName)
				param.Speed += 0.05f*UnitParameter.BasisSpeed;
			return true;
		}
	}
	/*
	public class KaguyaMobSkillTech : SpecialSkillTech
	{
		public KaguyaMobSkillTech(ButtonPosition x = ButtonPosition._0,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(Spell.White.KaguyaSkill).FullName;
			this.Name = "新難題「金閣寺の一枚天井」の習得";
			this.Description = "移動不可となる代わりに、長い射程と高い攻撃力を持つモードに変形できるようにする。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.ButtonDescription = "";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90*30;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/White/KaguyaSkill";
		}
	}
	public class ToramaruSkillTech : SpecialSkillTech
	{
		public ToramaruSkillTech(ButtonPosition x = ButtonPosition._1,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(Spell.White.ToramaruSkill).FullName;
			this.Name = "寅丸修練 基本編";
			this.Description = "防御力と移動速度が上昇する。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90*30;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
				typeof(Houtou).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/White/ShouSkill";

		}
	}
	public class MurasaSkillTech : SpecialSkillTech
	{
		public MurasaSkillTech(ButtonPosition x = ButtonPosition._2,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(Spell.White.MurasaSkill).FullName;
			this.Name = "村紗修練 基本編";
			this.Description = "水属性へのボーナスが増加します。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90*30;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
				typeof(Seirensen).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/White/MurasaSkill";
		}
	}
	public class ReisenSkillTech : SpecialSkillTech
	{
		public ReisenSkillTech(ButtonPosition x = ButtonPosition._3,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(Spell.White.ReisenSkill).FullName;
			this.Name = "鈴仙修練 基本編";
			this.Description = "周囲の味方ユニットのHPを自動で回復する。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90*30;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
				typeof(Hospital).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/White/ReisenSkill";
		}
	}
	*/
}
