﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Black;
using LotusCraft.Bullet.Black;
using LotusCraft.Spell.Black;

namespace LotusCraft.Unit.Black.Unique
{
	public class Miko : General.Unique
	{
		public Miko ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Black/Unique/Miko";
			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Miko";
			#endregion

			Costs = new [] {400,250,0,0};
			defaultCosts = new [] {400,250,0,0};
			incCosts = new []{10,5,0,0};

			#region define_lv_param
			HPs[0] = 30 + (800 + 50)/2  + 150;
			HPs[1] = 30 + HPs[0];
			HPs[2] = 30 + HPs[1];
			HPs[3] = 30 + HPs[2];
			HPs[4] = 30 + HPs[3];
			HPs[5] = 30 + HPs[4];
			HPs[6] = 30 + HPs[5];
			HPs[7] = 30 + HPs[6];
			HPs[8] = 30 + HPs[7];
			HPs[9] = 30 + HPs[8];
			
			Armors[0] = 1;
			Armors[1] = 1;
			Armors[2] = 2;
			Armors[3] = 2;
			Armors[4] = 3;
			Armors[5] = 3;
			Armors[6] = 4;
			Armors[7] = 4;
			Armors[8] = 5;
			Armors[9] = 5;

			ATKs [0] = 2 + 20+2;
			ATKs [1] = 2 + ATKs [0];
			ATKs [2] = 2 + ATKs [1];
			ATKs [3] = 3 + ATKs [2];
			ATKs [4] = 3 + ATKs [3];
			ATKs [5] = 3 + ATKs [4];
			ATKs [6] = 3 + ATKs [5];
			ATKs [7] = 4 + ATKs [6];
			ATKs [8] = 4 + ATKs [7];
			ATKs [9] = 4 + ATKs [8];

			#endregion

			#region UnitParams
			Name = "豊聡耳 神子";
			HP = HPs [0];
			Speed = 1*BasisSpeed;
			
			#endregion

			#region Animation
			this.SetBigSizeAnimation("LotusCraft/Image/Unit/Black/Unique/Miko");
			#endregion

			#region Cutin
			this.SetCutinAnimation("LotusCraft/Image/Cutin/Miko");
			#endregion

			#region Spell
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Black.Senfu (),
				new LotusCraft.Spell.Black.Hihou (),
				new LotusCraft.Spell.Black.Shinkou (),
				new LotusCraft.Spell.Black.Hoshifuru (),
				new LotusCraft.Spell.SpellLevelUp("Black"),
			};
			#endregion

			#region AutoCasts
			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
				SpellParams[1].DefaultAutoCast,
				SpellParams[2].DefaultAutoCast,
				SpellParams[3].DefaultAutoCast,
				SpellParams[4].DefaultAutoCast,
				// 経験値取得用オートキャスト
				new LotusCraft.AutoCast.ExpFlagAutoCast<thrts.IUnit> (this.Name + "Exp"),
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit> (this.Name + "AutoHeal"),
			};
			#endregion


			#region Bullets
			Bullets = new string[] { typeof(MikoBullet).FullName };
			#endregion
		}
		public override void OnLoad (thrts.IFaction faction)
		{
//			kindName = this.GetType().FullName;

			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].DefaultSpellButton,SpellParams[2].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].DefaultSpellButton,SpellParams[3].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].DefaultSpellButton,SpellParams[4].SpellButtons),
				//				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].LevelUpSpellButton),
			};
#endregion
			
			base.OnLoad (faction);
		}
		public override void OnLvUp (thrts.IUnit unit)
		{
			base.OnLvUp(unit);
		}
		
		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUniqueEffect).FullName, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}
}
namespace LotusCraft.Unit.Black
{

	public class Armillary : thrts.UnitParameter
	{
		public Armillary()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Black/Low01";
			#endregion
			
			#region UnitParams
			Name = "斑鳩寺の天球儀";
			HP = 100;
			Armor = 4;
			Radius = 4 * 16;
			Speed = 0.0f * BasisSpeed;
			Exp = 0;
			
			PopulationWeight = 0;

			MoveType |= UnitMoveType.Air;

			ViewRange = 16*Def.MapTipLengthOnField;
			
			MakingTime = 0 * 30;

			// lowest priority
			SelectPriority = 999;
			IsSummon = true;
			CanState = false;

			/// mine,gas,sup,?
			Costs = new [] {0,0,0,0};
			#endregion
			
			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Common/Blank");
			#endregion
			
			#region BuildableObjcets
			#endregion
			
			#region Bullets
			#endregion
			
		}
		public override void OnLoad (IFaction faction)
		{
			base.OnLoad (faction);
		}

		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUnitEffect).FullName, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}
}
namespace LotusCraft.Bullet.Black
{
	public class MikoBullet : General.HeroBullet
	{
		public MikoBullet()
		{
			Type = BulletType.ShortRange;
			this.Attack = 0;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			Gravity = 0f;
			MaxRange = 6.0f * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.5f * 30);
			AttackRigor = (int)(0.5f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;
			
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.GunLong).FullName, bullet.Position);
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			var faction = bullet.Generator.Faction;
			var offset = new Vector3D(0, 0, 4);
			var scale = new Vector3D(8, 8, 8);
			
			if (bullet.Parameter.HasSplash)
			{
				var effect = faction.World.EffectManager.CreateEffect(typeof(UtsuhoHitSplashEffect).FullName, target.Pos + offset);
				effect.SetScale(scale);
			}
			else
			{
				var effect = faction.World.EffectManager.CreateEffect(typeof(UtsuhoHitEffect).FullName, target.Pos + offset);
				effect.SetScale(scale);
			}
			
			faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitShortRangeAttack).FullName, target.Pos);
		}
	}
}
