﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Black;
using LotusCraft.Effect.Black;
using LotusCraft.Building.Black;


namespace LotusCraft.Unit.Black.Unique
{
	public class Rin : General.Unique
	{
		public Rin ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Black/Unique/rin";
			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Rin";
			#endregion

			Costs = new [] {400,250,0,0};
			defaultCosts = new [] {400,250,0,0};
			incCosts = new []{10,5,0,0};

			#region define_lv_param
			// range <= 5
			HPs[0] = 40+ (800 + 100)/2 + 150;
			HPs[1] = 40 + HPs[0];
			HPs[2] = 40 + HPs[1];
			HPs[3] = 40 + HPs[2];
			HPs[4] = 40 + HPs[3];
			HPs[5] = 40 + HPs[4];
			HPs[6] = 40 + HPs[5];
			HPs[7] = 40 + HPs[6];
			HPs[8] = 40 + HPs[7];
			HPs[9] = 40 + HPs[8];
			
			Armors[0] = 0;
			Armors[1] = 0;
			Armors[2] = 0;
			Armors[3] = 0;
			Armors[4] = 0;
			Armors[5] = 0;
			Armors[6] = 1;
			Armors[7] = 1;
			Armors[8] = 2;
			Armors[9] = 2;

			ATKs [0] = 2 + 23;
			ATKs [1] = 2 + ATKs [0];
			ATKs [2] = 3 + ATKs [1];
			ATKs [3] = 3 + ATKs [2];
			ATKs [4] = 3 + ATKs [3];
			ATKs [5] = 3 + ATKs [4];
			ATKs [6] = 4 + ATKs [5];
			ATKs [7] = 4 + ATKs [6];
			ATKs [8] = 4 + ATKs [7];
			ATKs [9] = 4 + ATKs [8];
			


#endregion

			#region UnitParams
			Name = "火焔猫  燐";
			HP = HPs[0];
			Speed = 1.2f*BasisSpeed;

			#endregion

			#region Animation
			this.SetBigSizeAnimation("LotusCraft/Image/Unit/Black/Unique/rin");

			#endregion

			#region Cutin
			this.SetCutinAnimation("LotusCraft/Image/Cutin/Rin");
			#endregion

			#region Bullets
			Bullets = new string[] { 
				typeof(RinBullet).FullName,
				typeof(YoukaiBullet).FullName,
			};
			#endregion
		}
		public override void OnLoad (thrts.IFaction faction)
		{
//			kindName = this.GetType().FullName;

			#region Spell
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Black.Jusei (),
				new LotusCraft.Spell.Black.Shokuzai(),
				new LotusCraft.Spell.Black.Byoufu (),
				new LotusCraft.Spell.Black.Youkai (),
				new LotusCraft.Spell.SpellLevelUp("Black"),
				new LotusCraft.Spell.CorpseTokenDisplay(),
			};
			#endregion
			
			#region AutoCasts
			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
				SpellParams[1].DefaultAutoCast,
				SpellParams[2].DefaultAutoCast,
				SpellParams[3].DefaultAutoCast,
				SpellParams[4].DefaultAutoCast,
				// 経験値取得用オートキャスト
				new LotusCraft.AutoCast.ExpFlagWithCollectTokenAutoCast<thrts.IUnit> (this.Name+"Exp"),
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit>(this.Name+"AutoHeal"),
			};
			#endregion
			
			#region Buttons
			
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].DefaultSpellButton,SpellParams[2].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].DefaultSpellButton,SpellParams[3].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].DefaultSpellButton,SpellParams[4].SpellButtons),
				//				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[5].DefaultSpellButton,SpellParams[5].SpellButtons),
			};
			#endregion

			base.OnLoad(faction);
			
		}
		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUniqueEffect).FullName, unit.Pos + offset, faction);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
		public override void OnLvUp (thrts.IUnit unit)
		{
			base.OnLvUp(unit);
		}
		public override void OnAppear (IUnit unit)
		{
			if (unit.UserValues.ContainsKey (Token.CorpseToken.TokenName)) {
				// refresh token count
				var tokenDisplay = unit.GetSpellWithName (Spell.CorpseTokenDisplay.TokenName);
				var token = unit.UserValues [Token.CorpseToken.TokenName] as Token.CorpseToken;
				if (null != tokenDisplay && null != token && token.Count - tokenDisplay.Level != 0) {
					tokenDisplay.LvUp(token.Count - tokenDisplay.Level);
				}
			} else {
				unit.UserValues.Add( Token.CorpseToken.TokenName,new Token.CorpseToken(unit,0));
			}

			base.OnAppear (unit);
		}
	}

}

namespace LotusCraft.Bullet.Black
{
	public class RinBullet : General.HeroBullet
	{
		public RinBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			this.Attack = 0;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			
			MaxRange = 5*Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.2f * 30);
			AttackRigor = (int)(0.8f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
			TextureAnimation.Offset.X = 128 * 0 + 16 * 3;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 0;
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.GunLong).FullName, bullet.Position);
		}
		static void OnHitEffect(IBullet bullet,ITargetObject target)
		{
			var faction = bullet.Generator.Faction;
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalBlue);
			faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitLongRangeAttack).FullName, target.Pos);
		}
	}
}
