﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Unit.Black
{
	public class UniqueBase : General.Unique
	{
		public const string statusDicKey = "black_status_key";
		const float a_atk_0 = 23;
		const float a_atk_1 = 0.1f;
		const float a_atk_2 = 0.125f;

		const float a_spd_0 = 0.9f;
		const float a_spd_1 = 0.25f;
		
		const float a_aspd_0 = 1.0f;
		const float a_aspd_1 = 0.125f;
		
		const float a_hp_0 = 300;
		const float a_hp_1 = 45;

		const float a_view_0 = 12f;
		const float a_view_1 = 0.25f;
		
		const float a_rng_0 = 1f;
		const float a_rng_1 = 0.5f;
		
		const float a_bns_0 = 1f;
		const float a_bns_1 = 0.1f;
		
		const float a_exp_0 = -0.3f;
		const float a_exp_1 = 0.05f;

		// レベルアップする度に [レベルアップ後のlv]*a_sp_1 ポイントのステータスポイントを得る
		const float a_sp_1 = 5;
		const int default_sp = 30;

		public MMOStatus LEVEL = new MMOStatusLevel();
		public MMOStatus REST = new MMOStatusRest();
		public MMOStatus VIT = new MMOStatusVit();
		public MMOStatus STR = new MMOStatusStr();
		public MMOStatus AGI = new MMOStatusAgi();
		public MMOStatus INT = new MMOStatusInt();
		public MMOStatus LUC = new MMOStatusLuc();

		public Dictionary<MMOKey,MMOStatus> MMOStatusDic = new Dictionary<MMOKey, MMOStatus>();

		public UniqueBase()
		{
			MMOStatusDic = new Dictionary<MMOKey, MMOStatus>(){
				{MMOKey.MMO_LEVEL,LEVEL},
				{MMOKey.MMO_REST,REST},
				{MMOKey.MMO_STR,STR},
				{MMOKey.MMO_VIT,VIT},
				{MMOKey.MMO_AGI,AGI},
				{MMOKey.MMO_INT,INT},
				{MMOKey.MMO_LUC,LUC},
			};
		}
		protected string kindName = string.Empty;
		public virtual bool CalcParam (IUnit unit = null, IFaction faction = null)
		{
			if (null == faction) {
				if (null != this.Faction)
					faction = Faction;
				else
					return false;
			}

			if (!faction.UserValues.ContainsKey (statusDicKey))
				faction.UserValues.Add (statusDicKey, new Dictionary<string,Dictionary<MMOKey,MMOStatus>> ());
			
			var sts = faction.UserValues [statusDicKey] as Dictionary<string,Dictionary<MMOKey,MMOStatus>>;
			if (null == sts) {
				sts = new Dictionary<string,Dictionary<MMOKey,MMOStatus>> ();
				faction.UserValues [statusDicKey] = sts;
			}
			if (!sts.ContainsKey (kindName)) {
				sts.Add (kindName, MMOStatusDic);
			}

			var status = sts [kindName] as Dictionary<MMOKey,MMOStatus>;

			int str = 0;
			if (status.ContainsKey (MMOKey.MMO_STR))
				str = (int)status [MMOKey.MMO_STR].Value;
			if (str > 0)
				faction.GetBulletParameter (Bullets [0]).Attack = (int)(a_atk_2 * str * str + a_atk_1 * str + a_atk_0);

			int vit = 0;
			if (status.ContainsKey (MMOKey.MMO_VIT))
				vit = (int)status [MMOKey.MMO_VIT].Value;
			if (vit > 0)
				HP = (int)(vit * a_hp_1 + a_hp_0);
			
			int agi = 0;
			if (status.ContainsKey (MMOKey.MMO_AGI))
				agi = (int)status [MMOKey.MMO_AGI].Value;
			if (agi > 0) {
				Speed = ((int)(agi * a_spd_1) / 10.0f + a_spd_0) * BasisSpeed;
				var aspd = ((int)(agi * a_aspd_1)) / 10.0f + a_aspd_0;
				faction.GetBulletParameter (Bullets [0]).AttackDelay = (int)(0.5f * Def.FPS / aspd);
				faction.GetBulletParameter (Bullets [0]).AttackRigor = (int)(0.5f * Def.FPS / aspd);
				faction.GetBulletParameter (Bullets [0]).AttackSpeed = (int)(1.0f * Def.FPS / aspd);
			}

			int inte = 0;
			if (status.ContainsKey (MMOKey.MMO_INT))
				inte = (int)status [MMOKey.MMO_INT].Value;
			if (inte > 0) {
				ViewRange = Math.Min ((int)(inte * a_view_1) + a_view_0, 16) * Def.MapTipLengthOnField;
				faction.GetBulletParameter (Bullets [0]).MaxRange = (int)Math.Min (inte * a_rng_1 + a_rng_0, ViewRange - 2) * Def.MapTipLengthOnField;
			}

			int luc = 0;
			if (status.ContainsKey (MMOKey.MMO_LUC))
				luc = (int)status [MMOKey.MMO_LUC].Value;
			if (luc > 0) {
				faction.GetBulletParameter (Bullets [0]).DamageBonus [(int)TargetObjectType.Hero] = luc * a_bns_1 + a_bns_0;
				ExpBonusRatio = luc * a_exp_1 + a_exp_0;
			}

			if (null != unit) {
				if (!unit.UserValues.ContainsKey (MMOKey.MMO_REST.ToString ()))
					unit.UserValues.Add (MMOKey.MMO_REST.ToString (), MMOStatusDic [MMOKey.MMO_REST].Value);
				else
					unit.UserValues [MMOKey.MMO_REST.ToString ()] = MMOStatusDic [MMOKey.MMO_REST].Value;
			
				if (!unit.UserValues.ContainsKey (MMOKey.MMO_VIT.ToString ()))
					unit.UserValues.Add (MMOKey.MMO_VIT.ToString (), MMOStatusDic [MMOKey.MMO_VIT].Value);
				else
					unit.UserValues [MMOKey.MMO_VIT.ToString ()] = MMOStatusDic [MMOKey.MMO_VIT].Value;
			
				if (!unit.UserValues.ContainsKey (MMOKey.MMO_STR.ToString ()))
					unit.UserValues.Add (MMOKey.MMO_STR.ToString (), MMOStatusDic [MMOKey.MMO_STR].Value);
				else
					unit.UserValues [MMOKey.MMO_STR.ToString ()] = MMOStatusDic [MMOKey.MMO_STR].Value;
			
				if (!unit.UserValues.ContainsKey (MMOKey.MMO_AGI.ToString ()))
					unit.UserValues.Add (MMOKey.MMO_AGI.ToString (), MMOStatusDic [MMOKey.MMO_AGI].Value);
				else
					unit.UserValues [MMOKey.MMO_AGI.ToString ()] = MMOStatusDic [MMOKey.MMO_AGI].Value;
			
				if (!unit.UserValues.ContainsKey (MMOKey.MMO_INT.ToString ()))
					unit.UserValues.Add (MMOKey.MMO_INT.ToString (), MMOStatusDic [MMOKey.MMO_INT].Value);
				else
					unit.UserValues [MMOKey.MMO_INT.ToString ()] = MMOStatusDic [MMOKey.MMO_INT].Value;
			
				if (!unit.UserValues.ContainsKey (MMOKey.MMO_LUC.ToString ()))
					unit.UserValues.Add (MMOKey.MMO_LUC.ToString (), MMOStatusDic [MMOKey.MMO_LUC].Value);
				else
					unit.UserValues [MMOKey.MMO_LUC.ToString ()] = MMOStatusDic [MMOKey.MMO_LUC].Value;

			}

			return true;
		}

		public override void OnLoad (IFaction faction)
		{
			if (!faction.UserValues.ContainsKey (statusDicKey))
				faction.UserValues.Add (statusDicKey, new Dictionary<string,Dictionary<MMOKey,MMOStatus>> ());

			var sts = faction.UserValues [statusDicKey] as Dictionary<string,Dictionary<MMOKey,MMOStatus>>;
			if (null == sts) {
				sts = new Dictionary<string,Dictionary<MMOKey,MMOStatus>>();
				faction.UserValues [statusDicKey] = sts;
			}
			if (!sts.ContainsKey (kindName)) {
				sts.Add (kindName, MMOStatusDic);
			}
			if (kindName != string.Empty) {
				var statusUpButtons = new []
			{
					new ButtonParameterHolder<IUnit> (new StatusUpButton (kindName, "STR", MMOKey.MMO_STR, ButtonPosition._3, ButtonPosition._0)),
					new ButtonParameterHolder<IUnit> (new StatusUpButton (kindName, "VIT", MMOKey.MMO_VIT, ButtonPosition._3, ButtonPosition._1)),
					new ButtonParameterHolder<IUnit> (new StatusUpButton (kindName, "AGI", MMOKey.MMO_AGI, ButtonPosition._3, ButtonPosition._2)),
					new ButtonParameterHolder<IUnit> (new StatusUpButton (kindName, "INT", MMOKey.MMO_INT, ButtonPosition._3, ButtonPosition._3)),
					new ButtonParameterHolder<IUnit> (new StatusUpButton (kindName, "LUC", MMOKey.MMO_LUC, ButtonPosition._3, ButtonPosition._4)),
				};
				#region Buttons
				ButtonParams = ButtonParams.Concat (statusUpButtons).ToArray ();
				#endregion
			}
			base.OnLoad (faction); 
		}
		public override void OnAppear (IUnit unit)
		{
			CalcParam(unit);
			Faction.ReloadParameters();
			base.OnAppear (unit);
		}
		public override void OnLvUp (IUnit unit)
		{
			var faction = unit.Faction;
			if (!faction.UserValues.ContainsKey (statusDicKey))
				faction.UserValues.Add (statusDicKey, new Dictionary<string,Dictionary<MMOKey,MMOStatus>> ());
			
			var sts = faction.UserValues [statusDicKey] as Dictionary<string,Dictionary<MMOKey,MMOStatus>>;
			if (null == sts) {
				sts = new Dictionary<string,Dictionary<MMOKey,MMOStatus>>();
				faction.UserValues [statusDicKey] = sts;
			}
			if (!sts.ContainsKey (kindName)) {
				sts.Add (kindName, MMOStatusDic);
			}

			while (unit.GetLevel() > MMOStatusDic[MMOKey.MMO_LEVEL].Value) {
				MMOStatusDic [MMOKey.MMO_LEVEL].Value++;
				MMOStatusDic [MMOKey.MMO_REST].Value += (int)(MMOStatusDic [MMOKey.MMO_LEVEL].Value * a_sp_1);
			}



			base.OnLvUp (unit);
			CalcParam (unit);

		}

		public class StatusUpButton : thrts.ButtonParameter<thrts.IUnit>
		{
			public StatusUpButton(string kindName,string buttonName,MMOKey statusKey,ButtonPosition row,ButtonPosition column,string iconPath = null)
			{
				Position = Tuple.Create( column, row );
				ButtonImagePath = "LotusCraft/Image/Button/Normal";
				ButtonName = buttonName+" +1";

				MouseOverTextFunc = faction =>
					{
					var unitParam = faction.GetUnitParameter(kindName) as UniqueBase;
					if(null == unitParam || !unitParam.MMOStatusDic.ContainsKey(statusKey) || !unitParam.MMOStatusDic.ContainsKey(MMOKey.MMO_REST))
						return new ColorTextLine[0];
					var st = unitParam.MMOStatusDic[statusKey];
					var rest = unitParam.MMOStatusDic[MMOKey.MMO_REST];
					return (
						new[]
						{
							new ColorTextLine(new ColorText(st.Name + "ステータスを1上昇させます")),
							(st.ReqStatusPoint > rest.Value? 
								 new ColorTextLine(new ColorText("必要ステータスポイント : "+st.ReqStatusPoint , new Color(1,0,0)))
								 :new ColorTextLine(new ColorText("必要ステータスポイント : "+st.ReqStatusPoint))),
							new ColorTextLine(new ColorText(st.Description)),
					}
					);
				};
				Kind = ButtonKind.Normal;
				CanExecute = (faction, _, holder) =>
				{
					var cantExecuteMessage = new List<ColorTextLine>();
					
					var unitParam = faction.GetUnitParameter(kindName) as UniqueBase;
					if(null != unitParam && unitParam.MMOStatusDic.ContainsKey(statusKey) && unitParam.MMOStatusDic.ContainsKey(MMOKey.MMO_REST))
					{
						var st = unitParam.MMOStatusDic[statusKey];
						var rest = unitParam.MMOStatusDic[MMOKey.MMO_REST];
						if(st.ReqStatusPoint > rest.Value)
						{
							cantExecuteMessage.Add(new ColorTextLine(new ColorText("ステータスポイントがたりません", new Color(1, 0, 0))));
						}
					}
					return new ExecutableInfo(!cantExecuteMessage.Any(), cantExecuteMessage);
				};

				NormalButtonEvent = (holder,_) => 
				{
					if(null == holder) return;
					var faction = holder.Parameter.Faction;
					var unitParam = faction.GetUnitParameter(kindName) as UniqueBase;
					if(null == unitParam || !unitParam.MMOStatusDic.ContainsKey(statusKey) || !unitParam.MMOStatusDic.ContainsKey(MMOKey.MMO_REST))
						return;

					var st = unitParam.MMOStatusDic[statusKey];
					var rest = unitParam.MMOStatusDic[MMOKey.MMO_REST];

					if(st.ReqStatusPoint <= rest.Value)
					{
						rest.Value-=st.ReqStatusPoint;
						st.Value ++;
						{
							unitParam.CalcParam(holder);
							faction.ReloadParameters();
						}
						
					}
				};
			}
		}

		public class MMOStatus
		{
			public string Name;
			public string Description;
			public int Value;
			public int ReqStatusPoint {
				get { return Value / 5 + 2; }
				set{}
			}

			public MMOStatus()
			{
				Name = string.Empty;
				Description = string.Empty;
				Value = 1;
			}
		}
		public class MMOStatusLevel:MMOStatus
		{
			public MMOStatusLevel()
			{
				Name = "LEVEL";
				Description = "現在レベルです";
			}
		}
		public class MMOStatusRest:MMOStatus
		{
			public MMOStatusRest()
			{
				Name = "StatusPoint";
				Description = "ステータスポイント : ステータス上昇に使用します";
				Value = default_sp;
			}
		}
		public class MMOStatusStr:MMOStatus
		{
			public MMOStatusStr()
			{
				Name = "STR";
				Description = "筋力 : 攻撃力に関係します";
			}
		}
		public class MMOStatusVit:MMOStatus
		{
			public MMOStatusVit()
			{
				Name = "VIT";
				Description = "体力 : HPや防御力に関係します";
			}
		}
		public class MMOStatusAgi:MMOStatus
		{
			public MMOStatusAgi()
			{
				Name = "AGI";
				Description = "敏捷性 : 移動速度や攻撃間隔に関係します";
			}
		}
		public class MMOStatusInt:MMOStatus
		{
			public MMOStatusInt()
			{
				Name = "INT";
				Description = "知性 : スペルの効果量や視界・射程に関係します";
			}
		}
		public class MMOStatusLuc:MMOStatus
		{
			public MMOStatusLuc()
			{
				Name = "LUC";
				Description = "幸運 : 取得経験値や対主ボーナスに関係します";
			}
		}
	}

}
