using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Black;
using LotusCraft.Building.Black;
using LotusCraft.Spell.Black;
using LotusCraft.Effect.Black;
//
using LotusCraft.Spell.Common;

namespace LotusCraft.Unit.Black
{
	public class Youmu : General.Special
	{
		public Youmu ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Black/Youmu";
			#endregion

			#region UnitParams
			Name = "魂魄 妖夢(式神)";
			HP = 280;
			Armor = 0;
			Radius = (float)Utls.UnitSize.Small;
			Speed = 1.15f * BasisSpeed;

			PopulationWeight = 2;
			StationWeight = 2;
			ButtonDescription = "近接ユニット　相手の防御力を無視する";

			//２体同時生産に変更
			//ConcurrentProductions = 2;

			ViewRange = 10*32;

			UnitType = new TargetObjectType[]{TargetObjectType.Water,};

			Costs = new [] {100,50,0,0};
			MakingTime = 27 * Def.FPS;

			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Black/Youmu");
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(new thrts.Unit.Button.BuildingButton()),
				new thrts.ButtonParameterHolder<thrts.IUnit>(new thrts.Unit.Button.AttackStateButton()),
				new thrts.ButtonParameterHolder<thrts.IUnit>(new thrts.Unit.Button.HoldPositionButton()),
				new thrts.ButtonParameterHolder<thrts.IUnit>(new thrts.Unit.Button.StationButton()),
			};
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(YoumuBullet).FullName };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new YoumuSkill (),
				new ShinsokuSkill(),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit> (SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new ButtonParameterHolder<IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
			};
#endregion
			
			base.OnLoad(faction);
		}
	}
}
namespace LotusCraft.Bullet.Black
{
	public class YoumuBullet : General.ShortRangeBullet
	{
		public YoumuBullet()
		{
			//Type = BulletType.LongRange;
			Type = BulletType.ShortRange;
			this.Attack = 20;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			Gravity = 0f;
			DamageBonus[(int)TargetObjectType.Clay] = 1.2f;
			//DamageBonus[(int)TargetObjectType.Structure] = 1.4f;
//			MaxRange = 1 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(1.0f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;

		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			//ランダム変数
			/*
			Random luck = new Random();
			int luckNumber = luck.Next(100);
			
			if(luckNumber < 10){
				bullet.Attack += (int)Math.Ceiling(bullet.Attack*0.5);
				var faction = bullet.Generator.Faction;
				LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
				faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitShortZangekiAttack).FullName, target.Pos);
			}
			else
				LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
			*/
			var faction = bullet.Generator.Faction;
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
			faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitShortZangekiAttack).FullName, target.Pos);
		}
	}
}
