﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Black;
using LotusCraft.Building.Black;

namespace LotusCraft.Unit.Black
{
	public class ZombieFairy : General.Water
	{
		public ZombieFairy ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Black/ZombieFairy";
			#endregion

			#region UnitParams
			Name = "ゾンビフェアリー";
			HP = 100;
			Armor = 0;
			Speed = 1.2f * BasisSpeed;
			UnitType = new TargetObjectType[]{TargetObjectType.Water,};

			ViewRange = 12 * Def.FPS;

			PopulationWeight = 0;

			Exp = 0;
			IsSummon = true;
			CanState = false;

			MakingTime = 20 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {45,0,0,0};

			SelectPriority += 5;

			Exp = 15;
			#endregion


			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Black/ZombieFairy");
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Bullet.Black.ZombieFairyBullet).FullName, };
			SelectBullet = (unit,target,distance)=>{return (target is IBuilding) ? -1 : 0;};
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			#region Buttons

			#endregion

			base.OnLoad (faction);
		}

		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUnitEffect).FullName, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}
}

namespace LotusCraft.Bullet.Black
{
	public class ZombieFairyBullet : General.LongRangeBullet
	{
		public ZombieFairyBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			DoesHitOnlyTarget = true;
			this.Attack = 10;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			MaxRange = 4 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(1.0f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			DamageBonus[(int)TargetObjectType.Structure] = 0.0f;
			
			OnHit = OnHitEffect;
			
			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullet";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.GunFire).FullName, bullet.Position);
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
		}
	}
}
