﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Blue;
using LotusCraft.Building.Blue;
using LotusCraft.Spell.Blue;
using LotusCraft.Effect.Blue;

//
using LotusCraft.Spell.Common;

namespace LotusCraft.Unit.Blue
{
	public class Sunny : General.Special
	{
		public Sunny ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Blue/Sunny";
			#endregion

			#region UnitParams
			Name = "サニーミルク(式神)";
			HP = 240;
			Armor = 0;
			Speed = 1.2f * BasisSpeed;

//			ViewRange = 6*32;
			ButtonDescription = "近接ユニット\nヒロイン以外の敵AIに自分と周囲の味方が気づかれない";
		   
			PopulationWeight = 2;
			StationWeight = 2;
			UnitType = new TargetObjectType[]{TargetObjectType.Water,};

			Costs = new [] {100,25,0,0};
			MakingTime = 21 * Def.FPS;

			RequireBuildings = new string[]{
				typeof(BigTree).FullName,
			};

			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Blue/Sunny");
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(new thrts.Unit.Button.BuildingButton()),
				new thrts.ButtonParameterHolder<thrts.IUnit>(new thrts.Unit.Button.AttackStateButton()),
				new thrts.ButtonParameterHolder<thrts.IUnit>(new thrts.Unit.Button.HoldPositionButton()),
				new thrts.ButtonParameterHolder<thrts.IUnit>(new thrts.Unit.Button.StationButton()),
			};
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(SunnyBullet).FullName };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new SunnySkill (),
				//
				new ShinsokuSkill(),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit> (SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				//
				new ButtonParameterHolder<IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
			};
#endregion
			
			base.OnLoad(faction);
		}
	}
}
namespace LotusCraft.Bullet.Blue
{
	public class SunnyBullet : General.ShortRangeBullet
	{
		public SunnyBullet()
		{
			Type = BulletType.LongRange;
			this.Attack = 30;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			Gravity = 0f;
//			MaxRange = 4 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(1.5f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			//DamageBonus[(int)TargetObjectType.Clay] = 1.5f;
			//DamageBonus[(int)TargetObjectType.Structure] = 2.0f;

			OnHit = OnHitEffect;

		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
		}
	}
}
