﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Blue;
using LotusCraft.Effect.Blue;
using LotusCraft.Building.Blue;
 
namespace LotusCraft.Unit.Blue.Unique
{
	public class Tenshi : General.Unique
	{
		public Tenshi ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Blue/Unique/Tenshi";
			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Tenshi";
			#endregion
			#region define_lv_param
			HPs[0] = 50 + 850/2 + 150;
			HPs[1] = 50 + HPs[0];
			HPs[2] = 50 + HPs[1];
			HPs[3] = 50 + HPs[2];
			HPs[4] = 50 + HPs[3];
			HPs[5] = 50 + HPs[4];
			HPs[6] = 50 + HPs[5];
			HPs[7] = 50 + HPs[6];
			HPs[8] = 50 + HPs[7];
			HPs[9] = 50 + HPs[8];
			
			Armors[0] = 3;
			Armors[1] = 3;
			Armors[2] = 4;
			Armors[3] = 4;
			Armors[4] = 5;
			Armors[5] = 5;
			Armors[6] = 6;
			Armors[7] = 6;
			Armors[8] = 7;
			Armors[9] = 7;

			ATKs [0] = 2 + 23;
			ATKs [1] = 2 + ATKs [0];
			ATKs [2] = 3 + ATKs [1];
			ATKs [3] = 3 + ATKs [2];
			ATKs [4] = 3 + ATKs [3];
			ATKs [5] = 3 + ATKs [4];
			ATKs [6] = 4 + ATKs [5];
			ATKs [7] = 4 + ATKs [6];
			ATKs [8] = 4 + ATKs [7];
			ATKs [9] = 4 + ATKs [8];

#endregion

			#region UnitParams
			Name = "比那名居 天子";
			HP = HPs[0];
			Speed = 1.0f * BasisSpeed;

#endregion
			MakingTime = 23*Def.FPS;
			#region Cutin
			this.SetCutinAnimation("LotusCraft/Image/Cutin/Tenshi");
			#endregion

			#region Animation
			this.SetBigSizeAnimation("LotusCraft/Image/Unit/Blue/Unique/tenshi");
#endregion
			
			#region BuildableObjcets
			//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
#endregion
			

			#region Bullets
			Bullets = new string[] { 
				typeof(TenshiBullet).FullName,
				typeof(JishinBullet).FullName,
			};
			#endregion
		}
		public override void OnLoad (thrts.IFaction faction)
		{
			
			#region Spell
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Blue.Chifu (),
				new LotusCraft.Spell.Blue.Kifu (),
				new LotusCraft.Spell.Blue.Jishin(),
				new LotusCraft.Spell.Blue.Hisouten(),
				new LotusCraft.Spell.SpellLevelUp("Blue"),
			};
#endregion
			
			#region AutoCasts
			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
				SpellParams[1].DefaultAutoCast,
				SpellParams[2].DefaultAutoCast,
				SpellParams[3].DefaultAutoCast,
				SpellParams[4].DefaultAutoCast,
				// 経験値取得用オートキャスト
				new LotusCraft.AutoCast.ExpFlagAutoCast<thrts.IUnit> (this.Name+"Exp"),
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit>(this.Name+"AutoHeal",0.06f),
			};
#endregion
			
			#region Buttons
			
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].DefaultSpellButton,SpellParams[2].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].DefaultSpellButton,SpellParams[3].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].DefaultSpellButton,SpellParams[4].SpellButtons),
				//				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].LevelUpSpellButton),
			};
#endregion
			
			base.OnLoad(faction);
			
		}
		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUniqueEffect).FullName, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
		public override void OnLvUp (thrts.IUnit unit)
		{
			base.OnLvUp(unit);
		}
	}
	
}

namespace LotusCraft.Bullet.Blue
{
	public class TenshiBullet : General.HeroBullet
	{
		public TenshiBullet()
		{
			Type = BulletType.ShortRange;
			SpaceType = BulletSpaceType.Earth;
			this.Attack = 0;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			DamageBonus[(int)TargetObjectType.Structure] = 1.5f;
			MaxRange = 1 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.5f * 30);
			AttackRigor = (int)(0.5f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;
			
		}
		static void OnHitEffect(IBullet bullet,ITargetObject target)
		{
			var faction = bullet.Generator.Faction;
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalYellow);
			faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitLongRangeAttack).FullName, target.Pos);
		}
	}
}

#endif