﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Common;
using LotusCraft.Effect.Common;
//2013 2.16追加
using LotusCraft.Ability;

namespace LotusCraft.Unit.Common
{
	public class Yuyuko : PatchouliMain
	{
		public Yuyuko ()
			:base()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Common/yuyuko";
//			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Yuyuko";
#endregion
			Name = "西行寺 幽々子 (式神)";
			ButtonDescription = "防衛ユニット\n長距離射程と対空能力を持つが移動ができない。\n研究所を建造するたびに最大生産数が1体増える。\n但し、同時に6体までしか存在できない。";
			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Common/Yuyuko");
#endregion
			#region Bullets
			Bullets = new string[] { 
				typeof(YuyukoBullet).FullName, 
			};
			#endregion
			
		}
	}
	public class Yukari : PatchouliMain
	{
		public Yukari ()
			:base()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Common/Yukari";
//			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Yukari";
#endregion
			Name = "八雲 紫 (式神)";
			ButtonDescription = "防衛ユニット\n長距離射程と対空能力を持つが移動ができない。\n研究所を建造するたびに最大生産数が1体増える。\n但し、同時に6体までしか存在できない。";
			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Common/Yukari");
#endregion
			Bullets = new string[] { 
				typeof(YukariBullet).FullName, 
			};
			
		}
	}
	public class Erin : PatchouliMain
	{
		public Erin ()
			:base()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Common/Erin";
//			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Erin";
			#endregion
			Name = "八意 永琳 (式神)";
			ButtonDescription = "防衛ユニット\n長距離射程と対空能力を持つが移動ができない。\n研究所を建造するたびに最大生産数が1体増える。\n但し、同時に6体までしか存在できない。";
			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Common/Erin");
			#endregion
			#region Bullets
			Bullets = new string[] { 
				typeof(ErinBullet).FullName, 
			};
			#endregion

		}
	}

	public class Patchouli : PatchouliMain
	{
		public Patchouli ()
			:base()
		{
			MaximumExists = 1;
		}
	}
	
	public class PatchouliMain : General.Special
	{
		int duration = 30*Def.FPS;
		public PatchouliMain ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Common/Patchouli";
//			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Patch";
			#endregion

			#region UnitParams
			Name = "パチュリー・ノーレッジ(式神)";
			HP = 450;
			Armor = 2;

			Speed = 0.0f * BasisSpeed;
			ButtonDescription = "防衛ユニット\n長距離射程と対空能力を持つが移動ができない。\n研究所を建造するたびに最大生産数が1体増える。\n但し、同時に6体までしか存在できない。";

			//UnitType = new TargetObjectType[]{TargetObjectType.None};
			UnitType = new TargetObjectType[]{TargetObjectType.Clay,};
			IsDefence = true;
			//2013 2.16追加
			//IsSummon = true;
			
			ViewRange = 10 * Def.MapTipLengthOnField;
			MakingTime = 36 * Def.FPS;
			PopulationWeight = 1;
			MaximumExists = 1;
			CanState = false;

			Costs = new int[4];
			Costs[0] = 125;
			Costs[1] = 25;
			Costs[2] = 0;
			Costs[3] = 0;
			//MoveType |= UnitMoveType.Air;

			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Common/Patchouli");
			#endregion

			#region AutoCasts
//			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
//			{
//				// 自動回復用オートキャスト +1% HP/sec
//				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit> (this.Name + "AutoHeal"),
//			};
			#endregion

			#region Bullets
			Bullets = new string[] { 
				typeof(PatchouliBullet).FullName, 
			};
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Common.DefenceSkill (),
				new LotusCraft.Spell.Common.ArmbreakSkill (),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
				SpellParams[1].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
			};
			#endregion

			base.OnLoad(faction);
		}

	}
}

namespace LotusCraft.Bullet.Common
{
	public class YuyukoBullet : Black.YuyukoBullet
	{
		public YuyukoBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			this.Attack = 26;
			DamageBonus[(int)TargetObjectType.Hero] =  1.2f;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			Gravity = 0.5f;
			MaxRange = 10 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * Def.FPS);
			AttackRigor = (int)(0.0f * Def.FPS);
			AttackSpeed =  (int)(1.0f * Def.FPS);
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.taihou).FullName, bullet.Position);
		}
	}
	public class YukariBullet : Blue.YukariBullet
	{
		public YukariBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			this.Attack = 26;
			DamageBonus[(int)TargetObjectType.Hero] =  1.2f;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			Gravity = 0.5f;
			MaxRange = 10 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * Def.FPS);
			AttackRigor = (int)(0.0f * Def.FPS);
			AttackSpeed =  (int)(1.0f * Def.FPS);
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.taihou).FullName, bullet.Position);
		}
	}
	public class ErinBullet : White.EirinBullet
	{
		public ErinBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			this.Attack = 26;
			DamageBonus[(int)TargetObjectType.Hero] =  1.2f;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			Gravity = 0.5f;
			MaxRange = 10 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * Def.FPS);
			AttackRigor = (int)(0.0f * Def.FPS);
			AttackSpeed =  (int)(1.0f * Def.FPS);
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.taihou).FullName, bullet.Position);
		}
	}
	public class PatchouliBullet : Red.PatchouliBullet
	{
		public PatchouliBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			this.Attack = 26;
			DamageBonus[(int)TargetObjectType.Hero] =  1.2f;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			Gravity = 0.5f;
			MaxRange = 10 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * Def.FPS);
			AttackRigor = (int)(0.0f * Def.FPS);
			AttackSpeed =  (int)(1.0f * Def.FPS);
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.taihou).FullName, bullet.Position);
		}
	}
}
#endif