﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Unit.General
{
	public class Water : thrts.UnitParameter
	{
		public Water()
		{
			#region Icon
 //		   IconPath = "LotusCraft/Image/Button/chen";
			#endregion

			#region UnitParams
			Name = "(水)";
			HP = 300;
			Radius = (float)Utls.UnitSize.Small;
			Speed = 1.0f * BasisSpeed;

			ViewRange = 12 * 32;

			MakingTime = 25 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {125,0,0,0};
			SelectPriority = 45;
			UnitType = new TargetObjectType[]{TargetObjectType.Water,};
			#endregion

			#region Description
			ButtonDescription += "水属性を持つユニットです。";

			#endregion
			/*
			#region Animation
			Animation = new TextureAnimation();
			Animation.Path = "LotusCraft/Image/Unit/unit";
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.Center.X = 0;
			Animation.Center.Y = 10;
			Animation.CenterPosition = CenterPosition.MiddleMiddle;
			Animation.FrameCount = 4;
			Animation.FrameTime = 4;
			Animation.HasDirection = true;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 4;
			Animation.Count.Y = 8;
			#endregion

			#region BuildableObjcets
			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion
*/
			#region Bullets
//			Bullets = new string[] { "LotusCraft.Bullet.Gun" };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			if(ConcurrentProductions > 1)
				Exp = Costs.Sum()/(4*ConcurrentProductions);
			else
				Exp = Costs.Sum()/4;

			if(StationWeight < 2)
				StationWeight = PopulationWeight;
			#region Buttons
			ButtonParams = ButtonParams.Concat(faction.Parameter.CommonUnitButton).ToArray();
			#endregion

		}
		public override void OnAppear (IUnit unit)
		{
			if (unit.Faction.World.CurrentTime > 10)
			{
				unit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.CreatedUnit).FullName, unit.Pos);

				// 生成エフェクト
				var effect = unit.Faction.World.EffectManager.CreateEffect(typeof(Effect.Common.CreateUnitEffect).FullName, unit.Pos);
				effect.SetScale(new Vector3D(3, 3, 3));
			}

			base.OnAppear (unit);
		}
		public override void OnVanish (IUnit unit)
		{
			unit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.PCH).FullName, unit.Pos);
			base.OnVanish (unit);
		}
	}
}
namespace LotusCraft.Bullet.General
{
	public class LongRangeBullet : thrts.BulletParameter
	{
		public LongRangeBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			this.Attack = 18;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			Gravity = 0f;
			Radius =  20.0f;
			MaxRange = 6 * Def.MapTipLengthOnField;
			DamageBonus = new float[AttackBonusSet.None.Length];
			for(int i=0;i<this.DamageBonus.Length;++i)
				DamageBonus[i] = AttackBonusSet.None[i];

			AttackDelay = (int)(0.2f * 30);
			AttackRigor = (int)(0.4f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
		}
	}
}
