﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Green;
using LotusCraft.Building.Green;
using LotusCraft.Effect.Green;

namespace LotusCraft.Unit.Green
{
	public class Low03 : General.Water
	{
		public Low03 ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Green/Low03";
			#endregion

			#region UnitParams
			Name = "妖精(水)";
			HP = 120;
			Armor = 0;
			Speed = 1.0f * BasisSpeed;
			ButtonDescription = "射撃ユニット\n高い攻撃力を持ち対空攻撃が可能";

			PopulationWeight = 2;

			ViewRange = 12*Def.MapTipLengthOnField;

			MakingTime = 38 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {110, 65, 0, 0};

			RequireBuildings = new string[]{
				typeof(Muenzuka).FullName,
			};

#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Green/Low03");
			Animation.FrameCount = 3;
			AnimationWalk.FrameCount = 3; 
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Low03Bullet).FullName };
			#endregion
			
		}
		public override void OnLoad (IFaction faction)
		{
			base.OnLoad (faction);
		}
		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUnitEffect).FullName, unit.Pos + offset, faction);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
		public override void OnAppear (IUnit unit)
		{
			unit.AbilityManager.AppendAbility(new Ability.Green.OnGardenEffectAbility());
			base.OnAppear (unit);
		}
	}
}

namespace LotusCraft.Bullet.Green
{
	public class Low03Bullet : General.LongRangeBullet
	{
		public Low03Bullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			DoesHitOnlyTarget = true;
			this.Attack = 24 ;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			
			MaxRange = 5*Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(0.8f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
			TextureAnimation.Offset.X = 128 * 3 + 16 * 3;
			TextureAnimation.Offset.Y = 128 * 0 + 16 * 0;
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.GunFire).FullName, bullet.Position);
		}
		static void OnHitEffect(IBullet bullet,ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalBlue);
		}
	}
}