﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


using thrts;
using LotusCraft.Effect.Green;
using LotusCraft.Bullet.Green;
using LotusCraft.Spell.Green;

namespace LotusCraft.Unit.Green.Unique
{
	public class Yuka : General.Unique
	{
		public Yuka ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Green/Unique/Yuka";
			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Yuka";
			#endregion

			#region define_lv_param
			HPs[0] = 50 + 800/2 + 150;
			HPs[1] = 50 + HPs[0];
			HPs[2] = 50 + HPs[1];
			HPs[3] = 50 + HPs[2];
			HPs[4] = 50 + HPs[3];
			HPs[5] = 50 + HPs[4];
			HPs[6] = 50 + HPs[5];
			HPs[7] = 50 + HPs[6];
			HPs[8] = 50 + HPs[7];
			HPs[9] = 50 + HPs[8];
			
			Armors[0] = 3;
			Armors[1] = 3;
			Armors[2] = 4;
			Armors[3] = 4;
			Armors[4] = 5;
			Armors[5] = 5;
			Armors[6] = 6;
			Armors[7] = 6;
			Armors[8] = 7;
			Armors[9] = 7;
			
			ATKs [0] = 2 + 26 +2 ;
			ATKs [1] = 2 + ATKs [0];
			ATKs [2] = 3 + ATKs [1];
			ATKs [3] = 3 + ATKs [2];
			ATKs [4] = 3 + ATKs [3];
			ATKs [5] = 4 + ATKs [4];
			ATKs [6] = 4 + ATKs [5];
			ATKs [7] = 4 + ATKs [6];
			ATKs [8] = 4 + ATKs [7];
			ATKs [9] = 5 + ATKs [8];
			
			#endregion

			#region UnitParams
			Name = "風見 幽香";
			HP = HPs[0];
			Speed = 0.6f*BasisSpeed;

			#endregion

			#region Animation
			this.SetBigSizeAnimation("LotusCraft/Image/Unit/Green/Unique/Yuka");
			#endregion

			#region Cutin
			this.SetCutinAnimation("LotusCraft/Image/Cutin/Yuuka");
			Cutin.Type = CutinType.FadeIn;
			#endregion


			#region Spell
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Green.FlowerMaster (),
				new LotusCraft.Spell.Green.Syunka (),
				new LotusCraft.Spell.Green.Kaika (),
				new LotusCraft.Spell.Green.Genso (),
				new LotusCraft.Spell.SpellLevelUp("Green"),
			};
			#endregion

			#region AutoCasts
			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
				SpellParams[1].DefaultAutoCast,
				SpellParams[2].DefaultAutoCast,
				SpellParams[3].DefaultAutoCast,
				SpellParams[4].DefaultAutoCast,
				// 経験値取得用オートキャスト
				new LotusCraft.AutoCast.ExpFlagAutoCast<thrts.IUnit> (this.Name + "Exp"),
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit> (this.Name + "AutoHeal"),
			};
			#endregion


			#region Bullets
			Bullets = new string[] { typeof(LotusCraft.Bullet.Green.YukaBullet).FullName };
			#endregion
		}
		public override void OnLoad (thrts.IFaction faction)
		{

			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].DefaultSpellButton,SpellParams[2].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].DefaultSpellButton,SpellParams[3].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].DefaultSpellButton,SpellParams[4].SpellButtons),
				//				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].LevelUpSpellButton),
			};
#endregion

			
			base.OnLoad (faction);
		}

		public override void OnLvUp(thrts.IUnit unit)
		{
			base.OnLvUp(unit);
		}

		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUniqueEffect).FullName, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
		public override void OnAppear (IUnit unit)
		{
			unit.AbilityManager.AppendAbility(new Ability.Green.OnGardenEffectAbility(1.0f));
//			unit.AbilityManager.AppendAbility(new Ability.Green.PropagateGardenAbility(10,1,4*Def.FPS,1));
			base.OnAppear (unit);
		}
	}

}

namespace LotusCraft.Bullet.Green
{
	public class YukaBullet : General.HeroBullet
	{
		public YukaBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;

			this.Attack = 50;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			Gravity = 0.0f;

			MaxRange = 6 * Def.MapTipLengthOnField;

			AttackDelay = Def.FPS/2;
			AttackRigor = 0;
			AttackSpeed = Def.FPS;

			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 0;
			TextureAnimation.Center.Y = 0;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
			TextureAnimation.Offset.X = 128 * 0 + 16 * 1;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 0;
		}

		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
		}
	}
}

namespace LotusCraft.Ability.Green
{
	class OnGardenEffectAbility : thrts.AbilityTemplate
	{
		public float SpeedRatio = 1.2f;
		public const string AbilityName = "花畑効果(移動速度上昇)";
		public OnGardenEffectAbility(float incSpeedRatio = 0.2f)
		{
			this.Name = AbilityName;
			this.DurationTime = Def.FPS;
			SpeedRatio = 1+incSpeedRatio;
		}
		public override bool ExecUnitAbility (thrts.IUnit unit, thrts.AbilityOrder order)
		{
			var tip = unit.Faction.World.Map.GetMapTipIndex(unit.Pos.X,unit.Pos.Y);
			if (unit.Faction.World.Map.IsSpecialArea (tip.X,tip.Y)) {
				switch (order) {
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					break;
				case thrts.AbilityOrder.ConstIncParam:
					break;
				case thrts.AbilityOrder.RateIncParam:
					unit.Speed = unit.Speed * SpeedRatio;
					break;
				case AbilityOrder.OtherExecs:
					break;
				default:
					break;
				}
			}
			return base.ExecUnitAbility(unit,order);
		}
		// 常設アビリティのため減少無し
		public override void DecDurationTime ()
		{
			return;
		}
	}

	class PropagateGardenAbility : thrts.AbilityTemplate
	{
		public const string AbilityName = "花畑繁殖効果(ユニット・建物共用)";
		int propCounter = 0;
		public int PropagationInterval = Def.FPS;
		int updateCounter = 0;
		int radius = 0;
		int initRadius = 0;
		public int PropagateTip = 1;
		public int MaxRadius = 10;
		Vector3D lastPos;
		public PropagateGardenAbility(int max,int propagates,int interval=Def.FPS,int initRadius = 3)
		{
			this.Name = AbilityName;
			this.DurationTime = Def.FPS;
			propCounter = interval;
			updateCounter = interval;
			PropagationInterval = interval;
			PropagateTip = propagates;
			MaxRadius = max;
			this.initRadius = initRadius;
			radius = initRadius;
			lastPos = new Vector3D();
		}
		public override bool ExecUnitAbility (thrts.IUnit unit, thrts.AbilityOrder order)
		{

			switch (order) {
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					break;
				case thrts.AbilityOrder.ConstIncParam:
					break;
				case thrts.AbilityOrder.RateIncParam:
					break;
				case AbilityOrder.OtherExecs:

				if(++updateCounter >= Def.FPS)
				{
					updateCounter = 0;

					if(lastPos.X != unit.Pos.X || lastPos.Y != unit.Pos.Y || lastPos.Z != unit.Pos.Z)
					{
						radius = -1;
					}
					else
					{
						var tipPos = unit.Faction.World.Map.GetMapTipIndex(unit.Pos.X,unit.Pos.Y);
						for(int x = - MaxRadius;x <= +MaxRadius;++x)
						{
							for(int y = - MaxRadius;y <= +MaxRadius;++y)
							{

								if(x*x + y*y <= (radius+0.5f)*(radius+0.5f))
								{
									int lifeTime = PropagationInterval + (int)(radius - Math.Sqrt(x*x + y*y)) * Def.FPS * 2;
									unit.Faction.World.Map.AddSpecialArea(tipPos.X+x,tipPos.Y+y,lifeTime);
								}
								else if(x*x + y*y <= (MaxRadius+0.5f)*(MaxRadius+0.5f))
								{
									if(unit.Faction.World.Map.IsSpecialArea(tipPos.X+x,tipPos.Y+y))
									{
										int lifeTime = PropagationInterval;
										unit.Faction.World.Map.AddSpecialArea(tipPos.X+x,tipPos.Y+y,lifeTime);
									}
								}
							}
								
						}
					}

				}
				int interval=PropagationInterval;
				object tmp = null;
				if(unit.Faction.UserValues.TryGetValue(Spell.Green.FlowerMaster.DecPropagateGardenIntervalKey,out tmp))
				{
					interval -= (int)tmp;
				}
				
				if(++propCounter >= interval)
				{
					propCounter = 0;
					if(radius<initRadius)
						radius = initRadius;
					
					if(radius < MaxRadius)
						radius += PropagateTip;
					
					lastPos.X = unit.Pos.X;
					lastPos.Y = unit.Pos.Y;
					lastPos.Z = unit.Pos.Z;
				}
				break;
				default:
					break;
			}
			return base.ExecUnitAbility(unit,order);
		}
		public override bool ExecBuildingAbility (IBuilding building, AbilityOrder order)
		{
			switch (order) {
			case thrts.AbilityOrder.ConstDecParam:
				break;
			case thrts.AbilityOrder.RateDecParam:
				break;
			case thrts.AbilityOrder.ConstIncParam:
				break;
			case thrts.AbilityOrder.RateIncParam:
				break;
			case AbilityOrder.OtherExecs:
				int interval=PropagationInterval;
				object tmp = null;
				if(building.Faction.UserValues.TryGetValue(Spell.Green.FlowerMaster.DecPropagateGardenIntervalKey,out tmp))
				{
					interval -= (int)tmp;
				}

				if(++propCounter >= interval)
				{
					propCounter = 0;
					int propMax = MaxRadius;
					if(building.Faction.UserValues.TryGetValue(Spell.Green.FlowerMaster.IncMaxPropagateGardenKey,out tmp))
					{
						propMax += (int)tmp;
					}

					if(radius < propMax)
						radius += PropagateTip;
					
					var tipPos = building.Faction.World.Map.GetMapTipIndex(building.Pos.X,building.Pos.Y);
					for(int x = - MaxRadius;x <= +MaxRadius;++x)
					{
						for(int y = - MaxRadius;y <= MaxRadius;++y)
						{
							if(x*x + y*y <= (radius+0.5f)*(radius+0.5f))
							{
								int lifeTime = PropagationInterval + (int)(radius - Math.Sqrt(x*x + y*y)) * Def.FPS * 2;
								building.Faction.World.Map.AddSpecialArea(tipPos.X+x,tipPos.Y+y,lifeTime);
							}
							else if(x*x + y*y <= (MaxRadius+0.5f)*(MaxRadius+0.5f) && building.Faction.World.Map.IsSpecialArea(tipPos.X+x,tipPos.Y+y))
							{
								int lifeTime = PropagationInterval;
								building.Faction.World.Map.AddSpecialArea(tipPos.X+x,tipPos.Y+y,lifeTime);
							}
						}
						
					}
				}
				break;
			default:
				break;
			}
			return base.ExecBuildingAbility (building, order);
		}
		// 常設アビリティのため減少無し
		public override void DecDurationTime ()
		{
			return;
		}
	}
}