﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Neutral;
using LotusCraft.Effect.Neutral;
using LotusCraft.Ability.Neutral;

namespace LotusCraft.Unit.Neutral
{
	public class High01 : NeutralBase
	{
		public High01()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Neutral/kfairy03_n";
			#endregion

			#region UnitParams
			Name = "中立・妖精(強)";
			HP = 625;
			Armor = 4;
			Radius = (float)Utls.UnitSize.Medium;
			Speed = 1.2f * BasisSpeed;

			ViewRange = 7 * 32;

			MakingTime = 25 * 30;
			Exp = 70;
			/// mine,gas,sup,?
			Costs = new [] {150,0,0,0};
			#endregion

			#region Description
			ButtonDescription += "中立の妖精。強めで、近くの敵を攻撃することができる。\n周囲の中立ユニットを強化 する能力を持つ。";

			#endregion

			#region Animation
//			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Neutral/fluff01");
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Neutral/kfairy03_n");
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] {};
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(High01Bullet).FullName };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{

			this.AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				new AutoCast.AutoCast<IUnit>(this.Name,Def.FPS,skillAutocast,true),
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.MoveButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StopButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.HoldPositionButton ()),
//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.PatrolButton ()),
//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.AttackButton ()),
//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StationButton ()),
			};
			#endregion

		}

		public bool skillAutocast(IUnit selfUnit)
		{
			var selfFaction = selfUnit.Faction;
			var affectRadius = 4;
			var autocastInterval = Def.FPS/2;
			/// add ability
			var targets = selfFaction.World.GetObjectFromCircle (new Circle2D (affectRadius * 32, new Vector2D (selfUnit.Pos.X, selfUnit.Pos.Y))).Where (_ => _ != null);
			foreach (IUnit u in targets.OfType<IUnit>().Where(_=>selfFaction.World.IsSameTeam(selfFaction,_.Faction))) {
				if (u.AbilityManager.ContainsAbility (this.Name)) {
					/// 既に掛かっていたら時間を延長
					u.AbilityManager.ExtendLifetimeWithName (autocastInterval, this.Name,autocastInterval*2);
				} else {
					IEffect effect = null;
					if (u != selfUnit) {
						/// エフェクトを描画
						var faction = u.Faction;
						Vector3D offset = new Vector3D (2.0f, 2.0f, 1.0f);
//						effect = world.EffectManager.CreateEffect (typeof(Effect).FullName, selfFaction, u.Pos + offset);
//						effect.SetScale (new Vector3D (12, 12, 12));
					}
					if (!u.AbilityManager.AppendAbility (new High01Ability (1, effect))) {
						effect.Stop ();
					}
				}
			}
			return true;
		}
	}
}


namespace LotusCraft.Bullet.Neutral
{
	public class High01Bullet : General.ShortRangeBullet
	{
		public High01Bullet()
		{
			Type = BulletType.ShortRange;
			this.Attack = 36;
			Speed = 0.0f;
//			MaxRange = 0.1f * 32;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(1.2f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;
			
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
		}
	}
}
