﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Red;
using LotusCraft.Effect.Red;

namespace LotusCraft.Unit.Red
{
	public class Low01 : General.Clay
	{
		public Low01 ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Red/Low01";
			#endregion

			#region UnitParams
			Name = "メイド"+Name;
			HP = 400;
			Armor = 2;
			Speed = 1.0f * BasisSpeed;

			PopulationWeight = 2;
			//Exp = 40;
			MakingTime = 34 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {125,50,0,0};

			ButtonDescription = "近接ユニット\n水属性と鋼属性にボーナスを持つ";
			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Red/Low01");
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Low01Bullet).FullName };
			#endregion
			
		}
		public override void OnLoad (IFaction faction)
		{
			#region Buttons
			#endregion
			base.OnLoad (faction);
		}
		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUnitEffect).FullName, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}
}

namespace LotusCraft.Bullet.Red
{
	public class Low01Bullet : General.ShortRangeBullet
	{
		public Low01Bullet()
		{
			Type = BulletType.ShortRange;
			this.Attack = 18;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			Gravity = 0f;
//			MaxRange = 0.5f * Def.MapTipLengthOnField;

			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(0.0f * 30);
			AttackSpeed = (int)(1.5f * 30);

			DamageBonus[(int)TargetObjectType.Structure] = 2.0f;
			DamageBonus[(int)TargetObjectType.Water] = 2.0f;

			OnHit = OnHitEffect;
			
		}

		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
		}
	}
}
