﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Red;
using LotusCraft.Bullet.Red;

namespace LotusCraft.Unit.Red
{
	public class Low02 : General.Water
	{
		public Low02 ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Red/Low02";
			#endregion

			#region UnitParams
			Name = "メイド"+Name;
			HP = 260;
			Armor = 1;
			Speed = 1.0f * BasisSpeed;

			ViewRange = 12*Def.MapTipLengthOnField;

			PopulationWeight = 1;
			StationWeight = 2;

			MakingTime = 35  * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {150,0,0,0};
			ButtonDescription = "射撃ユニット\n岩属性にボーナスを持つ";
			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Red/Low02");
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Low02Bullet).FullName, };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			#region Buttons
			#endregion

			base.OnLoad (faction);
		}

		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUnitEffect).FullName, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}
}

namespace LotusCraft.Bullet.Red
{
	public class Low02Bullet : General.MiddleRangeBullet
	{
		public Low02Bullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			DoesHitOnlyTarget = true;

			this.Attack = 15;
			DamageBonus[(int)TargetObjectType.Clay] = 1.2f;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			MaxRange = 4 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0*Def.FPS);
			AttackRigor = (int)(0.0  *Def.FPS);
			AttackSpeed = (int)(0.9 *Def.FPS);
			
			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
			TextureAnimation.Offset.X = 128 * 1 + 16 * 3;
			TextureAnimation.Offset.Y = 128 * 0 + 16 * 0;
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.GunFire).FullName, bullet.Position);
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalBlue);
		}
	}
}
