﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using LotusCraft.Bullet.Red;
using LotusCraft.Effect.Red;
using thrts;

namespace LotusCraft.Unit.Red.Unique
{
	public class Aya: General.Unique
	{
		public Aya()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Red/Unique/Aya";
			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Aya";
			#endregion

			#region define_lv_param
			// range <= 5
			HPs[0] = 40 + 800/2 + 150 - 50;
			HPs[1] = 40 + HPs[0];
			HPs[2] = 40 + HPs[1];
			HPs[3] = 40 + HPs[2];
			HPs[4] = 40 + HPs[3];
			HPs[5] = 40 + HPs[4];
			HPs[6] = 40 + HPs[5];
			HPs[7] = 40 + HPs[6];
			HPs[8] = 40 + HPs[7];
			HPs[9] = 40 + HPs[8];
			
			Armors[0] = 0;
			Armors[1] = 0;
			Armors[2] = 1;
			Armors[3] = 1;
			Armors[4] = 2;
			Armors[5] = 2;
			Armors[6] = 3;
			Armors[7] = 3;
			Armors[8] = 4;
			Armors[9] = 4;

			// 対空のみなので、とりあず毛玉を一回で殺せる数値に設定。強すぎたら後で直す。
			ATKs [0] = 2 + 23 + 15;//2 + 23 - 2;
			ATKs [1] = 2 + ATKs [0];
			ATKs [2] = 3 + ATKs [1];
			ATKs [3] = 3 + ATKs [2];
			ATKs [4] = 3 + ATKs [3];
			ATKs [5] = 3 + ATKs [4];
			ATKs [6] = 4 + ATKs [5];
			ATKs [7] = 4 + ATKs [6];
			ATKs [8] = 4 + ATKs [7];
			ATKs [9] = 4 + ATKs [8];
			
			#endregion

			#region UnitParams
			Name = "射命丸文";
			HP = HPs[0];
			Speed = 1.1f * BasisSpeed;

			MoveType |= UnitMoveType.Air;

			#endregion

			#region Animation
			this.SetBigSizeAnimation("LotusCraft/Image/Unit/Red/Unique/aya");
			#endregion

			#region Cunin
			this.SetCutinAnimation("LotusCraft/Image/Cutin/Aya");
			#endregion

			#region Spell
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Red.Sarutahiko(),
				new LotusCraft.Spell.Red.KouyouSenpu(),
				new LotusCraft.Spell.Red.Hujin(),
				new LotusCraft.Spell.Red.Gyakuhu(),
				new LotusCraft.Spell.SpellLevelUp("Red"),
			};
			#endregion

			#region AutoCasts
			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				SpellParams [0].DefaultAutoCast,
				SpellParams [1].DefaultAutoCast,
				SpellParams [2].DefaultAutoCast,
				SpellParams [3].DefaultAutoCast,
				SpellParams [4].DefaultAutoCast,
				// 経験値取得用オートキャスト
				new LotusCraft.AutoCast.ExpFlagAutoCast<thrts.IUnit> (this.Name+"Exp"),
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit>(this.Name+"AutoHeal"),
			};
			#endregion

			#region Bullets
			Bullets = new string[] { 
				typeof(AyaBullet).FullName  
			};
			#endregion
		}
		public override void OnLoad(IFaction faction)
		{
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].DefaultSpellButton,SpellParams[2].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].DefaultSpellButton,SpellParams[3].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].DefaultSpellButton,SpellParams[4].SpellButtons),
//				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].LevelUpSpellButton),
			};
			#endregion

			base.OnLoad(faction);
		}
		public override void OnLvUp(thrts.IUnit unit)
		{
			base.OnLvUp(unit);
		}

		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUniqueEffect).FullName, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}

}

namespace LotusCraft.Bullet.Red
{
	public class AyaBullet : General.HeroBullet
	{
		public AyaBullet()
		{
			Type = BulletType.ShortRange;
			SpaceType = BulletSpaceType.Sky;
			this.Attack = 0;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			Gravity = 0f;
			MaxRange = 5f * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.5f * 30);
			AttackRigor = (int)(0.5f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;
			
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.GunLong).FullName, bullet.Position);
		}
		static void OnHitEffect(IBullet bullet,ITargetObject target)
		{
			var faction = bullet.Generator.Faction;
			var offset = new Vector3D(-2,-2,8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(Effect.Common.HitCloseRedEffect).FullName, target.Pos + offset);
			var scale = new Vector3D(8,8,8);
			effect.SetScale(scale);
			faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitShortRangeAttack).FullName, target.Pos);
		}
	}
}

#endif
