﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Red;
using LotusCraft.Effect.Red;

namespace LotusCraft.Unit.Red.Unique
{
	public class Patchouli : General.Unique
	{
		public Patchouli ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Red/Unique/Patchouli";
			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Patch";
			#endregion

			#region define_lv_param
			HPs[0] = 20 + 530;
			HPs[1] = 20 + HPs[0];
			HPs[2] = 20 + HPs[1];
			HPs[3] = 20 + HPs[2];
			HPs[4] = 20 + HPs[3];
			HPs[5] = 20 + HPs[4];
			HPs[6] = 20 + HPs[5];
			HPs[7] = 20 + HPs[6];
			HPs[8] = 20 + HPs[7];
			HPs[9] = 20 + HPs[8];
			
			Armors[0] = 0;
			Armors[1] = 0;
			Armors[2] = 0;
			Armors[3] = 0;
			Armors[4] = 1;
			Armors[5] = 1;
			Armors[6] = 2;
			Armors[7] = 2;
			Armors[8] = 3;
			Armors[9] = 3;

			ATKs [0] = 2 + 26;
			ATKs [1] = 2 + ATKs [0];
			ATKs [2] = 3 + ATKs [1];
			ATKs [3] = 3 + ATKs [2];
			ATKs [4] = 3 + ATKs [3];
			ATKs [5] = 4 + ATKs [4];
			ATKs [6] = 4 + ATKs [5];
			ATKs [7] = 4 + ATKs [6];
			ATKs [8] = 4 + ATKs [7];
			ATKs [9] = 5 + ATKs [8];

			for(int i=0;i<ATKs.Length;++i)
				ATKs[i] *= 4;
			
			#endregion

			#region UnitParams
			Name = "パチュリー・ノーレッジ";
			HP = HPs[0];
			Armor = Armors[0];

			Speed = 0.6f*BasisSpeed;
			
			ViewRange = 14 * Def.MapTipLengthOnField;
			
			#endregion

			#region Animation
			this.SetBigSizeAnimation("LotusCraft/Image/Unit/Red/Unique/Patchouli");
			#endregion

			#region Cutin
			this.SetCutinAnimation("LotusCraft/Image/Cutin/Patch");
			//Cutin.Type = CutinType.SlidinFromRight;
			#endregion


			#region Spell
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Red.Agni(),
				new LotusCraft.Spell.Red.Pillar(),
				new LotusCraft.Spell.Red.Kenja(),
				new LotusCraft.Spell.Red.RoyalFlare(),
				new LotusCraft.Spell.SpellLevelUp("Red"),
			};
			#endregion

			#region AutoCasts
			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
				SpellParams[1].DefaultAutoCast,
				SpellParams[2].DefaultAutoCast,
				SpellParams[3].DefaultAutoCast,
				SpellParams[4].DefaultAutoCast,
				// 経験値取得用オートキャスト
				new LotusCraft.AutoCast.ExpFlagAutoCast<thrts.IUnit> (this.Name + "Exp"),
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit> (this.Name + "AutoHeal"),
			};
			#endregion

			#region Bullets
			Bullets = new string[] { 
				typeof(PatchouliBullet).FullName, 
				typeof(PillarBullet).FullName, 
				typeof(PillarLv1Bullet).FullName, 
				typeof(PillarLv2Bullet).FullName, 
				typeof(PillarLv3Bullet).FullName, 
			};
			#endregion
		}
		public override void OnLoad (thrts.IFaction faction)
		{
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].DefaultSpellButton,SpellParams[2].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].DefaultSpellButton,SpellParams[3].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].DefaultSpellButton,SpellParams[4].SpellButtons),
				//				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].LevelUpSpellButton),
			};
#endregion
			
			base.OnLoad (faction);
		}
		public override void OnLvUp (thrts.IUnit unit)
		{
			base.OnLvUp(unit);
		}
		
		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUniqueEffect).FullName, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}
}

namespace LotusCraft.Bullet.Red
{
	public class PatchouliBullet : General.HeroBullet
	{
		public PatchouliBullet()
		{
			Type = BulletType.LongRange;
			this.Attack = 0;
			Speed = BulletUtls.SlowSpeed * BasisSpeed;
			Gravity = 1;
			MaxRange = 12 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(1.0f * Def.FPS);
			AttackRigor = (int)(3.0f * Def.FPS);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 0;
			TextureAnimation.Center.Y = 0;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 1;
			TextureAnimation.Offset.X = 128 * 2 + 16 * 0;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 4;
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.taihou).FullName, bullet.Position);
		}
		public static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.ColumnRed);
		}
	}
}

#endif