﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
//
using LotusCraft.Spell.Common;
namespace LotusCraft.Unit.White
{
	public class FlyBomber : General.Fly
	{
		public FlyBomber ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/White/Fly02";
			#endregion

			#region UnitParams
			Name = "UFO(対地)";
			HP = 180;
			Armor = 0;
			Speed =1.3f * BasisSpeed;
			
			PopulationWeight = 2;
			
			ViewRange = 12 * Def.MapTipLengthOnField;
			
			MakingTime = 50 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {125,125,0,0};
			UnitType = new TargetObjectType[]{TargetObjectType.Water,};
			CanState = false;//他のオブジェに駐留可能か
			
			IsDetector = true;
			ButtonDescription = "飛行・対地ユニット\n高い連射性能を持つ\n一部の近接ユニットにダメージ2倍\n";
			#endregion


			#region Animation
			this.SetUFOAnimation("LotusCraft/Image/Unit/White/Fly02");
			Animation.HasDirection = false;
			AnimationWalk.HasDirection = false;
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Bullet.White.Fly01Bullet).FullName, };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new ArmbreakSkill (),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit> (SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
			#endregion
			base.OnLoad (faction);
		}
	}
}

namespace LotusCraft.Bullet.White
{
	public class Fly01Bullet : General.MiddleRangeBullet
	{
		public Fly01Bullet()
		{
			Type = BulletType.LongRange;
			DoesHitOnlyTarget = true;
			this.Attack = 5;
			
//			HasSplash = true;
//			SplashDamageRates.Add(0.75f * Def.MapTipLengthOnField, 0.75f);
			
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			SpaceType = BulletSpaceType.Earth;
			MaxRange = 3 * Def.MapTipLengthOnField;
			
			AttackDelay = 0*Def.FPS;
			AttackRigor = 0 * Def.FPS;
			AttackSpeed = (int)(0.2f*Def.FPS);
			
			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 0;
			TextureAnimation.Center.Y = 0;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 1;
			TextureAnimation.Offset.X = 128 * 2 + 16 * 0;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 0;
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			//bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.GunRenzoku).FullName, bullet.Position);
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
			var u = target as IUnit;
			if(null != u)
			{
			//ヒロインと中立を除く、ほとんどの近接ユニットに対してダメージを追加
				switch (u.Parameter.Name)
				{
				case "毛玉":
					bullet.Attack *= 2;
					break;				
				case "メイド(岩)":
					bullet.Attack *= 2;
					break;		
				case "魂魄 妖夢(式神)":
					bullet.Attack *= 2;
					break;
				case "霊烏路 空(式神)":
					bullet.Attack *= 2;
					break;
				case "寅丸 星(式神)":
					bullet.Attack *= 2;
					break;					
				case "フランドール・スカーレット(式神)":
					bullet.Attack *= 2;
					break;					
				case "小野塚 小町(式神)":
					bullet.Attack *= 2;
					break;					
				case "エリー(式神)":
					bullet.Attack *= 2;
					break;					
				case "サニーミルク(式神)":
					bullet.Attack *= 2;
					break;					
				default:
					break;
				}
			}
		}
	}
}
