﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Unit.White
{
	public class FlyFighter : General.Fly
	{
		public FlyFighter ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/White/Fly01";
			#endregion

			#region UnitParams
			Name = "UFO(対空)";
			HP = 280;
			Armor = 0;
			Speed =1.1f * BasisSpeed;

			PopulationWeight = 2;

			ViewRange = 14 * Def.MapTipLengthOnField;

			MakingTime = 35 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {125,100,0,0};
			UnitType = new TargetObjectType[]{TargetObjectType.Clay,};
			CanState = false;//他のオブジェに駐留可能か

			ButtonDescription = "飛行・対空ユニット\n長距離射程を持つ\n";
			#endregion


			#region Animation
			this.SetUFOAnimation("LotusCraft/Image/Unit/White/Fly01");
			Animation.HasDirection = false;
			AnimationWalk.HasDirection = false;
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Bullet.White.Fly02Bullet).FullName, };
			#endregion
		}
		public override void OnAppear (IUnit unit)
		{
			if(null != unit)
				unit.AbilityManager.AppendAbility(new Ability.Common.UFOCloakAbility());
			base.OnAppear (unit);
		}
	}
}

namespace LotusCraft.Bullet.White
{
	public class Fly02Bullet : General.LongRangeBullet
	{
		public Fly02Bullet()
		{
			Type = BulletType.LongRange;
			DoesHitOnlyTarget = true;
			this.Attack = 24;
			DamageBonus[(int)TargetObjectType.Clay] = 1.25f;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			SpaceType = BulletSpaceType.Sky;
			MaxRange = 8 * Def.MapTipLengthOnField;

			AttackDelay = 0;
			AttackRigor = 0;
			AttackSpeed = (int)(1.5f*Def.FPS);
			
			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 0;
			TextureAnimation.Center.Y = 0;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 1;
			TextureAnimation.Offset.X = 128 * 2 + 16 * 0;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 1;
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.GunLong).FullName, bullet.Position);
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalBlue);
		}
	}
}
