 using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.White;
using LotusCraft.Building.White;
using LotusCraft.Effect.White;
using LotusCraft.Spell.White;

namespace LotusCraft.Unit.White
{
	public class Kosuzu : General.Special
	{
		public Kosuzu ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/White/Kosuzu";
			#endregion

			#region UnitParams
			Name = "本居小鈴(式神)";
			ButtonDescription += "射程の長いスプラッシュ攻撃を持つ魔導書を召喚する\n自分自身は攻撃不可";
			HP = 120; 
			Radius = (float)Utls.UnitSize.Large;
			Speed = 1.0f * BasisSpeed;

			PopulationWeight = 3;

			ViewRange = 12*Def.MapTipLengthOnField;
			UnitType = new TargetObjectType[]{TargetObjectType.Water,};

//			MoveType |= UnitMoveType.Air;
			
			Costs = new [] {75,150,0,0};
			MakingTime = 35 * Def.FPS;

			RequireBuildings = new string[]{
				typeof(Airport).FullName,
			};

			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/White/Kosuzu");
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Buttons
			#endregion

			#region Bullets
			Bullets = new string[0];
			SelectBullet = (IUnit u,ITargetObject t, float d) => -1;
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.White.KosuzuSkill (),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
#endregion
			
			base.OnLoad(faction);
		}
	}
}


