﻿using System; 
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.White;

namespace LotusCraft.Unit.White
{
	public class Low03 : General.Water
	{
		public Low03 ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/White/Low02";
			#endregion

			#region UnitParams
			Name = "兎"+Name;
			HP = 120;
			Armor = 0;
			Speed += 0.0f * BasisSpeed;

			PopulationWeight = 1;
			StationWeight = 1;

			MakingTime = 25 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {75,0,0,0};
			ButtonDescription = "射撃ユニット\n対空攻撃を行うことができる";
			#endregion


			#region Animation
			this.SetBigSizeAnimation2 ("LotusCraft/Image/Unit/White/Low02");
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Bullet.White.Low03Bullet).FullName, };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			#region Buttons
			#endregion

			base.OnLoad (faction);
		}

		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUnitEffect).FullName, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}
}

namespace LotusCraft.Bullet.White
{
	public class Low03Bullet : General.LongRangeBullet
	{
		public Low03Bullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			DoesHitOnlyTarget = true;
			this.Attack = 11;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			MaxRange = 5 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(0.8f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
			TextureAnimation.Offset.X = 128 * 1 + 16 * 3;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 0;
			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.GunFire).FullName, bullet.Position);
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalBlue);
		}
	}
}
