using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.White;
using LotusCraft.Building.White;
using LotusCraft.Bullet.White;

namespace LotusCraft.Unit.White
{
	public class Nazurin : LotusCraft.Unit.General.Special
	{
		public Nazurin ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/White/Nazurin";
			#endregion

			#region UnitParams
			Name = "ナズーリン(式神)";
			HP = 140;
			Armor = 0;
			Speed = 1.2f * BasisSpeed;

			PopulationWeight = 2;

			ViewRange = 12 * 32;

			MakingTime = 30 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {50,50,0,0};

			CanJump = true;

			UnitType = new TargetObjectType[]{TargetObjectType.Water,};

			RequireBuildings = new string[]{
			};

			ButtonDescription = "遠隔ユニット。\n一段のみ崖を昇降できる。\n建物にボーナス。";
		
			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/White/Nazurin");
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(NazurinBullet).FullName, };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.White.NazurinSkill (),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
			#endregion

			base.OnLoad(faction);
		}
	}
}


namespace LotusCraft.Bullet.White
{
	public class NazurinBullet : General.MiddleRangeBullet
	{
		public NazurinBullet()
		{
			this.Attack = 15;
			DamageBonus[(int)TargetObjectType.Structure] = 1.4f;
			Speed = BulletUtls.NormalSpeed * BasisSpeed;
			MaxRange = 4f * Def.MapTipLengthOnField;
			DoesHitOnlyTarget = true;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(0.0f * 30);
			AttackSpeed = (int)(1.2f * 30);
			
			OnHit = OnHitEffect;

			
			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
			TextureAnimation.Offset.X = 128 * 0 + 16 * 4;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 0;

			OnCreated = OnCreate;
		}
		static void OnCreate(IBullet bullet)
		{
			Unit.Utls.ShowGunFire(bullet);
			bullet.Generator.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.GunFire).FullName, bullet.Position);
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
		}
	}
}
