﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.White;
using LotusCraft.Ability;

namespace LotusCraft.Unit.White
{
	public class NyokiObj : thrts.UnitParameter
	{
		public NyokiObj()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/White/Farmer";
			#endregion

			#region UnitParams
			Name = "入道";
			HP = 1000;
			Radius = (float)Utls.UnitSize.Large;
			Speed = 0.0f * BasisSpeed;
			Exp = 0;
			IsSummon = true;
			CanState = false;

			PopulationWeight = 0;

			ViewRange = 3 * 32;

			MakingTime = 0 * 30;
			/// mine,gas,sup,?
			Costs = new [] {0,0,0,0};

			SelectPriority = 999;

			CanState = false;

			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Common/Blank");
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			//Bullets = new string[] { typeof(Bullet.White.Low01Bullet).FullName };
			#endregion

			#region AutoCast
			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				new LotusCraft.AutoCast.AutoCast<thrts.IUnit>(this.Name,Def.FPS,AutoCast,true),
			};
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			base.OnLoad (faction);
		}

		public bool AutoCast(thrts.IUnit self)
		{
			if (!self.AbilityManager.ContainsAbility("にょき"))
				self.AbilityManager.AppendAbility(new SuicideAbility(null, 6 * Def.FPS, "にょき"));
//			self.AbilityManager.AppendAbility(new ZUP(null, 10, ""));
			if (self.AbilityManager.GetAbilityWithName("にょき").DurationTime <= 30) self.HP = 0;

			return true;
		}

		public override void OnVanish(IUnit unit)
		{
			//var faction = unit.Faction;
			//var offset = new Vector3D(-2, -2, 8);
			//var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUnitEffect).FullName, unit.Pos + offset);
			//var scale = new Vector3D(8, 8, 8);
			//effect.SetScale(scale);
			base.OnVanish(unit);
		}

		class ZUP : LotusCraft.Ability.EffectContinuousAbility
		{
			public ZUP(IEffect effect, int duration, string name)
				: base(effect, duration, name)
			{
			}
			public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
			{
				var pos = unit.Faction.World.GetGroundAtPos(new Vector2D(unit.Pos.X,unit.Pos.Y));
				if (unit.Pos.Z < pos.Z)
				{
					
				}
				return true;
			}
		}
	}

	public class NyokiObj2 : NyokiObj
	{
		public NyokiObj2()
		{
			Name = "入道2";
			Radius = (float)Utls.UnitSize.Small;
		}
	}
}
